<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 03/10/2018
 * Time: 14:33
 */
require_once("../../classes/company_class.php");
require_once("../../classes/api_class.php");
require_once("../../classes/company_category_class.php");
require_once("../../classes/purchase_class.php");
require_once("../../classes/plans_class.php");
require_once("../../classes/portal_user_class.php");
require_once("../../classes/flag_class.php");
require_once ("../../classes/xoxoday_class.php");
require_once ("../../classes/log_class.php");


if (isset($_SERVER['HTTP_TOKEN'])) {

    if ($_SERVER['HTTP_TOKEN'] == "") {
        $response_array['status'] = 0;
        $response_array['message'] = "blank token sent";
    } else {
        $token = $_SERVER['HTTP_TOKEN'];

        $get_company = new Reward_company();

        $check_token = $get_company->check_company_token($token);

        if (is_array($check_token)){

            $company_id = $check_token['company_id'];
            $plan_id = $check_token['user_plan'];
            $client_no = $check_token['client_no'];
            $prefix = $check_token['prefix'];
            $use_log = new log_class();
            if($_GET['api'] == "get_products") {

                    if (isset($_POST['category_id'])) {

                        if ($_POST['category_id'] == "" || !is_numeric($_POST['category_id'])) {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Invalid Category";

                        } else {

                            if(!isset($_POST['country_id']) || $_POST['country_id'] == ""){

                                $country_id = null;
                            } else {

                                $country_id = $_POST['country_id'];
                            }

                            if(!isset($_POST['city_id']) || $_POST['city_id'] == ""){

                                $city_id = null;
                            } else {

                                $city_id = $_POST['city_id'];
                            }

                            if(!isset($_POST['page']) || $_POST['page'] == "" || !is_numeric($_POST['page'])){

                                $page = null;
                            } else {

                                $page = $_POST['page'];
                            }

                            if(!isset($_POST['limit']) || $_POST['limit'] == "" || !is_numeric($_POST['limit'])){

                                $limit = null;
                            } else {

                                $limit = $_POST['limit'];
                            }

                            $category_id = $_POST['category_id'];

                            $find_api = new api_class();
                            $get_api_result = $find_api->list_products($category_id, $company_id, $token, $country_id, $city_id,$page, $limit);
                            if (is_array($get_api_result)) {

                                $response_array['status'] = 1;
                                $response_array['message'] = "success";
                                $response_array['total'] = $get_api_result['total'];
                                $response_array['category'] = $get_api_result['category'];
                                $response_array['data'] = $get_api_result['data'];

                            } else {

                                $response_array['status'] = 0;
                                $response_array['message'] = $get_api_result;

                            }


                        }


                    } else {

                        $response_array['status'] = 0;
                        $response_array['message'] = "No category sent";

                    }
            }elseif($_GET['api'] == "get_movies"){

                $category_id =178 ;

                $find_api = new api_class();
                $get_api_result = $find_api->list_products($category_id, $company_id, $token);
                if (is_array($get_api_result)) {

                    $response_array['status'] = 1;
                    $response_array['message'] = "success";
                    $response_array['total'] = $get_api_result['total'];
                    $response_array['category'] = $get_api_result['category'];
                    $response_array['data'] = $get_api_result['data'];

                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] = $get_api_result;

                }

            }elseif($_GET['api'] == "get_category"){
                if(isset($_GET['flag'])) {
                    if ($_GET['flag'] !== "") {
                        $use_flag = new flag_class();
                        $get_id = $use_flag->get_flag_id($_GET['flag']);

                        if (is_array($get_id)) {
                            $flag_id = $get_id['flag_id'];
                            $find_category = new company_category_class();
                            $get_category = $find_category->get_company_category($company_id, $flag_id);

                            if (is_array($get_category)) {
                                $response_array['status'] = 1;
                                $response_array['message'] = "success";
                                foreach ($get_category as $category) {
                                    $change_array['category_id'] = $category['cat_id'];
                                    $change_array['category'] = $category['cat_name'];
                                    $response_array['data'][] = $change_array;
                                }


                            } else {

                                $response_array['status'] = 0;
                                $response_array['message'] = "No category found";
                            }
                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Unable to identify flag";

                        }
                    } else {

                        $response_array['status'] = 0;
                        $response_array['message'] = "Invalid flag";
                    }
                } else {
                    $response_array['status'] = 0;
                    $response_array['message'] = "Flag is required";

                }

            }elseif($_GET['api'] == "nested_category"){
                if(isset($_GET['flag'])) {
                    if ($_GET['flag'] !== "") {
                        $use_flag = new flag_class();
                        $get_id = $use_flag->get_flag_id($_GET['flag']);

                        if (is_array($get_id)) {
                            $flag_id = $get_id['flag_id'];
                            $find_category = new company_category_class();
                            $get_category = $find_category->nested_company_category($company_id, $flag_id);

                            if (is_array($get_category)) {
                                $response_array['status'] = 1;
                                $response_array['message'] = "success";
                                $response_array['data'] = $get_category;


                            } else {

                                $response_array['status'] = 0;
                                $response_array['message'] = "No category found";
                            }
                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Unable to identify flag";

                        }
                    } else {

                        $response_array['status'] = 0;
                        $response_array['message'] = "Invalid flag";
                    }
                } else {
                    $response_array['status'] = 0;
                    $response_array['message'] = "Flag is required";

                }

            } elseif($_GET['api'] == "movie_details") {

                if (isset($_GET['product_code'])) {

                    if ($_GET['product_code'] == "") {

                        $response_array['status'] = 0;
                        $response_array['message'] = "Blank Product code";
                    } else {

                            $category_id=178;
                            $product_code = $_GET['product_code'];

                            $find_api = new api_class();
                            $get_api_result = $find_api->get_product_details($category_id, $product_code, $company_id, $token);
                            if (is_array($get_api_result)) {

                                $response_array['status'] = 1;
                                $response_array['message'] = "success";
                                $response_array['data'] = $get_api_result;

                            } else {

                                $response_array['status'] = 0;
                                $response_array['message'] = $get_api_result;

                            }

                    }
                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] = "Product code required";
                }

            } elseif($_GET['api'] == "view_events") {


                        $category_id=179;
                        $product_code = "events";

                        $find_api = new api_class();
                        $get_api_result = $find_api->get_product_details($category_id, $product_code, $company_id, $token);
                        if (is_array($get_api_result)) {

                            $response_array['status'] = 1;
                            $response_array['message'] = "success";
                            $response_array['events'] = $get_api_result;

                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] = $get_api_result;

                        }




            } elseif($_GET['api'] == "product_details") {

                if (isset($_GET['product_code'])) {

                    if ($_GET['product_code'] == "") {

                        $response_array['status'] = 0;
                        $response_array['message'] = "Blank Product code";
                    } else {

                        $product_array = base64_decode($_GET['product_code']);

                        $r_array = json_decode($product_array, true);
                        if(is_array($r_array)) {
                            $category_id = $r_array['c_id'];
                            $product_code = $r_array['p_id'];

                            $find_api = new api_class();
                            $get_api_result = $find_api->get_product_details($category_id, $product_code, $company_id, $token);
                            if (is_array($get_api_result)) {

                                $response_array['status'] = 1;
                                $response_array['message'] = "success";
                                $response_array['data'] = $get_api_result;

                            } else {

                                $response_array['status'] = 0;
                                $response_array['message'] = $get_api_result;

                            }
                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Invalid product";
                        }
                    }
                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] = "Product code required";
                }

            } elseif($_GET['api'] == "meals_products") {

                if (isset($_POST['branch_id'])) {
                    $branch_id = $_POST['branch_id'];

                    if(isset($_POST['category_data'])){

                        $category_array = json_decode($_POST['category_data'], true);

                        if (is_array($category_array)){
                            $use_category_lv2 = new category_lv2_class();
                            $get_party_id = $use_category_lv2->get_menu($branch_id);
                            if (is_array($get_party_id)) {
                                $branch_party_id = $get_party_id['party_id'];
                                $use_api = new api_class();
                                $get_data = $use_api->list_multi_product($category_array, $company_id, $token, $branch_party_id);

                                if (is_array($get_data)) {

                                    $response_array['status'] = 1;
                                    $response_array['message'] = "success";
                                    $response_array['data'] = $get_data;

                                } else {

                                    $response_array['status'] = 0;
                                    $response_array['message'] = $get_data;

                                }
                            } else {

                                $response_array['status'] = 0;
                                $response_array['message'] = "Error getting details";
                            }

                        } else {
                            $response_array['status'] = 0;
                            $response_array['message'] = "Invalid Category Data";


                        }

                    } else {
                        $response_array['status'] = 0;
                        $response_array['message'] = "Category id(s) required";

                    }

                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] = "Branch id required";
                }




            }elseif($_GET['api'] == "exp_purchase"){

                if (isset($_POST['date']) && isset($_POST['price']) && isset($_POST['signature']) && isset($_POST['address_id']) && isset($_POST['first_name']) && isset($_POST['last_name']) && isset($_POST['email']) && isset($_POST['phone_no'])) {

                    $first_name = $_POST['first_name'];
                    $last_name = $_POST['last_name'];
                    $email = $_POST['email'];
                    $phone_no = $_POST['phone_no'];
                    if (isset($_POST['member_no'])) {

                        $member_no = $_POST['member_no'];
                    } else {

                        $member_no = null;
                    }

                    if(isset($_POST['adult_quantity'])){

                        $adult_quantity = $_POST['adult_quantity'];
                    } else {

                        $adult_quantity = 0;
                    }

                    if(isset($_POST['kid_quantity'])){

                        $kid_quantity = $_POST['kid_quantity'];
                    } else {

                        $kid_quantity = 0;
                    }
                    $delivery_type = 4;
                    $is_shipping =2;




                    if ($_POST['date'] == "") {
                        $response_array['status'] = 0;
                        $response_array['message'] = "Date required";

                    } else {

                        if ($_POST['price'] == "" || !is_numeric($_POST['price']) || $_POST['price'] < 1) {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Invalid price";

                        } else {
                            if ($_POST['signature'] == "") {

                                $response_array['status'] = 0;
                                $response_array['message'] = "Blank signature";

                            } else {

                                $use_plan = new Reward_plan();
                                $check_portal = $use_plan->check_portal_user($plan_id, $company_id, $member_no);
                                if ($check_portal == 0) {

                                    $response_array['status'] = 0;
                                    $response_array['message'] = "Invalid member no";
                                } else {
                                    if (is_array($check_portal)) {

                                        $portal_user_id = $check_portal['portal_user_id'];
                                    } else {

                                        $portal_user_id = null;
                                    }



                                    $contact_details = array();
                                    $contact_details['first_name'] = $first_name;
                                    $contact_details['last_name'] = $last_name;
                                    $contact_details['email']= $email;
                                    $contact_details['phone_no']= $phone_no;

                                    if (isset($_POST['ref_no'])) {
                                        $ref_no = $_POST['ref_no'];

                                    } else {

                                        // $contact_details = array();
                                        $ref_no = "RB";
                                    }


                                    $one_array['signature'] = $_POST['signature'];
                                    $one_array['delivery_type'] = $delivery_type;
                                    $one_array['price'] = $_POST['price'];
                                    $one_array['quantity'] = 1;
                                    $one_array['adult_quantity'] = $adult_quantity;
                                    $one_array['kid_quantity'] = $kid_quantity;
                                    $one_array['date'] = $_POST['date'];
                                    $one_array['ref_no'] = $ref_no;
                                    $one_array['address_id'] = $_POST['address_id'];

                                    $product_details[] = $one_array;


                                    $purchase_array['product_details'][] = $product_details;
                                    $purchase_array['delivery_details'] = $contact_details;
                                    if (is_array($product_details)) {

                                        $use_purchase_class = new purchase_class();
                                        //change to array tahat accepts all data token and purchase array
                                        $check_purchase = $use_purchase_class->get_purchase_request($token, $company_id, $portal_user_id, $is_shipping, $contact_details, $product_details, $prefix);

                                        if($check_purchase['status'] == 1){
                                            $response_array['status'] = $check_purchase['status'];
                                            $response_array['message'] = $check_purchase['message'];
                                            $response_array['order_no'] = $check_purchase['data']['order_no'];
                                            $response_array['voucher_code'] = $check_purchase['data']['success'][0]['voucher_code'];

                                        } else {
                                            $response_array['status'] = $check_purchase['status'];
                                            $response_array['message'] = $check_purchase['message'];

                                        }

                                    } else {

                                        $response_array['status'] = 0;
                                        $response_array['message'] = "Invalid product details";
                                    }





                                }



                            }

                        }

                    }
                }else{

                    $response_array['status'] = 0;
                    $response_array['message'] = "Missing Parameters";
                }
                $use_log->record_log($_POST,$response_array);

            }elseif($_GET['api'] == "bills_purchase"){

                if (!isset($_POST['customer_id'])) {

                    $response_array['status'] = 0;
                    $response_array['message'] = "Missing Customer id";

                } elseif(!isset($_POST['price']))   {

                    $response_array['status'] = 0;
                    $response_array['message'] = "Missing Price";


                } elseif(!isset($_POST['signature']))   {

                    $response_array['status'] = 0;
                    $response_array['message'] = "Missing Signature";

                } elseif(!isset($_POST['email']))   {

                    $response_array['status'] = 0;
                    $response_array['message'] = "Missing Email";

                } elseif(!isset($_POST['phone_no']))   {

                    $response_array['status'] = 0;
                    $response_array['message'] = "Missing Phone Number";
                } else {

                    $email = $_POST['email'];
                    $phone_no = $_POST['phone_no'];
                    if (isset($_POST['member_no'])) {

                        $member_no = $_POST['member_no'];
                    } else {

                        $member_no = null;
                    }

                    if(isset($_POST['quantity'])){

                        $quantity = $_POST['quantity'];
                    } else {

                        $quantity = 1;
                    }


                    $delivery_type = 5;
                    $is_shipping =3;




                    if ($_POST['customer_id'] == "") {
                        $response_array['status'] = 0;
                        $response_array['message'] = "Customer Identifier required";

                    } else {

                        if ($_POST['price'] == "" || !is_numeric($_POST['price']) || $_POST['price'] < 1) {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Invalid price";

                        } else {
                            if ($_POST['signature'] == "") {

                                $response_array['status'] = 0;
                                $response_array['message'] = "Blank signature";

                            } else {

                                $use_plan = new Reward_plan();
                                $check_portal = $use_plan->check_portal_user($plan_id, $company_id, $member_no);
                                if ($check_portal == 0) {

                                    $response_array['status'] = 0;
                                    $response_array['message'] = "Invalid member no";
                                } else {
                                    if (is_array($check_portal)) {

                                        $portal_user_id = $check_portal['portal_user_id'];
                                    } else {

                                        $portal_user_id = null;
                                    }



                                    $contact_details = array();

                                    $contact_details['email']= $email;
                                    $contact_details['phone_no']= $phone_no;

                                    if (isset($_POST['ref_no'])) {
                                        $ref_no = $_POST['ref_no'];

                                    } else {

                                        // $contact_details = array();
                                        $ref_no = "RB";
                                    }


                                    $one_array['signature'] = $_POST['signature'];
                                    $one_array['delivery_type'] = $delivery_type;
                                    $one_array['price'] = $_POST['price'];
                                    $one_array['quantity'] = $quantity;

                                    $one_array['customer_id'] = $_POST['customer_id'];
                                    $one_array['ref_no'] = $ref_no;

                                    $product_details[] = $one_array;


                                    $purchase_array['product_details'][] = $product_details;
                                    $purchase_array['delivery_details'] = $contact_details;
                                    if (is_array($product_details)) {

                                        $use_purchase_class = new purchase_class();
                                        //change to array tahat accepts all data token and purchase array
                                        $check_purchase = $use_purchase_class->get_purchase_request($token, $company_id, $portal_user_id, $is_shipping, $contact_details, $product_details, $prefix);

                                        if($check_purchase['status'] == 1){
                                            $response_array['status'] = $check_purchase['status'];
                                            $response_array['message'] = $check_purchase['message'];
                                            $response_array['order_no'] = $check_purchase['data']['order_no'];
                                            $response_array['voucher_code'] = $check_purchase['data']['success'][0]['voucher_code'];

                                        } else {
                                            $response_array['status'] = $check_purchase['status'];
                                            $response_array['message'] = $check_purchase['message'];

                                        }

                                    } else {

                                        $response_array['status'] = 0;
                                        $response_array['message'] = "Invalid product details";
                                    }





                                }



                            }

                        }

                    }
                }
                $use_log->record_log($_POST,$response_array);
            }elseif($_GET['api'] == "cinema_purchase"){

                if(!isset($_POST['signature']))   {

                    $response_array['status'] = 0;
                    $response_array['message'] = "Missing Signature";

                } elseif(!isset($_POST['email']))   {

                    $response_array['status'] = 0;
                    $response_array['message'] = "Missing Email";

                } elseif(!isset($_POST['phone_no']))   {

                    $response_array['status'] = 0;
                    $response_array['message'] = "Missing Phone Number";
                } elseif(!isset($_POST['price']))   {

                    $response_array['status'] = 0;
                    $response_array['message'] = "Missing Price";

                } elseif(!isset($_POST['quantity']))   {

                    $response_array['status'] = 0;
                    $response_array['message'] = "Missing quantity";
                } elseif(!is_numeric($_POST['quantity']) || $_POST['quantity'] < 1)   {

                    $response_array['status'] = 0;
                    $response_array['message'] = "Invalid Quantity";
                } else {

                    $email = $_POST['email'];
                    $phone_no = $_POST['phone_no'];
                    if (isset($_POST['member_no'])) {

                        $member_no = $_POST['member_no'];
                    } else {

                        $member_no = null;
                    }



                    $delivery_type = 6;
                    $is_shipping =3;





                        if ($_POST['price'] == "" || !is_numeric($_POST['price']) || $_POST['price'] < 1) {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Invalid price";

                        } else {
                            if ($_POST['signature'] == "") {

                                $response_array['status'] = 0;
                                $response_array['message'] = "Blank signature";

                            } else {

                                $use_plan = new Reward_plan();
                                $check_portal = $use_plan->check_portal_user($plan_id, $company_id, $member_no);
                                if ($check_portal == 0) {

                                    $response_array['status'] = 0;
                                    $response_array['message'] = "Invalid member no";
                                } else {
                                    if (is_array($check_portal)) {

                                        $portal_user_id = $check_portal['portal_user_id'];
                                    } else {

                                        $portal_user_id = null;
                                    }



                                    $contact_details = array();

                                    $contact_details['email']= $email;
                                    $contact_details['phone_no']= $phone_no;

                                    if (isset($_POST['ref_no'])) {
                                        $ref_no = $_POST['ref_no'];

                                    } else {

                                        // $contact_details = array();
                                        $ref_no = "RB";
                                    }


                                    $one_array['signature'] = $_POST['signature'];
                                    $one_array['delivery_type'] = $delivery_type;
                                    $one_array['price'] = $_POST['price'];
                                    $one_array['quantity'] = $_POST['quantity'];

                                    //$one_array['customer_id'] = $_POST['customer_id'];
                                    $one_array['ref_no'] = $ref_no;

                                    $product_details[] = $one_array;


                                    $purchase_array['product_details'][] = $product_details;
                                    $purchase_array['delivery_details'] = $contact_details;
                                    if (is_array($product_details)) {

                                        $use_purchase_class = new purchase_class();
                                        //change to array tahat accepts all data token and purchase array
                                        $check_purchase = $use_purchase_class->get_purchase_request($token, $company_id, $portal_user_id, $is_shipping, $contact_details, $product_details, $prefix);

                                        if($check_purchase['status'] == 1){
                                            $response_array['status'] = $check_purchase['status'];
                                            $response_array['message'] = $check_purchase['message'];
                                            $response_array['order_no'] = $check_purchase['data']['order_no'];
                                            $response_array['voucher_code'] = $check_purchase['data']['success'][0]['voucher_code'];

                                        } else {
                                            $response_array['status'] = $check_purchase['status'];
                                            $response_array['message'] = $check_purchase['message'];

                                        }

                                    } else {

                                        $response_array['status'] = 0;
                                        $response_array['message'] = "Invalid product details";
                                    }





                                }



                            }

                        }


                }
                $use_log->record_log($_POST,$response_array);

            }elseif($_GET['api'] == "event_purchase"){

                if(!isset($_POST['signature']))   {

                    $response_array['status'] = 0;
                    $response_array['message'] = "Missing Signature";

                } elseif(!isset($_POST['email']))   {

                    $response_array['status'] = 0;
                    $response_array['message'] = "Missing Email";

                } elseif(!isset($_POST['phone_no']))   {

                    $response_array['status'] = 0;
                    $response_array['message'] = "Missing Phone Number";
                } elseif(!isset($_POST['price']))   {

                    $response_array['status'] = 0;
                    $response_array['message'] = "Missing Price";

                } elseif(!isset($_POST['quantity']))   {

                    $response_array['status'] = 0;
                    $response_array['message'] = "Missing quantity";
                } elseif(!is_numeric($_POST['quantity']) || $_POST['quantity'] < 1)   {

                    $response_array['status'] = 0;
                    $response_array['message'] = "Invalid Quantity";
                } else {

                    $email = $_POST['email'];
                    $phone_no = $_POST['phone_no'];
                    if (isset($_POST['member_no'])) {

                        $member_no = $_POST['member_no'];
                    } else {

                        $member_no = null;
                    }



                    $delivery_type = 7;
                    $is_shipping =3;





                    if ($_POST['price'] == "" || !is_numeric($_POST['price']) || $_POST['price'] < 1) {

                        $response_array['status'] = 0;
                        $response_array['message'] = "Invalid price";

                    } else {
                        if ($_POST['signature'] == "") {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Blank signature";

                        } else {

                            $use_plan = new Reward_plan();
                            $check_portal = $use_plan->check_portal_user($plan_id, $company_id, $member_no);
                            if ($check_portal == 0) {

                                $response_array['status'] = 0;
                                $response_array['message'] = "Invalid member no";
                            } else {
                                if (is_array($check_portal)) {

                                    $portal_user_id = $check_portal['portal_user_id'];
                                } else {

                                    $portal_user_id = null;
                                }



                                $contact_details = array();

                                $contact_details['email']= $email;
                                $contact_details['phone_no']= $phone_no;

                                if (isset($_POST['ref_no'])) {
                                    $ref_no = $_POST['ref_no'];

                                } else {

                                    // $contact_details = array();
                                    $ref_no = "RB";
                                }


                                $one_array['signature'] = $_POST['signature'];
                                $one_array['delivery_type'] = $delivery_type;
                                $one_array['price'] = $_POST['price'];
                                $one_array['quantity'] = $_POST['quantity'];

                                //$one_array['customer_id'] = $_POST['customer_id'];
                                $one_array['ref_no'] = $ref_no;

                                $product_details[] = $one_array;


                                $purchase_array['product_details'][] = $product_details;
                                $purchase_array['delivery_details'] = $contact_details;
                                if (is_array($product_details)) {

                                    $use_purchase_class = new purchase_class();
                                    //change to array tahat accepts all data token and purchase array
                                    $check_purchase = $use_purchase_class->get_purchase_request($token, $company_id, $portal_user_id, $is_shipping, $contact_details, $product_details, $prefix);

                                    if($check_purchase['status'] == 1){
                                        $response_array['status'] = $check_purchase['status'];
                                        $response_array['message'] = $check_purchase['message'];
                                        $response_array['order_no'] = $check_purchase['data']['order_no'];
                                        $response_array['voucher_code'] = $check_purchase['data']['success'][0]['voucher_code'];

                                    } else {
                                        $response_array['status'] = $check_purchase['status'];
                                        $response_array['message'] = $check_purchase['message'];

                                    }

                                } else {

                                    $response_array['status'] = 0;
                                    $response_array['message'] = "Invalid product details";
                                }





                            }



                        }

                    }


                }
                $use_log->record_log($_POST,$response_array);
            }elseif($_GET['api'] == "item_purchase"){

                if (isset($_POST['delivery_type']) && isset($_POST['price']) && isset($_POST['signature']) && isset($_POST['quantity'])) {

                    if (isset($_POST['member_no'])) {

                        $member_no = $_POST['member_no'];
                    } else {

                        $member_no = null;
                    }

                    if ($_POST['delivery_type'] == 2 ){

                        $is_shipping =1;

                    } else {

                        $is_shipping= 0;
                    }


                    if ($_POST['delivery_type'] == "") {
                        $response_array['status'] = 0;
                        $response_array['message'] = "Blank delivery type";

                    } else {

                        if ($_POST['price'] == "" || !is_numeric($_POST['price']) || $_POST['price'] < 1) {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Invalid price";

                        } else {
                            if ($_POST['signature'] == "") {

                                $response_array['status'] = 0;
                                $response_array['message'] = "Blank signature";

                            } else {

                                if ($_POST['quantity'] == "" || !is_numeric($_POST['quantity']) || $_POST['quantity'] < 1) {

                                    $response_array['status'] = 0;
                                    $response_array['message'] = "Invalid quantity";

                                } else {


                                    $use_plan = new Reward_plan();
                                    $check_portal = $use_plan->check_portal_user($plan_id, $company_id, $member_no);
                                    if ($check_portal == 0) {

                                        $response_array['status'] = 0;
                                        $response_array['message'] = "Invalid member no";
                                    } else {
                                        if (is_array($check_portal)) {

                                            $portal_user_id = $check_portal['portal_user_id'];
                                        } else {

                                            $portal_user_id = null;
                                        }

                                        if($is_shipping == 1 && !isset($_POST['delivery_details'])){

                                            $response_array['status'] = 0;
                                            $response_array['message'] = "delivery details required";

                                        } else {
                                            if ($_POST['delivery_type'] == 1 && !isset($_POST['branch_id'])){

                                                $response_array['status'] = 0;
                                                $response_array['message'] = "Branch required";

                                            } else {

                                                if (isset($_POST['variants'])) {
                                                    $variants = json_decode($_POST['variants'], true);

                                                } else {

                                                    $variants = array();
                                                }


                                                if (isset($_POST['variants']) && !is_array($variants)) {

                                                    $response_array['status'] = 0;
                                                    $response_array['message'] = "Invalid variant sent";

                                                } else {

                                                    if (isset($_POST['delivery_details'])) {
                                                        $contact_details = json_decode($_POST['delivery_details'], true);

                                                    } else {

                                                        $contact_details = array();
                                                    }

                                                    if (isset($_POST['ref_no'])) {
                                                        $ref_no = $_POST['ref_no'];

                                                    } else {

                                                        $contact_details = array();
                                                        $ref_no = "RB";
                                                    }


                                                    $one_array['signature'] = $_POST['signature'];
                                                    $one_array['delivery_type'] = $_POST['delivery_type'];
                                                    $one_array['price'] = $_POST['price'];
                                                    $one_array['variants'] = $variants;
                                                    $one_array['quantity'] = $_POST['quantity'];
                                                    $one_array['ref_no'] = $ref_no;
                                                    if(isset($_POST['branch_id'])){
                                                        $one_array['branch_id'] = $_POST['branch_id'];


                                                    }
                                                    $product_details[] = $one_array;


                                                    $purchase_array['product_details'][] = $product_details;
                                                    $purchase_array['delivery_details'] = $contact_details;
                                                    if (is_array($product_details)) {

                                                        $use_purchase_class = new purchase_class();
                                                        //change to array tahat accepts all data token and purchase array
                                                        $check_purchase = $use_purchase_class->get_purchase_request($token, $company_id, $portal_user_id, $is_shipping, $contact_details, $product_details, $prefix);

                                                        if($check_purchase['status'] == 1){
                                                            $response_array['status'] = $check_purchase['status'];
                                                            $response_array['message'] = $check_purchase['message'];
                                                            $response_array['order_no'] = $check_purchase['data']['order_no'];
                                                            $response_array['voucher_code'] = $check_purchase['data']['success'][0]['voucher_code'];

                                                        } else {
                                                            $response_array['status'] = $check_purchase['status'];
                                                            $response_array['message'] = $check_purchase['message'];

                                                        }

                                                    } else {

                                                        $response_array['status'] = 0;
                                                        $response_array['message'] = "Invalid product details";
                                                    }

                                                }
                                            }
                                        }

                                    }

                                }

                            }

                        }

                    }
                }else{

                    $response_array['status'] = 0;
                    $response_array['message'] = "Missing Parameters";
                }

              $use_log->record_log($_POST,$response_array);
            }elseif($_GET['api'] == "bulk_purchase"){

                if(isset($_POST['product_details']) && isset($_POST['delivery_details']) && isset($_POST['is_shipping'])) {

                    if ($_POST['is_shipping'] == 0 ||$_POST['is_shipping'] ==1) {
                        if (isset($_POST['member_no'])) {

                            $member_no = $_POST['member_no'];
                        } else {

                            $member_no = null;
                        }
                        $use_plan = new Reward_plan();
                        $check_portal = $use_plan->check_portal_user($plan_id, $company_id, $member_no);
                        if ($check_portal == 0) {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Invalid member no";
                        } else {

                            if (is_array($check_portal)) {

                                $portal_user_id = $check_portal['portal_user_id'];
                            } else {

                                $portal_user_id = null;
                            }

                            //$purchase_array['portal_user_id'] = $portal_user_id;
                            //$purchase_array['is_shipping'] = $_POST['is_shipping'];
                            //$purchase_array['company_id'] = $company_id;
                            $is_shipping=$_POST['is_shipping'];


                            $product_details = json_decode($_POST['product_details'], true);
                            $contact_details = json_decode($_POST['delivery_details'], true);

                            $purchase_array['product_details'] = $product_details;
                            $purchase_array['delivery_details'] = $contact_details;
                            if (is_array($product_details)) {

                                $use_purchase_class = new purchase_class();
                                //change to array tahat accepts all data token and purchase array
                                $check_purchase = $use_purchase_class->get_purchase_request($token, $company_id,$portal_user_id,$is_shipping,$contact_details,$product_details,$prefix);

                                $response_array = $check_purchase;

                            } else {

                                $response_array['status'] = 0;
                                $response_array['message'] = "Invalid product details";
                            }

                        }
                    } else {

                        $response_array['status'] = 0;
                        $response_array['message'] = "Invalid shipping flag";
                    }
                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] = "Missing product or delivery details";
                }
                $use_log->record_log($_POST,$response_array);
            }elseif ($_GET['api'] == "get_state") {
                $use_state_city = new state_city_class();
                $get_state = $use_state_city->list_state();

                if (is_array($get_state)){
                    $response_array['status'] = 1;
                    $response_array['message'] = "Success";
                    $response_array['data'] = $get_state;

                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] = "Error getting state";

                }

            }elseif ($_GET['api'] == "get_city") {
                $use_state_city = new state_city_class();
                if(isset($_GET['state_id'])){

                    if(is_numeric($_GET['state_id'])){

                        $get_city = $use_state_city->list_city($_GET['state_id']);

                        if (is_array($get_city)){

                            $response_array['status'] = 1;
                            $response_array['message'] = "Success";
                            $response_array['data'] = $get_city;
                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Error getting city";
                        }


                    } else {

                        $response_array['status'] = 0;
                        $response_array['message'] = "Invalid data type for state";
                    }

                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] = "State Required";
                }

            }elseif ($_GET['api'] == "item_delivery_price") {

                if (isset($_POST['state_id']) && isset($_POST['city_id']) && isset($_POST['signature']) && isset($_POST['quantity'])) {


                    if ($_POST['state_id'] == "") {
                        $response_array['status'] = 0;
                        $response_array['message'] = "Blank state";

                    } else {

                        if ($_POST['city_id'] == "") {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Blank City";

                        } else {
                            if ($_POST['signature'] == "") {

                                $response_array['status'] = 0;
                                $response_array['message'] = "Blank signature";

                            } else {

                                if ($_POST['quantity'] == "" || !is_numeric($_POST['quantity']) || $_POST['quantity'] < 1) {

                                    $response_array['status'] = 0;
                                    $response_array['message'] = "Invalid quantity";

                                } else {
                                    $one_array ['signature']= $_POST['signature'];
                                    $one_array['quantity'] = $_POST['quantity'];
                                    $product_details[] = $one_array;

                                    $use_purchase_class = new purchase_class();
                                    $get_delivery_price = $use_purchase_class->get_delivery_price($_POST['state_id'], $_POST['city_id'], $product_details, $token);

                                    if (is_array($get_delivery_price)) {

                                        $response_array['status'] = 1;
                                        $response_array['message'] = "Success";
                                        $response_array['data'] = $get_delivery_price;

                                    } else {

                                        $response_array['status'] = 0;
                                        $response_array['message'] = $get_delivery_price;
                                    }

                                }

                            }

                        }

                    }

                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] = "Missing Parameter";
                }

            }elseif ($_GET['api'] == "notification") {
                $use_send_email = new send_mail_class();
                if(isset($_GET['note'])){
                    $note = $_GET['note'];

                    if($note == "reset") {

                        if(isset($_POST['first_name']) && isset($_POST['reset_url']) && isset($_POST['email'])){

                            $first_name = $_POST['first_name'];
                            $reset_url = $_POST['reset_url'];
                            $email = $_POST['email'];

                            if($first_name == "" || $reset_url == "" || $email == ""){

                                $response_array['status'] = 0;
                                $response_array['message'] = "Blank Parameter";
                            } else {

                                $send_email = $use_send_email->send_reset_password($first_name,$email, $reset_url,$client_no);

                                if(is_array($send_email)){


                                    $response_array['status'] = 1;
                                    $response_array['message'] = "Email Sent";
                                } else {

                                    $response_array['status'] = 0;
                                    $response_array['message'] = $send_email;
                                }
                            }

                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Missing Parameter";
                        }
                    }elseif ($note == "change_password"){

                        if(isset($_POST['first_name']) && isset($_POST['member_no']) && isset($_POST['email']) ){

                            $first_name = $_POST['first_name'];

                            $email = $_POST['email'];
                            $member_no = $_POST['member_no'];

                            if($first_name == "" || $member_no == "" || $email == "" ){

                                $response_array['status'] = 0;
                                $response_array['message'] = "Blank Parameter";
                            } else {

                                $send_email = $use_send_email->send_change_password($first_name,$email, $member_no,$client_no);

                                if(is_array($send_email)){


                                    $response_array['status'] = 1;
                                    $response_array['message'] = "Email Sent";
                                } else {

                                    $response_array['status'] = 0;
                                    $response_array['message'] = $send_email;
                                }
                            }

                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Missing Parameter";
                        }

                    }elseif ($note == "transaction"){

                        if(isset($_POST['first_name']) && isset($_POST['current_balance']) && isset($_POST['email']) && isset($_POST['details'])){

                            $first_name = $_POST['first_name'];
                            $current_balance = $_POST['current_balance'];
                            $email = $_POST['email'];
                            $table = $_POST['details'];

                            if($first_name == "" || $current_balance == "" || $email == "" || $table == ""){

                                $response_array['status'] = 0;
                                $response_array['message'] = "Blank Parameter";
                            } else {

                                $send_email = $use_send_email->send_redemption($first_name,$email, $current_balance,$table,$client_no);

                                if(is_array($send_email)){


                                    $response_array['status'] = 1;
                                    $response_array['message'] = "Email Sent";
                                } else {

                                    $response_array['status'] = 0;
                                    $response_array['message'] = $send_email;
                                }
                            }

                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Missing Parameter";
                        }

                    } else {

                        $response_array['status'] = 0;
                        $response_array['message'] = "Invalid Notification";

                    }


                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] = "No notification set";

                }

            }elseif ($_GET['api'] == "delivery_price") {
                // print_r($_POST['product_details']);
                //echo "<br>";
                if (isset($_POST['state_id']) && isset($_POST['city_id']) && isset($_POST['product_details'])) {

                    if ($_POST['state_id'] == "") {
                        $response_array['status'] = 0;
                        $response_array['message'] = "Blank state";

                    } else {

                        if ($_POST['city_id'] == "") {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Blank City";

                        } else {

                            if ($_POST['product_details'] == "") {

                                $response_array['status'] = 0;
                                $response_array['message'] = "Blank product details";
                            } else {
                                $product_details = json_decode($_POST['product_details'], true);
                                if (is_array($product_details)) {
                                    $use_purchase_class = new purchase_class();
                                    $get_delivery_price = $use_purchase_class->get_delivery_price($_POST['state_id'], $_POST['city_id'], $product_details, $token);

                                    if (is_array($get_delivery_price)) {

                                        $response_array['status'] = 1;
                                        $response_array['message'] = "Success";
                                        $response_array['data'] = $get_delivery_price;

                                    } else {

                                        $response_array['status'] = 0;
                                        $response_array['message'] = $get_delivery_price;
                                    }


                                } else {

                                    $response_array['status'] = 0;
                                    $response_array['message'] = "Invalid product details";

                                }

                            }

                        }
                    }

                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] = "Parameters missing";

                }


            } elseif ($_GET['api'] == "exp_country"){

                $use_xoxo = new xoxoday_class();
                $get_country = $use_xoxo->get_countries();

                if (is_array($get_country)){

                    $response_array['status'] = 1;
                    $response_array['message'] = "success";
                    $response_array['data'] = $get_country;

                }else {

                    $response_array['status'] = 0;
                    $response_array['message'] = $get_country;
                }


            } elseif ($_GET['api'] == "exp_city"){

                if (isset($_GET['country_id'])){

                    if ($_GET['country_id'] == ""){

                        $response_array['status'] = 0;
                        $response_array['message'] = "Country required";
                    } else{

                        $use_xoxo = new xoxoday_class();
                        $get_city = $use_xoxo->get_city($_GET['country_id']);

                        if (is_array($get_city)){

                            $response_array['status'] = 1;
                            $response_array['message'] = "success";
                            $response_array['data'] = $get_city;

                        }else {

                            $response_array['status'] = 0;
                            $response_array['message'] = $get_city;
                        }


                    }

                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] = "Missing country";

                }

            }else {

                $response_array['status'] = 0;
                $response_array['message'] = "Invalid request";

            }



        } else {

            $response_array['status'] = 0;
            $response_array['message'] = "Invalid token";

        }
    }

} else {

    $response_array['status'] = 0;
    $response_array['message'] = "Missing token";
}


echo json_encode($response_array);
        