<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 03/10/2018
 * Time: 14:29
 */

require_once("company_category_class.php");
require_once("category_class.php");
require_once("api_link_class.php");
require_once("catalogue_service_class.php");
require_once ("giftingowl_class.php");
require_once("interswitch_class.php");
require_once ("nairabox_class.php");
require_once ("seamfix_class.php");
require_once("main_class.php");
require_once ("uber_class.php");
require_once ("nairafood_class.php");

class api_class extends Rewardsbox_main
{

    private $fuel_cat_id = 223;
    private $experience_cat_id = 232;
    private $experience_partner_id = 3;
    private $food_partner_id = 11;
    private $food_category_id = 233;

    public function list_multi_product($category_array, $company_id, $token, $branch = null, $country = null, $city = null, $page = null, $limit = null){

            if(is_array($category_array)){
                $use_company_category = new company_category_class();
                $get_margins  = $use_company_category->get_multi_margin($category_array, $company_id);

                if (is_array($get_margins)){


                    $api_category_id_array = array_column($get_margins, 'partner_category_id');

                    //$flag_id = $get_margins[0]['flag_id'];
                    $api_id = $get_margins[0]['partner_api_id'];

                    $find_api = new api_link_class();
                    $get_api = $find_api->get_link($api_id);
                    if (is_array($get_api)) {

                        $partner_id = $get_api['partner_id'];
                        $end_point = $get_api['end_point'];

                        if ($partner_id == 1) {

                            $find_catalogue_service = new catalogue_service_class();
                            $get_catalogue = $find_catalogue_service->get_multi_service_products($end_point, $token, $partner_id, $api_category_id_array, $get_margins, $branch, $page, $limit);
                            if (is_array($get_catalogue)) {

                                //$return_data['data'] = $get_catalogue;
                                $return_data['data'] = $get_catalogue['data'];
                                $return_data['total'] = $get_catalogue['total'];
                                return $return_data;
                            } else {

                                return $get_catalogue;
                            }

                        } else {

                            return "Invalid data";
                        }


                    } else {

                        return "Error returning result";
                    }

                } else {

                    return $get_margins;
                }


            } else {

                return "Invalid Category array";
            }


    }

    public function list_multi_product_random($company_id, $token, $page= null, $limit = null, $max_price = null){


            $use_company_category = new company_category_class();
            $get_margins  = $use_company_category->get_rand_multi_margin($company_id,$page);

            if (is_array($get_margins)){


                $api_category_id_array = array_column($get_margins, 'partner_category_id');

//                        echo json_encode($get_margins);
//                        echo "<hr>";
                        $find_catalogue_service = new catalogue_service_class();
                        $get_catalogue = $find_catalogue_service->get_multi_summary_products( $token, $api_category_id_array, $get_margins,$limit,$max_price);
                        if (is_array($get_catalogue)) {

                            //$return_data['data'] = $get_catalogue;
                            $return_data['data'] = $get_catalogue['data'];
                            $return_data['total'] = $get_catalogue['total'];
                            return $return_data;
                        } else {

                            return $get_catalogue;
                        }




            } else {

                return $get_margins;
            }


    }

    public function list_search_product($company_id, $token, $search, $max_price = null, $delivery_type = null, $sort = null){


        if (strlen($search) >= 3) {
            $use_company_category = new company_category_class();
            $get_margins = $use_company_category->get_all_multi_margin($company_id);

            if (is_array($get_margins)) {


                $api_category_id_array = array_column($get_margins, 'partner_category_id');


                $find_catalogue_service = new catalogue_service_class();
                $get_catalogue = $find_catalogue_service->get_multi_search_products($token, $api_category_id_array, $get_margins, $search, $delivery_type, $sort, $max_price);
                if (is_array($get_catalogue)) {

                    //$return_data['data'] = $get_catalogue;
                    $return_data['data'] = $get_catalogue['data'];
                    $return_data['total'] = $get_catalogue['total'];
                    return $return_data;
                } else {

                    return $get_catalogue;
                }


            } else {

                return $get_margins;
            }
        } else {

            return "Search length must be greater than 3";
        }

    }

    public function list_sale_items($company_id, $token, $page = 1, $limit = 20, $delivery_type = null, $sort = null, $max_price = null){

        $use_com_category = new company_category_class();

        $get_margins = $use_com_category->get_all_multi_margin($company_id);

        if (is_array($get_margins)) {


            $api_category_id_array = array_column($get_margins, 'partner_category_id');
            $api_category_id_array[] = "sale";

//            echo json_encode($get_margins);
//            echo "<hr>";
//            echo json_encode($api_category_id_array);
//            die();

            $find_catalogue_service = new catalogue_service_class();
            $get_catalogue = $find_catalogue_service->get_multi_service_group_products($get_margins[0]['end_point'],$token,$get_margins[0]['partner_id'],$api_category_id_array, $get_margins,"", $page, $limit, $delivery_type, $sort, $max_price);

            if (is_array($get_catalogue)) {

                //$return_data['data'] = $get_catalogue;
                $return_data['data'] = $get_catalogue['data'];
                $return_data['total'] = $get_catalogue['total'];
                return $return_data;
            } else {

                return $get_catalogue;
            }

        } else {

            return "No data returned";
        }
    }

    public function list_products($category_id,$company_id, $token, $restaurant_id = null, $city_id = null, $page = 1, $limit = 20,$delivery_type=null,$sort = null, $max_price = null){

        $find_margin = new company_category_class();

        $get_margin = $find_margin->get_margin($category_id, $company_id);

        if (is_array($get_margin)){

            $margin = $get_margin['margin'];
            $margin_type = $get_margin['margin_type'];
            $flag_id = $get_margin['flag_id'];

                $find_partner_details = new category_class();

                $get_details = $find_partner_details->get_partner_category_details($category_id, $flag_id);

                if (is_array($get_details)){

                    $api_id = $get_details['partner_api_id'];
                    $partner_category_id = $get_details['partner_category_id'];
                    $partner_category_name = $get_details['partner_category_name'];
                    $return_data ['category'] = $get_details['cat_name'];

                    if (isset($get_details['image_url'])){

                        if ($get_details['image_url'] == ""){

                            $return_data ['image'] = "";

                        } else {

                            $return_data ['image'] = $this->image_url.$get_details['image_url'];
                        }

                    } else {

                        $return_data ['image'] = "";
                    }


                        $find_api = new api_link_class();
                        $get_api = $find_api->get_link($api_id);
                        if (is_array($get_api)){

                            // echo json_encode($get_api);
                            // echo "<hr>";
                            $partner_id = $get_api['partner_id'];
                            $end_point = $get_api['end_point'];

                            if ($partner_id == 1) {

                                $find_catalogue_service = new catalogue_service_class();
                                $get_catalogue = $find_catalogue_service->get_service_products($end_point, $token, $partner_category_id, $partner_id, $margin, $margin_type, $category_id,$page, $limit,$delivery_type,$sort, $max_price);
                                if (is_array($get_catalogue)) {

                                    //$return_data['data'] = $get_catalogue;
                                    $return_data['data'] = $get_catalogue['data'];
                                    $return_data['total'] = $get_catalogue['total'];
                                    return $return_data;
                                } else {

                                    return $get_catalogue;
                                }

                            }elseif ($partner_id == 3) {

//echo $city_id;
//echo "<hr>";
                                if ($city_id == "" || !is_numeric($city_id)) {

                                    return "Invalid City";
                                } else {
                                    $use_gift = new giftingowl_class();

                                    $get_catalogue = $use_gift->get_service_products($category_id, $partner_id, $margin, $margin_type, $city_id, $page, $limit);

                                    if (is_array($get_catalogue)) {

                                        $return_data['data'] = $get_catalogue['data'];
                                        $return_data['total'] = $get_catalogue['total'];
                                        return $return_data;
                                    } else {

                                        return $get_catalogue;
                                    }
                                }


                            }elseif ($partner_id == 4 || $partner_id == 6) {
                                   
                                    $use_interswitch = new interswitch_class();
                                    $get_catalogue = $use_interswitch->get_service_products( $partner_category_id, $partner_id, $margin, $margin_type,$partner_category_name);
                             
                                    if (is_array($get_catalogue)) {

                                        //$return_data['data'] = $get_catalogue;
                                        $return_data['data'] = $get_catalogue['data'];
                                        $return_data['total'] = "";
                                        return $return_data;
                                    } else {

                                        return $get_catalogue;
                                    }

                            }elseif ($partner_id == 7) {

                                $use_nairabox = new nairabox_class();
                                $get_catalogue = $use_nairabox->get_all_movies();
                                if (is_array($get_catalogue)) {

                                    //$return_data['data'] = $get_catalogue;
                                    $return_data['data'] = $get_catalogue;
                                    $return_data['total'] = "";
                                    return $return_data;
                                } else {

                                    return $get_catalogue;
                                }
                            }elseif ($partner_id == 8) {

                                $use_seamfix = new seamfix_class();
                                $get_catalogue = $use_seamfix->get_service_products( $partner_id, $margin, $margin_type);
                                if (is_array($get_catalogue)) {

                                    //$return_data['data'] = $get_catalogue;
                                    $return_data['data'] = $get_catalogue;
                                    $return_data['total'] = "";
                                    return $return_data;
                                } else {

                                    return $get_catalogue;
                                }

                            }elseif ($partner_id == 10) {

                                $use_uber = new uber_class();
                                $get_catalogue = $use_uber->get_service_products( $partner_id, $margin, $margin_type);
                                if (is_array($get_catalogue)) {

                                    //$return_data['data'] = $get_catalogue;
                                    $return_data['data'] = $get_catalogue;
                                    $return_data['total'] = "";
                                    return $return_data;
                                } else {

                                    return $get_catalogue;
                                }
                            }elseif ($partner_id == 11) {

                                $use_food = new nairafood_class();
                                $get_catalogue = $use_food->get_service_products($margin,$margin_type,$restaurant_id);
                                if (is_array($get_catalogue)) {

                                    //$return_data['data'] = $get_catalogue;
                                    $return_data['data'] = $get_catalogue;
                                    $return_data['total'] = "";
                                    return $return_data;
                                } else {

                                    return $get_catalogue;
                                }


                            } else {


                                return "Invalid location";
                            }

                        } else {

                            return "Unable to locate products";
                        }
                } else {

                    return "Unable to get details";
                }
        } else {

            return "Unassigned Service";
        }



    }


    public function get_product_details($category_id, $product_code, $company_id, $token, $event_id=''){


        $find_margin = new company_category_class();

        $get_margin = $find_margin->get_margin($category_id, $company_id);
        if (is_array($get_margin)){

            $margin = $get_margin['margin'];
            $margin_type = $get_margin['margin_type'];
            $flag_id = $get_margin['flag_id'];

            $find_partner_details = new category_class();

            $get_details = $find_partner_details->get_partner_category_details($category_id, $flag_id);
            if (is_array($get_details)){

                $api_id = $get_details['partner_api_id'];
                $find_api = new api_link_class();
                $get_api = $find_api->get_link($api_id);
                
                if (is_array($get_api)){

                    $partner_id = $get_api['partner_id'];
                    //$flag_id = $get_api['flag_id'];
                    $get_link = $find_api->get_api_end_point($partner_id, 2, $flag_id);

                    if (is_array($get_link)){

                        $end_point = $get_link['end_point'];

                        if ($partner_id == 1) {

                            $find_catalogue_service = new catalogue_service_class();
                            $get_details = $find_catalogue_service->get_product_details($end_point, $token, $partner_id, $margin, $margin_type, $product_code);
                            if (is_array($get_details)) {

                                return $get_details;
                            } else {

                                return $get_details;
                            }

                        }elseif ($partner_id == 3){
                            $use_gift = new giftingowl_class();
                            $get_details= $use_gift->get_product_details($partner_id, $margin, $margin_type, $product_code);
                            if (is_array($get_details)) {

                                return $get_details;
                            } else {

                                return $get_details;
                            }

                        }elseif ($partner_id == 7){
                            $use_naira_box = new nairabox_class();

                            if($flag_id == 5){
                                $get_details = $use_naira_box->get_movie_details($partner_id, $margin, $margin_type, $product_code);
                            } else {
                                $get_details = $use_naira_box->get_events_details($partner_id, $margin, $margin_type, $event_id);//get_events_details
                            }
                            if (is_array($get_details)) {

                                return $get_details;
                            } else {

                                return $get_details;
                            }

                        } else {


                            return "Invalid location";
                        }

                    } else {

                        return "Unable to get end point";
                    }

                } else{

                    return "Invalid partner";
                }

            } else {

                return "Unable to get details";
            }


        } else {

            return "Invalid Category";
        }

    }

    public function get_fuel_stations($company_id){
        $use_com_category = new company_category_class();
        $get_data = $use_com_category->verify_assign_category($this->fuel_cat_id, $company_id);
        if (is_array($get_data)){

            $use_seamfix = new seamfix_class();
            $get_stations = $use_seamfix->get_fuel_stations($this->fuel_cat_id);
            if (is_array($get_stations)){

                return $get_stations;
            } else {

                return "Unable to load Fuel Stations";
            }

        } else {

            return "Access Denied";
        }

    }

    public function get_experience_date($product_code, $company_id){

        $category_id = $this->experience_cat_id;
        $partner_id = $this->experience_partner_id;
        $find_margin = new company_category_class();

        $get_margin = $find_margin->get_margin($category_id, $company_id);

        if (is_array($get_margin)) {

            $margin = $get_margin['margin'];
            $margin_type = $get_margin['margin_type'];
            $flag_id = $get_margin['flag_id'];

            $use_gift = new giftingowl_class();

            $get_gift = $use_gift->get_availability($product_code,$partner_id,$margin,$margin_type);

            if (is_array($get_gift)){

                return$get_gift;

            } else {

                return "No available date";
            }
        } else {

            return $get_margin;
        }
    }


    public function get_food_price($company_id, $email, $phone, $restaurant,$delivery_location,$delivery_city, $delivery_address,$delivery_instruction,$cart){


        $partner_id = $this->food_partner_id;
        $find_margin = new company_category_class();

        $get_margin = $find_margin->get_margin($this->food_category_id, $company_id);

        if (is_array($get_margin)) {

            $margin = $get_margin['margin'];
            $margin_type = $get_margin['margin_type'];
            $flag_id = $get_margin['flag_id'];

            $use_food = new nairafood_class();

            $get_food = $use_food->confirm_order_price($partner_id, $margin, $margin_type, $email, $phone, $restaurant,$delivery_location,$delivery_city, $delivery_address,$delivery_instruction,$cart);

            if (is_array($get_food)){

                return$get_food;

            } else {

                return $get_food;
            }
        } else {

            return $get_margin;
        }
    }
    
    public function list_best_selling_product($company_id, $token, $limit = null){

        $use_company_category = new company_category_class();
        $get_margins = $use_company_category->get_all_multi_margin($company_id);

        if (is_array($get_margins)) {


            $api_category_id_array = array_column($get_margins, 'partner_category_id');


            $find_catalogue_service = new catalogue_service_class();
            $get_catalogue = $find_catalogue_service->get_best_selling_products($token, $get_margins, $limit);
            if (is_array($get_catalogue)) {


                return $get_catalogue;
            } else {

                return "No data found";
            }


        } else {

            return $get_margins;
        }
    }
    
    public function list_featured_product($company_id, $token){

        $use_company_category = new company_category_class();
        $get_margins = $use_company_category->get_all_multi_margin($company_id);

        if (is_array($get_margins)) {


            $api_category_id_array = array_column($get_margins, 'partner_category_id');


            $find_catalogue_service = new catalogue_service_class();
            $get_catalogue = $find_catalogue_service->get_featured_products($token, $get_margins);
            if (is_array($get_catalogue)) {


                return $get_catalogue;
            } else {

                return "No data found";
            }


        } else {

            return $get_margins;
        }
    }
    
    public function get_experience_random($company_id){

        $category_id = $this->experience_cat_id;
        $partner_id = $this->experience_partner_id;
        $find_margin = new company_category_class();

        $get_margin = $find_margin->get_margin($category_id, $company_id);

        if (is_array($get_margin)) {

            $margin = $get_margin['margin'];
            $margin_type = $get_margin['margin_type'];
            $flag_id = $get_margin['flag_id'];

            $use_gift = new giftingowl_class();

            $get_gift = $use_gift->get_service_random_products($partner_id,$margin,$margin_type, $category_id);

            if (is_array($get_gift)){

                return$get_gift;

            } else {

                return $get_gift;
            }
        } else {

            return $get_margin;
        }
    }
}
//$page_test = new api_class();
//$token = "78295BBJEA7E9J";
//$cat_id= 310;
//echo json_encode($page_test->list_products(3,10,$token));
//$array = array(3,2,1,4);
//echo json_encode($page_test->list_search_product(10, 1200, "baby"));
//echo json_encode($page_test->list_multi_product_random(10, 1200, 5));
//echo json_encode($page_test->list_products(15,10,1200,"","","","","",""));
//echo json_encode($page_test->list_multi_product(array(11,12,13,14),10,"1200",70));
//echo json_encode($page_test->list_products(3,10,1200,"","",2,3,"2","2"));