<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 05/11/2018
 * Time: 14:00
 */

require_once ("main_class.php");
require_once ("category_lv1_class.php");
class category_lv2_class extends Rewardsbox_main
{
    private $table = "rewardsbox_category_level_2";
    //private $table_parent = "rewardsbox_category_level_1";


    public function create_lv2_category($level1_id, $name)
    {

        $column = array("parent_id", "menu_name");
        $value = array($level1_id, $name);

        $use_level1 = new category_lv1_class();
        $check_parent = $use_level1->get_menu($level1_id);
//        echo json_encode($check_parent);
//        echo "<br>";
        if (is_array($check_parent)) {

            $parent = $check_parent['menu_name'];
            $thirdwhere['column_name'] = "menu_name";
            $thirdwhere['sign'] = "=";
            $thirdwhere['value'] = $name;
            $where[] = $thirdwhere;

            $insert_data = $this->insert_check_duplicate($this->table, $column, $value, $where);

            if ($insert_data > 0) {
                $insert_array['id'] = $insert_data;
                $insert_array['name'] = ucfirst($name);
                $insert_array['parent'] = ucfirst($parent);
                return $insert_array;

            } elseif ($insert_data < 0) {
                return "Menu already exists";

            } else {
                return "An error occurred";
            }

        } else {

            return "Parent not found";
        }
    }


    public function view_all_lv2_menu()
    {

        $columns = array($this->table.".menu_id", "rewardsbox_category_level_1.menu_name", $this->table.".menu_name");

        $firstjoin ['table_name']="rewardsbox_category_level_1";
        $firstjoin ['first_column']="rewardsbox_category_level_1.menu_id";
        $firstjoin ['second_column']=$this->table.".parent_id";
        $leftjoin []=$firstjoin;

        $get_data = $this->select_tb($this->table, $columns,"","","","","","",$leftjoin);

        if (is_array($get_data)) {

            return $get_data['data'];
        } else {

            return "No data found";
        }


    }


    public function get_lv2_category($parent_id){

        $columns = array("menu_id","menu_name");

        $thirdwhere['column_name'] = "parent_id";
        $thirdwhere['sign'] = "=";
        $thirdwhere['value'] = $parent_id;
        $where[] = $thirdwhere;

        $get_data = $this->select_tb($this->table, $columns, $where);

        if(is_array($get_data)){

            return $get_data['data'];
        } else {

            return "No data found";
        }



    }

    public function get_child($parent_id, $child_id){

        $columns = array("menu_id","menu_name");

        $thirdwhere['column_name'] = "parent_id";
        $thirdwhere['sign'] = "=";
        $thirdwhere['value'] = $parent_id;
        $where[] = $thirdwhere;

        $thirdwhere['column_name'] = "menu_id";
        $thirdwhere['sign'] = "=";
        $thirdwhere['value'] = $child_id;
        $where[] = $thirdwhere;


        $get_data = $this->select_tb($this->table, $columns, $where);

        if(is_array($get_data)){

            return $get_data['data'][0];
        } else {

            return "No data found";
        }


    }

    public function edit_child($id, $child_name) {
        $key = "menu_id";
        //$columns_name = "service_name";

        $firstset['column_name'] ="menu_name";
        $firstset['sign'] ="=";
        $firstset['value'] =$child_name;
        $set[] = $firstset;
        $whereduplicate[] = $firstset;


        $first_where['column_name'] ="menu_id";
        $first_where['sign'] ="=";
        $first_where['value'] =$id;
        $where[] = $first_where;

        $edit_result = $this->update_check_duplicate($this->table, $set, $where, $whereduplicate, $key);
        //print_r($edit_name);

        if ($edit_result == 1){
            return 1;

        } elseif ($edit_result ==-1) {
            return $child_name." already exists";

        }  else {
            return "Invalid Child Category";
        }

    } // end edi name function


    public function get_menu($id){

        $columns = array("menu_id", "menu_name","party_id");

        $thirdwhere['column_name'] ="menu_id";
        $thirdwhere['sign'] ="=";
        $thirdwhere['value'] =$id;
        $where[] = $thirdwhere;

        $get_data = $this->select_tb($this->table, $columns, $where);

        if (is_array($get_data)){

            return $get_data['data'][0];

        } else {

            return 0;
        }


    }

    public function del_child($id){

        $check_data = $this->get_menu($id);
        if (is_array($check_data)){

            $first_where['column_name'] ="menu_id";
            $first_where['sign'] ="=";
            $first_where['value'] =$id;
            $where[] = $first_where;

            $del_data = $this->delete_data($this->table, $where);

            if ($del_data == 1){

                return 1;

            } else {

                return "Error Deleting Child";
            }


        } else {

            return "Invalid Child Category";
        }


    }

}

//$test = new category_lv2_class();
//echo json_encode($test->get_menu(6));
//echo json_encode($test->del_child(4));
//echo json_encode($test->create_lv2_category(1,"Kitchen Appliance"));
//echo json_encode($test->view_all_lv2_menu());