<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 12/10/2018
 * Time: 19:45
 */

require_once("curl_class.php");
require_once ("main_class.php");
require_once ("company_class.php");
require_once ("service_access_class.php");
require_once ("company_user_class.php");
class email_custom_class extends Rewardsbox_main
{

    private $table = "email_store";

    private function save_email_store ($client_id, $first_name, $last_name, $member_no, $current_balance, $email){

        $columns = array("client_id", "first_name", "last_name","member_no", "current_balance", "email");
        $values = array($client_id, $first_name, $last_name, $member_no, $current_balance, $email);
        $insert_data = $this->insert_data($this->table, $columns, $values);

        if ($insert_data > 0) {
            return 1;
        } else {

            return 0;
        }

    }


    public function save_email($client_id, $email_array){

//        echo "<hr>";
//        echo json_encode($email_array);
//        echo $client_id;
            $this->delete_email_store($client_id);
        if(is_array($email_array)) {
            //$bulk_array = array();

            $counter = 1;
            foreach ($email_array as $value) {

                if (isset($value['firstname']) && isset($value['member_number']) && filter_var($value['email'], FILTER_VALIDATE_EMAIL)) {

                    $this->save_email_store($client_id, $value['firstname'], $value['lastname'],$value['member_number'], $value['point_virtual'], $value['email']);
//                    $send_body['to'] = $value['phone'];
//                    $send_body['body'] = $value['body'];
//                    $bulk_array[] = $send_body;
                    $counter++;
                } else {

                    //return "Variables not set ";
                }


            }

            return $counter;

        } else {

            return "Array Expected";
        }

    }


    private function get_email_data($client_id)
    {

        $limit_array = array(0, 1000);
        $columns = array("id", "first_name", "last_name", "member_no", "current_balance", "email", "client_id");
        $thirdwhere['column_name'] = "client_id";
        $thirdwhere['sign'] = "=";
        $thirdwhere['value'] = $client_id;
        $where[] = $thirdwhere;

        $check_no = $this->select_tb($this->table, $columns, $where,'','','',$limit_array);

//        echo json_encode($check_no);
//        echo "<br>";
        if (is_array($check_no)) {

            return $check_no['data'];
        } else {

            return 0;
        }

    }

    public function delete_email_data($id){

        $thirdwhere['column_name'] ="id";
        $thirdwhere['sign'] = "=";
        $thirdwhere['value'] =$id;
        $where[] = $thirdwhere;

        $get_delete = $this->delete_data($this->table, $where);

        return $get_delete;

    }

    public function send_email_api ($client_id){
        $counter = 1;
        $use_company = new Reward_company();
        $get_company = $use_company->get_company($client_id);

        if(is_array($get_company)) {
            $client_no = $get_company['client_no'];
            $send_array = $this->get_email_data($client_id);
            if (is_array($send_array)) {

                foreach ($send_array as $send_data ) {
                    $use_email = new send_mail_class();
                    $use_email->send_rewardsbox_custom($send_data['first_name'], $send_data['email'], $send_data['last_name'], $send_data['member_no'], $client_no, $send_data['current_balance']);
                    $this->delete_email_data($send_data['id']);
                $counter ++;
                }
                return $counter;
            } else {

                return "No data found";
            }
        } else {

            return "Company not found";
        }
    }
    
    
    public function delete_email_store($client_id){

        $thirdwhere['column_name'] ="client_id";
        $thirdwhere['sign'] = "=";
        $thirdwhere['value'] =$client_id;
        $where[] = $thirdwhere;

        $get_delete = $this->delete_data($this->table, $where);

        return $get_delete;

    }

}