<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 20/12/2018
 * Time: 12:11
 */

require_once ("main_class.php");
require_once ("portal_user_class.php");
class file_upload_class extends Rewardsbox_main
{

    private $table ="rewardsbox_upoad_files";
    private $failed_table = "rewardsbox_upload_failed";
    private $enrol_file_type = 1;
    private $report_path = "../reports/";
    private $logo_path = "../img/company_logo/";



    public function upload_enrol_file($file_type, $file_name){

        $columns = array("file_type","file_name", "status");
        $value = array($file_type, $file_name, 0);
        $thirdwhere['column_name'] = "file_name";
        $thirdwhere['sign'] = "=";
        $thirdwhere['value'] = $file_name;
        $where[] = $thirdwhere;


        $insert_data = $this->insert_check_duplicate($this->table, $columns, $value, $where);

        if ($insert_data > 0) {
            $insert_array['id'] = $insert_data;
            $insert_array['name'] = $file_name;
            $insert_array['file_type'] = $file_type;

            return $insert_array;

        } elseif ($insert_data < 0) {
            return "File name already exists";

        } else {
            return "An error occurred";
        }

    }

    public function upload_file($file, $company_id, $type = 1){
        if (isset($file) && isset($company_id)) {

            $filename = $file['name'];
            $filename0 = basename($filename, ".csv");
            $ext_file = explode('.', $file['name']);
            $file_ext = strtolower(end($ext_file));
            $file_size = $file["size"];

            $extensions = array(
                "csv"
            );
            if (in_array($file_ext, $extensions) === false)
            {
                return "File must be CSV";

            } else {

                //$filecheck = substr($file,0,5);

                    //$response_array['status'] = "working2";
                    if ($file['size'] < (5120000)) {

                        // if file is ok
                        $create_report = 0;
                        if ($type == 1 || $type == 2){

                            $create_report = $this->upload_enrol_file($type, $filename);

                        }

                        if(is_array($create_report)) {


                            if (move_uploaded_file($file["tmp_name"], $this->report_path.$filename)) {
                                return $create_report;
                            }// sucessful
                            else {

                                return "Error moving file to upload location";
                            }// error moving file

                        } else {

                            return "$create_report";
                        }
                    }

                    else {
                        return "File is too large. Must be less than 2 MB";
                    }// file size check


            }// file extension check

        } else {

            return "Missing parameters";
        }



    }

    public function upload_logo($file){
        if (isset($file)) {

            $filename = $file['name'];
            $filename0 = basename($filename, ".csv");
            $ext_file = explode('.', $file['name']);
            $file_ext = strtolower(end($ext_file));
            $file_size = $file["size"];

            $extensions = array(
                "png","jpg"
            );
            if (in_array($file_ext, $extensions) === false)
            {
                return "File must be PNG or JPG";

            } else {

                //$filecheck = substr($file,0,5);

                //$response_array['status'] = "working2";
                if ($file['size'] < (1280000)) {




                        if (move_uploaded_file($file["tmp_name"], $this->logo_path.$filename)) {
                            $s_array['file_name'] = $filename;
                            $s_array['message'] = "Success";
                            return $s_array;
                        }// successful
                        else {

                            return "Error moving file to upload location";
                        }// error moving file


                }

                else {
                    return "File is too large. Must be less than 512 kb";
                }// file size check


            }// file extension check

        } else {

            return "Missing parameters";
        }



    }

    public function get_all_report(){

        $columns = array("file_id","file_type","file_name", "create_date", "status");

        $thirdwhere['column_name'] = "file_type";
        $thirdwhere['sign'] = "=";
        $thirdwhere['value'] = 1;
        $where[] = $thirdwhere;

        $thirdwhere['column_name'] = "file_type";
        $thirdwhere['sign'] = "=";
        $thirdwhere['value'] = 2;
        $where[] = $thirdwhere;

        $get_data = $this->select_tb($this->table, $columns, $where,"OR");

        if (is_array($get_data)){

            return $get_data['data'];
        } else {

            return "No data found";
        }


    }

    public function check_run_file($file_id){
        $column = array("file_name", "file_type");

        $thirdwhere['column_name'] = "status";
        $thirdwhere['sign'] = "=";
        $thirdwhere['value'] = 0;
        $where[] = $thirdwhere;

        $thirdwhere['column_name'] = "file_id";
        $thirdwhere['sign'] = "=";
        $thirdwhere['value'] = $file_id;
        $where[] = $thirdwhere;

        $get_data = $this->select_tb($this->table,$column, $where);

        if(is_array($get_data)){

            return $get_data['data'][0];


        } else {

            return "No file found";
        }

    }

    private function update_run_file($file_id){

        $thirdwhere['column_name'] = "status";
        $thirdwhere['sign'] = "=";
        $thirdwhere['value'] = 0;
        $where[] = $thirdwhere;

        $thirdwhere['column_name'] = "file_id";
        $thirdwhere['sign'] = "=";
        $thirdwhere['value'] = $file_id;
        $where[] = $thirdwhere;

        $firstset['column_name'] = "status";
        $firstset['sign'] = "=";
        $firstset['value'] = 1;
        $set[] = $firstset;

        $update_data = $this->update_data($this->table, $set, $where);

        return $update_data;

    }

    public function convert_csv_json($file_name){

        if (strlen($file_name) >4){

            $csv = file_get_contents($this->report_path.$file_name);
           //print_r($csv);
            //echo $this->report_path.$file_name;
            //echo "<br>";
            $array = array_map("str_getcsv",explode("\n",$csv));
            return $array;


        } else {

            return "Invalid file name";
        }
    }

    public function bulk_file_upload ($company_id, $file_id, $tier = null){

        $check_file= $this->check_run_file($file_id);
        if(is_array($check_file)) {
            $file_name = $check_file['file_name'];
            $file_type = $check_file['file_type'];

            if ($file_type == 1 && $tier == null) {

                return "Tier required";
            } else {
                $this->update_run_file($file_id);

                $run_file = $this->convert_csv_json($file_name);

                if (is_array($run_file)) {
                    $use_portal = new portal_user_class();
                    if ($file_type == 1) {

                        $run_upload = $use_portal->check_array_enrol($company_id, $tier, $run_file);

                        //return $run_upload;
                    } elseif ($file_type == 2) {
                        $run_upload = $use_portal->check_array_transaction($company_id, $file_id, $run_file);
                        //return $run_upload;
                    } else {

                        $run_upload = "Invalid File Type";
                        //return $run_upload;
                    }

                    if(is_array($run_upload)) {
                        if ($run_upload['status'] == 1) {
                            if (!empty($run_upload['data']['failed'])) {

                                $put_data = $this->save_failed_upload($file_id, $run_upload['data']['failed']);

                            }

                        }
                    }

                    return $run_upload;
                } else {

                    return $run_file;
                }

            }
        }else {

                return $check_file;
        }


    }

    private function insert_failed_upload ($file_id, $string_array){

        if (isset($file_id) && isset($string_array)) {
            $columns = array("file_id", "respond_array");
            $values = array($file_id, $string_array);

            $put_data = $this->insert_data($this->failed_table, $columns, $values);

            if ($put_data == 1){
                $d_array['file_id'] = $file_id;
                $d_array['array'] = $string_array;
                return $d_array;
            } else {

                return "Error processing data";
            }
        } else {

            return "Missing parameter";
        }
    }

    private function save_failed_upload ($file_id, $failed_array){

        if (isset($file_id) && isset($failed_array)){

            if (is_array($failed_array)){

                if (empty($failed_array)){

                    return "Array is empty";
                } else {

                    foreach ($failed_array as $f_array){

                        $put_data = $this->insert_failed_upload($file_id, json_encode($f_array));
                    }

                    return "Failed data saved";
                }

            } else {

                return "Invalid Parameter";
            }

        } else {

            return "Missing Parameter";
        }


    }

    public function get_failed_upload ($file_id){

        if (isset($file_id)){

            if (is_numeric($file_id) && $file_id > 0){

                $column = array("respond_array");


                $thirdwhere['column_name'] = "file_id";
                $thirdwhere['sign'] = "=";
                $thirdwhere['value'] = $file_id;
                $where[] = $thirdwhere;

                $get_data = $this->select_tb($this->failed_table,$column, $where);

                if(is_array($get_data)){

                    return $get_data['data'];


                } else {

                    return "No data found";
                }



            } else {

                return "Invalid File";
            }

        } else {

            return "Missing Parameter";
        }


    }
//    public function bulk_enrol ($company_id, $tier, $file_id){
//
//        $check_file= $this->check_run_file($file_id);
//
//        if(is_array($check_file)){
//            $file_name = $check_file['file_name'];
//            $this->update_run_file($file_id);
//
//            $run_file = $this->convert_csv_json($file_name);
//
//            if(is_array($run_file)){
//                $use_portal = new portal_user_class();
//                $run_upload = $use_portal->check_array_enrol($company_id,$tier,$run_file);
//
//                return $run_upload;
//
//            } else {
//
//                return $run_file;
//            }
//
//
//        } else {
//
//            return $check_file;
//        }
//
//
//    }

}


//$page_test = new file_upload_class();
//echo json_encode($page_test->get_failed_upload(3));
//echo json_encode($page_test->insert_failed_upload(1,"abc"));
//echo json_encode($page_test->bulk_file_upload(10,3));
//echo json_encode($page_test->get_all_report());
//echo json_encode($page_test->bulk_enrol(10,1,1));
//echo json_encode($page_test->convert_csv_json("book1.csv"));