<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 07/01/2019
 * Time: 13:44
 */
require_once ("main_class.php");
require_once ("company_class.php");
require_once ("portal_user_class.php");
require_once ("send_mail_class.php");
class job_status_update_class extends Rewardsbox_main
{

    private $table = "rewardsbox_item_status_jobs";


    public function insert_jobs($company_id, $job_type_id,  $status_variable, $process_data, $status){

        $columns = array("company_id","job_type_id","process_status","process_data","status");
        $values =  array($company_id, $job_type_id, $status_variable, json_encode($process_data), $status);

        $insert_data = $this->insert_data($this->table, $columns, $values);

        return $insert_data;


    }


    public function insert_jobs_array($status, $job_array){
        if(is_array($job_array)){
            $result = array();
            foreach ($job_array as $key=> $order){
                $run_data = "";
                    $process_array = $this->adjust_order_array($status, $order);
//                    echo json_encode($process_array);
//                    echo "<br>";
                    if(is_array($process_array)){

                        //$process_array_array[] = $process_array;
//                        echo $key;
//                        echo "<br>";

                        $run_data = $this->insert_jobs($key,1,$status,$process_array,0 );
                    }


                $result [] = $run_data;

            }

            return $result;
        } else {

            return "Invalid array";

        }
    }


    public function insert_jobs_expire_reminder($status, $job_array){
        if(is_array($job_array)){
            $result = array();
            foreach ($job_array as $key=> $order){
                $run_data = "";
                $process_array = $this->adjust_order_array($status, $order);

                if(is_array($process_array)){

                    echo json_encode($process_array);
                    echo "<hr>";

                    foreach ( $process_array['orders'] as $jobs) {
                        $run_data = $this->insert_jobs($key, 3, $process_array['status'], $jobs, 0);

                    }
                }


                $result [] = $run_data;

            }

            return $result;
        } else {

            return "Invalid array";

        }
    }



//    public function insert_wallet_jobs_array($job_array){
//        if(is_array($job_array)){
//            $result = array();
//            $status = 55;
//            foreach ($job_array as $key=> $wallet){
//                $run_data = "";
//                $process_array = $this->adjust_wallet_array($status, $wallet);
////                    echo json_encode($process_array);
////                    echo "<br>";
//                if(is_array($process_array)){
//
//                    //$process_array_array[] = $process_array;
////                        echo $key;
////                        echo "<br>";
//
//                    $run_data = $this->insert_jobs($key,$status,$process_array,0 );
//                }
//
//
//                $result [] = $run_data;
//
//            }
//
//            return $result;
//        } else {
//
//            return "Invalid array";
//
//        }
//    }

    private function adjust_order_array($status, $order_array){

        if(is_array($order_array)){
            $result_array = array();
            $result_array['status'] = $status;
            foreach ($order_array as $key=> $update_array){

                $t_array= $update_array;
                $t_array['order_no'] = $key;

            $result_array['orders'][] = $t_array;
            }


            return $result_array;
        } else{

            return "Invalid array";
        }


    }

//    private function adjust_wallet_array($status, $order_array){
//
//        if(is_array($order_array)){
//            $result_array = array();
//            $result_array['status'] = $status;
//            foreach ($order_array as $key=> $update_array){
//
//                $t_array= $update_array;
//                $t_array['order_no'] = $key;
//
//                $result_array['orders'][] = $t_array;
//            }
//
//
//            return $result_array;
//        } else{
//
//            return "Invalid array";
//        }
//
//
//    }

    public function  update_job_run($job_id, $response){

        $today_date = Date('Y-m-d H:i:s');
        $thirdwhere['column_name'] = "job_id";
        $thirdwhere['sign'] = "=";
        $thirdwhere['value'] = $job_id;
        $where[] = $thirdwhere;

        $firstset['column_name'] = "status";
        $firstset['sign'] = "=";
        $firstset['value'] = 1;
        $set[] = $firstset;

        $firstset['column_name'] = "response";
        $firstset['sign'] = "=";
        $firstset['value'] = $response;
        $set[] = $firstset;

        $firstset['column_name'] = "run_date";
        $firstset['sign'] = "=";
        $firstset['value'] = $today_date;
        $set[] = $firstset;


        $update_data = $this->update_data($this->table, $set,$where);
        return $update_data;

    }


    public function pick_job($limit){
        $columns = array("job_id","job_type_id","company_id","process_status","process_data");
        $limit_array = array(0, $limit);

        $thirdwhere['column_name'] = "status";
        $thirdwhere['sign'] = "=";
        $thirdwhere['value'] = 0;
        $where[] = $thirdwhere;

        $get_data = $this->select_tb($this->table, $columns, $where, "","","",$limit_array);

        if (is_array($get_data)){

            return $get_data['data'];

        } else {

            return "No data found";
        }


    }

    public function process_jobs($job_array){

        echo json_encode($job_array);
        echo "<hr><hr>";
        $use_company = new Reward_company();
        $use_portal  = new portal_user_class();
        $use_wallet = new wallet_service_class();
        foreach ($job_array as $j_array){

            $check_company = $use_company->get_company($j_array['company_id']);

            if(is_array($check_company)){

                if($j_array['job_type_id'] == 1) { // portal notification
                    if ($check_company['portal_access'] == 1) {

                        if ($j_array['process_status'] == 2 || $j_array['process_status'] == 3 || $j_array['process_status'] == 5 || $j_array['process_status'] == 0 || $j_array['process_status'] == 8) {
                            echo $j_array['process_data'];
                            echo "<br>";

                            $array_data = json_decode($j_array['process_data'], true);
                            $body['status'] = $array_data['status'];
                            $body['orders'][0]['vouchers'] = $array_data['orders'][0]['vouchers'];
                            $body['orders'][0]['order_no'] = $array_data['orders'][0]['order_no'];
                            $body['orders'][0]['delivery_cost'] = $array_data['orders'][0]['delivery_cost'];

                            if ($j_array['process_status'] == 0) {
                                $body['orders'][0]['reason'] = $array_data['orders'][0]['reason'];
                            }
                            //$body_array []=$body;
                            echo json_encode($body);
                            echo "<br>";
                            $send_data = $use_portal->change_order_status($body);

                            $response = json_encode($send_data);
                        }
                        else if ($j_array['process_status'] == 10) {
                            echo $j_array['process_data'];
                            echo "<br>";

                            $array_data = json_decode($j_array['process_data'], true);
                            $body['status'] = 2;
                            $body['orders'][0]['vouchers'] = $array_data['orders'][0]['vouchers'];
                            $body['orders'][0]['order_no'] = $array_data['orders'][0]['order_no'];
                            $body['orders'][0]['delivery_cost'] = $array_data['orders'][0]['delivery_cost'];

                            if ($j_array['process_status'] == 0) {
                                $body['orders'][0]['reason'] = $array_data['orders'][0]['reason'];
                            }
                            //$body_array []=$body;
                            echo json_encode($body);
                            echo "<br>";
                            $send_data = $use_portal->confirm_shipped_status($body);

                            //$response = json_encode($send_data);
                            $response = "done";
                        }
                         else if ($j_array['process_status'] == 11) { //bulk cancel
                            echo $j_array['process_data'];
                            echo "<br>";
    
                            $array_data = json_decode($j_array['process_data'], true);
                            $body['status'] = 11;
                            $body['orders'] = $array_data['orders'][0]['vouchers'];
                            $body['order_no'] = $array_data['orders'][0]['order_no'];
                            $body['refund_amount'] = $array_data['orders'][0]['refund_amount'];
    
  
                            echo json_encode($body);
                            echo "<br>";
                            $send_data = $use_portal->bulk_cancel_status($body);
                            echo json_encode($send_data);
                            echo "<hr>";
                            $response = json_encode($send_data);
                            
    
                        }
                        else if ($j_array['process_status'] == 12) { //bulk cancel Pickup
                            echo $j_array['process_data'];
                            echo "<br>";

                            $array_data = json_decode($j_array['process_data'], true);
                            $body['status'] = 12;
                            $body['order_no'] = $array_data['order_no'];
                            $body['pickup'] = $array_data['pickup'];
                            $body['cancel'] = $array_data['cancel'];

                            echo json_encode($body);
                            echo "<br>";
                            $send_data = $use_portal->bulk_cancel_pickup_status($body);

                            $response = json_encode($send_data);
                            

                        }

                    } else {


                        $response = " Not portal user ";
                    }

                } elseif ($j_array['job_type_id'] == 2){ // wallet debit

                    if ($j_array['process_status'] == 50 || $j_array['process_status'] == 55) {
                        // 50 - redemption  55 - cancel redemption

                        $send_data = "No data";
                        if($j_array['process_status'] == 50){

                            $send_data = $use_wallet->wallet_job($check_company['client_no'],json_decode($j_array['process_data'], true));
                        } elseif ($j_array['process_status'] == 55){

                            $send_data = $use_wallet->cancel_transaction($check_company['client_no'], json_decode($j_array['process_data'], true));

                        }
                        $response = json_encode($send_data);

                    }
                    //$response = "wallet cancel";
                } elseif ($j_array['job_type_id'] == 3){ // notifications

                    if ($check_company['portal_access'] == 1) {
                        //2 - evoucher expires 2 days, 7 - evoucher expires 7 days

                        if ($j_array['process_status'] == 2 || $j_array['process_status'] == 7) {


                            echo $j_array['process_data'];
                            echo "<br>";

                            $array_data = json_decode($j_array['process_data'], true);
                            //$body['status'] = $j_array['process_status'];

                            $body_1['vouchers'] = $array_data['vouchers'];
                            $body_1['order_no'] = $array_data['order_no'];

                            $date=date_create($array_data['expiry_date']);


                            $body_1['expiry_date'] = date_format($date,"D, d/m/Y"); ;
                            $body['orders'] = array();
                            $body['orders'][] = $body_1;
                            //$body_array []=$body;
                            echo json_encode($body);
                            echo "<hr>";
                            $send_data = $use_portal->expire_reminder($j_array['process_status'], $body);

                            $response = json_encode($send_data);
                        }
                    } else {

                        $response = "Not portal user";
                    }
                } elseif ($j_array['job_type_id'] == 4){ // Job notifications

                    if ($check_company['portal_access'] == 1) {
                        //30 - 3 days forfeit , 5 - 5 days forfeit, 1 - forfeit notification

                        if ($j_array['process_status'] == 30 || $j_array['process_status'] == 90 || $j_array['process_status'] == 60 || $j_array['process_status'] == 5 || $j_array['process_status'] == 1) {



                            //var_dump($j_array['process_data']);
                            //echo "<br>";
                            $a_data = json_decode($j_array['process_data'], true);
                            $array_data = json_decode($a_data, true);
                            //$body['status'] = $j_array['process_status'];
                            var_dump($array_data);
                            $first_name = $array_data['firstname'];
                            $last_name = $array_data['lastname'];
                            $email = $array_data['email'];
                            $client_no = $check_company['client_no'];
                            $company_name = $check_company['company_name'];
                            $member_no = $array_data['member_number'];
                            $forfeit_date = $array_data['forfeit_date'];
                            $points = $array_data['point_virtual'];

                            //$date=date_create($array_data['forfeit_date']);

                            $use_mail = new send_mail_class();

                            if ($j_array['process_status'] == 30) {
                                $send_data = $use_mail->forfeit_reminder_30days($first_name, $last_name, $email, $forfeit_date, $client_no, $points, $company_name, $member_no);
                            } elseif($j_array['process_status'] == 5){

                                $send_data = $use_mail->forfeit_reminder_5days($first_name, $last_name, $email, $forfeit_date, $client_no, $points, $company_name, $member_no);

                            } elseif ($j_array['process_status'] == 90) {

                                $send_data = $use_mail->forfeit_reminder_90days($first_name, $last_name, $email, $forfeit_date, $client_no, $points, $company_name, $member_no);

                            } elseif ($j_array['process_status'] == 60) {

                                $send_data = $use_mail->forfeit_reminder_60days($first_name, $last_name, $email, $forfeit_date, $client_no, $points, $company_name, $member_no);

                            }elseif ($j_array['process_status'] == 1){
                                $send_data = $use_mail->forfeit_complete($first_name, $last_name, $email, $forfeit_date, $client_no, $points, $company_name, $member_no);


                            }else {

                                $send_data = "Error";
                            }
                            $response = json_encode($send_data);
                            //$response = $send_data;
                        } else {

                            $response = "Not set job";
                        }
                    } else {

                        $response = "Not Portal User";
                    }
                } else {

                    $response= "invalid job";
                }


            } else {

                $response = "Invalid Company";

            }




            $this->update_job_run($j_array['job_id'],$response);

            $t_array['job_id'] = $j_array['job_id'];
            $t_array['message'] = $response;
            $result_array[] = $t_array;
        }

        return $result_array;
    }


    public function pick_process_jobs($limit = 1){

        $get_array = $this->pick_job($limit);

        if(is_array($get_array)){

            $process_data = $this->process_jobs($get_array);
            return $process_data;

        } else {

            return "Invalid array";
        }


    }
}


//$s_array = array();
//
//$b_array = array();
//$c_array = array();
//$c_array[] = "1234";
//$c_array[] = "1235";
//$c_array[] = "1236";
//
//$b_array['123'] = $c_array;
//
//$c_array = array();
//$c_array[] = "2234";
//$c_array[] = "2235";
//$c_array[] = "2236";
//
//$b_array['223'] = $c_array;
//$s_array[2]= $b_array;
//$s_array[10]= $b_array;
//
//echo json_encode($s_array);
//
//$page_test = new job_status_update_class();
//echo json_encode($page_test->pick_process_jobs());
//echo json_encode($page_test->pick_job(5));
//echo json_encode($page_test->update_job_run(1));
//echo json_encode($page_test->insert_jobs_array(2, $s_array));