<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 24/09/2018
 * Time: 15:53
 */
require_once("main_class.php");

class menu_class extends Rewardsbox_main
{


    private $table ="user_mgt_menu";

    public function show_all_menus(){

        $columns = array("menu_id","menu_name", "parent_id", "page_name", "library", "icon", "queue_id", "user_mgt_menu.status");

        $l_join['table_name'] ="usr_mgt_page";
        $l_join['first_column'] ="$this->table.page_id";
        $l_join['second_column'] ="usr_mgt_page.page_id";
        $left_join[] = $l_join;

        $get_menu = $this->select_tb($this->table,$columns,"","","","","","",$left_join);

        if (is_array($get_menu)){

            return $get_menu;
        } else{

            return "No menu found";
        }
    }


    public function show_all_child(){

        $columns = array("menu_id","menu_name", "parent_id", "page_name", "queue_id", "user_mgt_menu.status");

        $l_join['table_name'] ="usr_mgt_page";
        $l_join['first_column'] ="$this->table.page_id";
        $l_join['second_column'] ="usr_mgt_page.page_id";
        $left_join[] = $l_join;

        $third_where['column_name'] ="parent_id";
        $third_where['sign'] =">";
        $third_where['value'] =0;
        $where[] = $third_where;

        $get_menu = $this->select_tb($this->table,$columns,$where,"","","","","",$left_join);

        if (is_array($get_menu)){

            $parent_array = $this->show_all_parent();

            foreach ($get_menu['data'] as $key1=>$menu){

                $key = array_search($menu['parent_id'], array_column($parent_array, 'menu_id'));

                $get_menu['data'][$key1]['parent'] = $parent_array[$key]['menu_name'];
            }

            return $get_menu['data'];
           // return $get_menu['data'];
        } else{

            return "No menu found";
        }
    }

    public function show_parent_child($parent_id){

        $columns = array("menu_id","menu_name", "parent_id", "page_name", "queue_id", "user_mgt_menu.status");

        $l_join['table_name'] ="usr_mgt_page";
        $l_join['first_column'] ="$this->table.page_id";
        $l_join['second_column'] ="usr_mgt_page.page_id";
        $left_join[] = $l_join;

        $third_where['column_name'] ="parent_id";
        $third_where['sign'] ="=";
        $third_where['value'] =$parent_id;
        $where[] = $third_where;

        $get_menu = $this->select_tb($this->table,$columns,$where,"","","","","",$left_join);

        if (is_array($get_menu)){

            $parent_array = $this->show_all_parent();

            foreach ($get_menu['data'] as $key1=>$menu){

                $key = array_search($menu['parent_id'], array_column($parent_array, 'menu_id'));

                $get_menu['data'][$key1]['parent'] = $parent_array[$key]['menu_name'];
            }

            return $get_menu['data'];
            // return $get_menu['data'];
        } else{

            return "No menu found";
        }
    }

    public function show_all_parent(){

        $columns = array("menu_id","menu_name", "parent_id", "page_name", "color","library", "icon", "queue_id", $this->table.".status");

        $l_join['table_name'] ="usr_mgt_page";
        $l_join['first_column'] ="$this->table.page_id";
        $l_join['second_column'] ="usr_mgt_page.page_id";
        $left_join[] = $l_join;

        $third_where['column_name'] ="parent_id";
        $third_where['sign'] ="=";
        $third_where['value'] =0;
        $where[] = $third_where;

        $get_menu = $this->select_tb($this->table,$columns,$where, "","","","","",$left_join);

        if (is_array($get_menu)){

            return $get_menu['data'];
        } else{

            return "No menu found";
        }
    }

    public function show_all_active_menus(){

        $columns = array("menu_id","menu_name", "parent_id", "page_name", "color", "library", "icon", "queue_id", "user_mgt_menu.status");

        $l_join['table_name'] ="usr_mgt_page";
        $l_join['first_column'] ="$this->table.page_id";
        $l_join['second_column'] ="usr_mgt_page.page_id";
        $left_join[] = $l_join;

        $third_where['column_name'] ="user_mgt_menu.status";
        $third_where['sign'] ="=";
        $third_where['value'] =1;
        $where[] = $third_where;

        $order_by = array("queue_id","ASC");

        $get_menu = $this->select_tb($this->table,$columns,$where,"","",$order_by,"","",$left_join);

        if (is_array($get_menu)){

            return $get_menu['data'];
        } else{

            return "No menu found";
        }
    }


    public function show_role_access_menus($role_id){

        $columns = array("menu_id","menu_name", "parent_id", "page_name", "color", "library", "icon", "queue_id", "user_mgt_menu.status");

        $l_join['table_name'] ="usr_mgt_page";
        $l_join['first_column'] ="$this->table.page_id";
        $l_join['second_column'] ="usr_mgt_page.page_id";
        $left_join[] = $l_join;

        $l_join['table_name'] ="user_mgt_permissions";
        $l_join['first_column'] ="$this->table.page_id";
        $l_join['second_column'] ="user_mgt_permissions.page_id";
        $left_join[] = $l_join;

        $third_where['column_name'] ="user_mgt_menu.status";
        $third_where['sign'] ="=";
        $third_where['value'] =1;
        $where[] = $third_where;

        $third_where['column_name'] ="user_mgt_permissions.role_id";
        $third_where['sign'] ="=";
        $third_where['value'] =$role_id;
        $where[] = $third_where;

        $third_where['column_name'] ="user_mgt_permissions.status";
        $third_where['sign'] ="=";
        $third_where['value'] =1;
        $where[] = $third_where;

        $order_by = array("queue_id","ASC");

        $get_menu = $this->select_tb($this->table,$columns,$where,"","",$order_by,"","",$left_join);

        if (is_array($get_menu)){

            return $get_menu['data'];
        } else{

            return "No menu found";
        }
    }

    public function display_all_active_menu (){

        $get_menu =$this->show_all_active_menus();

//        echo json_encode($get_menu);
//        echo "<br>";

        $menu_array = array();

        foreach ($get_menu as $display_menu){

            $menu_array[$display_menu['parent_id']][] = $display_menu;
        }

        $show_menu =$this->loop_array($menu_array);
        return $show_menu;
    }

    public function display_all_user_menu ($role_id){

        if ($role_id == 1){
            $show_menu=$this->display_all_active_menu();

            return $show_menu;
        } else {
            $get_menu = $this->show_role_access_menus($role_id);
            $get_parent = $this->show_all_parent();

//        echo json_encode($get_menu);
//        echo "<br>";

            $menu_array = array();
            $pre_menu_array = $get_menu;
            foreach ($get_menu as $display_menu) {

                if($display_menu['parent_id'] != 0){

                    $key = array_search($display_menu['parent_id'], array_column($get_parent, 'menu_id'));
//                    echo "<br>";
//                    echo $key;
//                    echo "<br>";
//                    echo json_encode($get_parent[$key]);
//                    echo "<br>";
//                    echo "<br>";

                    $parent_menu_id = $get_parent[$key]['menu_id'];
                    $key2 = array_search($parent_menu_id, array_column($pre_menu_array, 'menu_id'));

//                    echo $key2;
//                    echo "<br>";
                    if($key2 == null) {
                        $pre_menu_array[] = $get_parent[$key];
                    }
                }

                //$menu_array[$display_menu['parent_id']][] = $display_menu;
            }

            array_multisort(array_column($pre_menu_array,"queue_id"), SORT_ASC, SORT_NUMERIC, $pre_menu_array);


            foreach ($pre_menu_array as $show_array){

                $menu_array[$show_array['parent_id']][] = $show_array;
            }
            //return $pre_menu_array;
            $show_menu = $this->loop_array($menu_array);
            return $show_menu;
        }
    }



    public function loop_array($array = array(), $parent_id = 0)
    {
        $extension = ".php";
        $nested_array = "";
        $html_code = "";
        if (!empty($array[$parent_id])) {

            if ($parent_id == 0) {

                $html_code .= "<ul class=\"side-menu-list\">";
            } else {

                $html_code .= "<ul>";

            }
            //if (!empty($array[$parent_id])) {

            foreach ($array[$parent_id] as $items) {

                if ($parent_id == 0) {

                    $html_code .= '<li class="' . $items['color'] . ' with-sub">';
                    if ($items['page_name'] != null) {
                        $html_code .= '<a href="' . $items['page_name'] . $extension . '">';
                    }
                    $html_code .= '<span>';
                    $html_code .= '<i class="' . $items['library'] . ' ' . $items['icon'] . '"></i>';
                    $html_code .= '<span class="lbl">' . ucwords($items['menu_name']) . '</span>';
                    $html_code .= '</span>';
                    if ($items['page_name'] != null) {
                        $html_code .= '</a>';
                    }


                } else {
                    $html_code .= '<li>';
                    $html_code .= '<a href="' . $items['page_name'] . $extension . '"><span class="lbl">';
                    $html_code .= ucwords($items['menu_name']);
                    $html_code .= '</span>';
                    $html_code .= '</a>';
                    //$html_code .= '</li>';
                }
                $html_code .= $this->loop_array($array, $items['menu_id']);
                //echo $html_code;
                $html_code .= '</li>';
                $nested_array .= $html_code;
                $html_code = "";
            }

            $nested_array .="</ul>";
        }

        return $nested_array;
    }


    public function show_user_menu($role_id){

        if ($role_id == 1) {
            $show_menu = $this->display_all_active_menu();
            //$show_menu= $this->display_all_user_menu($role_id);
            return $show_menu;
        } else {

            $show_menu= $this->display_all_user_menu($role_id);
            return $show_menu;
        }
    }


    public function get_queue_id(){
        $column = "queue_id";
        $max = $this->select_max($this->table,$column);
//        echo json_encode($max);
        if(is_array($max)){

            $max_val = $max[0]['max'];

            return (int)$max_val + 1;
        } else {

            return "Error getting queue location";
        }


    }
    public function create_parent($name, $color,$library,$icon){

        if (isset($name) && isset($color) && isset($library) && isset($icon)){

            if ($name == "" || $color == "" || $library == "" || $icon == ""){

                return "Blank Parameter";
            } else{
                    $queue_id = $this->get_queue_id();
                    $columns=array("menu_name","parent_id","page_id","color","library","icon","queue_id","status");
                    $values =array($name,0,0,$color,$library,$icon,$queue_id,1);

                $third_where['column_name'] ="menu_name";
                $third_where['sign'] ="=";
                $third_where['value'] =$name;
                $where[] = $third_where;
                $insert_menu =$this->insert_check_duplicate($this->table,$columns,$values,$where);

                if (is_numeric($insert_menu)&& $insert_menu > 0){

                    $insert_array['id'] = $insert_menu;
                    $insert_array['name'] = $name;
                    $insert_array['lib'] = $library;
                    $insert_array['icon'] = $icon;
                    $insert_array['color'] = $color;

                    return $insert_array;
                } elseif ($insert_menu <0) {

                    return "Menu already exists";
                } else {

                    return "Error creating menu";
                }
            }

        } else {

            return "Missing Parameter";
        }

    }


    public function check_parent_id($parent_id){

    $column = array("menu_name","queue_id");

        $third_where['column_name'] ="menu_id";
        $third_where['sign'] ="=";
        $third_where['value'] =$parent_id;
        $where[] = $third_where;

        $third_where['column_name'] ="parent_id";
        $third_where['sign'] ="=";
        $third_where['value'] =0;
        $where[] = $third_where;

        $parent = $this->select_tb($this->table, $column,$where);

        if(is_array($parent)){

            return $parent['data'][0];
        } else {

            return "Invalid Parent";
        }


    }


    public function check_child_id($child_id){

        $column = array("menu_name","queue_id");

        $third_where['column_name'] ="menu_id";
        $third_where['sign'] ="=";
        $third_where['value'] =$child_id;
        $where[] = $third_where;

        $third_where['column_name'] ="parent_id";
        $third_where['sign'] ="!=";
        $third_where['value'] =0;
        $where[] = $third_where;

        $child = $this->select_tb($this->table, $column,$where);

        if(is_array($child)){

            return $child['data'][0];
        } else {

            return "Invalid Child Menu";
        }


    }

    public function create_child($name, $parent_id,$page_id){

        if (isset($name) && isset($parent_id) && isset($page_id) ){

            if ($name == "" || $parent_id == "" || $page_id ==""){

                return "Blank Parameter";
            } else{
                $use_page = new Create_pages();
                $parent = $this->check_parent_id($parent_id);
                $page_name = $use_page->get_page_name($page_id);
                if (is_array($parent)) {
                    $parent_name= $parent['menu_name'];

                    $queue_id = $this->get_queue_id();
                    $columns = array("menu_name", "parent_id", "page_id", "queue_id", "status");
                    $values = array($name, $parent_id, $page_id, $queue_id, 1);

                    $third_where['column_name'] = "menu_name";
                    $third_where['sign'] = "=";
                    $third_where['value'] = $name;
                    $where[] = $third_where;
                    $insert_menu = $this->insert_check_duplicate($this->table, $columns, $values, $where);

                    if (is_numeric($insert_menu) && $insert_menu > 0) {

                        $insert_array['page_id'] = $insert_menu;
                        $insert_array['name'] = $name;
                        $insert_array['parent_menu'] = $parent_name;
                        $insert_array['page_name'] = $page_name;


                        return $insert_array;
                    } elseif ($insert_menu < 0) {

                        return "Menu already exists";
                    } else {

                        return "Error creating menu";
                    }
                } else {

                    return $parent;
                }
            }

        } else {

            return "Missing Parameter";
        }

    }


    public function swap_parent_menu ($parent_id_1, $parent_id_2){

        if($parent_id_1 == $parent_id_2){

         return "Same value selected for swap";

        } else {
            $check_parent_1 = $this->check_parent_id($parent_id_1);

            if (is_array($check_parent_1)) {

                $check_parent_2 = $this->check_parent_id($parent_id_2);

                if (is_array($check_parent_2)) {

                    $this->update_queue($parent_id_1, $check_parent_2['queue_id']);
                    $this->update_queue($parent_id_2, $check_parent_1['queue_id']);

                    return 1;
                } else {

                    return "Invalid Second Parent";
                }

            } else {

                return "Invalid first Parent";
            }
        }

    }


    public function swap_child_menu ($child_id_1, $child_id_2){

        if($child_id_1 == $child_id_2){

            return "Same value selected for swap";

        } else {
            $check_child_1 = $this->check_child_id($child_id_1);

            if (is_array($check_child_1)) {

                $check_child_2 = $this->check_child_id($child_id_2);

                if (is_array($check_child_2)) {

                    $this->update_queue($child_id_1, $check_child_2['queue_id']);
                    $this->update_queue($child_id_2, $check_child_1['queue_id']);

                    return 1;
                } else {

                    return "Invalid Second Child";
                }

            } else {

                return "Invalid first Child";
            }
        }

    }

    public function update_queue($menu_id, $queue_id){

        $p_where['column_name'] = "menu_id";
        $p_where['sign'] = "=";
        $p_where['value'] = $menu_id;
        $where[] = $p_where;

        $ci_set['column_name'] = "queue_id";
        $ci_set['sign'] = "=";
        $ci_set['value'] = $queue_id;

        $set[] = $ci_set;

        $set_data = $this->update_data($this->table, $set, $where);

        return $set_data;




    }
}


//$page_test = new menu_class();
//echo json_encode($page_test->display_all_user_menu(2));
//echo json_encode($page_test->show_user_menu(2));
//echo json_encode($page_test->swap_parent_menu(38,39));
//echo json_encode($page_test->check_child_id(7));
//echo json_encode($page_test->show_all_active_menus());
//echo json_encode($page_test->show_all_child());
//echo json_encode($page_test->show_all_parent());
//echo json_encode($page_test->check_parent_id(5));
//echo json_encode($page_test->display_all_active_menu());
//echo json_encode($page_test->show_role_access_menus(2));