<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 11/10/2018
 * Time: 04:39
 */

require_once ("main_class.php");
require_once ("partner_type_class.php");
require_once ("payment_type_class.php");
require_once ("wallet_service_class.php");
require_once ("rims_class.php");
require_once ("send_mail_class.php");
class partner_class extends Rewardsbox_main
{

    private $table = "rewardsbox_partner";
    private $partner_account = "rewardsbox_partner_account";


    public function get_partner_id($partner_id){

        $column = array("partner_id","partner_no","partner_name", "payment_type", "total_credit","total_debit","current_balance","threshold");
        $p_where['column_name'] ="status";
        $p_where['sign'] ="=";
        $p_where['value'] =1;

        $where[]=$p_where;

        $p_where['column_name'] ="partner_id";
        $p_where['sign'] ="=";
        $p_where['value'] =$partner_id;

        $where[]=$p_where;

        $get_partner =$this->select_tb($this->table,$column,$where);

        if (is_array($get_partner)){

            return $get_partner['data'][0];

        } else {

            return 0;
        }
    }


    public function create_partner ($partner_type, $partner_name, $partner_token, $payment_type){

        if (isset($partner_type) && isset($partner_name) && isset($partner_token) && isset($payment_type)) {

            if ($partner_type == "" || $partner_name == "" || $partner_token == "" || $payment_type == "") {

                return "Blank Parameters";
            } else {
                $use_type = new partner_type_class();
                $type_name_array = $use_type->get_type($partner_type);

                if (is_array($type_name_array)) {

                    $type_name = $type_name_array['type_name'];

                    $use_payment = new payment_type_class();
                    $payment_array = $use_payment->get_type($payment_type);

                    if(is_array($payment_array)) {


                        $payment = $payment_array['name'];
                        $randno = mt_rand(100, 9999);
                        $gen_column = array("details");
                        $gen_values = array("Create partner");
                        $unique_no = $this->insert_data("rewardsbox_gen_no", $gen_column, $gen_values);
                        $partner_no = $unique_no.$randno;

                        $use_rims = new rims_class();
                        $save_rims = $use_rims->create_partner($partner_name);

                        $columns = array("partner_no", "partner_type", "partner_name", "payment_type", "partner_token","rims_partner_id","status");
                        $values = array($partner_no, $partner_type, $partner_name, $payment_type,$partner_token,$save_rims,1);

                        $p_where['column_name'] ="partner_name";
                        $p_where['sign'] ="=";
                        $p_where['value'] =$partner_name;

                        $where[]=$p_where;


                        $insert_data = $this->insert_check_duplicate($this->table, $columns, $values, $where );
                        if (is_numeric($insert_data) && $insert_data > 0) {

                            $use_wallet = new wallet_service_class();
                            $use_wallet->create_partner($partner_no);
                            $insert_array['id'] = $insert_data;
                            $insert_array['partner_no'] = $unique_no.$randno;
                            $insert_array['partner_name'] = $partner_name;
                            $insert_array['partner_type'] = $type_name;
                            $insert_array['payment_type'] = $payment;


                            return $insert_array;
                        } elseif ($insert_data < 0) {

                            return "Partner already exists";
                        } else {

                            return "Error creating partner";
                        }

                    } else {

                        return "Invalid Payment Type";

                    }
                } else {


                    return "Invalid Partner Type";
                }
            }

        } else {

            return "Missing Parameter";
        }


    }


    public function view_partners(){

        $columns = array("partner_id", "partner_no", "rewardsbox_partner_type.type_name","partner_name", "rewardsbox_payment_type.name", $this->table.".status");

        $firstjoin ['table_name']="rewardsbox_partner_type";
        $firstjoin ['first_column']="rewardsbox_partner_type.type_id";
        $firstjoin ['second_column']=$this->table.".partner_type";
        $leftjoin []=$firstjoin;

        $firstjoin ['table_name']="rewardsbox_payment_type";
        $firstjoin ['first_column']="rewardsbox_payment_type.payment_id";
        $firstjoin ['second_column']=$this->table.".payment_type";
        $leftjoin []=$firstjoin;

        $get_data = $this->select_tb($this->table, $columns, "","","","","","",$leftjoin);

        if(is_array($get_data)){

            return $get_data['data'];

        } else {

            return $get_data;
        }

    }


    public function view_prepaid_wallet(){
        $columns = array("partner_id","partner_name","total_credit", "total_debit", "current_balance","threshold");

        $p_where['column_name'] ="status";
        $p_where['sign'] ="=";
        $p_where['value'] =1;
        $where[]=$p_where;

        $p_where['column_name'] ="payment_type";
        $p_where['sign'] ="=";
        $p_where['value'] =1;
        $where[]=$p_where;

        $get_data = $this->select_tb($this->table, $columns, $where);

        if(is_array($get_data)){

            return $get_data['data'];

        } else {

            return $get_data;
        }

    }

    public function view_prepaid_transactions($partner_id = null, $start_date = null, $end_date= null){

        $columns=array("account_id", "partner_name","amount_in", "amount_out", "balance", "tran_type", "remark", $this->partner_account.".create_date");
        $where = null;

        $firstjoin ['table_name']="rewardsbox_partner";
        $firstjoin ['first_column']=$this->table.".partner_id";
        $firstjoin ['second_column']=$this->partner_account.".partner_id";
        $leftjoin []=$firstjoin;


        if($partner_id != null || $partner_id!="") {
            $p_where['column_name'] = $this->partner_account . ".partner_id";
            $p_where['sign'] = "=";
            $p_where['value'] = $partner_id;
            $where[] = $p_where;
        }

        if($start_date != null || $start_date!=""){

            if($end_date != null || $end_date!=""){

                $p_where['column_name'] = $this->partner_account.".create_date";
                $p_where['sign'] = ">=";
                $p_where['value'] = $start_date;
                $where[] = $p_where;

                $p_where['column_name'] = $this->partner_account.".create_date";
                $p_where['sign'] = "<=";
                $p_where['value'] = $end_date;
                $where[] = $p_where;
            }



        }

        $get_data = $this->select_tb($this->partner_account, $columns, $where, "","","","","",$leftjoin);
        if (is_array($get_data)){

            return $get_data['data'];
        } else {

            return "No data found";
        }

    }

    public function total_active_partners(){


        $column = array("partner_id","partner_name");

        $p_where['column_name'] ="status";
        $p_where['sign'] ="=";
        $p_where['value'] =1;
        $where[]=$p_where;
        $get_data = $this->select_tb($this->table, $column,$where);
        return $get_data;
    }

    public function change_partner_status ($partner_id, $new_status){
        $key = "partner_id";
        //$columns = array($key,"status");

        if ($new_status == 1) {

            $msg = "Active";

        } else {
            $new_status = 0;
            $msg= "Inactive";
        }

        $change_status = $this->change_status($partner_id, $new_status,$this->table,$key);
        if ($change_status == 1){
            return 1;

        } elseif ($change_status ==-2) {
            return "Cannot locate Partner";

        } elseif ($change_status ==-1) {
            return "Partner already ".$msg;

        } else {
            return "An error occurred";
        }


    } // end change status

    public function edit_partner_category($partner_id, $partner_name, $partner_type, $payment_type){

        $use_payment = new payment_type_class();
        $get_payment = $use_payment->get_type($payment_type);

        if (is_array($get_payment)) {
            $payment_type_name = $get_payment['name'];
            $use_partner = new partner_type_class();
            $get_partner = $use_partner->get_type($partner_id);

            if (is_array($get_partner)) {
                $key = "partner_id";
                $partner_type_name = $get_partner['type_name'];

                $firstset['column_name'] = "partner_type";
                $firstset['sign'] = "=";
                $firstset['value'] = $partner_type;
                $set[] = $firstset;

                $firstset['column_name'] = "payment_type";
                $firstset['sign'] = "=";
                $firstset['value'] = $payment_type;
                $set[] = $firstset;

                $firstset['column_name'] = "partner_name";
                $firstset['sign'] = "=";
                $firstset['value'] = $partner_name;
                $set[] = $firstset;
                $whereduplicate[] = $firstset;

                $third_where['column_name'] = "partner_id";
                $third_where['sign'] = "=";
                $third_where['value'] = $partner_id;
                $where[] = $third_where;

                $update_data = $this->update_check_duplicate($this->table, $set,$where,$whereduplicate,$key);

                if ($update_data == 1) {

                    $d_array['partner_name'] =$partner_name;
                    $d_array['partner_type'] =$partner_type_name;
                    $d_array['payment_type'] =$payment_type_name;

                    return $d_array;

                } elseif ($update_data ==-1) {
                    return $partner_name." already exists";

                } else {

                    return "Error updating";
                }
            } else {

                return "Invalid Partner Type";
            }
        } else {

            return "Invalid Payment Type";
        }
    }

    public function view_partner_by_type($payment_type)
    {

        $columns = array("partner_id", "partner_name");

        $third_where['column_name'] = "payment_type";
        $third_where['sign'] = "=";
        $third_where['value'] = $payment_type;
        $where[] = $third_where;

        $get_data = $this->select_tb($this->table, $columns,$where);

        if (is_array($get_data)){

            return $get_data['data'];
        } else{

            return "No data found";
        }


    }

    private function insert_partner_transaction ($partner_id, $amount_in, $amount_out, $balance, $tran_type, $description = null){

        $columns = array("partner_id", "amount_in", "amount_out", "balance", "tran_type", "remark");
        $values = array($partner_id, $amount_in, $amount_out, $balance, $tran_type, $description);

        $put_data = $this->insert_data($this->partner_account, $columns, $values);
        if (is_numeric($put_data) && $put_data > 0) {

            return 1;
        } else {

            return "Error saving transaction";
        }
    }

    private function credit_partner_transaction($partner_id, $amount_in, $balance, $remark){

        if(isset($partner_id) && isset($amount_in) && isset($balance) && isset($remark)) {

            if (is_numeric($amount_in) && is_numeric($balance) && $amount_in > 0) {

                $credit_partner = $this->insert_partner_transaction($partner_id, $amount_in, 0, $balance, 1, $remark);

                return $credit_partner;

            } else {

                return "Invalid amount or balance";

            }
        } else {

            return "Missing Parameter";
        }

    }


    private function debit_partner_transaction($partner_id, $amount_out, $balance, $remark){

        if(isset($partner_id) && isset($amount_out) && isset($balance) && isset($remark)) {

            if (is_numeric($amount_out) && is_numeric($balance) && $amount_out > 0) {

                $debit_partner = $this->insert_partner_transaction($partner_id, 0, $amount_out, $balance, 2, $remark);

                return $debit_partner;

            } else {

                return "Invalid amount or balance";

            }
        } else {

            return "Missing Parameter";
        }

    }

    public function credit_partner_wallet($partner_id, $amount, $description){

        if (isset($partner_id) && isset($amount) && isset($description)){
            $this->auto_commit_off();
            $get_partner = $this->get_partner_id($partner_id);

            if (is_array($get_partner)){

                $tran_type = 1; // credit
                $partner_name = $get_partner['partner_name'];
                $present_total_credit = $get_partner['total_credit'];
                $present_balance = $get_partner['current_balance'];

                $payment_type = $get_partner['payment_type'];

                if ($payment_type == 1) {


                    $new_total_credit = (float)$amount + (float)$present_total_credit;
                    $new_balance = (float)$amount + (float)$present_balance;

                    $credit_totals = $this->update_totals($partner_id, $new_total_credit, $new_balance, $tran_type);

                    if ($credit_totals == 1) {

                        $save_tran = $this->credit_partner_transaction($partner_id, $amount, $new_balance, $description);

                        if ($save_tran == 1) {
                            $this->commit_now();
                            $r_array['partner_name'] = $partner_name;
                            $r_array['total_credit'] = $new_total_credit;
                            $r_array['balance'] = $new_balance;

                            $use_mail = new send_mail_class();
                            $use_mail->send_partner_credit($partner_name,$amount, $new_balance);
                            return $r_array;
                        } else {
                            $this->rollback_now();
                            return $save_tran;
                        }

                    } else {
                        $this->rollback_now();
                        return "Update failed";
                    }
                } else {
                    $this->rollback_now();
                    return "Not Prepaid partner";
                }
            } else {
                $this->rollback_now();
                return $get_partner;
            }

        } else{

            return "Missing Parameter";
        }

    }


    public function debit_partner_wallet($partner_id, $amount, $description){

        if (isset($partner_id) && isset($amount) && isset($description)){
            $this->auto_commit_off();
            $get_partner = $this->get_partner_id($partner_id);

            if (is_array($get_partner)){

                $tran_type = 2; // debit
                $partner_name = $get_partner['partner_name'];
                $present_total_debit = $get_partner['total_debit'];
                $present_balance = $get_partner['current_balance'];
                $reminder_limit = $get_partner['threshold'];
                $payment_type = $get_partner['payment_type'];

                if ($payment_type == 1) {

                    $new_total_debit = (float)$amount + (float)$present_total_debit;
                    $new_balance = (float)$present_balance - (float)$amount;

                    $debit_totals = $this->update_totals($partner_id, $new_total_debit, $new_balance, $tran_type);

                    if ($debit_totals == 1) {

                        $save_tran = $this->debit_partner_transaction($partner_id, $amount, $new_balance, $description);

                        if ($save_tran == 1) {
                            $this->commit_now();
                            $r_array['partner_name'] = $partner_name;
                            $r_array['total_debit'] = $new_total_debit;
                            $r_array['balance'] = $new_balance;
                            //$use_mail = new send_mail_class();
                            //$use_mail->send_partner_debit($partner_name,$amount, $new_balance);
//                            if ($reminder_limit !== ""){
//
//                                if(is_numeric($reminder_limit) && $r_array['balance'] < $reminder_limit) {
//                                    $use_mail = new send_mail_class();
//                                    $use_mail->prepaid_partner_limit_reminder($partner_name,$new_balance,$reminder_limit);
//
//                                }
//                            }
                            return $r_array;
                        } else {
                            $this->rollback_now();
                            return $save_tran;
                        }

                    } else {
                        $this->rollback_now();
                        return "Update failed";
                    }
                } else {
                        $this->rollback_now();
                    return "Not Prepaid partner";
                }

            } else {
                $this->rollback_now();
                return $get_partner;
            }

        } else{

            return "Missing Parameter";
        }

    }

    private function update_totals ($partner_id, $total_amount, $current_balance, $tran_type)
    {
        //tran type 1  credit 2 - debit

        $today = date('Y-m-d H:i:s');
        if ($tran_type == 1) {
            $firstset['column_name'] = "total_credit";
            $firstset['sign'] = "=";
            $firstset['value'] = $total_amount;
            $set[] = $firstset;
        } elseif ($tran_type == 2) {
            $firstset['column_name'] = "total_debit";
            $firstset['sign'] = "=";
            $firstset['value'] = $total_amount;
            $set[] = $firstset;
        }

        $firstset['column_name'] = "current_balance";
        $firstset['sign'] = "=";
        $firstset['value'] = $current_balance;
        $set[] = $firstset;

        $firstset['column_name'] = "update_date";
        $firstset['sign'] = "=";
        $firstset['value'] = $today;
        $set[] = $firstset;

        $third_where['column_name'] = "partner_id";
        $third_where['sign'] = "=";
        $third_where['value'] = $partner_id;
        $where[] = $third_where;

        $set_total = $this->update_data($this->table, $set,$where);

        return $set_total;
        // sucessful = 1

    }


    public function prepaid_wallet_reminder(){

        $prepaid_partners = $this->view_prepaid_wallet();

        if (is_array($prepaid_partners)){
                $send_array = array();
            foreach ($prepaid_partners as $partner){

                if ($partner['threshold'] !== ""){

                    if(is_numeric($partner['threshold']) && $partner['current_balance'] < $partner['threshold']) {
                        $use_mail = new send_mail_class();
                        $use_mail->prepaid_partner_limit_reminder($partner['partner_name'],$partner['current_balance'],$partner['threshold']);


                        $send_array[] = $partner['partner_name'];
                    }

                }



            }

            return $send_array;

        } else {

            return "No partner found";
        }

    }

}

//$page_test = new partner_class();
//echo json_encode($page_test->prepaid_wallet_reminder());
//echo json_encode($page_test->create_partner(2,"Uber", "2345", 1));
//echo json_encode($page_test->view_prepaid_transactions(7, "2019-03-16", "2019-03-18"));
//echo json_encode($page_test->view_prepaid_wallet());
//echo json_encode($page_test->debit_partner_wallet(7, 500, "REDEMPTION: Test Item2"));
//echo json_encode($page_test->credit_partner_wallet(7,250,"Bank Transfer"));
//echo json_encode($page_test->view_partner_by_type(2));
//echo json_encode($page_test->edit_partner_category(1,"test",1,1));
//echo json_encode($page_test->create_partner(2,"naira_box", "abcdefghijkl1234", 1));
//echo json_encode($page_test->total_active_partners());
//echo json_encode($page_test->view_partners());
//echo json_encode($page_test->get_partner_id(1));