<?php
require_once("main_class.php");

class Reward_permission extends Rewardsbox_main {


    private $role_table = "user_mgt_roles";
    private $permissions_table = "user_mgt_permissions";
    private $page_table = "usr_mgt_page";

    public function create_permission ($page_id, $role_id, $create = 0,$read=0, $update=0,$delete =0){
        $status =0;
        if ($create != 1){

            $create = 0;
        }

        if ($read != 1){

            $read = 0;
        }

        if ($update != 1){

            $update = 0;
        }

        if ($delete != 1){

            $delete = 0;
        }

        if($role_id == 1){

            $status =1;
            $delete = 1;
            $create = 1;
            $update = 1;
            $read = 1;
        } else {

            $status = 0;
        }

        $p_where['column_name'] ="page_id";
        $p_where['sign'] ="=";
        $p_where['value'] =$page_id;
        $page_where[] = $p_where;

        //$p2_where['column_name'] ="status";
        //$p2_where['sign'] ="=";
        //$p2_where['value'] =1;

        $page_columns = array("page_name");

        $r_where['column_name'] ="role_id";
        $r_where['sign'] ="=";
        $r_where['value'] =$role_id;

        $role_where[] = $r_where;
        //$role_where[] = $p2_where;
        $role_columns = array("role_name");

        //$pc_where['column_name'] ="create";
        //$pc_where['sign'] ="=";
        //$pc_where['value'] =$create;

        //$pr_where['column_name'] ="read";
        //$pr_where['sign'] ="=";
        //$pr_where['value'] =$read;

        //$pu_where['column_name'] ="update";
        //$pu_where['sign'] ="=";
        //$pu_where['value'] =$update;

        //$pd_where['column_name'] ="delete";
        //$pd_where['sign'] ="=";
        //$pd_where['value'] =$delete;

        $permission_where[] =$p_where;
        $permission_where[] =$r_where;
        //$permission_where[] =$pc_where;
        //$permission_where[] =$pr_where;
        //$permission_where[] =$pu_where;
        //$permission_where[] =$pd_where;

        $insert_columns=array("page_id","role_id","create_access","read_access","update_access","delete_access","status");
        $insert_values = array($page_id, $role_id,$create,$read, $update, $delete, $status);

        $page_columns = array("page_name");

        $check_page = $this->select_tb($this->page_table,$page_columns,$page_where);
        if (is_array($check_page)){
            //print_r($check_page);
            //echo "<br>";
            $role_check = $this->select_tb($this->role_table, $role_columns, $role_where);
            if (is_array($role_check)){
               // print_r($role_check);
                //echo "<br>";
                $insert_permissions =$this->insert_check_duplicate($this->permissions_table,$insert_columns, $insert_values, $permission_where, 1);
                return $insert_permissions;
            } else {
                return 0;
            }
        } else {
            return 0;
        }

    }

    public function check_permission($page_id,$role_id){
        $column =array("create_access","read_access","update_access","delete_access");

        $p_where['column_name'] ="page_id";
        $p_where['sign'] ="=";
        $p_where['value'] =$page_id;

        $where[] = $p_where;

        $r_where['column_name'] ="role_id";
        $r_where['sign'] ="=";
        $r_where['value'] =$role_id;

        $where[] = $r_where;

        $check_access = $this->select_tb($this->permissions_table,$column,$where);
            if (is_array($check_access)) {
                return $check_access['data'][0];

            } else {
                return 0;
            }

    }

    public function view_permissions($role_id){

        if(isset($role_id)) {

            $columns = array("perm_id", "menu_name","page_name", "create_access", "read_access", "update_access", "delete_access", $this->permissions_table.".status");


            $firstjoin ['table_name'] = "usr_mgt_page";
            $firstjoin ['first_column'] = "usr_mgt_page.page_id";
            $firstjoin ['second_column'] = $this->permissions_table . ".page_id";
            $leftjoin [] = $firstjoin;

            $firstjoin ['table_name'] = "user_mgt_menu";
            $firstjoin ['first_column'] = "user_mgt_menu.page_id";
            $firstjoin ['second_column'] = "usr_mgt_page.page_id";
            $leftjoin [] = $firstjoin;

            $p_where['column_name'] = "role_id";
            $p_where['sign'] = "=";
            $p_where['value'] = $role_id;

            $where[] = $p_where;

            $get_data = $this->select_tb($this->permissions_table, $columns, $where, "", "", "", "", "", $leftjoin);

            if (is_array($get_data)) {

                return $get_data['data'];

            } else {

                return "No data found";
            }
        } else {

            return "Role required";
        }
    }


    public function change_permission_status ($perm_id, $new_status){
        $key = "perm_id";
        //$columns = array($key,"status");

        if ($new_status == 1) {

            $msg = "Active";

        } else {
            $new_status = 0;
            $msg= "Inactive";
        }

        $change_status = $this->change_status($perm_id, $new_status,$this->permissions_table,$key);
        if ($change_status == 1){
            return "Successfully made ".$msg;

        } elseif ($change_status ==-2) {
            return "Cannot locate permission";

        } elseif ($change_status ==-1) {
            return "Permission already ".$msg;

        } else {
            return "An error occurred";
        }


    } // end change status


    public function change_read_access($perm_id, $new_status){

        $column_name = "read_access";

        $update_data = $this->change_permission_access($perm_id, $new_status, $column_name);

        return $update_data;

    }

    public function change_create_access($perm_id, $new_status){

        $column_name = "create_access";

        $update_data = $this->change_permission_access($perm_id, $new_status, $column_name);

        return $update_data;

    }

    public function change_update_access($perm_id, $new_status){

        $column_name = "update_access";

        $update_data = $this->change_permission_access($perm_id, $new_status, $column_name);

        return $update_data;

    }

    public function change_delete_access($perm_id, $new_status){

        $column_name = "delete_access";

        $update_data = $this->change_permission_access($perm_id, $new_status, $column_name);

        return $update_data;

    }

    private function change_permission_access($perm_id, $new_status, $column_name){

        if ($new_status == 1 || $new_status == 0){

            $columns = array($column_name);


            $thirdwhere['column_name'] ="perm_id";
            $thirdwhere['sign'] ="=";
            $thirdwhere['value'] =$perm_id;
            $where[] = $thirdwhere;

            if ($new_status == 1) {

                $status_msg = " Active";
            } else {
                $new_status = 0;
                $status_msg = " Inactive";
            }

            $check_access = $this->select_tb($this->permissions_table, $columns,$where);

            if (is_array($check_access)){

                $data_status = $check_access['data'][0][$column_name];

                if ($new_status == $data_status) {

                    return "Permission already".$status_msg;
                } else {
                    $firstset['column_name'] =$column_name;
                    $firstset['sign'] ="=";
                    $firstset['value'] =$new_status;
                    $set[] = $firstset;
                    if ($this->update_data($this->permissions_table,$set, $where) == 1){

                        return 1;
                    }
                    else {

                        return "Error updating";
                    }

                }

            } else {


                return "Invalid permission";
            }





        } else {

            return "Invalid status";
        }




    }
} // end class

//$page_test = new Reward_permission();
//echo json_encode($page_test->change_permission_status(3,0));
//echo json_encode($page_test->change_create_access(3,1));
//echo json_encode($page_test->view_permissions(1));
//echo json_encode ($page_test->create_permission(1,1,1,1,0,0));
//echo json_encode ($page_test->check_permission(12,2));