<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 13/02/2020
 * Time: 10:50
 */

require_once ("main_class.php");
require_once ("company_class.php");
require_once ("portal_user_class.php");
require_once ("job_status_update_class.php");
class point_forfiet_class extends Rewardsbox_main
{


    private $table = "rewardsbox_forfiet_setup";


    public function create_forfeit($company_id, $cycle_days, $activate_date){

        $today_date = Date('Y-m-d H:i:s');
        $status = 0;
        $columns = array("program_id","cycle_days","create_date","active_flag", "activate_date");
        $values =  array($company_id, $cycle_days, $today_date, $status, $activate_date);

        $insert_data = $this->insert_data($this->table, $columns, $values);

        return $insert_data;


    }

    public function check_all_forfeit($company_id){

        $column = array("program_id", "activate_date","run_date", "cycle_days","active_flag");

        $m_where['column_name'] ="program_id";
        $m_where['sign'] ="=";
        $m_where['value'] =$company_id;
        $where[] = $m_where;

        $check_forfeit = $this->select_tb($this->table,$column,$where);

        if (is_array($check_forfeit)){

            return $check_forfeit['data'];

        } else {

            return 0;
        }


    }

    public function check_all_active_forfeit(){

        $column = array("program_id", "activate_date","run_date", "cycle_days","active_flag");


        $m_where['column_name'] ="active_flag";
        $m_where['sign'] ="=";
        $m_where['value'] =0;
        $where[] = $m_where;

        $check_forfeit = $this->select_tb($this->table,$column,$where);

        if (is_array($check_forfeit)){

            return $check_forfeit['data'];

        } else {

            return 0;
        }


    }

    public function check_active_forfeit($company_id){

        $column = array("program_id", "activate_date","run_date", "cycle_days","active_flag");

        $m_where['column_name'] ="program_id";
        $m_where['sign'] ="=";
        $m_where['value'] =$company_id;
        $where[] = $m_where;

        $m_where['column_name'] ="active_flag";
        $m_where['sign'] ="=";
        $m_where['value'] =0;
        $where[] = $m_where;

        $check_forfeit = $this->select_tb($this->table,$column,$where);

        if (is_array($check_forfeit)){

            return $check_forfeit['data'][0];

        } else {

            return 0;
        }


    }

    public function create_new_forfeit($company_id, $cycle_days, $start_date){

        if(is_numeric($cycle_days) && $cycle_days > 0) {

            $get_company = new Reward_company();
            $check_company = $get_company->get_company($company_id);

            if (is_array($check_company)) {

                if ($check_company['portal_access'] == 1) {

                    $check_exists = $this->check_company_active_forfeit($company_id);

                    if (is_array($check_exists)) {

                        return "Company already has forfeiture setup";

                    } else {

                        //$activate_date = Date('Y-m-d', strtotime("+" . $cycle_days . "days"));
                        $activate_date = $start_date;
                        $create_forfeit = $this->create_forfeit($company_id, $cycle_days, $activate_date);

                        if ($create_forfeit > 0) {
                            $insert_array['id'] = $create_forfeit;
                            $insert_array['name'] = $check_company['company_name'];
                            $insert_array['no_of_days'] = $cycle_days;
                            $insert_array['activate_date'] = $activate_date;
                            return $insert_array;

                        } else {
                            return "Error creating forfeiture rule";

                        }

                    }

                } else {

                    return "Company does not have Portal Access";
                }

            } else {

                return "Invalid Company ID";
            }

        } else {

            return "Invalid Number of Cycle Days";
        }
    }

    public function check_run_forfeit(){

        $check_active = $this->check_all_active_forfeit();

        if (is_array($check_active)){

            if(count($check_active) > 0) {
                foreach ($check_active as $item) {

                    $check_date = $item['activate_date'];
                    $day_30 = Date('Y-m-d', strtotime("+30 days"));
                    $day_5 = Date('Y-m-d', strtotime("+5 days"));
                    $day_90 = Date('Y-m-d', strtotime("+90 days"));
                    $day_60 = Date('Y-m-d', strtotime("+60 days"));
                    echo $check_date;
                    echo "<br>";
                    $use_portal = new portal_user_class();
                    $use_job = new job_status_update_class();
                    if ($day_30 == $check_date) {
                        $list = $use_portal->get_points_users($item['program_id']);
                        if(is_array($list)){
                            $job_type_id = 4;
                            $process_id = 30;
                            foreach ($list as $value){
                                $value['forfeit_date'] = $check_date;
                                $process_data = json_encode($value);
                                $use_job->insert_jobs($item['program_id'], $job_type_id, $process_id,$process_data,0);

                            }
                        } else {

                            echo "Error <br>";
                        }
                    } elseif ($day_90 == $check_date) {

                        $list = $use_portal->get_points_users($item['program_id']);
                        if(is_array($list)){
                            $job_type_id = 4;
                            $process_id = 90;
                            foreach ($list as $value){
                                $value['forfeit_date'] = $check_date;
                                $process_data = json_encode($value);
                                $use_job->insert_jobs($item['program_id'], $job_type_id, $process_id,$process_data,0);

                            }
                        } else {

                            echo "Error <br>";
                        }
                    } elseif ($day_60 == $check_date) {

                        $list = $use_portal->get_points_users($item['program_id']);
                        if(is_array($list)){
                            $job_type_id = 4;
                            $process_id = 60;
                            foreach ($list as $value){
                                $value['forfeit_date'] = $check_date;
                                $process_data = json_encode($value);
                                $use_job->insert_jobs($item['program_id'], $job_type_id, $process_id,$process_data,0);

                            }
                        } else {

                            echo "Error <br>";
                        }
                    } elseif ($day_5 == $check_date) {

                        $list = $use_portal->get_points_users($item['program_id']);
                        if(is_array($list)){
                            $job_type_id = 4;
                            $process_id = 5;
                            foreach ($list as $value){
                                $value['forfeit_date'] = $check_date;
                                $process_data = json_encode($value);
                                $use_job->insert_jobs($item['program_id'], $job_type_id, $process_id,$process_data,0);

                            }
                        } else {

                            echo "Error <br>";
                        }

                    } else {

                        echo "30:".$day_30 . "  5:" . $day_5 . "  60:".$day_60 . "  90:".$day_90;
                    }

                    echo "<hr>";

                }
                return "Check Completed";
            } else {

                return "No active Forfeit Found";
            }
        } else {

            return $check_active;
        }


    }
    
        public function check_company_active_forfeit($company_id){

        $column = array("program_id", "activate_date","run_date", "cycle_days","active_flag");

        $m_where['column_name'] ="program_id";
        $m_where['sign'] ="=";
        $m_where['value'] =$company_id;
        $where[] = $m_where;

        $m_where['column_name'] ="active_flag";
        $m_where['sign'] ="=";
        $m_where['value'] =0;
        $where[] = $m_where;

        $check_forfeit = $this->select_tb($this->table,$column,$where);

        if (is_array($check_forfeit)){

            return $check_forfeit['data'];

        } else {

            return 0;
        }


    }
    
    public function deactivate_run_forfeit ($company_id, $status, $run_date){

        $p_where['column_name'] = "program_id";
        $p_where['sign'] = "=";
        $p_where['value'] = $company_id;
        $where[] = $p_where;

        $first_set['column_name'] = "active_flag";
        $first_set['sign'] = "=";
        $first_set['value'] = 1;
        $set[] = $first_set;

        $first_set['column_name'] = "run_date";
        $first_set['sign'] = "=";
        $first_set['value'] = $run_date;
        $set[] = $first_set;

        $update_data = $this->update_data($this->table, $set, $where);

        if ($update_data == 1) {

            return $update_data;


        } else {

            return "Error updating forfeit";
        }

    }
    
    
    public function check_expired_forfeit(){

        $check_expired = $this->check_expired_forfeit_model();
        $response_array = array();
        if (is_array($check_expired)) {

            if (count($check_expired) > 0) {
                foreach ($check_expired as $item) {

                    $program_id = $item['program_id'];
                    $run_date = date('Y-m-d H:i:s');
                    $cycle_days = $item['cycle_days'];

                    $update_cycle = $this->deactivate_run_forfeit($program_id, 1, $run_date);

                    if ($update_cycle == 1){


                        if($cycle_days > 0){

                            $new_active_date =  Date('Y-m-d', strtotime("+".$cycle_days." days"));

                            $this->create_new_forfeit($program_id,$cycle_days,$new_active_date);
                        }

                        $use_portal = new portal_user_class();
                        $use_job = new job_status_update_class();
                        $list = $use_portal->forfeit_users_points($program_id);
                        if(is_array($list)) {
                            $job_type_id = 4;
                            $process_id = 1;
                            foreach ($list as $value) {

                                $check_member = $value['member_id'];
                                $points_amount = $value['point_raw'];
                                $use_portal->check_run_rb_forfeit($program_id, $check_member,$points_amount);

                                $value['forfeit_date'] = $run_date;
                                $process_data = json_encode($value);
                                $use_job->insert_jobs($item['program_id'], $job_type_id, $process_id,$process_data,0);
                            }
                        } else {

                            $response_array['error'][] = $program_id;
                        }
                        $response_array['success'][] = $program_id;
                    } else {

                        $response_array['error'] [] = $program_id;
                    }

                }

                return $response_array;
            } else {

                return "No expired program";
            }
        } else {

            return "No data found to expire";
        }
    }

    public function check_expired_forfeit_model(){

        $column = array("program_id", "activate_date","run_date", "cycle_days","active_flag");

        $m_where['column_name'] ="activate_date";
        $m_where['sign'] ="<";
        $m_where['value'] ="CURDATE()";
        $where[] = $m_where;

        $m_where['column_name'] ="active_flag";
        $m_where['sign'] ="=";
        $m_where['value'] =0;
        $where[] = $m_where;

        $check_forfeit = $this->select_tb($this->table,$column,$where);

        if (is_array($check_forfeit)){

            return $check_forfeit['data'];

        } else {

            return 0;
        }


    }
}


//$page_test = new point_forfiet_class();
//echo json_encode($page_test->create_new_forfeit(10, 366, '2020-03-28'));
//echo json_encode($page_test->check_all_active_forfeit());
//echo json_encode($page_test->check_run_forfeit());