<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 12/10/2018
 * Time: 19:45
 */

require_once("curl_class.php");
require_once ("main_class.php");
require_once ("company_class.php");
require_once ("tier_class.php");
require_once ("service_access_class.php");
require_once ("send_mail_class.php");
require_once ("report_class.php");
require_once ("company_user_class.php");
require_once ("sms_class.php");
require_once ("custom_email_class.php");
require_once ("email_custom_class.php");
class portal_user_class extends Rewardsbox_main
{

    private $table = "portal_users";
    private $details_table = "portal_user_details";
    private $account_table = "rewardsbox_portal_user_account";
    private $check_tran_table = "rewardbox_portal_trans_file_check";
    private $com_user_table = "user_mgt_com_users";
    //private $url ='http://rewardsboxnigeria.com/customer_portal/public/api/';
    private $url ='https://portal.perxclm.com/v1/public/';
    //private $url ='https://portal.perxclm.com/v1/public/';
    private $header;
    private $token = 9000;
    private $service_id = 2;


    public function confirm_member_no($company_id,$member_no){

        $columns =array("portal_id","max_show","portal_user_id");
        $thirdwhere['column_name'] =$this->table.".company_id";
        $thirdwhere['sign'] ="=";
        $thirdwhere['value'] =$company_id;
        $where[] = $thirdwhere;

        $thirdwhere['column_name'] ="member_no";
        $thirdwhere['sign'] ="=";
        $thirdwhere['value'] =$member_no;
        $where[] = $thirdwhere;

        $firstjoin ['table_name'] = "portal_user_tiers";
        $firstjoin ['first_column'] = "portal_user_tiers.tier_id";
        $firstjoin ['second_column'] = $this->table . ".tier_id";
        $leftjoin [] = $firstjoin;

        $check_no =  $this->select_tb($this->table,$columns, $where, "","","","","",$leftjoin);

        if (is_array($check_no)){

            return $check_no['data'][0];
        } else {

            return 0;
        }

    }

    public function view_company_portal($company_id){

        $columns =array("portal_user_id", "member_no");
        $thirdwhere['column_name'] ="company_id";
        $thirdwhere['sign'] ="=";
        $thirdwhere['value'] =$company_id;
        $where[] = $thirdwhere;



        $check_no =  $this->select_tb($this->table,$columns, $where);

        if (is_array($check_no)){

            return $check_no;
        } else {

            return 0;
        }

    }


    private function set_header(){

        //$header = array('content-type: multipart/form-data','token: ' . $this->master_token);
        return $this->header = array("token: " .$this->token,"content-type: application/json", "cache-control: no-cache");
    }


    public function create_file_user($first_name, $last_name, $email, $password, $member_no, $company_id, $tier_id, $phone = null, $points){

        if(isset($company_id) && isset($member_no) && isset($first_name) && isset($last_name) && isset($email) && isset($password) && isset($tier_id) && isset($points)){

            if($company_id == ""|| $member_no == "" || $first_name == "" || $last_name == "" || $email == "" || $password == "" || $tier_id == "" || $points == "") {

                return "Blank Parameter";

            } elseif (!filter_var($email, FILTER_VALIDATE_EMAIL)){

                return "Invalid Email";
            } elseif (strlen($password) < 6){


                return "Password has minimum of 6 characters";
            
            } else {
                
                $first_name = trim($first_name);
                $last_name = trim ($last_name);
                $email = trim($email);
                $password = trim($password);
                $member_no = $string = str_replace(' ', '', $member_no);
                $member_no = preg_replace('/[^A-Za-z0-9\-]/', '', $member_no);
                //$member_no = trim($member_no);
                $use_company = new Reward_company();
                $check_company = $use_company->get_company($company_id);

                if (is_array($check_company)) {
                    $use_report= new report_class();
                    $client_no = $check_company['client_no'];
                    $company_name = $check_company['company_name'];


                    $check_balance = $use_report->get_total_debit($company_id);
                    if(is_array($check_balance)) {


                        $current_balance = $check_balance[0]['current_balance'];


                        if ($check_balance[0]['payment_type'] == 1 && $current_balance < $points && $points > 0) {

                            return "Insufficient funds";

                        } else {
                            $send_data = $this->send_member($first_name, $last_name, $email, $password, $password, $client_no, $points, $member_no, $phone);
                            //print_r($send_data);
                            if (is_array($send_data)) {

                                if ($send_data['status'] == 200) {
                                    $d_array ['first_name'] = $send_data['data']['firstname'];
                                    $d_array['last_name'] = $send_data['data']['lastname'];
                                    $d_array ['email'] = $send_data['data']['email'];
                                    $d_array['member_no'] = $send_data['data']['member_number'];
                                    $d_array ['address'] = "";
                                    $d_array['user_id'] = $send_data['data']['member_id'];
                                    $d_array ['points_raw'] = $send_data['data']['balance_raw'];
                                    $d_array['points_virtual'] = $send_data['data']['balance_virtual'];
                                    $d_array['phone'] = $phone;

                                    if(isset($send_data['data']['pin'])){

                                        $pin = $send_data['data']['pin'];
                                    } else {

                                        $pin = "";
                                    }

                                    $user_id = $d_array['user_id'];
                                    $save_user = $this->save_portal_user($first_name, $last_name, $email, $member_no, $company_id, $tier_id, $user_id);
                                    if (is_array($save_user)) {
                                        if($points > 0){
                                        $use_report->set_debit($company_id, $points, 1, 'Enrolment', $save_user['id'], 1);
                                        }
                                    }

                                    $use_report->update_customers($company_id, 1);
                                    $use_send_mail = new send_mail_class();
                                    $use_send_mail->send_portal_enrol($d_array ['first_name'], $d_array ['email'], $password, $d_array ['points_virtual'], $client_no, $member_no, $pin);
                                    //print_r($save_user);
                                    return $d_array;

                                } else {

                                    return $send_data['data'];
                                }

                            } else {


                                return "Error sending data";
                            }
                        }
                    } else {


                        return $check_balance;
                    }
                } else {

                    return "Invalid Company";

                }
            }


        } else {

            return "Missing Parameter";
        }

    }

    public function create_portal_user($first_name, $last_name, $email, $password, $member_no, $company_id, $tier_id, $phone = null){

        if(isset($company_id) && isset($member_no) && isset($first_name) && isset($last_name) && isset($email) && isset($password) && isset($tier_id)){


            if($company_id == ""|| $member_no == "" || $first_name == "" || $last_name == "" || $email == "" || $password == "" || $tier_id == "") {

                return "Blank Parameter";
            } elseif (!filter_var($email, FILTER_VALIDATE_EMAIL)){

                return "Invalid Email";
            } elseif (strlen($password) < 6){


                return "Password has minimum of 6 characters";
            } else{

                $first_name = trim($first_name);
                $last_name = trim ($last_name);
                $email = trim($email);
                $password = trim($password);
                $member_no = trim($member_no);
                $use_company = new Reward_company();
                $check_company = $use_company->get_company_others($company_id);

                if (is_array($check_company)){
                    if(isset($check_company['enrol_no_limit'])) {
                        if($check_company['enrol_no_limit'] == 0  || (int)$check_company['total_customers'] < (int)$check_company['enrol_no_limit']) {
                            $client_no = $check_company['client_no'];
                            $company_name = $check_company['company_name'];

                            $use_tier = new tier_class();

                            $check_tier = $use_tier->get_tier_name($tier_id);

                            if (is_array($check_tier)) {

                                if ($check_tier['status'] == 1) {

                                    $points = $check_tier['credit_amount'];

                                    $use_report = new report_class();
                                    $check_balance = $use_report->get_total_debit($company_id);
                                    if (is_array($check_balance)) {


                                        $current_balance = $check_balance[0]['current_balance'];


                                        if ($check_balance[0]['payment_type'] == 1 && $current_balance < $points && $points > 0) {

                                            return "Insufficient funds";

                                        } else {


                                            $send_data = $this->send_member($first_name, $last_name, $email, $password, $password, $client_no, $points, $member_no, $phone);
                                            //print_r($send_data);
                                            if (is_array($send_data)) {

                                                if ($send_data['status'] == 200) {
                                                    $d_array ['first_name'] = $send_data['data']['firstname'];
                                                    $d_array['last_name'] = $send_data['data']['lastname'];
                                                    $d_array ['email'] = $send_data['data']['email'];
                                                    $d_array['member_no'] = $send_data['data']['member_number'];
                                                    $d_array ['address'] = "";
                                                    $d_array['user_id'] = $send_data['data']['member_id'];
                                                    $d_array ['points_raw'] = $send_data['data']['balance_raw'];
                                                    $d_array['points_virtual'] = $send_data['data']['balance_virtual'];
                                                    $d_array['phone'] = $phone;

                                                    if(isset($send_data['data']['pin'])){

                                                        $pin = $send_data['data']['pin'];
                                                    } else {

                                                        $pin = "";
                                                    }

                                                    $user_id = $d_array['user_id'];
                                                    $save_user = $this->save_portal_user($first_name, $last_name, $email, $member_no, $company_id, $tier_id, $user_id);

//                                                    echo json_encode($save_user);
//                                                    echo "<hr>";
                                                    if (is_array($save_user)) {

                                                        $use_report->set_debit($company_id, $points, 1, 'Enrolment', $save_user['id'], 1);
                                                    }
                                                    //$use_report= new report_class();
//                                            $this->rb_credit_user($save_user['id'],$points);
                                                    $use_report->update_customers($company_id, 1);
                                                    $use_send_mail = new send_mail_class();
                                                    $use_send_mail->send_portal_enrol($d_array ['first_name'], $d_array ['email'], $password, $d_array ['points_virtual'], $client_no, $d_array['member_no'],$pin);
                                                    //print_r($save_user);
                                                    return $d_array;

                                                } else {

                                                    return $send_data['data'];
                                                }

                                            } else {


                                                return "Error sending data";
                                            }
                                        }
                                    } else {

                                        return $check_balance;
                                    }
                                } else {

                                    return "Tier Inactive";
                                }
                            } else {


                                return "Invalid tier";
                            }
                        } else {

                            return "Maximum enrolment exceeded ".$check_company['enrol_no_limit'];
                        }
                    } else {

                        return "Enrolment limit Not set";
                    }
                } else {


                    return "Invalid Company";
                }





            }


        } else {

            return "Missing Parameter";

        }


    }


    public function send_company ($client_name , $client_no, $token){
        $this->set_header();
        $api = "company/create";

        $body['name']= $client_name;
        $body['client_number']= $client_no;
        $body['token'] = $token;

        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);

        if(is_array($send_data)){

            return $send_data;
        } else {


            return "Registration failed";
        }



    }


    public function save_company($client_name, $client_no, $company_id, $token){

        $send_data = $this->send_company($client_name, $client_no, $token);
        $use_service_access = new service_access_class();
        if (is_array($send_data)){

            if($send_data['status'] == 200){
                $store_access = $use_service_access->register_access($company_id,$this->service_id,$send_data['status'],"success",1);
                return 1;

            } else {
                $store_access = $use_service_access->register_access($company_id,$this->service_id,$send_data['status'],$send_data['message'],0);
                return $send_data['data'];
            }

        } else {

            return $send_data;
        }


    }

    private function save_portal_user($first_name, $last_name, $email, $member_no, $company_id, $tier_id, $user_id ){

        $columns = array("company_id", "member_no", "first_name", "last_name","email", "tier_id", "portal_id","status");
        $values = array($company_id, $member_no, $first_name, $last_name, $email, $tier_id, $user_id,1);

        $thirdwhere['column_name'] = "member_no";
        $thirdwhere['sign'] = "=";
        $thirdwhere['value'] = $member_no;
        $where[] = $thirdwhere;

        $thirdwhere['column_name'] = "company_id";
        $thirdwhere['sign'] = "=";
        $thirdwhere['value'] = $company_id;
        $where[] = $thirdwhere;


        $insert_data = $this->insert_check_duplicate($this->table, $columns, $values, $where, 1);

        if ($insert_data > 0) {
            $insert_array['id'] = $insert_data;
            $insert_array['first_name'] = $first_name;
            $insert_array['last_name'] = $last_name;
            $insert_array['member_no'] = $member_no;
            $insert_array['email'] = $email;
            $insert_array['status'] = 1;

            return $insert_array;

        } elseif ($insert_data < 0) {
            return "Member no already exists";

        } else {
            return "An error occurred";
        }



    }

    public function rb_credit_user($member_id, $amount, $remark ="Company Credit"){

        $this->auto_commit_off();

        $get_totals = $this->get_rb_member_totals($member_id);

        if (is_array($get_totals)){

            $new_balance = (float)$amount + (float)$get_totals['current_balance'];
            $total_credit = (float)$amount + (float)$get_totals['total_credit'];


            $set_data = $this->update_rb_member_totals($member_id,$new_balance, $total_credit, $amount, 1,$remark);

            if (is_array($set_data)){

                $this->commit_now();
                return $set_data;
            } else {
                $this->rollback_now();
                return $set_data;
            }


        } else {
            $this->rollback_now();
            return "User not found";
        }




    }

    public function rb_cancel_user_tran($member_id, $amount, $order_id, $product_name, $quantity){

        $this->auto_commit_off();
        $get_totals = $this->get_rb_member_totals($member_id);

        if (is_array($get_totals)){

            $company_id = $get_totals['company_id'];
            $new_balance = (float)$amount + (float)$get_totals['current_balance'];
            $total_credit = (float)$amount + (float)$get_totals['total_cancel'];

            $remark ="Refund: Cancellation of ".$product_name;
            $set_data = $this->update_rb_member_totals($member_id,$new_balance, $total_credit, $amount, 3,$remark, $order_id);

            if (is_array($set_data)){
                $use_report = new report_class();
                $set_report = $use_report->set_cancelled($company_id,$amount,$quantity);

                if ($set_report == 1) {
                    $this->commit_now();
                    return $set_data;
                } else {
                    $this->rollback_now();
                    return $set_report;

                }
            } else {
                $this->rollback_now();
                return $set_data;
            }


        } else {
            $this->rollback_now();
            return "User not found";
        }




    }

    public function rb_expire_user_tran($member_id, $amount, $order_id, $product_name, $quantity){

        $this->auto_commit_off();
        $get_totals = $this->get_rb_member_totals($member_id);

        if (is_array($get_totals)){

            $company_id = $get_totals['company_id'];
            $new_balance = (float)$amount + (float)$get_totals['current_balance'];
            $total_credit = (float)$amount + (float)$get_totals['total_expire'];

            $remark ="Refund: Expired item ".$product_name." (".$quantity.")";
            $set_data = $this->update_rb_member_totals($member_id,$new_balance, $total_credit, $amount, 5,$remark, $order_id);

            if (is_array($set_data)){

                $use_report = new report_class();

                $set_report = $use_report->set_expired($company_id,$amount,$quantity);

                if ($set_report == 1) {
                    $this->commit_now();
                    return $set_data;
                } else {
                    $this->rollback_now();
                    return $set_report;
                }
            } else {
                $this->rollback_now();
                return $set_data;
            }


        } else {
            $this->rollback_now();
            return "User not found";
        }




    }

    public function rb_failed_user_tran($member_id, $amount, $order_id, $product_name, $quantity){

        $this->auto_commit_off();
        $get_totals = $this->get_rb_member_totals($member_id);

        if (is_array($get_totals)){

            $company_id = $get_totals['company_id'];
            $new_balance = (float)$amount + (float)$get_totals['current_balance'];
            $total_credit = (float)$amount + (float)$get_totals['total_failed'];

            $remark ="Refund: Failed item ".$product_name." (".$quantity.")";
            $set_data = $this->update_rb_member_totals($member_id,$new_balance, $total_credit, $amount, 6,$remark, $order_id);

            if (is_array($set_data)){

                $use_report = new report_class();

                $set_report = $use_report->set_failed($company_id,$amount,$quantity);

                if ($set_report == 1) {
                    $this->commit_now();
                    return $set_data;
                } else {
                    $this->rollback_now();
                    return $set_report;
                }
            } else {
                $this->rollback_now();
                return $set_data;
            }


        } else {
            $this->rollback_now();
            return "User not found";
        }




    }

    public function rb_redeem_user_tran($member_id, $amount, $order_no, $item_count){

        $this->auto_commit_off();
        $get_totals = $this->get_rb_member_totals($member_id);

        if (is_array($get_totals)){

            $new_balance = (float)$get_totals['current_balance'] - (float)$amount;
            $total_debit = (float)$amount + (float)$get_totals['total_redeem'];
            $company_id = $get_totals['company_id'];

            $remark ="Redemption: Order no ".$order_no;

            if($new_balance >= 0) {
                $set_data = $this->update_rb_member_totals($member_id, $new_balance, $total_debit, $amount, 2, $remark);

                if (is_array($set_data)) {

                    $use_report = new report_class();
                    $set_report = $use_report->set_redemption($company_id,$amount, $item_count);
                    if(is_array($set_report)) {
                        $this->commit_now();
                        $s_array['balance'] = $new_balance;
                        $s_array['amount_debited'] = $amount;
                        return $s_array;
                    } else {
                        $this->rollback_now();
                        return $set_report;

                    }
                } else {
                    $this->rollback_now();
                    return $set_data;
                }
            } else {

                return "Insufficient balance to complete transaction";
            }

        } else {
            $this->rollback_now();
            return "User not found";
        }




    }


    public function rb_manual_debit_user($member_id, $amount, $reason){

        $this->auto_commit_off();
        $get_totals = $this->get_rb_member_totals($member_id);

        if (is_array($get_totals)){

            $new_balance = (float)$get_totals['current_balance'] - (float)$amount;
            $total_debit = (float)$amount + (float)$get_totals['total_redeem'];
            $company_id = $get_totals['company_id'];

            $remark ="Manual Debit: ".$reason;

            if($new_balance > 0) {
                $set_data = $this->update_rb_member_totals($member_id, $new_balance, $total_debit, $amount, 5, $remark);

                if (is_array($set_data)) {

                    $use_report = new report_class();
                    $check_company = $use_report->set_debit_reversal($company_id,$amount, $member_id);
                    if ($check_company == 1) {
                        $this->commit_now();
                        return $set_data;
                    } else {
                        $this->rollback_now();
                        return $check_company;
                    }
                } else {
                    $this->rollback_now();
                    return $set_data;
                }
            } else {
                $this->rollback_now();
                return "Insufficient balance to complete transaction";
            }

        } else {
            $this->rollback_now();
            return "User not found";
        }




    }


    public function update_rb_member_totals($member_id, $balance, $total_amount, $amount,  $type, $remark = null, $order_id = null){
        //type:  1- credit 2- redeem 3- cancel 4 - expire 5 - manual debit 6- failed

        if (isset($member_id) && isset($balance) && isset($total_amount) && isset($type)){

            if (is_numeric($balance) && is_numeric($total_amount)) {

                if ($balance > 0 || $total_amount > 0) {
                    if ($type == 1 || $type == 2 || $type == 3 || $type == 4 || $type == 5 || $type == 6 || $type == 7) {
                        $tran_id =0;
                        if ($type == 3){
                            //"total_credit","total_redeem","total_cancel", "total_expire","total_manual_debit"
                            $first_set['column_name'] = "total_cancel";
                            $first_set['sign'] = "=";
                            $first_set['value'] = $total_amount;
                            $set[] = $first_set;

                            $set_tran =$this->credit_user_transactions($member_id,$type, $amount, $balance, $remark);
                            if (is_numeric($set_tran) && $set_tran > 0 ){

                                $tran_id = $set_tran;
                            } else {

                                $tran_id =0;
                            }
                        } elseif ($type == 1){

                            $first_set['column_name'] = "total_credit";
                            $first_set['sign'] = "=";
                            $first_set['value'] = $total_amount;
                            $set[] = $first_set;

                            $set_tran = $this->credit_user_transactions($member_id,$type, $amount, $balance, $remark);
                            if (is_numeric($set_tran) && $set_tran > 0 ){

                                $tran_id = $set_tran;
                            } else {

                                $tran_id =0;
                            }
                        } elseif ($type == 2){

                            $first_set['column_name'] = "total_redeem";
                            $first_set['sign'] = "=";
                            $first_set['value'] = $total_amount;
                            $set[] = $first_set;

                            $set_tran=$this->debit_user_transactions($member_id,$amount,$balance,$type,$remark,$order_id);

                            if (is_numeric($set_tran) && $set_tran > 0 ){

                                $tran_id = $set_tran;
                            } else {

                                $tran_id =0;
                            }

                        } elseif ($type == 4){

                            $first_set['column_name'] = "total_expire";
                            $first_set['sign'] = "=";
                            $first_set['value'] = $total_amount;
                            $set[] = $first_set;

                            $set_tran=$this->credit_user_transactions($member_id,$type, $amount, $balance, $remark);
                            if (is_numeric($set_tran) && $set_tran > 0 ){

                                $tran_id = $set_tran;
                            } else {

                                $tran_id =0;
                            }
                        } elseif ($type == 6){

                            $first_set['column_name'] = "total_failed";
                            $first_set['sign'] = "=";
                            $first_set['value'] = $total_amount;
                            $set[] = $first_set;

                            $set_tran=$this->credit_user_transactions($member_id,$type, $amount, $balance, $remark);
                            if (is_numeric($set_tran) && $set_tran > 0 ){

                                $tran_id = $set_tran;
                            } else {

                                $tran_id =0;
                            }

                        } elseif ($type == 5){

                            $first_set['column_name'] = "total_manual_debit";
                            $first_set['sign'] = "=";
                            $first_set['value'] = $total_amount;
                            $set[] = $first_set;

                            $set_tran=$this->debit_user_transactions($member_id,$amount,$balance,$type,$remark,$order_id);
                            if (is_numeric($set_tran) && $set_tran > 0 ){

                                $tran_id = $set_tran;
                            } else {

                                $tran_id =0;
                            }
                        } elseif ($type == 7){

                            $first_set['column_name'] = "total_forfeit";
                            $first_set['sign'] = "=";
                            $first_set['value'] = $total_amount;
                            $set[] = $first_set;

                            $set_tran=$this->debit_user_transactions($member_id,$amount,$balance,$type,$remark,$order_id);
                            if (is_numeric($set_tran) && $set_tran > 0 ){

                                $tran_id = $set_tran;
                            } else {

                                $tran_id =0;
                            }
                        }

                        $first_set['column_name'] = "current_balance";
                        $first_set['sign'] = "=";
                        $first_set['value'] = $balance;
                        $set[] = $first_set;

                        $ci_where['column_name'] = "portal_user_id";
                        $ci_where['sign'] = "=";
                        $ci_where['value'] = $member_id;

                        $where[] = $ci_where;

                        $set_data = $this->update_data($this->table, $set,$where);

                        if ($set_data == 1){

                            $s_array['balance']= $balance;
                            $s_array['total'] = $total_amount;
                            $s_array['tran_id'] = $tran_id;
                            return $s_array;
                        } else {

                            return "Error updating data";
                        }

                    } else {

                        return "Invalid transaction type";
                    }
                } else {

                    return "Insufficient balance to make transaction";
                }
            } else {

                return "Invalid balance or amount";
            }

        } else {

            return "Missing parameters";
        }
    }

    public function update_account_order_id($tran_id, $order_id){
        $ci_where['column_name'] = "account_id";
        $ci_where['sign'] = "=";
        $ci_where['value'] = $tran_id;

        $where[] = $ci_where;

        $first_set['column_name'] = "order_id ";
        $first_set['sign'] = "=";
        $first_set['value'] = $order_id;
        $set[] = $first_set;

        $set_data = $this->update_data($this->account_table, $set, $where);

        return $set_data;

    }




    public function get_rb_member_totals($member_id){
        $columns = array("company_id", "current_balance","total_credit","total_redeem","total_cancel", "total_expire","total_manual_debit", "total_failed");

        $ci_where['column_name'] = "portal_user_id";
        $ci_where['sign'] = "=";
        $ci_where['value'] = $member_id;

        $where[] = $ci_where;



        $get_data = $this->select_tb($this->table, $columns, $where);

        if (is_array($get_data)) {

            return $get_data['data'][0];
        } else {

            return "No data found";
        }


    }

    private function insert_user_transactions ($portal_user_id, $amount_in, $amount_out, $balance, $tran_type, $spec_type, $description= null, $order_id = 0){
        // 1 credit 2 debit

        $columns = array("portal_user_id", "tran_spec_type","amount_in","amount_out","balance","tran_type","order_id","remark");
        $values = array($portal_user_id, $spec_type, $amount_in,$amount_out, $balance, $tran_type, $order_id, $description);

        $put_data = $this->insert_data($this->account_table, $columns, $values);

        if (is_numeric($put_data) && $put_data > 0) {

            return $put_data;
        } else {

            return "Error saving transaction";
        }




    }


    public function credit_user_transactions($member_id, $spec_type, $amount_in, $balance, $remark){

        if(isset($member_id) && isset($amount_in) && isset($balance) && isset($remark)){

            if (is_numeric($amount_in) && is_numeric($balance)  && $amount_in >0 && $balance >0){

                $credit_com = $this->insert_user_transactions($member_id,$amount_in, 0,$balance,1,$spec_type, $remark);
//                echo $credit_com;
//                echo "<br>";
                return $credit_com;

            } else {

                return "Invalid amount or balance";
            }

        } else {

            return "Missing parameters";
        }

    }


    public function debit_user_transactions($member_id, $amount_out, $balance,$spec_type, $remark, $order_id){

        if(isset($member_id) && isset($amount_out) && isset($balance) && isset($remark)){

            if (is_numeric($amount_out) && is_numeric($balance)  && $amount_out >0 && $balance >=0){

                $debit_com = $this->insert_user_transactions($member_id,0, $amount_out,$balance,2, $spec_type,$remark, $order_id);
                return $debit_com;

            } else {

                return "Invalid amount or balance";
            }

        } else {

            return "Missing parameters";
        }

    }

    public function view_portal_transactions($company_id = null, $user_id =null, $start_date=null, $end_date=null, $type = null)
    {

        $columns = array("account_id", "company_name", "member_no","first_name", "last_name", $this->account_table . ".create_date", "tran_type", "amount_in", "amount_out", "balance", "remark");

        $firstjoin ['table_name'] = "portal_users";
        $firstjoin ['first_column'] = "portal_users.portal_user_id";
        $firstjoin ['second_column'] = $this->account_table . ".portal_user_id";
        $leftjoin [] = $firstjoin;

        $firstjoin ['table_name'] = "user_mgt_company";
        $firstjoin ['first_column'] = "user_mgt_company.company_id";
        $firstjoin ['second_column'] = "portal_users.company_id";
        $leftjoin [] = $firstjoin;

        $where= null;

        if($company_id != null || $company_id!="") {
            $p_where['column_name'] = "user_mgt_company.company_id";
            $p_where['sign'] = "=";
            $p_where['value'] = $company_id;
            $where[] = $p_where;
        }

        if($user_id != null || $user_id!="") {
            $p_where['column_name'] = $this->account_table . ".company_id";
            $p_where['sign'] = "=";
            $p_where['value'] = $company_id;
            $where[] = $p_where;
        }

        if($type != null || $type!="" || $type == 1 || $type == 2) {
            if ($type == 1) { // credit
                $p_where['column_name'] = $this->account_table . ".tran_type";
                $p_where['sign'] = "=";
                $p_where['value'] = $type;
                $where[] = $p_where;
            } elseif ($type == 2) {//debit

                $p_where['column_name'] = $this->account_table . ".tran_type";
                $p_where['sign'] = "=";
                $p_where['value'] = $type;
                $where[] = $p_where;

            }
        }


        if($start_date != null || $start_date!=""){

            if($end_date != null || $end_date!=""){

                $p_where['column_name'] = $this->account_table.".create_date";
                $p_where['sign'] = ">=";
                $p_where['value'] = $start_date;
                $where[] = $p_where;

                $p_where['column_name'] = $this->account_table.".create_date";
                $p_where['sign'] = "<=";
                $p_where['value'] = $end_date;
                $where[] = $p_where;
            }



        }


        $get_data = $this->select_tb($this->account_table, $columns, $where, "", "", "", "", "", $leftjoin);

        if (is_array($get_data)) {

            return $get_data['data'];
        } else {

            return "No data found";
        }
    }



    public function send_member ($first_name, $last_name, $email, $password, $password_confirm, $client_no,$points, $member_no, $phone){


        $this->set_header();
        $api = "member/create";

        $body['firstname']= $first_name;
        $body['lastname']= $last_name;
        $body['client_number'] = $client_no;
        $body['email']= $email;
        $body['password']= $password;
        $body['password_confirmation'] = $password_confirm;
        $body['point'] = $points;
        $body['member_id'] = $member_no;
        $body['phone'] = $phone;
        $body['status'] = 1;

        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);

        //echo json_encode($fields);
        //echo "<br>";
        if(is_array($send_data)){

//            if($send_data['status'] == 200){


//
//
//
//
//
//            } else {
//
//                return json_encode($send_data['data']);
//            }
            return $send_data;
        } else {


            return "Member Registration failed";
        }

    }


    public function edit_member ($company_id, $member_no, $first_name, $last_name, $email, $phone){
        $use_company = new Reward_company();
        $check_company = $use_company->get_company($company_id);

        if (is_array($check_company)) {

            $client_no = $check_company['client_no'];
            //$company_name = $check_company['company_name'];

            $check_member = $this->confirm_member_no($company_id, $member_no);

            if (is_array($check_member)) {
                $portal_id = $check_member['portal_id'];

                $send_data = $this->edit_member_api($first_name, $last_name,$email, $client_no,$phone, $portal_id);

                if($send_data['status'] == 200) {
                    $r_array['message'] = $send_data['data'];
                    $r_array['member_no'] = $member_no;
                    return $r_array;
                } else {

                    return $send_data['data'];
                }

            } else {

                return "Invalid Member";
            }
        } else {

            return "Invalid Company";
        }


    }

    public function edit_member_api ($first_name, $last_name, $email, $client_no, $phone, $portal_id){


        $this->set_header();
        $api = "member/update";

        $body['firstname']= $first_name;
        $body['lastname']= $last_name;
        $body['client_number'] = $client_no;
        $body['member_id']= $portal_id;
        $body['email']= $email;
        $body['phone'] = $phone;


        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);

        if(is_array($send_data)){


            return $send_data;
        } else {


            return "Member Registration failed";
        }

    }

    private function send_status ($client_no, $portal_id,$status ){

        $this->set_header();
        $api = "customer/status";

        $body['member_id']= $portal_id;
        $body['status']= $status;
        $body['client_number'] = $client_no;

        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);

//        echo json_encode($fields);
//        echo "<br>";
        if(is_array($send_data)){

            return $send_data;
        } else {

            return "Status change failed";
        }

    }


    public function get_currency(){
        $this->set_header();
        $api = "appcurrency";
        $use_curl = new curl_class();
        $send_data = $use_curl->send_get($this->url.$api,$this->header);
        if(is_array($send_data)){

            if($send_data['status'] == 200) {
                return $send_data['data'];
            } else {

                return $send_data['data'];
            }
        } else {


            return "No data found";
        }



    }

    public function get_member ($client_no, $member_array = null){


        $this->set_header();
        $api = "company/customer/list";

        $body['client_number']= $client_no;

        if($member_array != null){
            $body['member_ids']= $member_array;
        }
        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);

        if(is_array($send_data)){

            return $send_data;
        } else {


            return "No data found";
        }

    }

    public function get_member_balance ($user_id, $client_no){


        $this->set_header();
        $api = "customer/account/total";

        $body['member_id']= $user_id;
        $body['client_number']= $client_no;


        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);

        if(is_array($send_data)){

            return $send_data;
        } else {


            return "No data found";
        }

    }


    public function get_company_members($client_no, $member_array = null){

        $this->set_header();
        $api = "company/customer/list";

        $body['client_number']= $client_no;

        if($member_array != null){

            $body['member_ids']= $member_array;
        }


        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);
//print_r($send_data);
//        if(is_array($send_data)){
        if($send_data['status']== 200){

            return $send_data['data'];
        } else {


            return "No data found";
        }


    }

    public function get_company_transaction($company_id,$start_date = null, $end_date = null, $member_array = null){

        $use_company = new Reward_company();
        $get_company = $use_company->get_company($company_id);

        if(is_array($get_company)) {

            $client_no= $get_company['client_no'];
            $this->set_header();
            $api = "company/transaction/list";

            $body['client_number'] = $client_no;

            if (isset($start_date) && isset($end_date)) {

                $body['from_date'] = $start_date;
                $body['to_date'] = $end_date;
            }

            if($member_array != null){

                if (is_array($member_array)) {

                    $body['member_ids'] = $member_array;

                } else {

                    return "Invalid Member Set";
                }
            }


            $fields = json_encode($body);
            $use_curl = new curl_class();
            $send_data = $use_curl->send_post($this->url . $api, $fields, $this->header);

//        if(is_array($send_data)){

            if ($send_data['status'] == 200) {
                //echo "<hr>";
                return $send_data['data'];
            } else {


                return "No data found";
            }
        } else {

            return "Invalid Company";
        }

    }


    public function get_customer_orders($company_id,$start_date = null, $end_date = null, $member_array = null){

        $use_company = new Reward_company();
        $get_company = $use_company->get_company($company_id);

        if(is_array($get_company)) {

            if ($get_company['portal_access'] == 1) {
                $client_no = $get_company['client_no'];
                $this->set_header();
                $api = "company/customer/orders";

                $body['client_number'] = $client_no;

                if (isset($start_date) && isset($end_date)) {

                    if ($start_date != null && $end_date != null) {
                        $body['from_date'] = $start_date;
                        $body['to_date'] = $end_date;
                    }
                }

                if ($member_array != null) {

                    if (is_array($member_array)) {

                        $body['member_ids'] = $member_array;

                    } else {

                        return "Invalid Member Set";
                    }
                }


                $fields = json_encode($body);
                $use_curl = new curl_class();
                $send_data = $use_curl->send_post($this->url . $api, $fields, $this->header);

//        if(is_array($send_data)){

                if ($send_data['status'] == 200) {
                    //echo "<hr>";
                    return $send_data['data'];
                } else {


                    return "No data found";
                }
            } else {

                return "Access denied for portal";
            }
        } else {

            return "Invalid Company";
        }

    }

    public function get_customer_transaction($client_no, $user_id){

        $this->set_header();
        $api = "customer/transaction/list";

        $body['client_number']= $client_no;
        $body['member_id']= $user_id;


        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);
        //var_dump($send_data);
//        if(is_array($send_data)){
        if($send_data['status']== 200){

            return $send_data['data'];
        } else {


            return "No data found";
        }


    }


    public function get_customer_transaction_admin($company_id, $user_id){

        $use_company = new Reward_company();
        $get_company = $use_company->get_company($company_id);

        if(is_array($get_company)) {

            if ($get_company['portal_access'] == 1) {
                $this->set_header();
                $api = "customer/transaction/list";

                $body['client_number'] = $get_company['client_no'];
                $body['member_id'] = $user_id;


                $fields = json_encode($body);
                $use_curl = new curl_class();
                $send_data = $use_curl->send_post($this->url . $api, $fields, $this->header);
                //var_dump($send_data);
//        if(is_array($send_data)){
                if ($send_data['status'] == 200) {

                    return $send_data['data'];
                } else {


                    return "No data found";
                }
            } else {

                return "Access denied for portal";
            }
        } else {

            return "Invalid Company";
        }

    }

    public function get_customer_order($client_no, $user_id){

        $this->set_header();
        $api = "customer/order/list";

        $body['client_number']= $client_no;
        $body['member_id']= $user_id;


        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);

        if(is_array($send_data)){

            return $send_data;
        } else {


            return "No data found";
        }


    }


    public function enable_disable_member ($company_id, $member_no, $status){

        if ($status == 0 || $status == 1) {
            $use_company = new Reward_company();
            $check_company = $use_company->get_company($company_id);

            if (is_array($check_company)) {

                $client_no = $check_company['client_no'];
                //$company_name = $check_company['company_name'];

                $check_member = $this->confirm_member_no($company_id, $member_no);

                if (is_array($check_member)) {
                    $portal_id = $check_member['portal_id'];

                    $send_data = $this->change_portal_status($client_no,$portal_id,$status);

                    return $send_data;

                } else {

                    return "Invalid Member";
                }
            } else {

                return "Invalid Company";
            }
        } else {

            return "Invalid Status";
        }

    }

    private function change_portal_status ($client_no, $portal_id, $new_status){

                //$columns = array($key,"status");



        if ($new_status == 1) {



            $msg = "Active";



        } else {

            $new_status = 0;

            $msg= "Inactive";

        }



        $change_status = $this->send_status($client_no, $portal_id, $new_status);

        if(is_array($change_status)) {

            if ($change_status['status'] == 200) {

                $d_array = array();

                //$d_array['reqstatus'] == 1;

                $d_array['status'] = $new_status;

                $d_array['message'] = "Successfully made " . $msg;

                return $d_array;


            }else {

                return $change_status['data'];

            }
        } else {

            return "Error changing status";
        }





    } // end change status

    public function get_customer_order_details($order_id){

        $this->set_header();
        $api = "customer/order";


        $body['order_id']= $order_id;


        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);

        if(is_array($send_data)){
            
            
            if($send_data['status'] == 200) {

                $d_array['member'] = $send_data['member'];
                $d_array['data'] = $send_data['data'];
                return $d_array;
                //return $send_data['data'];

            } else{

                return "Invalid Order";
            }

        } else {


            return "No data found";
        }


    }

    public function credit_customer($company_id, $member_no, $points, $reason){

        if (isset($company_id) && isset($member_no) && isset($points) && isset($reason)) {
            $this->auto_commit_off();
            $check_member = $this->confirm_member_no($company_id, $member_no);

            if (is_array($check_member)) {
                $portal_id = $check_member['portal_id'];
                $member_id = $check_member['portal_user_id'];
            // echo $portal_id;
            // echo "<br>";
            // die();
                $use_company = new Reward_company();
                $check_company = $use_company->get_company_others($company_id);

                if (is_array($check_company)) {

                    if (isset($check_company['credit_single_limit'])) {

                        if ($check_company['credit_single_limit'] == 0 || (float)$points <= (float)$check_company['credit_single_limit']) {

                            $use_report = new report_class();
                            $check_balance = $use_report->get_total_debit($company_id);
                            if (is_array($check_balance)) {


                                $current_balance = $check_balance[0]['current_balance'];


                                if ($check_balance[0]['payment_type'] == 1 && $current_balance < $points) {
                                    $this->rollback_now();
                                    return "Insufficient balance";

                                } else {

                                    $client_no = $check_company['client_no'];
                                    $company_name = $check_company['company_name'];

                                    $this->set_header();
                                    $api = "customer/account/credit";


                                    $body['client_number'] = $client_no;
                                    $body['member_id'] = $portal_id;
                                    $body['point'] = $points;
                                    $body['reason'] = $reason;


                                    $fields = json_encode($body);
                                    $use_curl = new curl_class();
                                    $send_data = $use_curl->send_post($this->url . $api, $fields, $this->header);
                // echo json_encode($send_data);
                // echo "<br>";
                                    if (is_array($send_data)) {

                                        if ($send_data['status'] == 200) {
                                            $this->commit_now();
                                            $use_report->set_debit($company_id, $points, 1, $reason, $member_id, 1);
                                            //$this->rb_credit_user($member_id, $points);
                                            $use_email = new send_mail_class();
                                            $use_email->send_customer_credit($send_data['data']['firstname'], $send_data['data']['email'], $send_data['data']['old_balance_virtual'], $send_data['data']['balance_virtual'], $send_data['data']['credit_virtual'], $company_name, $member_no, $client_no);


                                            return $send_data['data'];

                                        } else {
                                             $this->rollback_now();
                                            return $send_data['data'];
                                        }
                                    } else {

                                        $this->rollback_now();
                                        return "No data found";
                                    }
                                }

                            } else {
                                $this->rollback_now();
                                return "Member no found";
                            }
                        } else {
                            $this->rollback_now();
                            return "Amount cannot be greater than " . $check_company['credit_single_limit'];
                        }
                    } else {
                        $this->rollback_now();
                        return "Transaction limit not found";
                    }
                } else {
                    $this->rollback_now();
                    return "Invalid Company";
                }
            } else {
                    $this->rollback_now();
                return "Invalid Member";
            }
        } else {

            return "Missing Parameter";
        }
    }


    public function debit_customer($company_id, $member_no, $points, $reason){

        $check_member= $this->confirm_member_no($company_id,$member_no);

        if (is_array($check_member)) {
            $portal_id = $check_member['portal_id'];
            $use_company = new Reward_company();
            $check_company = $use_company->get_company($company_id);

            if (is_array($check_company)) {

                $client_no = $check_company['client_no'];
                $company_name = $check_company['company_name'];

                $this->set_header();
                $api = "customer/account/debit";


                $body['client_number'] = $client_no;
                $body['member_id'] = $portal_id;
                $body['point'] = $points;
                $body['reason'] = $reason;


                $fields = json_encode($body);
                $use_curl = new curl_class();
                $send_data = $use_curl->send_post($this->url . $api, $fields, $this->header);

                if (is_array($send_data)) {

                    if ($send_data['status'] == 200) {

                        $use_email = new send_mail_class();
                        $use_email->send_customer_debit($send_data['data']['firstname'], $send_data['data']['email'], $send_data['data']['balance_raw'], $send_data['data']['balance_raw'], $points, $company_name, $member_no, $client_no);

                        return $send_data['data'];

                    } else {

                        return $send_data['message'];
                    }
                } else {


                    return "No data found";
                }

            } else {

                return "Invalid Company";
            }
        }else {

            return "Invalid Member";
        }
    }



    public function get_single_customer($client_no, $member_no){

        $this->set_header();
        $api = "company/customer/show";

        $body['client_number']= $client_no;
        $body['member_number']= $member_no;


        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);
        //var_dump($send_data);
//        if(is_array($send_data)){
        if($send_data['status']== 200){

            return $send_data['data'];
        } else {


            return "No data found";
        }


    }

    public function get_single_com_customer($company_id, $member_no){

        $use_company = new Reward_company();
        $get_company = $use_company->get_company($company_id);

        if(is_array($get_company)) {
            $this->set_header();
            $api = "company/customer/show";

            $body['client_number'] = $get_company['client_no'];
            $body['member_number'] = $member_no;


            $fields = json_encode($body);
            $use_curl = new curl_class();
            $send_data = $use_curl->send_post($this->url . $api, $fields, $this->header);
            //var_dump($send_data);
//        if(is_array($send_data)){
            if ($send_data['status'] == 200) {

                return $send_data['data'];
            } else {


                return "No data found";
            }

        } else {

            return "Invalid Company";
        }
    }

    public function get_points_value($client_no, $naira_value){

        $this->set_header();
        $api = "appcurrency/convert";

        $body['client_number']= $client_no;
        $body['point']= $naira_value;


        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);
        //var_dump($send_data);
//        if(is_array($send_data)){
        if($send_data['status']== 200){

            return $send_data['data'];
        } else {


            return "No data found";
        }


    }

    public function get_points_value_admin($company_id, $naira_value){

        $use_company = new Reward_company();
        $get_company = $use_company->get_company($company_id);

        if(is_array($get_company)) {
            $this->set_header();
            $api = "appcurrency/convert";

            $body['client_number'] = $get_company['client_no'];
            $body['point'] = $naira_value;


            $fields = json_encode($body);
            $use_curl = new curl_class();
            $send_data = $use_curl->send_post($this->url . $api, $fields, $this->header);
            //var_dump($send_data);
//        if(is_array($send_data)){
            if ($send_data['status'] == 200) {

                return $send_data['data'];
            } else {


                return "No data found";
            }
        } else {

            return "Invalid Company";
        }

    }

    public function get_com_currency($client_no){

        $this->set_header();
        $api = "appcurrency";

        $body['client_number']= $client_no;



        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);
        //var_dump($send_data);
//        if(is_array($send_data)){
        if($send_data['status']== 200){

            return $send_data['data'];
        } else {


            return "No data found";
        }


    }


    public function get_com_currency_admin($company_id){

        $use_company = new Reward_company();
        $get_company = $use_company->get_company($company_id);

        if(is_array($get_company)) {

            if($get_company['portal_access'] == 1) {
                $this->set_header();
                $api = "appcurrency";

                $body['client_number'] = $get_company['client_no'];


                $fields = json_encode($body);
                $use_curl = new curl_class();
                $send_data = $use_curl->send_post($this->url . $api, $fields, $this->header);
                //var_dump($send_data);
//        if(is_array($send_data)){
                if ($send_data['status'] == 200) {

                    return $send_data['data'];
                } else {


                    return "No data found";
                }
            } else {

                return "No access to portal";
            }
        } else {

            return "Invalid Company";
        }

    }

    public function edit_com_currency($client_no,$currency, $rate, $is_currency){


        if($currency == ""){

            return "Currency name required";

        } else {


            if ($is_currency == 0 || $is_currency == 1) {

                if (is_numeric($rate) && $rate > 0) {

                    $this->set_header();
                    $api = "appcurrency/update";

                    $body['client_number'] = $client_no;
                    $body['is_currency_fixed'] = $is_currency;
                    $body['currency'] = $currency;
                    $body['rate'] = $rate;


                    $fields = json_encode($body);
                    $use_curl = new curl_class();
                    $send_data = $use_curl->send_post($this->url . $api, $fields, $this->header);
                    //var_dump($send_data);
//        if(is_array($send_data)){
                    if ($send_data['status'] == 200) {

                        return $send_data['data'];
                    } else {


                        return "No data found";
                    }
                } else {

                    return "Invalid rate";
                }

            } else {

                return "Invalid active flag";
            }
        }
    }

    public function edit_com_currency_admin($company_id,$currency, $rate, $is_currency){

        $use_company = new Reward_company();
        $get_company = $use_company->get_company($company_id);

        if(is_array($get_company)) {

            if ($get_company['portal_access'] == 1) {
                if ($currency == "") {

                    return "Currency name required";

                } else {


                    if ($is_currency == 0 || $is_currency == 1) {

                        if (is_numeric($rate) && $rate > 0) {

                            $this->set_header();
                            $api = "appcurrency/update";

                            $body['client_number'] = $get_company['client_no'];
                            $body['is_currency_fixed'] = $is_currency;
                            $body['currency'] = $currency;
                            $body['rate'] = $rate;


                            $fields = json_encode($body);
                            $use_curl = new curl_class();
                            $send_data = $use_curl->send_post($this->url . $api, $fields, $this->header);
                            //var_dump($send_data);
//        if(is_array($send_data)){
                            if ($send_data['status'] == 200) {

                                return $send_data['data'];
                            } else {


                                return "No data found";
                            }
                        } else {

                            return "Invalid rate";
                        }

                    } else {

                        return "Invalid active flag";
                    }
                }
            } else{

                return "No access to portal";
            }
        } else{

            return "Invalid Company";
        }
    }

    public function check_member_email($member_no, $email){
        $columns= array ("member_no","email");

        $thirdwhere['column_name'] = "member_no";

        $thirdwhere['sign'] = "=";

        $thirdwhere['value'] = $member_no;

        $where[] = $thirdwhere;

        $thirdwhere['column_name'] = "email";

        $thirdwhere['sign'] = "=";

        $thirdwhere['value'] = $email;

        $where[] = $thirdwhere;

        $get_data = $this->select_tb($this->table, $columns, $where,"OR");

        if (is_array($get_data)){

            $check_member_no = $get_data['data'][0]['member_no'];
            $check_email = $get_data['data'][0]['email'];

            if($check_member_no == $member_no){

                return "Member number already exists";
            } else {

                return "Email address already exists";
            }


        } else {

            return 0;
        }

    }


    public function check_array_enrol($company_id, $tier_id, $enrol_array){

        $success_array = array();
        $failed_array = array();
        $use_tier = new tier_class();
        $check_tier = $use_tier->single_com_tier($company_id, $tier_id);

        if (is_array($check_tier)){

            if(is_array($enrol_array)){

//                echo json_encode($enrol_array);
//                echo "<br>";
                foreach ($enrol_array as $enrol){

//                    echo json_encode($enrol);
//                    echo "<br>";
                    $each_array = array();
                    if($enrol[0] == "" || $enrol[0] == null ){

                        $each_array['first_name'] = $enrol[0];
                        $each_array['info'] = "Missing first name";

                    } else {

                        $each_array['first_name'] = $enrol[0];

                    }

                    if($enrol[1] == "" || $enrol[1] == null ){

                        $each_array['last_name'] = $enrol[1];


                    } else {

                        $each_array['last_name'] = $enrol[1];

                    }



                    if($enrol[4] == "" || $enrol[4] == null ){

                        $each_array['member_no'] = $enrol[4];
                        $each_array['info'] = "Missing Member no";

                    } else {

                        $each_array['member_no'] = $enrol[4];

                    }



                    if($enrol[2] == "" || $enrol[2] == null || !filter_var($enrol[2], FILTER_VALIDATE_EMAIL)){

                        $each_array['email'] = $enrol[2];
                        $each_array['info'] = "Invalid email";

                    } else {

                        $each_array['email'] = $enrol[2];

                        $check_data = $this->check_member_email($each_array['member_no'], $each_array['email']);

//                        echo $check_data;
//                        echo "<br>";
                        if($check_data !== 0){
//                            echo "Hiya";
//                            echo "<br>";
                            $each_array['info'] = $check_data;
                        }
                    }


                    if($enrol[3] == "" || $enrol[3] == null || strlen($enrol[3] < 6) ){

                        $each_array['password'] = $enrol[3];
                        $each_array['info'] = "Password must be grater than 6 characters";

                    } else {

                        $each_array['password'] = $enrol[3];

                    }




                    if($enrol[5] == "" || $enrol[5] == null ){

                        $each_array['phone_no'] = $enrol[5];


                    } else {

                        $each_array['phone_no'] = $enrol[5];

                    }


                    if($enrol[6] == "" || $enrol[6] == null ||!is_numeric($enrol[6]) ){

                        $each_array['points'] = $enrol[6];


                    } else {

                        $each_array['points'] = $enrol[6];

                    }

//                    echo json_encode($each_array);
//                    echo "<br>";
                    if(isset($each_array['info'])){

                        $failed_array[]= $each_array;
                    } else {

                        $each_array['tier_id']= $tier_id;
                        $each_array['company_id'] = $company_id;
                        $success_array[]= $each_array;
                    }






                }


                if (empty($success_array)) {

                    $status_array['status'] = 0;
                    $status_array['message'] = "No data processed";
                    $status_array['data']['failed'] = $failed_array;
                    $status_array['data']['success'] = $success_array;
                    return $status_array;

                } else {

                    foreach ($success_array as $key =>$success_data){

                        $enrol_data = $this->create_file_user($success_data['first_name'],$success_data['last_name'],$success_data['email'],$success_data['password'],$success_data['member_no'],$success_data['company_id'],$success_data['tier_id'],$success_data['phone_no'], $success_data['points']);

                        if(is_array($enrol_data)){



                        } else {

                            $success_data['info'] = $enrol_data;
                            $failed_array[] = $success_data;
                            unset($success_array[$key]);
                        }

                    }

                    if(empty($failed_array)){

                        $status_array['status'] = 1;
                        $status_array['message'] = "All data processed";
                        $status_array['data']['failed'] = $failed_array;
                        $status_array['data']['success'] = $success_array;
                        return $status_array;

                    } else {

                        $status_array['status'] = 1;
                        $status_array['message'] = "Some data processed";
                        $status_array['data']['failed'] = $failed_array;
                        $status_array['data']['success'] = $success_array;
                        return $status_array;

                    }
                }

            } else {

                return "Invalid enrolment array";
            }

        } else {

            return "Invalid Company for tier";
        }

    }


    public function check_array_transaction($company_id, $file_id, $transaction_array)
    {

        $success_array = array();
        $failed_array = array();
        $use_company = new Reward_company();
        $check_company = $use_company->get_company($company_id);

        if (is_array($check_company)){

            if ($check_company['portal_access'] == 1){

                if(is_array($transaction_array)){

                    foreach ($transaction_array as $trans){
                        if (isset($trans[1]) && isset($trans[2]) && isset($trans[3])) {
                            $each_array = array();
                            if ($trans[1] == "" || $trans[1] == null) {

                                $each_array['member_no'] = $trans[1];
                                $each_array['info'] = "Missing Member no";

                            } else {

                                $each_array['member_no'] = $trans[1];

                            }

                            if ($trans[2] == "" || $trans[2] == null || !is_numeric($trans[2])) {

                                $each_array['points'] = $trans[2];
                                $each_array['info'] = "Invalid amount value";

                            } else {

                                $each_array['points'] = $trans[2];

                            }

                            if ($trans[3] == "" || $trans[3] == null || !is_numeric($trans[3])) {

                                $each_array['tran_id'] = $trans[3];
                                $each_array['info'] = "Invalid transaction id";

                            } else {

                                $each_array['tran_id'] = $trans[3];

                            }


                            if (isset($each_array['info'])) {

                                $failed_array[] = $each_array;
                            } else {

                                $each_array['company_id'] = $company_id;
                                $success_array[] = $each_array;
                            }
                        }
                    }

                    if (empty($success_array)) {

                        $status_array['status'] = 0;
                        $status_array['message'] = "No data processed";
                        $status_array['data']['failed'] = $failed_array;
                        $status_array['data']['success'] = $success_array;
                        return $status_array;

                    } else {

                        foreach ($success_array as $key =>$success_data){

                            $member_no = trim($success_data['member_no']);
                            $trans_data = $this->check_transaction_duplicate($success_data['company_id'], $member_no, $success_data['points'], $success_data['tran_id'], $file_id);

                            if(is_array($trans_data)){



                            } else {

                                $success_data['info'] = $trans_data;
                                $failed_array[] = $success_data;
                                unset($success_array[$key]);
                            }

                        }

                        if(empty($failed_array)){

                            $status_array['status'] = 1;
                            $status_array['message'] = "All data processed";
                            $status_array['data']['failed'] = $failed_array;
                            $status_array['data']['success'] = $success_array;
                            return $status_array;

                        } else {

                            $status_array['status'] = 1;
                            $status_array['message'] = "Some data processed";
                            $status_array['data']['failed'] = $failed_array;
                            $status_array['data']['success'] = $success_array;
                            return $status_array;

                        }
                    }

                } else {

                    return "Invalid transaction data";
                }

            } else {

                return "Company does not have portal access";
            }

        } else {

            return "Invalid Company";
        }

    }

    private function check_transaction_duplicate ($company_id, $member_no, $points, $tran_id, $file_id){

        if(isset($company_id) && isset($member_no) && isset($points) && isset($tran_id) && isset($file_id)){
            $this->auto_commit_off();
            $columns = array("company_id", "member_no", "value", "trans_id", "file_id");
            $values = array($company_id, $member_no,$points,$tran_id, $file_id);

            $thirdwhere['column_name'] ="company_id";
            $thirdwhere['sign'] ="=";
            $thirdwhere['value'] =$company_id;
            $where[] = $thirdwhere;

            $thirdwhere['column_name'] ="trans_id";
            $thirdwhere['sign'] ="=";
            $thirdwhere['value'] =$tran_id;
            $where[] = $thirdwhere;

            $put_data = $this->insert_check_duplicate($this->check_tran_table,$columns,$values,$where,1);

            if (is_numeric($put_data) && $put_data > 0){

                $credit_customer = $this->credit_customer($company_id,$member_no,$points,"Company Credit");

                if (is_array($credit_customer)){
                    $this->commit_now();
                    return $credit_customer;
                } else {
                    $this->rollback_now();
                    return $credit_customer;
                }


            } elseif ($put_data == -1){

                return "Transaction ID already exists";

            } else {

                return "Error Processing";
            }
        } else {

            return "Missing parameter";
        }

    }


    public function change_order_status($order_array){
//        echo json_encode($order_array);
//        echo "<br>";
//        print_r($order_array);
//        echo "<br>";
        $status = $order_array['status'];
        $this->set_header();

        if($status == 0){
            $api = "order/cancel";
            $body['reason']= $order_array['reason'];

        } elseif ($status == 5){
            $api = "order/expire";

        } else {

            $api = "order/status/change";
        }

//        echo $api;
//        echo "<br>";
        $body['status']= $order_array['status'];
        $body['orders']= $order_array['orders'];

//        echo json_encode($body);
        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);
        //var_dump($send_data);
//        echo json_encode($send_data);
//        echo "<br>";
//        if(is_array($send_data)){
        if($send_data['status']== 200){

            return $send_data['data'];
        } else {


            return $send_data['data'];
        }


    }

    public function expire_order_status($order_array){

        $this->set_header();
        $api = "order/expire";

//        $body['status']= $order_array['status'];
//        $body['orders']= $order_array['orders'];


        $fields = json_encode($order_array);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);
        //var_dump($send_data);
//        if(is_array($send_data)){
        if($send_data['status']== 200){

            return $send_data['data'];
        } else {


            return "No data found";
        }


    }

    public function enable_mobile_api ($company_id, $status){

        if (isset($company_id) && isset($status)) {

            if ($status == 0 || $status == 1) {
                $use_company = new Reward_company();
                $check_company = $use_company->get_company($company_id);

                if (is_array($check_company)) {
                    $client_no = $check_company['client_no'];
                    $portal_access = $check_company['portal_access'];

                    if ($portal_access == 1) {
                        $this->set_header();
                        $api = "company/api/status/set";

                        $body['client_number'] = $client_no;
                        $body['status'] = $status;

                        $fields = json_encode($body);
                        $use_curl = new curl_class();
                        $send_data = $use_curl->send_post($this->url . $api, $fields, $this->header);

                        if ($send_data['status'] == 200) {

                            return $send_data['message'];
                        } else {


                            return $send_data['message'];
                        }
                    } else {

                        return "Company does not have access to portal";
                    }
                } else {

                    return "Invalid Company selected";
                }
            } else {

                return "Invalid Status";
            }
        } else {

            return "Missing Parameter";
        }
    }

    public function expire_reminder($days, $order_array){
//        echo json_encode($order_array);
//        echo "<br>";
        $this->set_header();
        $api2 = "order/reminder/2";
        $api7 = "order/reminder/7";

//        $body['status']= $order_array['status'];
//        $body['orders']= $order_array['orders'];


        $fields = json_encode($order_array);
        $use_curl = new curl_class();

        if ($days == 2) {
            $send_data = $use_curl->send_post($this->url . $api2, $fields, $this->header);
        } elseif ($days == 7) {

            $send_data = $use_curl->send_post($this->url . $api7, $fields, $this->header);
        } else{

            $send_data = "Invalid Days";
        }
        //var_dump($send_data);
//        if(is_array($send_data)){
        if($send_data['status']== 200){

            return $send_data['data'];
        } else {


            return $send_data['data'];
        }


    }

    
    public function get_points_users($company_id)
    {

        if (isset($company_id)) {


                $use_company = new Reward_company();
                $check_company = $use_company->get_company($company_id);

                if (is_array($check_company)) {
                    $client_no = $check_company['client_no'];
                    $portal_access = $check_company['portal_access'];

                    if ($portal_access == 1) {
                        $this->set_header();
                        $api = "customer/points";
                        $body['client_number'] = $client_no;

                        $fields = json_encode($body);
                        $use_curl = new curl_class();


                        $send_data = $use_curl->send_post($this->url . $api, $fields, $this->header);

                        if ($send_data['status'] == 200) {

                            return $send_data['data'];
                        } else {


                            return $send_data['data'];
                        }
                    } else {

                        return "Not Portal Company";
                    }
                } else {

                    return $check_company;
                }
        } else {

            return "Invalid Company Data";
        }
    }

    public function get_no_manager ($company_id){

        if (isset($company_id)){

            $columns =array("portal_user_id", "member_no", "first_name", "last_name","email");


            $thirdwhere['column_name'] ="company_id";
            $thirdwhere['sign'] ="=";
            $thirdwhere['value'] =$company_id;
            $where[] = $thirdwhere;

            $thirdwhere['column_name'] ="manager_id";
            $thirdwhere['sign'] ="=";
            $thirdwhere['value'] =$this->no_manger_type;
            $where[] = $thirdwhere;



            $check_no =  $this->select_tb($this->table,$columns, $where);

            if (is_array($check_no)){

                return $check_no;
            } else {

                return "No data found";
            }

        } else {

            return "Company id required";
        }


    }


    public function get_has_manager ($company_id){

        if (isset($company_id)){

            $columns =array("portal_user_id", "member_no", $this->table.".first_name", $this->table.".last_name","email","portal_id", $this->com_user_table.".first_name AS mgr_first_name" , $this->com_user_table.".last_name AS mgr_last_name");

            $firstjoin ['table_name'] = $this->com_user_table;
            $firstjoin ['first_column'] = $this->com_user_table.".user_id";
            $firstjoin ['second_column'] = $this->table . ".manager_id";
            $leftjoin [] = $firstjoin;

            $thirdwhere['column_name'] =$this->table.".company_id";
            $thirdwhere['sign'] ="=";
            $thirdwhere['value'] =$company_id;
            $where[] = $thirdwhere;

            $thirdwhere['column_name'] ="manager_id";
            $thirdwhere['sign'] ="!=";
            $thirdwhere['value'] =$this->no_manger_type;
            $where[] = $thirdwhere;



            $check_no =  $this->select_tb($this->table,$columns, $where,"","","","","",$leftjoin);

            if (is_array($check_no)){

                return $check_no;
            } else {

                return "No data found";
            }

        } else {

            return "Company required";
        }


    }

    public function get_manager_customer_id($company_id, $manager_id)
    {

        if (isset($company_id) && isset($manager_id)) {


            $columns = array("portal_user_id", "member_no", "first_name", "last_name", "portal_id");
            $thirdwhere['column_name'] = "company_id";
            $thirdwhere['sign'] = "=";
            $thirdwhere['value'] = $company_id;
            $where[] = $thirdwhere;

            $thirdwhere['column_name'] = "manager_id";
            $thirdwhere['sign'] = "=";
            $thirdwhere['value'] = $manager_id;
            $where[] = $thirdwhere;


            $check_no = $this->select_tb($this->table, $columns, $where);

            if (is_array($check_no)) {

                return $check_no;
            } else {

                return 0;
            }

        } else {

            return "Company and Manager required";
        }


    }



    public function get_confirm_user_id($company_id, $user_id)
    {

        if (isset($company_id) && isset($user_id)) {


            $columns = array("portal_user_id", "member_no", "first_name", "last_name", "email","portal_id","manager_id");
            $thirdwhere['column_name'] = "company_id";
            $thirdwhere['sign'] = "=";
            $thirdwhere['value'] = $company_id;
            $where[] = $thirdwhere;

            $thirdwhere['column_name'] = "portal_user_id";
            $thirdwhere['sign'] = "=";
            $thirdwhere['value'] = $user_id;
            $where[] = $thirdwhere;


            $check_no = $this->select_tb($this->table, $columns, $where);

            if (is_array($check_no)) {

                return $check_no['data'][0];
            } else {

                return 0;
            }

        } else {

            return "Company and user required";
        }


    }


    public function assign_manager($company_id, $user_id, $manager_id){

        $use_com = new company_user_class();
        $get_manager = $use_com->confirm_manager($company_id, $manager_id);

        if (is_array($get_manager)){
            $get_com_user = $this->get_confirm_user_id($company_id, $user_id);

            if(is_array($get_com_user)){

                if($get_com_user['manager_id'] == $this->no_manger_type){

                    $assign_manager = $this->update_manager_assign($user_id, $manager_id);

                    if (is_array($assign_manager)){

                        return $assign_manager;

                    } else {

                        return $assign_manager;
                    }

                } else {

                    return "User already assigned to Manager";
                }

            } else {

                return "Invalid Company User";
            }



        } else {

            return "User is not an account Manager";
        }


    }


    public function unassign_manager($company_id, $user_id){

        if(isset($company_id) && isset($user_id)){


            $get_com_user = $this->get_confirm_user_id($company_id, $user_id);
            
            // print_r($get_com_user);

            if(is_array($get_com_user)){

                if($get_com_user['manager_id'] != $this->no_manger_type){

                    $assign_manager = $this->update_manager_assign($user_id, $this->no_manger_type);

                    if (is_array($assign_manager)){

                        return $assign_manager;

                    } else {

                        return $assign_manager;
                    }

                } else {

                    return "User not assigned to a Manager";
                }

            } else {

                return "Invalid Company User";
            }


        } else {


            return "Company and user required";
        }

    }

    private function update_manager_assign($user_id, $manager_id){

        if (isset($user_id) && isset($manager_id)){

            $ci_where['column_name'] = "portal_user_id";
            $ci_where['sign'] = "=";
            $ci_where['value'] = $user_id;

            $where[] = $ci_where;

            $first_set['column_name'] = "manager_id ";
            $first_set['sign'] = "=";
            $first_set['value'] = $manager_id;
            $set[] = $first_set;

            $set_data = $this->update_data($this->table, $set, $where);

            if($set_data == 1){

                $r_array['user_id'] = $user_id;
                $r_array['manager_id'] = $manager_id;
                return $r_array;

            } else {

                return "Error updating data";
            }


        } else {

            return "User and Manger required";
        }



    }


    public function get_portal_manager ($company_id, $portal_id){

        if (isset($company_id)){

            $columns =array("member_no", "email","portal_id", $this->com_user_table.".first_name AS mgr_first_name" , $this->com_user_table.".last_name AS mgr_last_name");

            $firstjoin ['table_name'] = $this->com_user_table;
            $firstjoin ['first_column'] = $this->com_user_table.".user_id";
            $firstjoin ['second_column'] = $this->table . ".manager_id";
            $leftjoin [] = $firstjoin;

            $thirdwhere['column_name'] =$this->table.".company_id";
            $thirdwhere['sign'] ="=";
            $thirdwhere['value'] =$company_id;
            $where[] = $thirdwhere;

            $thirdwhere['column_name'] ="portal_id";
            $thirdwhere['sign'] ="=";
            $thirdwhere['value'] =$portal_id;
            $where[] = $thirdwhere;



            $check_no =  $this->select_tb($this->table,$columns, $where,"","","","","",$leftjoin);

            if (is_array($check_no)){

                return $check_no['data'][0];
            } else {

                return "No data found";
            }

        } else {

            return "Company required";
        }


    }


    private function view_manager_users_api ($company_id, $user_id){

        if(isset($company_id) && isset($user_id)){

            $use_com = new company_user_class();
            $get_manager = $use_com->confirm_manager($company_id, $user_id);
            if (is_array($get_manager)){

                $get_customers = $this->get_manager_customer_id($company_id, $user_id);

                if (is_array($get_customers)){


                    $array2 = array_column($get_customers['data'], 'portal_id');

                    return $array2;

                } else {

                    return "No Customer assigned to Manager";
                }


            } else {

                return "User is not a Manager";
            }

        } else {

            return "Company and user required";
        }


    }


    public function show_api_manager_members($company_id, $user_id){
        $get_customers = $this->view_manager_users_api($company_id, $user_id);

        if (is_array($get_customers)){

            $use_company = new Reward_company();
            $get_company = $use_company->get_company($company_id);

            if (is_array($get_company)) {
                $client_no = $get_company['client_no'];
                $portal_access = $get_company['portal_access'];

                if ($portal_access == 1) {

                    $get_data = $this->get_member ($client_no, $get_customers);

                    return $get_data;

                } else {

                    return "Access denied to portal";
                }

            } else {

                return "Invalid Company";
            }

        } else {

            return $get_customers;
        }


    }



    public function show_api_manager_transactions($company_id, $user_id, $start_date= null, $end_date = null){
        $get_customers = $this->view_manager_users_api($company_id, $user_id);

        if (is_array($get_customers)){



                    $get_data = $this->get_company_transaction($company_id,$start_date,$end_date,$get_customers);

                    return $get_data;


        } else {

            return $get_customers;
        }


    }


    public function show_api_manager_orders($company_id, $user_id, $start_date= null, $end_date= null){
        $get_customers = $this->view_manager_users_api($company_id, $user_id);

        if (is_array($get_customers)){


                    $get_data = $this->get_customer_orders($company_id,$start_date,$end_date,$get_customers);

                    return $get_data;


        } else {

            return $get_customers;
        }


    }
    
    
    public function confirm_shipped_status($order_array){

        $status = $order_array['status'];
        $this->set_header();

            $api = "order/status/shipped";

        $body['status']= $order_array['status'];
        $body['orders']= $order_array['orders'];

        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);

        if($send_data['status']== 200){

            return $send_data['data'];
        } else {


            return $send_data['data'];
        }


    }
    
    public function complete_pending_transaction ($order_no, $ref_no, $voucher_no, $client_no, $status){
        $this->set_header();
        $api = "order/pending";
        $body['status']= $status;
        $body['ref_no']= $ref_no;
        $body['voucher_no']= $voucher_no;
        $body['order_no']= $order_no;
        $body['client_number']= $client_no;

        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);

        if($send_data['status']== 200){

            return $send_data['data'];
        } else {


            return $send_data['data'];
        }
    }
    
    
    public function confirm_portal_id($company_id,$portal_id){

        $columns =array("member_no","portal_user_id");
        $thirdwhere['column_name'] =$this->table.".company_id";
        $thirdwhere['sign'] ="=";
        $thirdwhere['value'] =$company_id;
        $where[] = $thirdwhere;

        $thirdwhere['column_name'] ="portal_id";
        $thirdwhere['sign'] ="=";
        $thirdwhere['value'] =$portal_id;
        $where[] = $thirdwhere;



        $check_no =  $this->select_tb($this->table,$columns, $where);

        if (is_array($check_no)){

            return $check_no['data'][0];
        } else {

            return 0;
        }

    }
    
    
    public function check_run_rb_forfeit($company_id, $portal_id, $amount){

        $check_portal_id = $this->confirm_portal_id($company_id, $portal_id);

        if (is_array($check_portal_id)){

            $forfeit = $this->rb_forfeit_user($check_portal_id['portal_user_id'],$amount);

            return $forfeit;
        } else {

            return "Unable to find user";
        }


    }

    private function rb_forfeit_user($member_id, $amount, $reason = null){

        $this->auto_commit_off();
        $get_totals = $this->get_rb_member_totals($member_id);

        if (is_array($get_totals)){

            $new_balance = (float)$get_totals['current_balance'] - (float)$amount;
            $total_debit = (float)$amount + (float)$get_totals['total_forfeit'];
            $company_id = $get_totals['company_id'];

            $remark ="Points Forfeiture";

//            if($new_balance > 0) {
                $set_data = $this->update_rb_member_totals($member_id, $new_balance, $total_debit, $amount, 7, $remark,0);

                if (is_array($set_data)) {

                    $use_report = new report_class();
                    $check_company = $use_report->set_forfeit($company_id,$amount, 1);
                    if ($check_company == 1) {
                        $this->commit_now();
                        return $set_data;
                    } else {
                        $this->rollback_now();
                        return $check_company;
                    }
                } else {
                    $this->rollback_now();
                    return $set_data;
                }
//            } else {
//                $this->rollback_now();
//                return "Insufficient balance to complete transaction";
//            }

        } else {
            $this->rollback_now();
            return "User not found";
        }




    }

    public function forfeit_users_points($company_id)
    {

        if (isset($company_id)) {


            $use_company = new Reward_company();
            $check_company = $use_company->get_company($company_id);

            if (is_array($check_company)) {
                $client_no = $check_company['client_no'];
                $portal_access = $check_company['portal_access'];

                if ($portal_access == 1) {
                    $this->set_header();
                    $api = "company/forfeit";
                    $body['client_number'] = $client_no;

                    $fields = json_encode($body);
                    $use_curl = new curl_class();


                    $send_data = $use_curl->send_post($this->url . $api, $fields, $this->header);

                    if ($send_data['status'] == 200) {

                        return $send_data['data'];
                    } else {


                        return $send_data['data'];
                    }
                } else {

                    return "Not Portal Company";
                }
            } else {

                return $check_company;
            }
        } else {

            return "Invalid Company Data";
        }
    }
    
    public function bulk_cancel_status($order_array){
        $status = $order_array['status'];
        $this->set_header();



        $api = "order/bulk_cancel";


        $body['order_no']= $order_array['order_no'];
        $body['orders']= $order_array['orders'];
        $body['refund_amount'] = $order_array['refund_amount'];


        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);

        if($send_data['status']== 200){

            return $send_data['data'];
        } else {


            return $send_data['data'];
        }


    }

    public function bulk_cancel_pickup_status($order_array){
        $body['status'] = $order_array['status'];
        $this->set_header();



        $api = "order/cancel/pickup";



        $body['order_no']= $order_array['order_no'];
        $body['pickup']= $order_array['pickup'];
        $body['cancel'] = $order_array['cancel'];


        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);

        if($send_data['status']== 200){

            return $send_data['data'];
        } else {


            return $send_data['data'];
        }


    }
    
    
        public function get_company_members_disabled($client_no){

        $this->set_header();
        $api = "company/customer/disabled";

        $body['client_number']= $client_no;

        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);

        if($send_data['status']== 200){

            return $send_data['data'];
        } else {


            return "No data found";
        }


    }

    public function get_company_members_no_login($client_no){

        $this->set_header();
        $api = "company/customer/nologin";

        $body['client_number']= $client_no;

        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);

        
        if($send_data['status']== 200){

            return $send_data['data'];
        } else {


            return "No data found";
        }


    }
    
    public function check_no_login_sms($company_id, $client_no, $link){

        $get_data = $this->get_company_members_no_login_sms($client_no);

        
        if(is_array($get_data)){
            $pass_array = array();
            $pass_array['sms'] = array();
            $pass_array['failed'] = $get_data['failed'];

            
            $build_sms = $this->build_check_array($get_data['success'], $link);
            
            if(is_array($build_sms)){


                $use_sms = new sms_class();
                $del=$use_sms->delete_sms_store($company_id);
        
                $get_sms = $use_sms->generate_sms($company_id, 1, $build_sms);
                
                $pass_array['sms'] = $get_sms;

                return $pass_array;

            } else {

                return "Error building SMS";
            }

        } else {

            return $get_data;
        }


    }


    private function build_check_array($got_data, $link){

        $total_array = array();
        foreach ($got_data as $datum){
            $send_array = array();
            $send_array['firstname'] = ucfirst($datum['firstname']);
            $send_array['amount'] = number_format($datum['point_virtual']);
            $send_array['username'] = $datum['email'];
            $send_array['password'] = $datum['password'];
            $send_array['link'] = $link;
            $send_array['phone'] = $datum['phone'];

            $total_array[] = $send_array;
        }
        return $total_array;
    }


    private function get_company_members_no_login_sms($client_no){

        $this->set_header();
        $api = "company/customer/nologin/sms";

        $body['client_number']= $client_no;

        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);

        //return $send_data;
        if($send_data['status']== 200){

            return $send_data['data'];
        } else {


            return "No data found";
        }


    }
    
    public function send_no_login_sms($company_id){
        $use_sms = new sms_class();
        $send_array = $use_sms->get_sms_data($company_id);
        if(is_array($send_array)) {
            $bulk_array = array();
            foreach ($send_array['data'] as $value) {

                if (isset($value['phone']) && isset($value['body'])) {

                    $send_body['to'] = $value['phone'];
                    $send_body['body'] = $value['body'];
                    $bulk_array[] = $send_body;
                } else {

                    return "to and body not set " . json_encode($send_array);
                }

            }

            if(count($bulk_array) > 0){
                $use_sms = new sms_class();
                $send_sms = $use_sms->send_sms($company_id, $bulk_array);
                $use_sms->delete_sms_store($company_id);
                return $send_sms;
            } else{

                return "No sms to send";
            }

        } else {

            return "No data found";
        }
    }


    public function get_portal_pending($client_no){

        $this->set_header();
        $api = "cart/pending";

        $body['client_number']= $client_no;

        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);

        if($send_data['status']== 200){

            return $send_data['data'];
        } else {


            return "No data found";
        }


    }
    
    public function get_company_members_have_login($client_no){

        $this->set_header();
        $api = "company/customer/login";

        $body['client_number']= $client_no;

        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);

        if($send_data['status']== 200){

            return $send_data['data'];
        } else {


            return "No data found";
        }


    }
    
    
    private function get_company_send_email_login($client_no){

        $this->set_header();
        $api = "company/customer/nologin/email";

        $body['client_number']= $client_no;

        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);

//        echo json_encode($send_data);
//        echo "<hr>";
        if($send_data['status']== 200){

            return $send_data['data'];
        } else {


            return "No data found";
        }


    }


    public function get_email_login_enrolment($company_id){

        $use_company = new Reward_company();
        $check_company = $use_company->get_company($company_id);

        if (is_array($check_company)) {
            $client_no = $check_company['client_no'];
            $get_data = $this->get_company_send_email_login($client_no);
            if (is_array($get_data)) {
                $use_custom = new custom_email_class();

                return $use_custom->save_email($company_id, $client_no, 1, $get_data);


            } else {

                return "No data returned";
            }
        } else {

            return "Company not found";
        }


    }
    
        public function get_company_members_have_login_sms($client_no){

        $this->set_header();
        $api = "company/customer/login/sms";

        $body['client_number']= $client_no;

        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);

        if($send_data['status']== 200){

            return $send_data['data'];
        } else {


            return "No data found";
        }


    }

    public function check_login_sms($company_id, $client_no, $link){

        $get_data = $this->get_company_members_have_login_sms($client_no);


        if(is_array($get_data)){
            $pass_array = array();
            $pass_array['sms'] = array();
            $pass_array['failed'] = $get_data['failed'];

            $build_sms = $this->build_check_array($get_data['success'], $link);

            if(is_array($build_sms)){


                $use_sms = new sms_class();
                $use_sms->delete_sms_store($company_id);
                $get_sms = $use_sms->generate_sms($company_id, 3, $build_sms);

                $pass_array['sms'] = $get_sms;

                return $pass_array;

            } else {

                return "Error building SMS";
            }

        } else {

            return $get_data;
        }


    }
    
    
    public function get_company_members_enabled($client_no){

        $this->set_header();
        $api = "company/customer/enabled";

        $body['client_number']= $client_no;

        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);

        if($send_data['status']== 200){

            return $send_data['data'];
        } else {


            return "No data found";
        }


    }

    public function get_email_enabled_customers($company_id){

        $use_company = new Reward_company();
        $check_company = $use_company->get_company($company_id);

        if (is_array($check_company)) {
            $client_no = $check_company['client_no'];
            $get_data = $this->get_company_members_enabled($client_no);
            if (is_array($get_data)) {
                $use_custom_email = new email_custom_class();

                return $use_custom_email->save_email($company_id, $get_data);


            } else {

                return "No data returned";
            }
        } else {

            return "Company not found";
        }


    }
    
    
    public function fetch_save_criteria_sms($company_id, $redeem, $greater,$less){

        $use_company = new Reward_company();
        $check_company = $use_company->get_company($company_id);

        if (is_array($check_company)) {
            $client_no = $check_company['client_no'];
            $link = $check_company['portal_link'];
            $get_data = $this->get_company_members_criteria($client_no, $redeem, $greater, $less);
           
            if(is_array($get_data)){
                $pass_array = array();
                $pass_array['sms'] = array();
//                $pass_array['failed'] = $get_data['failed'];

                $build_sms = $this->build_check_array($get_data, $link);

                if(is_array($build_sms)){


                    $use_sms = new sms_class();
                    $use_sms->delete_sms_store($company_id);
                    $get_sms = $use_sms->generate_sms($company_id, 4, $build_sms);

                    $pass_array['sms'] = $get_sms;

                    return $pass_array;

                } else {

                    return "Error building SMS";
                }

            } else {

                return $get_data;
            }
        } else {

            return "No data returned";
        }

    }

    private function get_company_members_criteria($client_no, $redeem, $greater,$less){

        $this->set_header();
        $api = "company/customer/enabled/criteria";

        $body['client_number']= $client_no;
        $body['redeem']= $redeem;
        $body['greater']= $greater;
        $body['less']= $less;
        //echo json_encode($body);
        $fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post($this->url.$api,$fields,$this->header);
        //echo json_encode($send_data);
        if($send_data['status']== 200){

            return $send_data['data'];
        } else {


            return "No data found";
        }


    }
}

//$s_array ='{"status":0,"reason":"out of stock","orders":[{"order_no":"2678","delivery_cost":0,"first_name":"","last_name":"","email":"","address":"","vouchers":["YC114661GJ3GH"]}]}';

// $page_test = new portal_user_class();
// echo json_encode($page_test->check_no_login_sms(3,47829,'https://sigmaprime.sigmapensions.com'));
// echo json_encode($page_test->send_no_login_sms(3));
//echo json_encode($page_test->show_api_manager_transactions(10,6));
//echo json_encode($page_test->show_api_manager_members(10, 6));
//echo json_encode($page_test->get_confirm_user_id(10,2));
//echo json_encode($page_test->get_has_manager(10));
//echo json_encode($page_test->get_portal_manager(10,6));
//echo json_encode($page_test->get_manager_customer_id(10,6));
//echo json_encode($page_test->assign_manager(10, 3, 6));
//$member_array = array(2);
//echo json_encode($page_test->get_customer_orders(10, "", "", $member_array));
//echo json_encode($page_test->get_customer_orders(10));
//echo json_encode($page_test->get_customer_order_details(181));
//echo json_encode($page_test->get_customer_transaction_admin(8,22));
//echo json_encode($page_test->get_single_com_customer(8,"1114"));
//echo json_encode($page_test->get_no_manager(10));
//echo json_encode($page_test->edit_member_api("Jane","Smith","test@test25.com", "127892","08122891123",1));
//echo json_encode($page_test->enable_mobile_api(10,1));
//echo json_encode($page_test->check_transaction_duplicate(10, "2111", "570", "1223","2"));
//echo json_encode($page_test->credit_customer(10,"2111", 500, "test limit"));
//echo json_encode($page_test->save_portal_user("yinka","bighead","olayinka@loyaltysolutionsnigeria.com", "4447",10,1,6));

//echo json_encode($page_test->update_rb_member_totals(1, 70000, 6000, 6000, 6,"Test update fail1"));
//echo json_encode($page_test->save_company("Test 1", "1234","56", 1234));
//echo json_encode($page_test->view_portal_transactions(10));
//echo json_encode($page_test->change_order_status(json_decode($s_array, true)));
//echo json_encode($page_test->credit_customer(10,4446,5000,"test one"));
//$member_array = array(2);
//echo json_encode($page_test->get_company_members("127892"));
//echo json_encode($page_test->get_com_currency(127892));
//echo json_encode($page_test->get_single_customer(127892,2111));
//echo json_encode($page_test->get_points_value(127892,1000));
//echo json_encode($page_test->credit_customer(10, 2121,500,"test"));
//echo json_encode($page_test->get_customer_order_details(100));
//echo json_encode($page_test->get_customer_transaction("127892",1));
//echo json_encode($page_test->change_portal_status(127892, 52, 0));
//echo json_encode($page_test->send_status("127892", 52,1));
//echo json_encode($page_test->create_portal_user("test", "john", "test@test4.com", "112w123","993", 10, 1, 127892));
//echo json_encode($page_test->get_company_transaction(10,"","" , $member_array));
//echo json_encode($page_test->get_customer_transaction(127892, 1));
//echo json_encode($page_test->get_currency());
//echo json_encode ($page_test->send_company("Test_Company9","11111",800));
//echo json_encode($page_test->get_member_balance(1, 127892));
//echo json_encode($page_test->get_company_members(127892));
//echo json_encode($page_test->get_company_data(1));
//echo json_encode($page_test->view_company_portal(10));
//echo json_encode($page_test->confirm_member_no(10,2111));
//echo json_encode($page_test->send_member("King", "Hearts", "king@heart.com", "123456","123456","127892", 40,"3456","1234567890"));


