<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 12/10/2018
 * Time: 19:45
 */

require_once("curl_class.php");
require_once ("main_class.php");
require_once ("company_class.php");
require_once ("service_access_class.php");
require_once ("company_user_class.php");

class sms_class extends Rewardsbox_main
{

    private $table = "program_sms_variables";
    private $table2 = "program_sms";
    private $table3 = "program_sms_type";
    private $settings = "program_sms_settings";
    private $store = "sms_store";
    private $sms_url = "http://sms.perxclm2.com/public/api/sms/multi/send";
    private $header = array("Accept: application/json");

//    private $service_id = 2;


    public function add_sms_variable($variable_name,$var_replace){

        $columns =array("variable_name","var_replace","status");
        $values = array($variable_name, $var_replace, 1);
        $thirdwhere['column_name'] ="variable_name";
        $thirdwhere['sign'] = "=";
        $thirdwhere['value'] =$variable_name;
        $where[] = $thirdwhere;


        $insert_data = $this->insert_check_duplicate($this->table, $columns, $values, $where);

        if ($insert_data > 0) {
            $insert_array['id'] = $insert_data;
            return $insert_array;

        } elseif ($insert_data < 0) {
            return "Variable already exists";

        } else {
            return "An error occurred";
        }

    }

    public function view_variables(){

        $columns =array("variable_name", "var_replace");
        $thirdwhere['column_name'] ="status";
        $thirdwhere['sign'] ="=";
        $thirdwhere['value'] =1;
        $where[] = $thirdwhere;

        $check_no =  $this->select_tb($this->table,$columns, $where);

        if (is_array($check_no)){

            return $check_no;
        } else {

            return 0;
        }

    }



    public function view_all_variables(){

        $columns =array("variable_name", "var_replace");

        $check_no =  $this->select_tb($this->table,$columns);

        if (is_array($check_no)){

            return $check_no;
        } else {

            return 0;
        }

    }


    public function edit_variable($id, $variable_name = null, $var_replace = null, $status = null) {
        $key = "menu_id";
        //$columns_name = "service_name";


        if($variable_name != null || $variable_name="") {
            $firstset['column_name'] = "variable_name";
            $firstset['sign'] = "=";
            $firstset['value'] = $variable_name;
            $set[] = $firstset;
        }
        if($var_replace != null || $var_replace="") {
            $firstset['column_name'] = "var_replace";
            $firstset['sign'] = "=";
            $firstset['value'] = $var_replace;
            $set[] = $firstset;
        }
        if($status != null || $status="") {
                    $firstset['column_name'] = "status";
                    $firstset['sign'] = "=";
                    $firstset['value'] = $status;
                    $set[] = $firstset;
        }


        $first_where['column_name'] ="id";
        $first_where['sign'] ="=";
        $first_where['value'] =$id;
        $where[] = $first_where;

        $edit_result = $this->update_data($this->table, $set, $where);
        //print_r($edit_name);

        if ($edit_result == 1) {
            return 1;
        }else {
            return "error";
        }

    } //

    public function add_sms_type($name){

        $columns =array("name","status");
        $values = array($name,  1);
        $thirdwhere['column_name'] ="name";
        $thirdwhere['sign'] ="=";
        $thirdwhere['value'] =$name;
        $where[] = $thirdwhere;


        $insert_data = $this->insert_check_duplicate($this->table3, $columns, $values, $where);

        if ($insert_data > 0) {
            $insert_array['id'] = $insert_data;
            return $insert_array;

        } elseif ($insert_data < 0) {
            return "Type already exists";

        } else {
            return "An error occurred";
        }

    }

    public function view_active_types(){

        $columns =array("name");
        $thirdwhere['column_name'] ="status";
        $thirdwhere['sign'] ="=";
        $thirdwhere['value'] =1;
        $where[] = $thirdwhere;

        $check_no =  $this->select_tb($this->table3,$columns, $where);

        if (is_array($check_no)){

            return $check_no;
        } else {

            return 0;
        }

    }



    public function view_all_types(){

        $columns =array("name");

        $check_no =  $this->select_tb($this->table3,$columns);

        if (is_array($check_no)){

            return $check_no;
        } else {

            return 0;
        }

    }


    public function edit_type($id, $name = null,  $status = null) {



        if($name != null || $name="") {
            $firstset['name'] = "name";
            $firstset['sign'] = "=";
            $firstset['value'] = $name;
            $set[] = $firstset;
        }

        if($status != null || $status="") {
                    $firstset['column_name'] = "status";
                    $firstset['sign'] = "=";
                    $firstset['value'] = $status;
                    $set[] = $firstset;
        }


        $first_where['column_name'] ="id";
        $first_where['sign'] ="=";
        $first_where['value'] =$id;
        $where[] = $first_where;

        $edit_result = $this->update_data($this->table3, $set, $where);
        //print_r($edit_name);

        if ($edit_result == 1) {
            return 1;
        }else {
            return "error";
        }

    } //



    public function add_program_sms($program_id,$content){

        $columns =array("program_id", "sms_type","content","status");
        $values = array($program_id, $content, 1 );

        $insert_data = $this->insert_data($this->table2, $columns, $values);

        if ($insert_data > 0) {
            $insert_array['id'] = $insert_data;
            return $insert_array;

        }  else {
            return "An error occurred";
        }

    }

    public function view_active_sms(){

    $columns =array("program_id", "sms_type","content", "status", "create_date");
    $thirdwhere['column_name'] ="status";
    $thirdwhere['sign'] ="=";
    $thirdwhere['value'] =1;
    $where[] = $thirdwhere;

    $check_no =  $this->select_tb($this->table2,$columns, $where);

    if (is_array($check_no)){

        return $check_no;
    } else {

        return 0;
    }

}


    public function view_active_program_sms($program_id){

        $columns =array("program_id", "sms_type","content", "status", "create_date");
        $thirdwhere['column_name'] ="status";
        $thirdwhere['sign'] ="=";
        $thirdwhere['value'] =1;
        $where[] = $thirdwhere;


        $thirdwhere['column_name'] ="program_id";
        $thirdwhere['sign'] ="=";
        $thirdwhere['value'] =$program_id;
        $where[] = $thirdwhere;

        $check_no =  $this->select_tb($this->table2,$columns, $where);

        if (is_array($check_no)){

            return $check_no;
        } else {

            return 0;
        }

    }



    public function view_program_sms($program_id){

        $columns =array("program_id","sms_type", "content", "status", "create_date");
        $thirdwhere['column_name'] ="program_id";
        $thirdwhere['sign'] ="=";
        $thirdwhere['value'] =$program_id;
        $where[] = $thirdwhere;

        $check_no =  $this->select_tb($this->table2,$columns, $where);

        if (is_array($check_no)){

            return $check_no;
        } else {

            return 0;
        }

    }

    public function view_sms(){

        $columns =array("program_id", "sms_type", "content", "status", "create_date");
//        $thirdwhere['column_name'] ="program_id";
//        $thirdwhere['sign'] ="=";
//        $thirdwhere['value'] =$program_id;
//        $where[] = $thirdwhere;

        $check_no =  $this->select_tb($this->table2,$columns );

        if (is_array($check_no)){

            return $check_no;
        } else {

            return 0;
        }

    }






    public function edit_program_sms($id, $content = null, $sms_type = null, $program_id = null, $status = null) {
        $key = "menu_id";
        //$columns_name = "service_name";


        if($content != null || $content="") {
            $firstset['column_name'] = "content";
            $firstset['sign'] = "=";
            $firstset['value'] = $content;
            $set[] = $firstset;
        }
        if($program_id != null || $program_id="") {
            $firstset['column_name'] = "program_id";
            $firstset['sign'] = "=";
            $firstset['value'] = $program_id;
            $set[] = $firstset;
        }
        if($status != null || $status="") {
            $firstset['column_name'] = "status";
            $firstset['sign'] = "=";
            $firstset['value'] = $status;
            $set[] = $firstset;
        }
        if($sms_type != null || $sms_type="") {
            $firstset['column_name'] = "sms_type";
            $firstset['sign'] = "=";
            $firstset['value'] = $sms_type;
            $set[] = $firstset;
        }


        $first_where['column_name'] ="id";
        $first_where['sign'] ="=";
        $first_where['value'] =$id;
        $where[] = $first_where;

        $edit_result = $this->update_data($this->table2, $set, $where);
        //print_r($edit_name);

        if ($edit_result == 1) {
            return 1;
        }else {
            return "error";
        }

    } //

    public function get_content($company_id, $sms_type){
        $columns =array("content");
        $thirdwhere['column_name'] =$this->table2.".program_id";
        $thirdwhere['sign'] ="=";
        $thirdwhere['value'] =$company_id;
        $where[] = $thirdwhere;

        $thirdwhere['column_name'] ="sms_type";
        $thirdwhere['sign'] ="=";
        $thirdwhere['value'] =$sms_type;
        $where[] = $thirdwhere;



        $check_no =  $this->select_tb($this->table2,$columns, $where);

        if (is_array($check_no)){

            return $check_no['data'][0];
        } else {

            return 0;
        }


    }

    // public function generate_sms($company_id, $sms_type, $replace_data)

    // {
    //     $get_content = $this->get_content($company_id,$sms_type);

    //     if(is_array($get_content)) {
    //         $content = $get_content['content'];
    //         $getvar = $this->view_variables();

    //         if (is_array($getvar)) {

    //             foreach ($replace_data as $test => $key) {
    //                 $phone_no = "";
    //                 $replace2[] = $key;

    //                 if($key['phone']) {
    //                     $phone_no = $key['phone'];
    //                 }
    //             }
    //             foreach ($getvar['data'] as $var) {

    //                 $search[] = $var['var_replace'];

    //             }


    //             foreach ($replace2 as $val) {

    //                 $newbody = str_replace($search, $val, $content);


    //                 $all[] = ['phone' => $phone_no, 'body' =>$newbody];
    //             }

    //             return $all;

    //         } else {

    //             return "No SMS variable Found";
    //         }
    //     } else {

    //         return "No SMS Template found";
    //     }
    // }
    
    //  public function generate_sms($company_id, $sms_type, $replace_data)

    // {
    //     $get_content = $this->get_content($company_id,$sms_type);

    //     if(is_array($get_content)) {


    //         $content = $get_content['content'];
    //         $getvar = $this->view_variables();

    //         if (is_array($getvar)) {
    //             $all=[];

    //             foreach ($replace_data as $key => $value) {

    //                 if($value['phone']) {
    //                     $phone_no = $value['phone'];
    //                 }

    //                 $newbody=$content;
    //                 foreach ($getvar['data'] as $var) {

    //                     $var_name = $var['variable_name'];
    //                     $search = $var['var_replace'];
    //                     if(isset($value[$var_name]))
    //                     {
    //                         $val =$value[$var_name];
    //                         $newbody = str_replace($search, $val, $newbody);
    //                     }


    //                 }
    //                 $all[] = ['phone' => $phone_no, 'body' => $newbody];
    //             }

    //             return $all;

    //         } else {

    //             return "No SMS variable Found";
    //         }
    //     } else {

    //         return "No SMS Template found";
    //     }
    // }

    
    public function generate_sms($company_id, $sms_type, $replace_data)

    {
        $get_content = $this->get_content($company_id,$sms_type);

                  
        if(is_array($get_content)) {
            $content = $get_content['content'];
            $getvar = $this->view_variables();

            $respond_array = array();

            //run through replace data sent
            foreach ($replace_data as $datum) {
                $single_value = array();
                $new_value = array();
                //assign variables to corresponding variable names
                foreach ($getvar['data'] as $value) {

                    if(isset($datum[$value['variable_name']])) {
                        $value['replace'] = $datum[$value['variable_name']];
                    } else {
                        //assign null if variable is not found
                        $value['replace'] = null;
                    }
                    $new_value[] = $value;
                }

                //convert array to column array for search and replace ensures they are in teh correct order
                $search = array_column($new_value,'var_replace');
                $replace = array_column($new_value, 'replace');

                //search and replace variables in cotent
                $body = str_replace($search, $replace, $content);

                $single_value['phone'] = $datum['phone'];
                $single_value['body'] = $body;
                
                $this->save_sms_store($company_id, $single_value['phone'], $single_value['body']);
                $respond_array[] = $single_value;
            }

            return $respond_array;

        } else {

            return "No SMS Template found";
        }
    }


    private function get_sms_details($company_id){
        $columns =array("api_key", "sender_id");
        $thirdwhere['column_name'] =$this->settings.".program_id";
        $thirdwhere['sign'] ="=";
        $thirdwhere['value'] =$company_id;
        $where[] = $thirdwhere;




        $check_no =  $this->select_tb($this->settings,$columns, $where);

        if (is_array($check_no)){

            return $check_no['data'][0];
        } else {

            return 0;
        }


    }


    public function send_sms($company_id, $send_data){

        $get_details = $this->get_sms_details($company_id);

        if(is_array($get_details)) {

            $body['api_key'] = $get_details['api_key'];
            $body['from'] = $get_details['sender_id'];
            $body['send_flag'] = 1;
            $body['send_date'] = null;
            $body['message_details'] = $send_data;

            //$fields = json_encode($body);
            
            $use_curl = new curl_class();
            $send_data = $use_curl->send_post_v6($this->sms_url, '', $body);

            if (is_array($send_data)) {

                return $send_data;
            } else {


                return $send_data;
            }
        } else {

            return "Access to SMS denied";
        }
    }
    
    private function save_sms_store ($client_id, $phone, $body){

        $columns = array("client_id", "phone", "body");
        $values = array($client_id, $phone, $body);
        $insert_data = $this->insert_data($this->store, $columns, $values);

        if ($insert_data > 0) {
            return 1;
        } else {

            return 0;
        }

    }

    public function delete_sms_store($client_id){

        $thirdwhere['column_name'] ="client_id";
        $thirdwhere['sign'] = "=";
        $thirdwhere['value'] =$client_id;
        $where[] = $thirdwhere;

        $get_delete = $this->delete_data($this->store, $where);

        return $get_delete;

    }

    public function get_sms_data($client_id){

        $columns =array("phone", "body");
        $thirdwhere['column_name'] ="client_id";
        $thirdwhere['sign'] ="=";
        $thirdwhere['value'] =$client_id;
        $where[] = $thirdwhere;

        $check_no =  $this->select_tb($this->store,$columns, $where);

        if (is_array($check_no)){

            return $check_no;
        } else {

            return 0;
        }

    }
    
    
     public function view_active_program_type_sms($program_id, $type_id){

        $columns =array("id","program_id", "sms_type","content", "status", "create_date");
        $thirdwhere['column_name'] ="status";
        $thirdwhere['sign'] ="=";
        $thirdwhere['value'] =1;
        $where[] = $thirdwhere;


        $thirdwhere['column_name'] ="program_id";
        $thirdwhere['sign'] ="=";
        $thirdwhere['value'] =$program_id;
        $where[] = $thirdwhere;

        $thirdwhere['column_name'] ="sms_type";
        $thirdwhere['sign'] ="=";
        $thirdwhere['value'] =$type_id;
        $where[] = $thirdwhere;

        $check_no =  $this->select_tb($this->table2,$columns, $where);

        if (is_array($check_no)){

            return $check_no['data'][0];
        } else {

            return 0;
        }

    }

    public function edit_active_program_type_sms($id, $content){

        $p_where['column_name'] = "id";
        $p_where['sign'] = "=";
        $p_where['value'] = $id;
        $where[] = $p_where;

        $ci_set['column_name'] = "content";
        $ci_set['sign'] = "=";
        $ci_set['value'] = $content;

        $set[] = $ci_set;

        $set_data = $this->update_data($this->table2, $set, $where);


        return $set_data;




    }
    
    public function view_program_sms_store($program_id){

        $columns =array("id","client_id","phone", "body", "create_date");
        $thirdwhere['column_name'] ="client_id";
        $thirdwhere['sign'] ="=";
        $thirdwhere['value'] =$program_id;
        $where[] = $thirdwhere;

        $check_no =  $this->select_tb($this->store,$columns, $where);

        if (is_array($check_no)){

            return $check_no['data'];
        } else {

            return 0;
        }

    }


    public function send_store_sms($program_id){
        $get_sms = $this->view_program_sms_store($program_id);

        if(count($get_sms) > 0){
            $get_data = $this->build_store_sms($get_sms);
//            echo json_encode($get_data);
//            die();
            $send_data =  $this->send_sms($program_id, $get_data);
            if(array($send_data)){
                $this->delete_sms_store($program_id);
                return $send_data;

            } else {

                return $send_data;
            }

        } else {

            return "No data found";
        }


    }


    private function build_store_sms ($send_data){

        $return_array = array();
        foreach ($send_data as $data){
            $content = array();
            $content['to'] = $data['phone'];
            $content['body'] = $data['body'];
            $return_array[] = $content;
        }

        return $return_array;


    }
}

//$data = [
//
//    ["name"=>"charles","age"=>"10"], ["name"=>"john", "age"=>"19"]
//];

//$data = [
//
//    ["phone"=>"2348122890094","firstname"=>"charles","amount"=>"1000","link"=>"https://localhost","username"=>"charles@charles.com", "password"=>"LM4avG1"], ["phone"=>"2348122890094","firstname"=>"char","amount"=>"5000","link"=>"https://localhost","username"=>"char123@char123.com", "password"=>"KH8avG1"]
//];
//$page_test = new sms_class();
////echo json_encode($page_test->get_content(1,1));
//echo json_encode($page_test->generate_sms(1,1, $data));


