<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 16/11/2018
 * Time: 15:53
 */
require_once ("main_class.php");
require_once ("company_class.php");
class tier_class extends Rewardsbox_main
{
    private $table = "portal_user_tiers";



    public function get_all_tier(){

        $columns = array("tier_id", "user_mgt_company.company_name", "user_mgt_company.company_id", "tier_name", "credit_amount", $this->table.".status");

        $firstjoin ['table_name']="user_mgt_company";
        $firstjoin ['first_column']="user_mgt_company.company_id";
        $firstjoin ['second_column']=$this->table.".company_id";
        $leftjoin []=$firstjoin;

        $get_data = $this->select_tb($this->table, $columns,"","","","","","",$leftjoin);



        if (is_array($get_data)){

            return $get_data['data'];
        } else {

            return "No data found";
        }


    }


    public function get_com_active($company_id){

        $columns = array("tier_id", "tier_name");

        $first_where['column_name'] ="company_id";
        $first_where['sign'] ="=";
        $first_where['value'] =$company_id;
        $where[] = $first_where;


        $first_where['column_name'] ="status";
        $first_where['sign'] ="=";
        $first_where['value'] =1;
        $where[] = $first_where;

        $get_data = $this->select_tb($this->table, $columns, $where);

        if (is_array($get_data)){

            return $get_data['data'];
        } else {

            return "No data found";
        }


    }


    public function single_com_tier ($company_id, $tier_id){
        $column = array("tier_name", "credit_amount");
        $first_where['column_name'] ="company_id";
        $first_where['sign'] ="=";
        $first_where['value'] =$company_id;
        $where[] = $first_where;


        $first_where['column_name'] ="tier_id";
        $first_where['sign'] ="=";
        $first_where['value'] =$tier_id;
        $where[] = $first_where;


        $first_where['column_name'] ="status";
        $first_where['sign'] ="=";
        $first_where['value'] =1;
        $where[] = $first_where;

        $get_name = $this->select_tb($this->table,$column,$where);

        if (is_array($get_name)){

            return $get_name['data'][0];

        } else {

            return "No data found";

        }

    }


    public function get_tier_name($id){
        $column = array("tier_name", "credit_amount", "status");
        $first_where['column_name'] ="tier_id";
        $first_where['sign'] ="=";
        $first_where['value'] =$id;
        $where[] = $first_where;

        $get_name = $this->select_tb($this->table,$column,$where);

        if (is_array($get_name)){

            return $get_name['data'][0];
        } else {

            return 0;
        }
    }




    public function create_tier ($company_id, $tier_name, $credit_amount){

        if(isset($company_id) && isset($tier_name) && isset($credit_amount) ) {

            if ($company_id == "" || $tier_name == "" || $credit_amount == "" || !is_numeric($credit_amount) || $credit_amount < 0) {

                return "Invalid or blank Parameters";
            } else {

                $use_company = new Reward_company();
                $check_company = $use_company->get_company($company_id);
                if (is_array($check_company)) {
                    $company_name = $check_company['company_name'];
                    $column = array("company_id", "tier_name", "credit_amount", "status");
                    $value = array($company_id, $tier_name, $credit_amount, 1);


                    $thirdwhere['column_name'] = "tier_name";
                    $thirdwhere['sign'] = "=";
                    $thirdwhere['value'] = $tier_name;
                    $where[] = $thirdwhere;

                    $thirdwhere['column_name'] = "company_id";
                    $thirdwhere['sign'] = "=";
                    $thirdwhere['value'] = $company_id;
                    $where[] = $thirdwhere;

                    $insert_data = $this->insert_check_duplicate($this->table, $column, $value, $where, 1);

                    if ($insert_data > 0) {
                        $insert_array['id'] = $insert_data;
                        $insert_array['name'] = $tier_name;
                        $insert_array['company_name'] = $company_name;
                        $insert_array['credit_amount'] = $credit_amount;

                        return $insert_array;

                    } elseif ($insert_data < 0) {
                        return "Category type already exists";

                    } else {
                        return "An error occurred";
                    }
                } else {

                    return "Invalid Company";
                }
            }
        } else {

            return "Missing Parameter";
        }
    }


    public function edit_tier($id, $company_id, $tier_name, $credit_amount) {

        if(isset($id) && isset($company_id) && isset($tier_name) && isset($credit_amount)) {

//            if($id == "" || $company_id == "" || $tier_name == "" || $credit_amount == "" || !is_numeric($credit_amount || $credit_amount < 0)){
//
//
//                return "Blank or Invalid Parameter";
//
//            } else {

                $use_company = new Reward_company();
                $check_company = $use_company->get_company($company_id);

                if(is_array($check_company)) {

                    $company_name = $check_company['company_name'];
                    $key = "tier_id";
                    //$columns_name = "service_name";

                    $firstset['column_name'] = "tier_name";
                    $firstset['sign'] = "=";
                    $firstset['value'] = $tier_name;
                    $set[] = $firstset;
                    $whereduplicate[] = $firstset;

                    $firstset['column_name'] = "company_id";
                    $firstset['sign'] = "=";
                    $firstset['value'] = $company_id;
                    $set[] = $firstset;
                    $whereduplicate[] = $firstset;

                    $firstset['column_name'] = "credit_amount";
                    $firstset['sign'] = "=";
                    $firstset['value'] = $credit_amount;
                    $set[] = $firstset;


                    $first_where['column_name'] = $key;
                    $first_where['sign'] = "=";
                    $first_where['value'] = $id;
                    $where[] = $first_where;


                    $edit_result = $this->update_check_duplicate($this->table, $set, $where, $whereduplicate, $key, 1);
                    //print_r($edit_name);

                    if ($edit_result == 1) {
                        return 1;

                    } elseif ($edit_result == -1) {
                        return "Tier already exists for ".$company_name;

                    } else {
                        return "Invalid Tier";
                    }
                } else {

                    return "Invalid Company";
                }
//            }
        }
        else {

            return "Missing Parameter";
        }
    } // end edi name function


    public function change_tier_status ($tier_id, $new_status){
        $key = "tier_id";
        //$columns = array($key,"status");

        if ($new_status == 1) {

            $msg = "Active";

        } else {
            $new_status = 0;
            $msg= "Inactive";
        }

        $change_status = $this->change_status($tier_id, $new_status,$this->table,$key);
        if ($change_status == 1){
            $d_array = array();
            //$d_array['reqstatus'] == 1;
            $d_array['status'] = $new_status;
            $d_array['message'] = "Successfully made ".$msg;
            return $d_array;

        } elseif ($change_status ==-2) {
            return "Cannot locate Tier";

        } elseif ($change_status ==-1) {
            return "Tier already ".$msg;

        } else {
            return "An error occurred";
        }


    } // end change status

}

//$page_test = new tier_class();
//echo json_encode($page_test->get_all_tier());
//echo json_encode($page_test->create_tier(9,"Gold", 5000));