<?php
require_once("main_class.php");
require_once ("user_role_class.php");
require_once ("send_mail_class.php");

class Reward_users extends Rewardsbox_main {

    private $user_detail_table = "usr_mgt_lsl_user_details";
    private $user_table = "user_mgt_lsl_users";

    public function add_user_details($user_id, $first_name,$last_name,$phone_no_1, $phone_no_2){


    }


    public function add_user($username, $email, $password, $role_id, $page_id = 0, $first_name, $last_name=null, $phone_no = null,$phone_no_2 = null){

        if(isset($password) && strlen($password) > 6) {

            $role_table = "user_mgt_roles";
            $role_columns = array("role_name");
            $r_where['column_name'] = "role_id";
            $r_where['sign'] = "=";
            $r_where['value'] = $role_id;
            $role_where[] = $r_where;

            if($role_id == 1){

                $page_id = 1;
            }

            $r_where['column_name'] = "status";
            $r_where['sign'] = "=";
            $r_where['value'] = 1;
            $role_where[] = $r_where;

            $hash_password = hash('sha512', $password);
            $page_table = "usr_mgt_page";
            $page_columns = array("page_name");
            $p_where['column_name'] = "page_id";
            $p_where['sign'] = "=";
            $p_where['value'] = $page_id;
            $page_where[] = $p_where;

            $phone_no = $this->adjust_phone_no($phone_no);
            $phone_no_2 = $this->adjust_phone_no($phone_no_2);

            if (filter_var($email, FILTER_VALIDATE_EMAIL)) {
                $role_check = $this->select_tb($role_table, $role_columns, $role_where);
                if (is_array($role_check)) {

                    $role_name = $role_check['data'][0]['role_name'];

                        $page_check = $this->select_tb($page_table, $page_columns, $page_where);

                    if (is_array($page_check)) {
                        $columns = array("username", "email", "role_id", "page_id", "is_locked", "lock_count", "status", "password");
                        $values = array($username, $email, "$role_id", "$page_id", 0, 0, "1", $hash_password);

                        $u_where['column_name'] = "username";
                        $u_where['sign'] = "=";
                        $u_where['value'] = $username;
                        $user_where[] = $u_where;

                        $u1_where['column_name'] = "email";
                        $u1_where['sign'] = "=";
                        $u1_where['value'] = $email;
                        $user_where[] = $u1_where;
                        $add_user = $this->create_all_data($this->user_table, $columns, $values, $user_where);
                        if ($add_user > 0) {
                            $detail_column = array("user_id", "first_name", "last_name", "phone_no", "phone_no_2");
                            $detail_value = array($add_user, $first_name, $last_name, $phone_no, $phone_no_2);
                            $this->insert_data($this->user_detail_table, $detail_column, $detail_value);

                            $insert_array['id'] = $add_user;
                            $insert_array['user_name'] = $username;
                            $insert_array['email'] = $email;
                            $insert_array['role_name'] = $role_name;
                            $insert_array['first_name'] = $first_name;
                            $insert_array['last_name'] = $last_name;
                            $insert_array['phone_no'] = $phone_no;

                            $use_send_email = new send_mail_class();
                            $use_send_email->send_lsl_enrol($first_name, $last_name, $email, $password, $username, $role_name);
                            return $insert_array;

                        } elseif ($add_user == -1) {
                            return "Username or email Already exists";

                        } else {
                            return "An error occurred";
                        }

                    } else {

                        return "Invalid page selected";
                    }
                } else {

                    return "Invalid Role Selected";
                }
            } else {
                return "Invalid email address";
            }
        } else {

            return "Password must be greater than 6 characters";
        }
    }


    public function change_password($current_password, $new_password){

        if(isset($new_password) && strlen($new_password) > 6){
            $hash_password = hash('sha512', $current_password);
            $hash_new_password = hash('sha512', $new_password);
            $user_id= $_SESSION['user_id'];
            //$user_id = 5;
            $column = array($this->user_table.".user_id","email","first_name", "last_name");

            $firstjoin ['table_name'] = $this->user_detail_table;
            $firstjoin ['first_column'] = $this->user_table.".user_id";
            $firstjoin ['second_column'] = $this->user_detail_table . ".user_id";
            $leftjoin [] = $firstjoin;

            $u_where['column_name'] = $this->user_table.".user_id";
            $u_where['sign'] = "=";
            $u_where['value'] = $user_id;
            $user_where[] = $u_where;

            $u_where['column_name'] = "password";
            $u_where['sign'] = "=";
            $u_where['value'] = $hash_password;
            $user_where[] = $u_where;

            $check_data = $this->select_tb($this->user_table, $column,$user_where,"AND","","","","",$leftjoin);

            if(is_array($check_data)){


                $firstset['column_name'] = "password";
                $firstset['sign'] = "=";
                $firstset['value'] = $hash_new_password;
                $set[] = $firstset;

                $u_where['column_name'] = "user_id";
                $u_where['sign'] = "=";
                $u_where['value'] = $user_id;
                $where[] = $u_where;

                $update_data = $this->update_data($this->user_table,$set,$where);

                if($update_data == 1){
                    $d_array['message'] = "Password successfully changed";
                    $use_mail = new send_mail_class();
                    $use_mail->lsl_send_change_password($check_data['data'][0]['first_name'],$check_data['data'][0]['email'], $check_data['data'][0]['last_name']);
                    return $d_array;
                } else{

                    return "Unable to process request";
                }

            } else {

                return "Invalid Current Password";
            }



        } else {

            return "Password must be greater than 6 characters";
        }


    }

    public function view_profile(){
        $user_id= $_SESSION['user_id'];

        $column= array("email", "first_name", "last_name", "phone_no", "phone_no_2");
        $firstjoin ['table_name']=$this->user_detail_table;
        $firstjoin ['first_column']=$this->user_detail_table.".user_id";
        $firstjoin ['second_column']=$this->user_table.".user_id";
        $leftjoin []=$firstjoin;

        $u_where['column_name'] = $this->user_table.".user_id";
        $u_where['sign'] = "=";
        $u_where['value'] = $user_id;
        $where[] = $u_where;

        $get_data = $this->select_tb($this->user_table, $column, $where,"","","","","",$leftjoin);

        if(is_array($get_data)){

            return $get_data['data'][0];
        } else {

            return "No data found";
        }




    }

    public function view_users(){

        $columns = array($this->user_table.".user_id", "username", $this->user_detail_table.".first_name", $this->user_detail_table.".last_name", "email","phone_no", $this->user_table.".status", "is_locked","user_mgt_roles.role_name");

        $firstjoin ['table_name']="user_mgt_roles";
        $firstjoin ['first_column']="user_mgt_roles.role_id";
        $firstjoin ['second_column']=$this->user_table.".role_id";
        $leftjoin []=$firstjoin;

        $firstjoin ['table_name']=$this->user_detail_table;
        $firstjoin ['first_column']="$this->user_detail_table.user_id";
        $firstjoin ['second_column']=$this->user_table.".user_id";
        $leftjoin []=$firstjoin;



        $get_data = $this->select_tb($this->user_table, $columns, "","","","","","",$leftjoin);

        if (is_array($get_data)){

            return $get_data['data'];
        } else {

            return "No data found";
        }


    }


    public function view_active_users(){

        $columns = array($this->user_table.".user_id", "username", $this->user_detail_table.".first_name", $this->user_detail_table.".last_name", "email", $this->user_table.".status");


        $firstjoin ['table_name']=$this->user_detail_table;
        $firstjoin ['first_column']="$this->user_detail_table.user_id";
        $firstjoin ['second_column']=$this->user_table.".user_id";
        $leftjoin []=$firstjoin;

        $u_where['column_name'] = $this->user_table.".status";
        $u_where['sign'] = "=";
        $u_where['value'] = 1;
        $where[] = $u_where;



        $get_data = $this->select_tb($this->user_table, $columns, $where,"","","","","",$leftjoin);

        if (is_array($get_data)){

            return $get_data['data'];
        } else {

            return "No data found";
        }


    }

    public function edit_user_details($id, $first_name, $last_name, $phone_no){

        $today_date = Date('Y-m-d H:i:s');

        if(isset($id) && isset($first_name) && isset($last_name) && isset($phone_no)) {

           if ($first_name == "" || $last_name == "" || $phone_no == ""){


                return "Blank Parameters";
           } else {


               $key = "user_id";


               $firstset['column_name'] = "firstname";
               $firstset['sign'] = "=";
               $firstset['value'] = $first_name;
               $set[] = $firstset;

               $firstset['column_name'] = "lastname";
               $firstset['sign'] = "=";
               $firstset['value'] = $last_name;
               $set[] = $firstset;

               $firstset['column_name'] = "phone_no";
               $firstset['sign'] = "=";
               $firstset['value'] = $phone_no;
               $set[] = $firstset;

               $firstset['column_name'] = "update_date";
               $firstset['sign'] = "=";
               $firstset['value'] = $today_date;
               $set[] = $firstset;

               $first_where['column_name'] = $key;
               $first_where['sign'] = "=";
               $first_where['value'] = $id;
               $where[] = $first_where;

               $edit_result = $this->update_data($this->user_detail_table, $set, $where);
               //print_r($edit_name);

               if ($edit_result == 1) {
                   return 1;


               } else {
                   return "Error occurred";
               }

           }
        } else {

            return "Missing Parameter";
        }



    }


    public function edit_user($id, $user_name, $email, $role_id) {
        $today_date = Date('Y-m-d H:i:s');
        $key = "user_id";
        $use_role = new Reward_user_role();

        $check_role = $use_role->get_role_name($role_id);

        if (is_array($check_role)) {

            $firstset['column_name'] = "username";
            $firstset['sign'] = "=";
            $firstset['value'] = $user_name;
            $set[] = $firstset;
            $whereduplicate[] = $firstset;

            $firstset['column_name'] = "email";
            $firstset['sign'] = "=";
            $firstset['value'] = $email;
            $set[] = $firstset;
            $whereduplicate[] = $firstset;

            $firstset['column_name'] = "role_id";
            $firstset['sign'] = "=";
            $firstset['value'] = $role_id;
            $set[] = $firstset;

            $firstset['column_name'] = "update_date";
            $firstset['sign'] = "=";
            $firstset['value'] = $today_date;
            $set[] = $firstset;

            $first_where['column_name'] = $key;
            $first_where['sign'] = "=";
            $first_where['value'] = $id;
            $where[] = $first_where;

            $edit_result = $this->update_check_duplicate($this->user_table, $set, $where, $whereduplicate, $key,0);
            //print_r($edit_name);

            if ($edit_result == 1) {
                return 1;

            } elseif ($edit_result == -1) {
                return "Role already exists";

            } else {
                return "Invalid role";
            }

        } else {

            return "Invalid User";
        }
    } // end edi name function


    public function change_user_status ($user_id, $new_status){
        $key = "user_id";
        //$columns = array($key,"status");

        if ($new_status == 1) {

            $msg = "Active";

        } else {
            $new_status = 0;
            $msg= "Inactive";
        }

        $change_status = $this->change_status($user_id, $new_status,$this->user_table,$key);
        if ($change_status == 1){
            $d_array = array();
            $d_array['status'] = $new_status;
            $d_array['message'] = "Successfully made ".$msg;
            return $d_array;

        } elseif ($change_status ==-2) {
            return "Cannot locate User";

        } elseif ($change_status ==-1) {
            return "User already ".$msg;

        } else {
            return "An error occurred";
        }


    } // end change status

    public function lock_unlock_user ($user_id, $new_status){
        $key = "user_id";
        //$columns = array($key,"status");

        if ($new_status == 1) {

            $msg = "Lock";

        } else {
            $new_status = 0;
            $msg= "Unlock";
        }

        $check_user = $this->get_user($user_id);



        if (is_array($check_user)) {

            $is_locked = $check_user['is_locked'];

            if ($is_locked != $new_status) {

                $firstset['column_name'] = "is_locked";
                $firstset['sign'] = "=";
                $firstset['value'] = $new_status;
                $set[] = $firstset;

                if($new_status == 0){

                    $firstset['column_name'] = "lock_count";
                    $firstset['sign'] = "=";
                    $firstset['value'] = 0;
                    $set[] = $firstset;

                }
                $first_where['column_name'] = $key;
                $first_where['sign'] = "=";
                $first_where['value'] = $user_id;
                $where[] = $first_where;

                $change_status = $this->update_data($this->user_table,$set,$where);
                if ($change_status == 1) {
                    $d_array = array();
                    $d_array['status'] = $new_status;
                    $d_array['message'] = "Successfully " . $msg;
                    return $d_array;

                } else {
                    return "An error occurred";
                }

            } else {

                return "Account already ".$msg;

            }
        } else {

            return $check_user;
        }

    } // end change status


    public function get_user($id){

        $columns = array("user_id","username", "email", "is_locked", "lock_count");

        $first_where['column_name'] = "user_id";
        $first_where['sign'] = "=";
        $first_where['value'] = $id;
        $where[] = $first_where;

        $first_where['column_name'] = "status";
        $first_where['sign'] = "=";
        $first_where['value'] = 1;
        $where[] = $first_where;

        $get_data = $this->select_tb($this->user_table, $columns, $where);

        if (is_array($get_data)){

            return $get_data['data'][0];

        } else {

            return "Invalid or Disabled User";
        }
    }


    public function login_reset($user_id){

        $today_date = Date('Y-m-d H:i:s');

        $firstset['column_name'] = "lock_count";
        $firstset['sign'] = "=";
        $firstset['value'] = 0;
        $set[] = $firstset;

        $firstset['column_name'] = "last_login";
        $firstset['sign'] = "=";
        $firstset['value'] = $today_date;
        $set[] = $firstset;

        $first_where['column_name'] = "user_id";
        $first_where['sign'] = "=";
        $first_where['value'] = $user_id;
        $where[] = $first_where;

        $update_data = $this->update_data($this->user_table, $set, $where);



            return $update_data;




    }


    public function get_role_user($role_id){

        $columns = array("user_id","username", "email");

        $first_where['column_name'] = "role_id";
        $first_where['sign'] = "=";
        $first_where['value'] = $role_id;
        $where[] = $first_where;

        $first_where['column_name'] = "status";
        $first_where['sign'] = "=";
        $first_where['value'] = 1;
        $where[] = $first_where;

        $get_data = $this->select_tb($this->user_table, $columns, $where);

        if (is_array($get_data)){

            return $get_data['data'];

        } else {

            return "Invalid or Disabled User";
        }

    }

}// end class

//$page_test = new Reward_users();
//echo json_encode($page_test->view_active_users());
//echo json_encode($page_test->change_password("123456","1234567"));
//echo json_encode($page_test->view_profile());
//echo json_encode($page_test->get_role_user(2));
//echo json_encode($page_test->add_user("test231","test231@test.com","1234567","2",48,"Jane","Smith","8122890051"));
//echo json_encode($page_test->view_users());