<?php

require_once ('../includes/startsession.php');

if (isset($_SESSION['user_id'])) {
require_once ('../classes/user_login_class.php');
require_once ('../classes/portal_user_class.php');

$check_details = new Rewards_user_login_class();

$get_details = $check_details->script_access();
$get_portal = new portal_user_class();
if(is_array($get_details)) {
//{"create_access":"0","read_access":"0","update_access":"0","delete_access":"0"}
    if (isset($get_details['create_access'])) {

        $create = $get_details['create_access'];

    } else {

        $create = 0;
    }

    if (isset($get_details['read_access'])) {

        $read = $get_details['read_access'];

    } else {

        $read = 0;
    }

    if (isset($get_details['update_access'])) {

        $update = $get_details['update_access'];

    } else {

        $update = 0;
    }

    if (isset($get_details['delete_access'])) {

        $delete = $get_details['delete_access'];

    } else {

        $delete = 0;
    }


    if (isset($_POST['action'])){
        $action = $_POST['action'];

        if($action == 'add'){
            if ($create == 1){

                if(isset($_POST['firstname']) || isset($_POST['lastname']) || isset($_POST['company_id'])){

                    if ($_POST['company_id'] == ""){

                        $response_array['status'] = 0;
                        $response_array['message'] ="No Company_id sent";

                    } else {
                        $firstname = strtolower(trim($_POST['firstname']));
                        $lastname = strtolower(trim($_POST['lastname']));
                        $email = strtolower(trim($_POST['email']));
                        $phone = strtolower(trim($_POST['phone']));
                        $password = strtolower(trim($_POST['password']));
                        $memberno = strtolower(trim($_POST['memberno']));
                        $tier = strtolower(trim($_POST['tier']));
                        $company_id = strtolower(trim($_POST['company_id']));

                        $add_user = $get_portal->create_portal_user($firstname,$lastname, $email, $password, $memberno, $company_id, $tier, $phone);
                       if (is_array($add_user)) {
                            //if ($add_user['status'] == 200) {
                            $response_array['status'] = 1;
                            $response_array['message'] = "success";
                            $response_array['data'] = $add_user;
                            $response_array['iedit'] = $update;
                            $response_array['idelete'] = $delete;
                        } else {


                            $response_array['status'] = 0;
                            $response_array['message'] =$add_user;
                        }


                    }

                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] ="Invalid Data";

                }


            } else{

                $response_array['status'] = -1;
                $response_array['message'] ="Access denied";

            }


        } elseif ($action =='edit'){

            if ($update == 1){

                if(isset($_POST['email']) || isset($_POST['item_id'])){

                    if ($_POST['email'] == "" || $_POST['item_id'] ==""){

                        $response_array['status'] = 0;
                        $response_array['message'] ="Invalid data";

                    } else {

                        $memberno = trim($_POST['item_id']);
                        $firstname = strtolower(trim($_POST['firstname']));
                        $lastname = strtolower(trim($_POST['lastname']));
                        $email = strtolower(trim($_POST['email']));
                        $phone = strtolower(trim($_POST['phone']));
//                        $password = strtolower(trim($_POST['password']));
//                        $memberno = strtolower(trim($_POST['memberno']));
//                        $tier = strtolower(trim($_POST['tier']));
                        $company_id = strtolower(trim($_POST['company_id']));

                        $edit_color = $get_portal->edit_member($company_id,$memberno,$firstname, $lastname,$email, $phone);

//                        print_r($edit_color);

                        if (is_array($edit_color)){

                            $response_array['status'] = 1;
                            $response_array['message'] ="Account Updated";

                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] =$edit_color;
                        }


                    }

                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] ="No values set";

                }

            } else{

                $response_array['status'] = -1;
                $response_array['message'] ="Access denied";

            }

        } elseif ($action =='delete'){
            if ($delete == 1){

                if(isset($_POST['status']) || isset($_POST['item_id'])){


                    if($_POST['status'] == "" || $_POST['item_id'] == "" || !is_numeric($_POST['status']) || !is_numeric($_POST['item_id'])){

                        $response_array['status'] = 0;
                        $response_array['message'] ="Invalid Data sent";

                    } else {
                        $memberno = trim($_POST['item_id']);
                        $status = trim($_POST['status']);
                        $company_id = trim($_POST['company_id']);
                        if ($status == 1){
                        $msg = "active";

                        }else{

                            $msg = "inactive";
                        }

                        $del_color = $get_portal->enable_disable_member($company_id,$memberno,$status);

//                        print_r($del_color);

                        if (is_array($del_color)){
                            $response_array['status'] = 1;
                            $response_array['message'] ="member is ".$msg;

                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] =$del_color;
                        }

                    }


                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] ="Missing data";

                }


            } else{

                $response_array['status'] = -1;
                $response_array['message'] ="Access denied";

            }

        }else{

            $response_array['status'] = 0;
            $response_array['message'] ="Invalid action";
        }


    } else {

        $response_array['status'] = 0;
        $response_array['message'] ="No action sent";
    }


} else {

    $response_array['status'] = 0;
    $response_array['message'] = "Error getting Access";
}
} else {

    $response_array['status'] = 4004;
    $response_array['message'] ="Session expired";
}

echo json_encode($response_array);
?>