<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 06/10/2020
 * Time: 12:17
 */

require_once("../../classes/premium_incentives_class.php");
require_once("../../classes/send_mail_class.php");



if (isset($_SERVER['HTTP_TOKEN'])) {

    if ($_SERVER['HTTP_TOKEN'] == "") {
        $response_array['status'] = 0;
        $response_array['message'] = "blank token sent";
    } else {
        $token = $_SERVER['HTTP_TOKEN'];

        $use_premium = new premium_incentives_class();

        $check_token = $use_premium->check_token($token);

        if (is_array($check_token)) {

            $company_id = $check_token['company_id'];
            $plan_id = $check_token['user_plan'];
            $client_no = $check_token['client_no'];
            $company_name = $check_token['company_name'];
            $prefix = $check_token['prefix'];
            // $use_log = new log_class();
            $use_send_email = new send_mail_class();
            if ($_GET['api'] == "custom_mail") {

                if (isset($_POST['first_name']) && isset($_POST['email']) && isset($_POST['member_no'])) {

                    $first_name = $_POST['first_name'];
                    $email = $_POST['email'];
                    $member_no = $_POST['member_no'];

                    if (isset($_POST['last_name'])) {

                        $last_name = $_POST['last_name'];
                    } else {

                        $last_name = "";
                    }

                    if ($first_name == "" || $email == "" || $member_no =="") {

                        $response_array['status'] = 0;
                        $response_array['message'] = "Blank Parameter";
                    } else {

                        $send_email = $use_send_email->send_premium_incentives_custom($first_name, $email, $last_name,$member_no, $client_no);

                        if (is_array($send_email)) {


                            $response_array['status'] = 1;
                            $response_array['message'] = "Email Sent";
                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] = $send_email;
                        }
                    }

                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] = "Missing Parameter";
                }


            } else {

                $response_array['status'] = 0;
                $response_array['message'] = "Invalid request";

            }

        } else {

            $response_array['status'] = 0;
            $response_array['message'] = "Invalid token";
        }
        
        
    }
echo json_encode($response_array);
}

