<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 28/10/2018
 * Time: 12:45
 */
require_once ("main_class.php");
require_once ("company_class.php");
require_once ("user_class.php");
class company_access_class extends Rewardsbox_main
{

    private $table = "user_mgt_company";
    private $access_table = "user_mgt_assign_company";


    public function get_company(){

        if(isset($_SESSION['role_id'])) {

            if($_SESSION['role_id'] == 1) {

                $columns = array("company_id", "client_no", "company_name");
                $get_company = $this->select_tb($this->table, $columns);

                if (is_array($get_company)) {

                    return $get_company['data'];

                } else {

                    return $get_company;
                }
            } else {


                $user_id = $_SESSION['user_id'];
                $get_company = $this->get_access_company($user_id);
                if (is_array($get_company)){

                    return $get_company;
                } else {

                    return "No data found";
                }

            }

        } else {

            return "No session running";
        }

    }


    public function get_portal_company(){

        if(isset($_SESSION['role_id'])) {

            if($_SESSION['role_id'] == 1) {

                $columns = array("company_id", "client_no", "company_name");

                $p_where['column_name'] = "portal_access";
                $p_where['sign'] = "=";
                $p_where['value'] = 1;
                $where[] = $p_where;

                $get_company = $this->select_tb($this->table, $columns,$where);

                if (is_array($get_company)) {

                    return $get_company;

                } else {

                    return $get_company;
                }
            } else {


                $user_id = $_SESSION['user_id'];
                $get_company = $this->get_portal_access_company($user_id);
                if (is_array($get_company)){

                    return $get_company;
                } else {

                    return "No data found";
                }

            }

        } else {

            return "No session running";
        }

    }


    public function del_access_company($assign_id){

        $check_data = $this->check_assign($assign_id);

        if (is_array($check_data)){
            $u_where['column_name'] = $this->access_table.".assign_id";
            $u_where['sign'] = "=";
            $u_where['value'] = $assign_id;
            $where[] = $u_where;

            $del_data = $this->delete_data($this->access_table,$where);

            if ($del_data == 1){

                //return "Access to company removed";
                return $del_data;
            } else {

                return "Error deleting data";
            }

        } else {

            return $check_data;
        }



    }

    public function check_assign($assign_id){

        $columns = array("company_id");
        $u_where['column_name'] = $this->access_table.".assign_id";
        $u_where['sign'] = "=";
        $u_where['value'] = $assign_id;
        $where[] = $u_where;

        $get_data = $this->select_tb($this->access_table,$columns, $where);

        if (is_array($get_data)){

            return $get_data['data'][0];

        } else {

            return "No data found";
        }
    }

    public function get_access_company($user_id){

        $columns = array($this->table.".company_id", "client_no", "company_name","assign_id");
        $firstjoin ['table_name']=$this->access_table;
        $firstjoin ['first_column']=$this->access_table.".company_id";
        $firstjoin ['second_column']=$this->table.".company_id";
        $leftjoin []=$firstjoin;

        $u_where['column_name'] = $this->access_table.".user_id";
        $u_where['sign'] = "=";
        $u_where['value'] = $user_id;
        $where[] = $u_where;
        $get_company = $this->select_tb($this->table, $columns,$where,"","","","","",$leftjoin);

        if (is_array($get_company)) {

            return $get_company['data'];

        } else {

            return "No data found";
        }


    }

    public function get_portal_access_company($user_id){

        $columns = array($this->table.".company_id", "client_no", "company_name","assign_id");
        $firstjoin ['table_name']=$this->access_table;
        $firstjoin ['first_column']=$this->access_table.".company_id";
        $firstjoin ['second_column']=$this->table.".company_id";
        $leftjoin []=$firstjoin;

        $u_where['column_name'] = $this->access_table.".user_id";
        $u_where['sign'] = "=";
        $u_where['value'] = $user_id;
        $where[] = $u_where;

        $u_where['column_name'] = "portal_access";
        $u_where['sign'] = "=";
        $u_where['value'] = 1;
        $where[] = $u_where;

        $get_company = $this->select_tb($this->table, $columns,$where,"","","","","",$leftjoin);

        if (is_array($get_company)) {

            return $get_company['data'];

        } else {

            return "No data found";
        }


    }

    public function get_not_access_company($user_id){


            $select1 = "SELECT  company_id, company_name FROM ".$this->table." WHERE company_id";
            $sign = "NOT IN";
            $select2 ="SELECT company_id FROM ".$this->access_table." WHERE user_id =".$user_id;

            $get_list = $this->combine_two_select($select1,$sign,$select2);

            if (is_array($get_list)){

                return $get_list['data'];
            } else {

                return "No data found";
            }



    }

    public function add_company_access($user_id,$company_id){
        $column = array("user_id", "company_id");
        $values = array($user_id,$company_id);
        $u_where['column_name'] = "user_id";
        $u_where['sign'] = "=";
        $u_where['value'] = $user_id;
        $where[] = $u_where;

        $u_where['column_name'] = "company_id";
        $u_where['sign'] = "=";
        $u_where['value'] = $company_id;
        $where[] = $u_where;
        $use_user = new Reward_users();
        $check_user_id = $use_user->get_user($user_id);
        if (is_array($check_user_id)){

            $use_company = new Reward_company();
            $check_company = $use_company->get_company($company_id);

            if (is_array($check_company)){

                $insert_data = $this->insert_check_duplicate($this->access_table, $column,$values,$where,1);

                if($insert_data > 0){
                    $s_array['assign_id'] = $insert_data;
                    $s_array['company_name'] = $check_company['company_name'];
                    $s_array['user_email'] = $check_user_id['email'];
                    //return "Access to ".$check_company['company_name']." granted to ".$check_user_id['email'];
                    return $s_array;
                } else {

                    if ($insert_data == -1){


                        return "Duplicate entry";

                    } else {

                        return "Error inserting data";
                    }


                }

            } else {

                return "Invalid Company";
            }

        } else {

            return "Invalid User";
        }


    }


    public function get_single_company($id){
        $column = array("company_name");

        $p2_where['column_name'] ="company_id";
        $p2_where['sign'] ="=";
        $p2_where['value'] =$id;

        $where[]=$p2_where;

        $get_company = $this->select_tb($this->table,$column,$where);

        if (is_array($get_company)){

            return $get_company['data'][0];

        } else {

            return "No company found";
        }


    }

    public function get_token_company($id){
        $column = array("company_token","client_no");

        $p2_where['column_name'] ="company_id";
        $p2_where['sign'] ="=";
        $p2_where['value'] =$id;

        $where[]=$p2_where;

        $get_company = $this->select_tb($this->table,$column,$where);

        if (is_array($get_company)){

            return $get_company['data'][0];

        } else {

            return "No company found";
        }


    }


}

//$page_test = new company_access_class();
//echo json_encode($page_test->get_not_access_company(4));
//echo json_encode($page_test->get_access_company(10));
//echo json_encode($page_test->add_company_access(4,12));
//echo json_encode($page_test->del_access_company(2));