<?php
require_once("main_class.php");
//require_once("database_class.php");

class Reward_plan extends Rewardsbox_main {
	
	private $plan_table = "user_mgt_plan";
	private $link_table = "user_mgt_plan_services";
	private $wallet_id = 1;
	private $portal_id = 2;
	
	
	public function create_plan ($plan_name, $plan_desc){
		
		$columns = array("plan_name", "plan_desc","status");
		$values = array($plan_name,$plan_desc,"1");
		
		$thirdwhere['column_name'] ="plan_name";
		$thirdwhere['sign'] ="=";
		$thirdwhere['value'] =$plan_name;
		$where[] = $thirdwhere;
		
		$create_plan = $this->create_all_data($this->plan_table,$columns,$values,$where);
		if ($create_plan > 0){

            $r_array['id'] = $create_plan;
            $r_array['name'] = $plan_name;
            $r_array['desc'] = $plan_desc;
			return $r_array;
			
		} elseif ($create_plan <0) {
			return "Plan Already exists";
		
		} else {
			return "An error occurred";
		}
		

	} // end create plan
	
	
	public function edit_plan_details($id, $new_plan_name, $desc) {
		$key = "plan_id";
		//$columns_name = "service_name";
		
					$firstset['column_name'] ="plan_name";
					$firstset['sign'] ="=";
					$firstset['value'] =$new_plan_name;
					$set[] = $firstset;
					$whereduplicate[] = $firstset;
					
					$secondset['column_name'] ="plan_desc";
					$secondset['sign'] ="=";
					$secondset['value'] =$desc;
					$set[] = $secondset;
					
					$first_where['column_name'] ="plan_id";
					$first_where['sign'] ="=";
					$first_where['value'] =$id;
					$where[] = $first_where;
				
		$edit_name = $this->update_check_duplicate($this->plan_table, $set, $where, $whereduplicate, $key);
		//print_r($edit_name);
		
		if ($edit_name == 1){
			return 1;
			
		} elseif ($edit_name ==-1) {
			return "Unable to locate plan";
		
		}  else {
			return "An error occurred";
		}
		
	} // end edi name function
	
	public function change_plan_status ($plan_id, $new_status){
		$key = "plan_id";
	$columns = array($key,"status");
			
		if ($new_status == 1) {
			
			$msg = "Active";
			
		} else {
			$new_status = 0;
			$msg= "Inactive";	
		}
				
		$change_status = $this->change_status($plan_id, $new_status,$this->plan_table,$key);
		if ($change_status == 1){
			return 1;
			
		} elseif ($change_status ==-2) {
			return "Cannot locate plan";
		
		} elseif ($change_status ==-1) {
			return "Plan already ".$msg;
		
				} else {
			return "An error occurred";
		}
	
	
} // end change status

    public function view_all_plans (){
        $columns = array("plan_id","plan_name","plan_desc","status");

        $get_data = $this->select_tb($this->plan_table,$columns);

        if (is_array($get_data)){

            return $get_data['data'];

        } else {

            return "No data found";
        }


    }

public function view_active_plans(){
$columns = array("plan_id","plan_name","plan_desc");
	
	$get_plans = $this->view_all_active_data($this->plan_table,$columns);
	
	if (is_array($get_plans)) {
		
		return $get_plans;
	} else {
		return "No plan Found";	
	}
	
}


public function link_plan_service ($plan_id,$service_id) {

    $link_table = $this->link_table;
    $service_table = "user_mgt_services";

    $plan_columns = array("plan_id");
    $service_columns = array("service_id");
    $link_columns = array("plan_id","service_id","status");
    $link_values = array($plan_id,$service_id,1);

    $p_where['column_name'] ="plan_id";
    $p_where['sign'] ="=";
    $p_where['value'] =$plan_id;

    $plan_where[]=$p_where;

    $p2_where['column_name'] ="status";
    $p2_where['sign'] ="=";
    $p2_where['value'] =1;

    $plan_where[]=$p2_where;

    $s_where['column_name'] ="service_id";
    $s_where['sign'] ="=";
    $s_where['value'] =$service_id;

    $service_where[]=$s_where;

    $s2_where['column_name'] ="status";
    $s2_where['sign'] ="=";
    $s2_where['value'] =1;

    $service_where[]=$s2_where;

    $lp_where['column_name'] ="plan_id";
    $lp_where['sign'] ="=";
    $lp_where['value'] =$plan_id;

    $link_where[]=$lp_where;

    $ls_where['column_name'] ="service_id";
    $ls_where['sign'] ="=";
    $ls_where['value'] =$service_id;
    $link_where[]=$ls_where;

        $check_service = $this->select_tb($service_table,$service_columns,$service_where);
    //print_r( $check_service);
        if (is_array($check_service)) {
             $check_plan =$this->select_tb($this->plan_table, $plan_columns, $plan_where);
             //print_r($check_plan);
            if(is_array($check_plan)) {

                $check_link = $this->insert_check_duplicate($link_table,$link_columns,$link_values,$link_where,1);
                    //print_r($check_link);
                    if ($check_link > 0) {

                        return "Plan and Service link Successful";
                    } elseif ($check_link == -1){

                        return "Link already exists";
                    } else {
                        return "An error occurred";
                    }

            } else {
                    return "Invalid plan selected";

            }
        } else{

            return "Invalid Service Selected";

    }


  }// end function


    public function check_portal_service ($plan_id){

        $columns = array("plan_services_id");

        $thirdwhere['column_name'] ="service_id";
        $thirdwhere['sign'] ="=";
        $thirdwhere['value'] =$this->portal_id;
        $where[] = $thirdwhere;

        $thirdwhere['column_name'] ="plan_id";
        $thirdwhere['sign'] ="=";
        $thirdwhere['value'] =$plan_id;
        $where[] = $thirdwhere;

        $check_portal = $this->select_tb($this->link_table, $columns, $where);

        if (is_array($check_portal)){

            return $check_portal['data'][0];

        } else {

            return 0;
        }
    }


    public function check_portal_user($portal_access, $company_id, $member_no){

	    //$check_if_portal = $this->check_portal_service($plan_id);
	    if ($portal_access == 1){
	        if($member_no == ""){

	         return 0;

            } else {
                $use_portal_user = new portal_user_class();
                $get_portal_user = $use_portal_user->confirm_member_no($company_id, $member_no);

                if (is_array($get_portal_user)) {

                    return $get_portal_user;

                } else {

                    return 0;
                }
            }
        } else {

	        return 1;
        }
    }
}// end class



//$page_test = new Reward_plan();
//echo json_encode($page_test->view_all_plans());
//echo json_encode($page_test->create_plan("premium plus2","Her we go again"));
//echo json_encode($page_test->change_service_status(1,1));
//echo json_encode($page_test->edit_service_name(2,"Wallet2"));
//echo json_encode($page_test->view_active_plans());
//print_r(get_class_methods('Reward_plan'));
//echo json_encode($page_test->edit_plan_details(1,"master2","WHY always me"));
//echo json_encode($page_test->link_plan_service(1,1));
//echo json_encode($page_test->check_portal_service(1));
