<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 06/10/2020
 * Time: 11:48
 */

require_once("main_class.php");
require_once("curl_class.php");


class premium_incentives_class extends Rewardsbox_main
{

    private $incentives_table = "premium_incentives_user";
    private $comapany_table = "user_mgt_company";
    private $token = "ba3253876aed6bc22d4a6ff53d8406c6ad864195ed144ab5c87621b6c233b548baeae6956df346ec8c17f5ea10f35ee3cbc514797ed7ddd3145464e2a0bab4";
    private $url ='https://premiumincentives.biz/sigma/api.php?api=';
    private $header;

    private function set_header(){

        //$header = array('content-type: multipart/form-data','token: ' . $this->master_token);
        return $this->header = array("token: " .$this->token,"content-type: multipart/form-data", "cache-control: no-cache");
    }

    public function check_token($token){
        $today_date = date('Y-m-d');
        $column = array("company_id", "user_plan", "client_no","company_name","prefix","portal_access");

        $m_where['column_name'] ="token";
        $m_where['sign'] ="=";
        $m_where['value'] =$token;
        $where[] = $m_where;

        $m_where['column_name'] =$this->comapany_table.".status";
        $m_where['sign'] ="=";
        $m_where['value'] =1;
        $where[] = $m_where;

        $m_where['column_name'] =$this->comapany_table.".expire_date";
        $m_where['sign'] =">=";
        $m_where['value'] =$today_date;
        $where[] = $m_where;

        $firstjoin ['table_name'] = $this->comapany_table;
        $firstjoin ['first_column'] = $this->comapany_table.".company_id";
        $firstjoin ['second_column'] = $this->incentives_table . ".client_id";
        $leftjoin [] = $firstjoin;

        $check_token = $this->select_tb($this->incentives_table,$column,$where,'','','','','',$leftjoin);

        if (is_array($check_token)){

            return $check_token['data'][0];

        } else {

            return 0;
        }
    }
    
     public function update_profile($company_id,$member_no, $first_name, $last_name, $email, $phone_no){

        // if another company have to put the token and url in database and get
        return $this->update_profile_api($member_no, $first_name, $last_name, $email, $phone_no);


    }

    public function update_profile_api($member_no, $first_name, $last_name, $email, $phone_no){

        $this->set_header();
        $api = "update_details";

        $body['member_no']= $member_no;
        $body['first_name'] = $first_name;
        $body['last_name'] = $last_name;
        $body['email'] = $email;
        $body['phone_no'] = $phone_no;

        //$fields = json_encode($body);
        $use_curl = new curl_class();
        $send_data = $use_curl->send_post_v2($this->url.$api,$body,$this->header);


		$get_data = json_decode($send_data, true);
        if($get_data['status']== 1){

            return $get_data;
        } else {


            return $get_data;
        }


    }
}

//$page_test = new premium_incentives_class();
//echo json_encode($page_test->check_token(2020));