<?php

require_once ('../includes/startsession.php');

if (isset($_SESSION['user_id'])) {

    require_once ('../classes/user_login_class.php');
    require_once ('../classes/notification_class.php');

    $check_details = new Rewards_user_login_class();

    $get_details = $check_details->script_access();
    $get_not = new notification_class();
    if(is_array($get_details)) {
//{"create_access":"0","read_access":"0","update_access":"0","delete_access":"0"}
        if (isset($get_details['create_access'])) {

            $create = $get_details['create_access'];

        } else {

            $create = 0;
        }

        if (isset($get_details['read_access'])) {

            $read = $get_details['read_access'];

        } else {

            $read = 0;
        }

        if (isset($get_details['update_access'])) {

            $update = $get_details['update_access'];

        } else {

            $update = 0;
        }

        if (isset($get_details['delete_access'])) {

            $delete = $get_details['delete_access'];

        } else {

            $delete = 0;
        }


        if (isset($_POST['action'])){
            $action = $_POST['action'];

            if($action == 'add'){
                if ($create == 1){

                    if(isset($_POST['name'])){

                        if ($_POST['name'] == ""){

                            $response_array['status'] = 0;
                            $response_array['message'] ="No group Name sent";

                        } else {
                            $name = strtolower(trim($_POST['name']));
                            //$id = strtolower(trim($_POST['company_id']));
                            $add_item = $get_not->add_lsl_mail_groups($name);
                            if (is_array($add_item)) {
                                $response_array['status'] = 1;
                                $response_array['message'] = "success";
                                $response_array['data'] = $add_item;
                                $response_array['iedit'] = $update;
                                $response_array['idelete'] = $delete;
                            } else {

                                $response_array['status'] = 0;
                                $response_array['message'] =$add_item;
                            }


                        }

                    } else {

                        $response_array['status'] = 0;
                        $response_array['message'] ="Invalid data";

                    }


                } else{

                    $response_array['status'] = -1;
                    $response_array['message'] ="Access denied";

                }


            } elseif ($action =='edit'){

                if ($update == 1){

                    if(isset($_POST['color']) || isset($_POST['item_id'])){

                        if ($_POST['color'] == "" || $_POST['item_id'] =="" || !is_numeric($_POST['item_id']) || $_POST['item_id'] < 1){

                            $response_array['status'] = 0;
                            $response_array['message'] ="Invalid data";

                        } else {

                            $id = trim($_POST['item_id']);
                            $color = strtolower(trim($_POST['color']));
//                            $company_id = trim($_POST['company_id']);

                            $edit_color = $get_not->edit_lsl_mail_group($id,$color);

                            if (is_array($edit_color )){

                                $response_array['status'] = 1;
                                $response_array['message'] ="Update Successful";

                            } else {

                                $response_array['status'] = 0;
                                $response_array['message'] =$edit_color;
                            }


                        }

                    } else {

                        $response_array['status'] = 0;
                        $response_array['message'] ="No values set";

                    }

                } else{

                    $response_array['status'] = -1;
                    $response_array['message'] ="Access denied";

                }

            } elseif ($action =='delete'){
                if ($delete == 1){

                    if(isset($_POST['status']) || isset($_POST['item_id'])){


                        if($_POST['status'] == "" || $_POST['item_id'] == "" || !is_numeric($_POST['status']) || !is_numeric($_POST['item_id'])){

                            $response_array['status'] = 0;
                            $response_array['message'] ="Invalid Data sent";

                        } else {
                            $color_id = trim($_POST['item_id']);
                            $status = trim($_POST['status']);
                           // $company_id = trim($_POST['company_id']);
                            if ($status == 1){
                                $msg = "active";

                            }else{

                                $msg = "inactive";
                            }

                            $del_color = $get_not->change_lsl_group_status($status,$color_id);

                            if (is_array($del_color)){
                                $response_array['status'] = 1;
                                $response_array['message'] ="Group is ".$msg;

                            } else {

                                $response_array['status'] = 0;
                                $response_array['message'] =$del_color;
                            }

                        }


                    } else {

                        $response_array['status'] = 0;
                        $response_array['message'] ="Missing data";

                    }


                } else{

                    $response_array['status'] = -1;
                    $response_array['message'] ="Access denied";

                }

            }else{

                $response_array['status'] = 0;
                $response_array['message'] ="Invalid action";
            }


        } else {

            $response_array['status'] = 0;
            $response_array['message'] ="No action sent";
        }


    } else {

        $response_array['status'] = 0;
        $response_array['message'] = "Error getting Access";
    }
} else {

    $response_array['status'] = 4004;
    $response_array['message'] ="Session expired";
}

echo json_encode($response_array);
?>