<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 31/10/2018
 * Time: 10:08
 */
require_once ("main_class.php");
require_once ("company_class.php");
class company_user_token_class extends Rewardsbox_main
{


    private $table = "user_mgt_com_token";
    protected $tokenexpire = 600;
    protected $tokenkill = 86400;
    protected $hash1 = "1234" ;
    protected $hash2 = "abcd";




    Public function create_token($companyid, $userid, $user_type) {

        $randomno = mt_rand(1000000,9999999999);
        $status = 1;

        $createdate = date('Y-m-d H:i:s');
        $expiredate = date('Y-m-d H:i:s', time() +$this->tokenexpire);
        $killdate = date('Y-m-d H:i:s', time() +$this->tokenkill);
        if(is_numeric($companyid) && is_numeric($userid)) {
            $token = md5($this->hash1.$userid.$createdate.$randomno);
            //$store_token = hash_hmac('sha256',$token);
            $store_token = hash('sha512',$token);


            $columns = array("user_id","company_id", "user_access", "token","expire_date","status");
            $values = array($userid,$companyid,$user_type,$store_token,$killdate,$status);

            $insert_data = $this->insert_data($this->table,$columns,$values);

            if($insert_data > 0){
                $use_company = new Reward_company();
                $get_name = $use_company->get_company($companyid);
                if (is_array($get_name)){

                  $company_name = $get_name['company_name'];
                    $logo = $get_name['image'];
                } else {

                    $company_name="";
                    $logo = "";
                }

                $array['token'] = $token;
                $array['user_access'] = $user_type;
                $array['company_name'] = $company_name;
                $array['logo'] = $logo;

                return $array;

            } else {

                return "Unable to create token";
            }
        } else
        {
            return "Token creation failed";
        }
    }

    Public function verify_token($token) {

        if (isset($token)&& $token !="") {

            $hash_token = hash('sha512', $token);

            $createdate = date('Y-m-d H:i:s');

            $columns = array("token_id", "company_id", "user_id");
            $p_where['column_name'] = "token";
            $p_where['sign'] = "=";
            $p_where['value'] = $hash_token;
            $where[] = $p_where;

            $p_where['column_name'] = "status";
            $p_where['sign'] = "=";
            $p_where['value'] = 1;
            $where[] = $p_where;

            $p_where['column_name'] = "expire_date";
            $p_where['sign'] = ">";
            $p_where['value'] = $createdate;
            $where[] = $p_where;

            $get_data = $this->select_tb($this->table, $columns, $where);

            if (is_array($get_data)){

                return $get_data['data'][0];

            } else {

                return "Invalid token";
            }

        } else {

            return "token not found";
        }
    }


    public function log_out ($token_id){
        $today_date =date('Y-m-d H:i:s');

        if(is_numeric($token_id) && $token_id > 0){

            $p_where['column_name'] = "token_id";
            $p_where['sign'] = "=";
            $p_where['value'] = $token_id;
            $where[] = $p_where;

            $firstset['column_name'] = "status";
            $firstset['sign'] = "=";
            $firstset['value'] = 0;
            $set[] = $firstset;

            $firstset['column_name'] = "update_date";
            $firstset['sign'] = "=";
            $firstset['value'] = $today_date;
            $set[] = $firstset;

            $update_data = $this->update_data($this->table, $set, $where );

            if ($update_data == 1){

                return $update_data;

            } else {

                return "Log Out failed";
            }


        } else {

            return "Invalid Token";
        }



    }
}

//$test = new company_user_token_class();
//echo json_encode($test->verify_token("04f01225f5caa5e947210e1329dac47d"));