<?php
require_once ('../includes/startsession.php');

if (isset($_SESSION['user_id'])) {


require_once ('../classes/user_login_class.php');
require_once ('../classes/permission_class.php');

$check_details = new Rewards_user_login_class();

$get_details = $check_details->script_access();
$get_permission = new Reward_permission();

if(is_array($get_details)) {
//{"create_access":"0","read_access":"0","update_access":"0","delete_access":"0"}
    if (isset($get_details['create_access'])) {

        $create = $get_details['create_access'];

    } else {

        $create = 0;
    }

    if (isset($get_details['read_access'])) {

        $read = $get_details['read_access'];

    } else {

        $read = 0;
    }

    if (isset($get_details['update_access'])) {

        $update = $get_details['update_access'];

    } else {

        $update = 0;
    }

    if (isset($get_details['delete_access'])) {

        $delete = $get_details['delete_access'];

    } else {

        $delete = 0;
    }


    if (isset($_POST['action'])){
        $action = $_POST['action'];

        if($action == 'add'){
            if ($create == 1){

                if(isset($_POST['id'])){

                    if ($_POST['id'] == ""){

                        $response_array['status'] = 0;
                        $response_array['message'] ="No Data sent";

                    } else {
                        $id = trim($_POST['id']);
                        $status = trim($_POST['status']);
                        $add_access = $get_permission->change_create_access($id, $status);
                        if ($add_access == 1) {
                            $response_array['status'] = 1;
                            $response_array['message'] = "Update Successful";
                            $response_array['data'] = $add_access;
                            $response_array['iedit'] = $update;
                            $response_array['idelete'] = $delete;
                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] ="Error Updating";
                        }


                    }

                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] ="Invalid Data";

                }


            } else{

                $response_array['status'] = -1;
                $response_array['message'] ="Access denied";

            }


        } elseif ($action =='read'){

            if ($update == 1){

                if(isset($_POST['id'])){

                    if ($_POST['id'] == ""){

                        $response_array['status'] = 0;
                        $response_array['message'] ="Invalid data";

                    } else {

                        $id = trim($_POST['id']);
                        $status = trim($_POST['status']);

                        $read_access = $get_permission->change_read_access($id,$status);

                        if ($read_access == 1){

                            $response_array['status'] = 1;
                            $response_array['message'] ="Update Successful";

                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] =$read_access;
                        }


                    }

                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] ="No values set";

                }

            } else{

                $response_array['status'] = -1;
                $response_array['message'] ="Access denied";

            }

        }



     elseif ($action =='edit'){

            if ($update == 1){

                if(isset($_POST['id'])){

                    if ($_POST['id'] == ""){

                        $response_array['status'] = 0;
                        $response_array['message'] ="Invalid data";

                    } else {

                        $id = trim($_POST['id']);
                        $status = trim($_POST['status']);

                        $access = $get_permission->change_update_access($id,$status);

                        if ($access == 1){

                            $response_array['status'] = 1;
                            $response_array['message'] ="Update Successful";

                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] =$access;
                        }


                    }

                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] ="No values set";

                }

            } else{

                $response_array['status'] = -1;
                $response_array['message'] ="Access denied";

            }

        }




        elseif ($action =='delete'){

            if ($update == 1){

                if(isset($_POST['item_id'])){

                    if ($_POST['item_id'] == ""){

                        $response_array['status'] = 0;
                        $response_array['message'] ="Invalid data";

                    } else {

                        $id = trim($_POST['item_id']);
                        $status = trim($_POST['status']);

                        $access = $get_permission->change_permission_status($id,$status);
//                        print_r($access);

                        if ($access = 'Successfully made Active'){

                            $response_array['status'] = 1;
                            $response_array['message'] ="Update Successful";

                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] =$access;
                        }


                    }

                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] ="No values set";

                }

            } else{

                $response_array['status'] = -1;
                $response_array['message'] ="Access denied";

            }

        }





    } else {

        $response_array['status'] = 0;
        $response_array['message'] ="No action sent";
    }


} else {

    $response_array['status'] = 0;
    $response_array['message'] = "Error getting Access";
}
} else {

    $response_array['status'] = 4004;
    $response_array['message'] ="Session expired";
}

echo json_encode($response_array);
?>