<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 31/10/2018
 * Time: 10:43
 */
require_once("../../../classes/company_user_class.php");
require_once("../../../classes/company_user_token_class.php");
require_once("../../../classes/company_category_class.php");
require_once("../../../classes/purchase_class.php");
require_once("../../../classes/portal_user_class.php");
require_once("../../../classes/xoxoday_class.php");
require_once("../../../classes/api_class.php");
require_once("../../../classes/company_access_class.php");
require_once ("../../../classes/company_class.php");
require_once ("../../../classes/wallet_service_class.php");

if (isset($_SERVER['HTTP_TOKEN'])) {

    if ($_SERVER['HTTP_TOKEN'] == "") {
        $response_array['status'] = 0;
        $response_array['message'] = "blank token sent";
    } else {
        $token = $_SERVER['HTTP_TOKEN'];
        $use_com_token = new company_user_token_class();
        $get_details = $use_com_token->verify_token($token);

        if (is_array($get_details)){

            $user_id = $get_details['user_id'];
            $company_id = $get_details['company_id'];
            $token_id = $get_details['token_id'];

            if( isset($_GET['api'])){

                if($_GET['api'] == ""){

                    $response_array['status'] = 0;
                    $response_array['message'] = "Blank api call";

                } else {
                    $api = $_GET['api'];

                    if ($api == "view_users") {

                        $use_com_user = new company_user_class();
                        $get_data = $use_com_user->view_company_users($company_id);

                        if (is_array($get_data)) {

                            $response_array['status'] = 1;
                            $response_array['message'] = "success";
                            $response_array['data'] = $get_data['data'];
                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] = $get_data;

                        }

                    } elseif ($api== "view_totals") {

                        $total_sale = 0;
                        $total_categories = 0;
                        $total_company_users = 0;
                        $total_customers = 0;

                        $use_purchase = new purchase_class();
                        $total_sale_array = $use_purchase->total_successful_orders($company_id);
                        if (is_array($total_sale_array)) {
//                            echo json_encode($total_sale_array);
//                            echo "<br>";
                            $total_sale = $total_sale_array['total_count'];
                        } else {

                            $total_sale = 0;
                        }


                        $use_com_cat = new company_category_class();
                        $total_cat_array = $use_com_cat->view_company_categories($company_id);
                        if (is_array($total_cat_array)) {

                            $total_categories = $total_cat_array['total'];
                        } else {

                            $total_categories = 0;
                        }

                        $use_portal = new portal_user_class();
                        $total_portal_array = $use_portal->view_company_portal($company_id);
                        if (is_array($total_portal_array)) {

                            $total_customers = $total_portal_array['total'];
                        } else {

                            $total_customers = 0;
                        }

                        $use_company_users = new company_user_class();
                        $total_user_array = $use_company_users->view_company_users($company_id);
                        if (is_array($total_user_array)) {

                            $total_company_users = $total_user_array['total'];
                        } else {

                            $total_company_users = 0;
                        }

                        $data_array['sales'] = $total_sale;
                        $data_array['categories'] = $total_categories;
                        $data_array['users'] = $total_company_users;
                        $data_array['customers'] = $total_customers;

                        $response_array['status'] = 1;
                        $response_array['message'] = "success";
                        $response_array['data'] = $data_array;

                    } elseif ($api=="view_categories") {
                        if (isset($_GET['flag_id']) && $_GET['flag_id'] != "") {
                            $use_com_cat = new company_category_class();
                            $total_cat_array = $use_com_cat->get_company_category($company_id, $_GET['flag_id']);
                            if (is_array($total_cat_array)) {

                                $response_array['status'] = 1;
                                $response_array['message'] = "success";
                                $response_array['data'] = $total_cat_array;
                            } else {

                                $response_array['status'] = 0;
                                $response_array['message'] = $total_cat_array;
                            }
                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Flag required";

                        }
                    } elseif ($api == "view_flags" ) {
                        $use_com_cat = new company_category_class();
                        $flag_array = $use_com_cat->view_company_flags($company_id);

                        if (is_array($flag_array)) {
                            $response_array['status'] = 1;
                            $response_array['message'] = "success";
                            $response_array['data'] = $flag_array['data'];

                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] = "No flag found";

                        }


                    } elseif ($api=="get_products"){
                        if (isset($_GET['category_id']) && $_GET['category_id'] != "") {

                            $category_id = $_GET['category_id'];
                            if(isset($_GET['country_id']) && $_GET['country_id']!=""){

                                $country_id = $_GET['country_id'];
                            } else {

                                $country_id = null;
                            }

                            if(isset($_GET['city_id']) && $_GET['city_id']!=""){

                                $city_id = $_GET['city_id'];
                            } else {

                                $city_id = null;
                            }
                            $use_company = new company_access_class();
                           $get_token_array =$use_company->get_token_company($company_id);

                           if (is_array($get_token_array)){

                               $token = $get_token_array['company_token'];
                           } else {

                               $token = 0;
                           }

                           $use_api = new api_class();
                           $get_product = $use_api->list_products($category_id,$company_id, $token, $country_id, $city_id);

                            if (is_array($get_product)) {

                                $response_array['status'] = 1;
                                $response_array['message'] = "success";
                                $response_array['category'] = $get_product['category'];
                                $response_array['data'] = $get_product['data'];

                            } else {

                                $response_array['status'] = 0;
                                $response_array['message'] = $get_product;

                            }
                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Category required";

                        }



                    } elseif ($api == "exp_country"){

                        $use_xoxo = new xoxoday_class();
                        $get_country = $use_xoxo->get_countries();

                        if (is_array($get_country)){

                            $response_array['status'] = 1;
                            $response_array['message'] = "success";
                            $response_array['data'] = $get_country;

                        }else {

                            $response_array['status'] = 0;
                            $response_array['message'] = $get_country;
                        }


                    } elseif ($_GET['api'] == "exp_city"){

                        if (isset($_GET['country_id'])) {

                            if ($_GET['country_id'] == "") {

                                $response_array['status'] = 0;
                                $response_array['message'] = "Country required";
                            } else {

                                $use_xoxo = new xoxoday_class();
                                $get_city = $use_xoxo->get_city($_GET['country_id']);

                                if (is_array($get_city)) {

                                    $response_array['status'] = 1;
                                    $response_array['message'] = "success";
                                    $response_array['data'] = $get_city;

                                } else {

                                    $response_array['status'] = 0;
                                    $response_array['message'] = $get_city;
                                }


                            }



                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Missing country";

                        }

                    }elseif($_GET['api'] =="wallet_tran"){

                        $use_company = new Reward_company();

                        $get_company_array = $use_company->get_company($company_id);

                        if(is_array($get_company_array)) {

                            $company_no = $get_company_array['client_no'];
                            $use_wallet = new wallet_service_class();

                            $get_wallet = $use_wallet->list_transactions($company_no);

                            if (is_array($get_wallet)) {

                                $response_array['status'] = 1;
                                $response_array['message'] = "success";
                                $response_array['data'] = $get_wallet;

                            } else {

                                $response_array['status'] = 0;
                                $response_array['message'] = $get_wallet;

                            }
                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Error getting data";

                        }
                    } else {


                        $response_array['status'] = 0;
                        $response_array['message'] = "Invalid api call";
                    }




                }

            } else {

                $response_array['status'] = 0;
                $response_array['message'] = "No api called";

            }



        } else {

            $response_array['status'] = 0;
            $response_array['message'] = $get_details;
            
        }


    }


} elseif ($_GET['api'] == 'gain_access'){

    if (isset($_POST['username']) && isset($_POST['password'])){

        if($_POST['username'] == ""){

            $response_array['status'] = 0;
            $response_array['message'] = "Blank username";
        } else {

            if($_POST['password'] == ""){

                $response_array['status'] = 0;
                $response_array['message'] = "Blank password";
            } else {

                $use_com_user = new company_user_class();
                $get_token = $use_com_user->verify_account($_POST['username'], $_POST['password']);

                if (is_array($get_token)){

                    $response_array['status'] = 1;
                    $response_array['message'] = "success";
                    $response_array['token'] = $get_token['token'];
                    $response_array['company'] = $get_token['company_name'];

                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] = $get_token;
                }



            }

        }

    } else {

        $response_array['status'] = 0;
        $response_array['message'] = "Username and Password required";
    }


}
echo json_encode($response_array);



