<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 03/10/2018
 * Time: 12:07
 */

require_once("main_class.php");

class api_link_class extends Rewardsbox_main
{

    private $table = "rewardsbox_api_link";


    public function get_link($api_id){
        $columns=array($this->table.".partner_id","end_point","rewardsbox_partner.partner_name","flag_id");

        $m_where['column_name'] =$this->table.".partner_api_id";
        $m_where['sign'] ="=";
        $m_where['value'] =$api_id;
        $where[] = $m_where;

        $firstjoin ['table_name']="rewardsbox_partner";
        $firstjoin ['first_column']="rewardsbox_partner.partner_id";
        $firstjoin ['second_column']="rewardsbox_api_link.partner_id";
        $leftjoin []=$firstjoin;


        $get_link = $this->select_tb($this->table,$columns,$where,"","","","","",$leftjoin);

        if (is_array($get_link)){

            return $get_link['data'][0];

        } else {

            return 0;
        }

    }



    public function get_api_end_point ($partner_id, $api_type, $flag_id){

        $columns=array("partner_id","end_point");

        $m_where['column_name'] ="partner_id";
        $m_where['sign'] ="=";
        $m_where['value'] =$partner_id;
        $where[] = $m_where;

        $m_where['column_name'] ="flag_id";
        $m_where['sign'] ="=";
        $m_where['value'] =$flag_id;
        $where[] = $m_where;

        $m_where['column_name'] ="api_type";
        $m_where['sign'] ="=";
        $m_where['value'] =$api_type;
        $where[] = $m_where;

        $get_end_point = $this->select_tb($this->table, $columns, $where);

        if (is_array($get_end_point)){

            return $get_end_point['data'][0];

        } else {

            return 0;
        }
    }


    public function get_cat_link($api_type){

        $columns = array("partner_api_id", "end_point", "partner_name");

        $m_where['column_name'] ="api_type";
        $m_where['sign'] ="=";
        $m_where['value'] =$api_type;
        $where[] = $m_where;

        $firstjoin ['table_name']="rewardsbox_partner";
        $firstjoin ['first_column']="rewardsbox_partner.partner_id";
        $firstjoin ['second_column']="rewardsbox_api_link.partner_id";
        $leftjoin []=$firstjoin;

        $get_data = $this->select_tb($this->table,$columns, $where,"","","","","",$leftjoin);

        if(is_array($get_data)){

            return $get_data['data'];

        } else {

            return "No data found";
        }




    }

}




//$page_test = new api_link_class();
//echo json_encode($page_test->get_cat_link(1));
//echo json_encode($page_test->get_link(1));
//echo json_encode($page_test->get_api_end_point(1,2));