<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 03/10/2018
 * Time: 10:54
 */
require_once("main_class.php");
require_once ("flag_class.php");
require_once ("api_link_class.php");
require_once ("category_lv1_class.php");
require_once ("category_lv2_class.php");

class category_class extends Rewardsbox_main
{

private $table = "rewardsbox_category";


    public function get_partner_category_details($category_id, $flag_id){

        $columns = array("partner_api_id","partner_category_id","partner_category_name","cat_name", "image_url");

        $m_where['column_name'] ="cat_id";
        $m_where['sign'] ="=";
        $m_where['value'] =$category_id;
        $where[] = $m_where;

        $m_where['column_name'] ="flag_id";
        $m_where['sign'] ="=";
        $m_where['value'] =$flag_id;
        $where[] = $m_where;

        $m_where['column_name'] ="status";
        $m_where['sign'] ="=";
        $m_where['value'] =1;
        $where[] = $m_where;


        $get_partner_details = $this->select_tb($this->table,$columns,$where);

        if (is_array($get_partner_details)){

            return $get_partner_details['data'][0];

        } else {

            return 0;
        }


    }


    public function check_partner_category_($category_id){

        $columns = array("partner_api_id","partner_category_id","partner_category_name","cat_name");

        $m_where['column_name'] ="cat_id";
        $m_where['sign'] ="=";
        $m_where['value'] =$category_id;
        $where[] = $m_where;

        $m_where['column_name'] ="status";
        $m_where['sign'] ="=";
        $m_where['value'] =1;
        $where[] = $m_where;


        $get_partner_details = $this->select_tb($this->table,$columns,$where);

        if (is_array($get_partner_details)){

            return $get_partner_details['data'][0];

        } else {

            return 0;
        }


    }

    public function get_all_categories (){
        $columns=array("cat_id","rewardsbox_category_level_1.menu_name AS main_menu", "rewardsbox_category_level_2.menu_name AS sub_menu","rewardsbox_flag.name","cat_name",$this->table.".partner_api_id", "rewardsbox_partner.partner_name",$this->table.".partner_category_id","partner_category_name", $this->table.".status", $this->table.".image_url");

        $firstjoin ['table_name']="rewardsbox_flag";
        $firstjoin ['first_column']="rewardsbox_flag.flag_id";
        $firstjoin ['second_column']=$this->table.".flag_id";
        $leftjoin []=$firstjoin;

        $firstjoin ['table_name']="rewardsbox_category_level_2";
        $firstjoin ['first_column']="rewardsbox_category_level_2.menu_id";
        $firstjoin ['second_column']=$this->table.".parent_id";
        $leftjoin []=$firstjoin;

        $firstjoin ['table_name']="rewardsbox_category_level_1";
        $firstjoin ['first_column']="rewardsbox_category_level_1.menu_id";
        $firstjoin ['second_column']="rewardsbox_category_level_2.parent_id";
        $leftjoin []=$firstjoin;


        $firstjoin ['table_name']="rewardsbox_api_link";
        $firstjoin ['first_column']="rewardsbox_api_link.partner_api_id";
        $firstjoin ['second_column']=$this->table.".partner_api_id";
        $leftjoin []=$firstjoin;

        $firstjoin ['table_name']="rewardsbox_partner";
        $firstjoin ['first_column']="rewardsbox_partner.partner_id";
        $firstjoin ['second_column']="rewardsbox_api_link.partner_id";
        $leftjoin []=$firstjoin;

        $get_data = $this->select_tb($this->table, $columns,"","","","","","",$leftjoin);

        if (is_array($get_data)){


            return $get_data['data'];
        } else {

            return "No data found";
        }


    }


    public function create_category($flag_id,$parent_id, $child_id, $cat_name,$cat_desc,$partner_api_id, $partner_category_id, $partner_category_name, $image_url = null){

        if (isset($flag_id) || isset($cat_name) || isset($partner_api_id)){

            if (!isset($partner_category_id) || $partner_api_id == ""){

                $partner_category_id = 0;
            }

            $use_parent = new category_lv1_class();

            $check_parent =$use_parent->get_menu($parent_id);
            if (is_array($check_parent)) {
                $parent_name = $check_parent['menu_name'];

                $use_child = new category_lv2_class();
                $check_child = $use_child->get_child($parent_id, $child_id);

                if(is_array($check_child)) {
                    $child_name = $check_child['menu_name'];

                    $use_flag = new flag_class();
                    $get_flag = $use_flag->get_flag_name($flag_id);

                    if (is_array($get_flag)) {

                        $flag_name = $get_flag['name'];

                    } else {

                        $flag_name = "";
                    }

                    $use_api_link = new api_link_class();
                    $get_partner = $use_api_link->get_link($partner_api_id);

                    if (is_array($get_partner)) {

                        $partner_name = $get_partner['partner_name'];
                    } else {

                        $partner_name = "";
                    }

                    $columns = array("flag_id","parent_id", "cat_name", "cat_desc", "partner_api_id", "partner_category_id", "partner_category_name", "status", "image_url");
                    $values = array($flag_id, $child_id, $cat_name, $cat_desc, $partner_api_id, $partner_category_id, $partner_category_name, 1, $image_url);

                    $third_where['column_name'] = "cat_name";
                    $third_where['sign'] = "=";
                    $third_where['value'] = $cat_name;
                    $where[] = $third_where;


                    $insert_data = $this->insert_check_duplicate($this->table, $columns, $values, $where);

                    if (is_numeric($insert_data) && $insert_data > 0) {

                        $insert_array['cat_id'] = $insert_data;
                        $insert_array['cat_flag'] = $flag_name;
                        $insert_array['cat_parent'] = $parent_name;
                        $insert_array['cat_child'] = $child_name;
                        $insert_array['cat_name'] = $cat_name;
                        $insert_array['cat_partner'] = $partner_name;
                        $insert_array['cat_partner_cat_id'] = $partner_category_id;
                        $insert_array['cat_partner_cat'] = $partner_category_name;


                        return $insert_array;

                    } elseif ($insert_data < 0) {

                        return "Category already exists";

                    } else {

                        return "Error creating category";
                    }
                } else {


                    return "Invalid Child Category";
                }
            } else {

                return "Invalid Parent Category";
            }
        } else {

            return "Missing parameter";
        }

    }


    public function edit_category($id, $flag_id, $parent_id, $child_id, $category_name, $partner_cat_id, $partner_cat_name, $image_url) {

        $use_flag = new flag_class();

        $check_flag = $use_flag->get_flag_name($flag_id);

        if (is_array($check_flag)) {

            $use_parent = new category_lv2_class();

            $check_cat = $use_parent->get_child($parent_id, $child_id);

            if (is_array($check_cat)) {
                $key = "cat_id";
                //$columns_name = "service_name";

                $firstset['column_name'] = "cat_name";
                $firstset['sign'] = "=";
                $firstset['value'] = $category_name;
                $set[] = $firstset;
                $whereduplicate[] = $firstset;

//                $exempt_where['column_name'] = $key;
//                $exempt_where_where['sign'] = "=";
//                $exempt_where['value'] = $id;
//                $where_not[] = $exempt_where_where;

//                $firstset['column_name'] = "cat_desc";
//                $firstset['sign'] = "=";
//                $firstset['value'] = $desc;
//                $set[] = $firstset;
//
//                $firstset['column_name'] = "partner_api_id";
//                $firstset['sign'] = "=";
//                $firstset['value'] = $partner_api_id;
//                $set[] = $firstset;

				$firstset['column_name'] = "parent_id";
                $firstset['sign'] = "=";
                $firstset['value'] = $child_id;
                $set[] = $firstset;
				
                $firstset['column_name'] = "partner_category_id";
                $firstset['sign'] = "=";
                $firstset['value'] = $partner_cat_id;
                $set[] = $firstset;

                $firstset['column_name'] = "partner_category_name";
                $firstset['sign'] = "=";
                $firstset['value'] = $partner_cat_name;
                $set[] = $firstset;

                $firstset['column_name'] = "image_url";
                $firstset['sign'] = "=";
                $firstset['value'] = $image_url;
                $set[] = $firstset;

                $first_where['column_name'] = $key;
                $first_where['sign'] = "=";
                $first_where['value'] = $id;
                $where[] = $first_where;

                $edit_result = $this->update_check_duplicate($this->table, $set, $where, $whereduplicate, $key);
                //print_r($edit_name);

                if ($edit_result == 1) {
                    return 1;

                } elseif ($edit_result == -1) {
                    return "Category already exists";

                } else {
                    return "Invalid Category";
                }

            } else {

                return "Invalid Parent or Child Category";
            }
        } else {

            return "Invalid Flag";
        }

    } // end edi name function


    public function change_category_status ($cat_id, $new_status)
    {
        $key = "cat_id";
        //$columns = array($key,"status");

        if ($new_status == 1) {

            $msg = "Active";

        } else {
            $new_status = 0;
            $msg = "Inactive";
        }

        $change_status = $this->change_status($cat_id, $new_status, $this->table, $key);
        if ($change_status == 1) {
            $d_array = array();
            $d_array['status'] = $new_status;
            $d_array['message'] = "Successfully made " . $msg;
            return $d_array;

        } elseif ($change_status == -2) {
            return "Cannot locate Category";

        } elseif ($change_status == -1) {
            return "Category already " . $msg;

        } else {
            return "An error occurred";
        }
    }


    public function total_active_category(){


        $column = array("cat_id","cat_name");

        $p_where['column_name'] ="status";
        $p_where['sign'] ="=";
        $p_where['value'] =1;
        $where[]=$p_where;
        $get_data = $this->select_tb($this->table, $column,$where);
        return $get_data;
    }


    public function get_rewardsbox_category_($partner_category_id){

        $columns = array("partner_api_id","cat_id","partner_category_name","cat_name");

        $m_where['column_name'] ="partner_category_id";
        $m_where['sign'] ="=";
        $m_where['value'] =$partner_category_id;
        $where[] = $m_where;

        $m_where['column_name'] ="status";
        $m_where['sign'] ="=";
        $m_where['value'] =1;
        $where[] = $m_where;


        $get_partner_details = $this->select_tb($this->table,$columns,$where);

        if (is_array($get_partner_details)){

            return $get_partner_details['data'][0];

        } else {

            return 0;
        }


    }
}


//$page_test = new category_class();
//echo json_encode($page_test->change_category_status(10, 1));
//echo json_encode($page_test->edit_category(10, 1, 1, 2,"test", 4,1, 0, "tested"));
//echo json_encode($page_test->get_all_categories());
//echo json_encode($page_test->get_partner_category_details(3));