<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 05/11/2018
 * Time: 13:32
 */

require_once ("main_class.php");
class category_lv1_class extends Rewardsbox_main
{
    private $table = "rewardsbox_category_level_1";


    public function create_lv1_category ($name, $image_url = null){

        $column = array("menu_name");
        $value = array($name);

        if($image_url != null || $image_url="") {
            $column[] = "image";
            $value[] = $image_url;
        }

        $thirdwhere['column_name'] ="menu_name";
        $thirdwhere['sign'] ="=";
        $thirdwhere['value'] =$name;
        $where[] = $thirdwhere;

        $insert_data = $this->insert_check_duplicate($this->table,$column,$value, $where);

        if ($insert_data > 0){
            $insert_array['id'] = $insert_data;
            $insert_array['name'] = ucfirst($name);
            return $insert_array;

        } elseif ($insert_data <0) {
            return "Menu already exists";

        } else {
            return "An error occurred";
        }
    }

    public function get_menu($id){

        $columns = array("menu_id", "menu_name");

        $thirdwhere['column_name'] ="menu_id";
        $thirdwhere['sign'] ="=";
        $thirdwhere['value'] =$id;
        $where[] = $thirdwhere;

        $get_data = $this->select_tb($this->table, $columns, $where);

        if (is_array($get_data)){

            return $get_data['data'][0];

        } else {

            return 0;
        }


    }

    public function view_all_lv1_menu(){

        $columns = array("menu_id", "menu_name", "image");

        $get_data = $this->select_tb($this->table, $columns);

        if(is_array($get_data)){

            return $get_data['data'];
        } else {

            return "No data found";
        }


    }



    public function edit_parent($id, $parent_name, $image_url = null) {
        $key = "menu_id";
        //$columns_name = "service_name";

        $firstset['column_name'] ="menu_name";
        $firstset['sign'] ="=";
        $firstset['value'] =$parent_name;
        $set[] = $firstset;

        $whereduplicate[] = $firstset;

        if($image_url != null || $image_url="") {
            $firstset['column_name'] = "image";
            $firstset['sign'] = "=";
            $firstset['value'] = $image_url;
            $set[] = $firstset;
        }


        $first_where['column_name'] ="menu_id";
        $first_where['sign'] ="=";
        $first_where['value'] =$id;
        $where[] = $first_where;

        $edit_result = $this->update_check_duplicate($this->table, $set, $where, $whereduplicate, $key);
        //print_r($edit_name);

        if ($edit_result == 1){
            return 1;

        } elseif ($edit_result ==-1) {
            return $parent_name." already exists";

        }  else {
            return "Invalid Parent";
        }

    } // end edi name function


    public function del_parent($id){

        $check_data = $this->get_menu($id);
        if (is_array($check_data)){

            $first_where['column_name'] ="menu_id";
            $first_where['sign'] ="=";
            $first_where['value'] =$id;
            $where[] = $first_where;

            $del_data = $this->delete_data($this->table, $where);

            if ($del_data == 1){

                return 1;

            } else {

                return "Error Deleting Parent";
            }


        } else {

            return "Invaid Parent Category";
        }


    }
}

//$test = new category_lv1_class();
//echo json_encode($test->edit_parent(9, "Data", "http://rewardsboxnigeria.com/images/partner/rewardsbox.png"));
//echo json_encode($test->del_parent(2));
//echo json_encode($test->create_lv1_category("Test2","testurl"));