<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 03/10/2018
 * Time: 10:54
 */
require_once("main_class.php");
require_once ("margin_type_class.php");
require_once ("category_class.php");


class company_category_class extends Rewardsbox_main


{
    private $table = 'rewardsbox_company_category';
    private $general_category = 'rewardsbox_category';
    private $api_table = "rewardsbox_api_link";
    //private $image_root = 'http://rewardsboxnigeria.com/rewardsbox/img/company_logo/';

    public function get_margin($category_id, $company_id){

        $columns = array("margin","margin_type","flag_id");

        $firstjoin ['table_name']=$this->general_category;
        $firstjoin ['first_column']=$this->general_category.".cat_id";
        $firstjoin ['second_column']=$this->table.".cat_id";
        $leftjoin []=$firstjoin;

        $m_where['column_name'] ="company_id";
        $m_where['sign'] ="=";
        $m_where['value'] =$company_id;
        $where[] = $m_where;

        $m_where['column_name'] =$this->table.".cat_id";
        $m_where['sign'] ="=";
        $m_where['value'] =$category_id;
        $where[] = $m_where;


        $get_margin = $this->select_tb($this->table,$columns,$where,"","","","","",$leftjoin);

        if (is_array($get_margin)){

            return $get_margin['data'][0];

        } else {

            return 0;
        }
    }


    public function get_multi_margin($category_array, $company_id){

            $columns = array("margin", "margin_type", $this->table . ".cat_id", "partner_category_id", "partner_api_id", "partner_category_name","flag_id", "cat_name");

            $firstjoin ['table_name'] = $this->general_category;
            $firstjoin ['first_column'] = $this->general_category . ".cat_id";
            $firstjoin ['second_column'] = $this->table . ".cat_id";
            $leftjoin [] = $firstjoin;

            $m_where['column_name'] = "company_id";
            $m_where['sign'] = "=";
            $m_where['value'] = $company_id;
            $where[] = $m_where;

            $m_where['column_name'] = $this->table . ".cat_id";
            $m_where['sign'] = "IN";
            $m_where['value'] = $category_array;
            $where[] = $m_where;


            $get_margin = $this->select_tb($this->table, $columns, $where, "", "", "", "", "", $leftjoin);

            if (is_array($get_margin)) {

                return $get_margin['data'];

            } else {

                return 0;
            }

    }

    public function get_rand_multi_margin($company_id, $limit = 1, $flag_id = 1){

        $columns = array("margin", "margin_type", $this->table . ".cat_id", "partner_category_id", "partner_api_id", "partner_category_name","flag_id", "cat_name");

        $firstjoin ['table_name'] = $this->general_category;
        $firstjoin ['first_column'] = $this->general_category . ".cat_id";
        $firstjoin ['second_column'] = $this->table . ".cat_id";
        $leftjoin [] = $firstjoin;

        $m_where['column_name'] = "company_id";
        $m_where['sign'] = "=";
        $m_where['value'] = $company_id;
        $where[] = $m_where;

        $m_where['column_name'] = "flag_id";
        $m_where['sign'] = "=";
        $m_where['value'] = $flag_id;
        $where[] = $m_where;

        $limit_array[] = 0;
        $limit_array[] = $limit;

        $order_type[] = "";

        $get_margin = $this->select_tb($this->table, $columns, $where, "", "", $order_type, $limit_array, "", $leftjoin);

        if (is_array($get_margin)) {

            return $get_margin['data'];

        } else {

            return 0;
        }

    }


public function get_all_multi_margin($company_id, $flag_id = 1){

        $columns = array("margin", "margin_type", $this->table . ".cat_id", "partner_category_id", $this->general_category.".partner_api_id", "partner_category_name",$this->general_category.".flag_id", "cat_name", "partner_id", "end_point");

        $firstjoin ['table_name'] = $this->general_category;
        $firstjoin ['first_column'] = $this->general_category . ".cat_id";
        $firstjoin ['second_column'] = $this->table . ".cat_id";
        $leftjoin [] = $firstjoin;

        $firstjoin ['table_name'] = $this->api_table;
        $firstjoin ['first_column'] = $this->general_category . ".partner_api_id";
        $firstjoin ['second_column'] = $this->api_table . ".partner_api_id";
        $leftjoin [] = $firstjoin;

        $m_where['column_name'] = "company_id";
        $m_where['sign'] = "=";
        $m_where['value'] = $company_id;
        $where[] = $m_where;

        $m_where['column_name'] =  $this->general_category.".flag_id";
        $m_where['sign'] = "=";
        $m_where['value'] =$flag_id;
        $where[] = $m_where;

        $m_where['column_name'] = $this->api_table.".api_type";
        $m_where['sign'] = "=";
        $m_where['value'] = 1;
        $where[] = $m_where;

        $get_margin = $this->select_tb($this->table, $columns, $where, "", "", "", "", "", $leftjoin);

        if (is_array($get_margin)) {

            return $get_margin['data'];

        } else {

            return 0;
        }

    }


    public function apply_margin ($margin, $margin_type, $price) {

        if ($margin_type == 1){

            $percent_value = ((float)$margin /100) * (float)$price;
            //return $new_price = round( (float)$price + $percent_value,2);
            return $new_price = ceil( (float)$price + $percent_value);
        } else {


            //return $new_price = round((float)$margin + (float)$price, 2);
            return $new_price = ceil((float)$margin + (float)$price);
        }

    }


    public function get_company_category($company_id, $flag_id){

        if(is_numeric($company_id)){

            $columns =array($this->table.".cat_id", "cat_name", "image_url");

            $m_where['column_name'] ="company_id";
            $m_where['sign'] ="=";
            $m_where['value'] =$company_id;
            $where[] = $m_where;

            $m_where['column_name'] ="flag_id";
            $m_where['sign'] ="=";
            $m_where['value'] =$flag_id;
            $where[] = $m_where;

            $firstjoin ['table_name']=$this->general_category;
            $firstjoin ['first_column']=$this->general_category.".cat_id";
            $firstjoin ['second_column']=$this->table.".cat_id";
            $leftjoin []=$firstjoin;

            $get_category = $this->select_tb($this->table, $columns,$where,"","","","","",$leftjoin);

            if(is_array($get_category)){

                return $get_category['data'];

            } else {

                return 0;
            }

        } else {

            return "No Category found";
        }

    }

    public function get_detailed_company_category($company_id){

        $columns =array("company_cat_id", $this->table.".cat_id", "rewardsbox_flag.name", "cat_name", "margin", "rewardsbox_margin_type.name");

        $m_where['column_name'] ="company_id";
        $m_where['sign'] ="=";
        $m_where['value'] =$company_id;
        $where[] = $m_where;

        $firstjoin ['table_name']=$this->general_category;
        $firstjoin ['first_column']=$this->general_category.".cat_id";
        $firstjoin ['second_column']=$this->table.".cat_id";
        $leftjoin []=$firstjoin;

        $firstjoin ['table_name']="rewardsbox_margin_type";
        $firstjoin ['first_column']="rewardsbox_margin_type.type_id";
        $firstjoin ['second_column']=$this->table.".margin_type";
        $leftjoin []=$firstjoin;

        $firstjoin ['table_name']="rewardsbox_flag";
        $firstjoin ['first_column']=$this->general_category.".cat_id";
        $firstjoin ['second_column']="rewardsbox_flag.flag_id";
        $leftjoin []=$firstjoin;


        $get_category = $this->select_tb($this->table, $columns,$where,"","","","","",$leftjoin);

        if(is_array($get_category)){

            return $get_category['data'];

        } else {

            return 0;
        }


    }


    public function get_not_assigned($company_id){

        $select1 = "SELECT  cat_id, cat_name FROM rewardsbox_category WHERE  status = 1 AND cat_id";
        $sign = "NOT IN";
        $select2 ="SELECT cat_id FROM rewardsbox_company_category WHERE company_id =".$company_id;

        $get_list = $this->combine_two_select($select1,$sign,$select2);

        if (is_array($get_list)){

            return $get_list['data'];
        } else {

            return "No data found";
        }


    }

    public function edit_assign_category($id, $margin_type, $margin){

        $firstset['column_name'] ="margin";
        $firstset['sign'] ="=";
        $firstset['value'] =$margin;
        $set[] = $firstset;

        $firstset['column_name'] ="margin_type";
        $firstset['sign'] ="=";
        $firstset['value'] =$margin_type;
        $set[] = $firstset;

        $third_where['column_name'] = "company_cat_id";
        $third_where['sign'] = "=";
        $third_where['value'] = $id;
        $where[] = $third_where;

        $update_data = $this->update_data($this->table, $set,$where);

        if ($update_data == 1){

            return $update_data;
        } else {

            return "Error updating";
        }

    }
    public function assign_category($company_id, $category, $margin_type, $margin){

        if(isset($company_id) && isset($category) && isset($margin_type) && isset($margin)){


            $use_category = new category_class();
            $get_category = $use_category->check_partner_category_($category);

            if(is_array($get_category)) {

                $category_name = $get_category['cat_name'];

                $use_type = new margin_type_class();
                $get_type = $use_type->get_type($margin_type);

                if (is_array($get_type)) {

                    $margin_type_name = $get_type['name'];

                    $columns = array("company_id", "cat_id", "margin", "margin_type");
                    $values = array($company_id, $category, $margin, $margin_type);

                    $third_where['column_name'] = "company_id";
                    $third_where['sign'] = "=";
                    $third_where['value'] = $company_id;
                    $where[] = $third_where;

                    $third_where['column_name'] = "cat_id";
                    $third_where['sign'] = "=";
                    $third_where['value'] = $category;
                    $where[] = $third_where;


                    $insert_category = $this->insert_check_duplicate($this->table, $columns, $values, $where,1);

                    if (is_numeric($insert_category) && $insert_category > 0) {

                        $insert_array['id'] = $insert_category;
                        $insert_array['cat_id'] = $category;
                        $insert_array['name'] = $category_name;
                        $insert_array['margin_type'] = $margin_type_name;
                        $insert_array['margin_val'] = $margin;


                        return $insert_array;
                    } elseif ($insert_category < 0) {

                        return "Category already assigned";
                    } else {

                        return "Error assigning category";
                    }
                } else {

                    return "Invalid margin type";
                }
            } else {

                return "Invalid Category";
            }

        } else {

            return "Missing Parameter";
        }


    }

    public function view_company_categories($company_id){

        if(is_numeric($company_id)){

            $columns =array($this->table.".cat_id", "rewardsbox_category_level_1.menu_name AS main_menu", "rewardsbox_category_level_2.menu_name AS sub_menu","rewardsbox_flag.name","cat_name");

            $m_where['column_name'] ="company_id";
            $m_where['sign'] ="=";
            $m_where['value'] =$company_id;
            $where[] = $m_where;


            $firstjoin ['table_name']=$this->general_category;
            $firstjoin ['first_column']=$this->general_category.".cat_id";
            $firstjoin ['second_column']=$this->table.".cat_id";
            $leftjoin []=$firstjoin;

            $firstjoin ['table_name']="rewardsbox_flag";
            $firstjoin ['first_column']=$this->general_category.".flag_id";
            $firstjoin ['second_column']="rewardsbox_flag.flag_id";
            $leftjoin []=$firstjoin;

            $firstjoin ['table_name']="rewardsbox_category_level_2";
            $firstjoin ['first_column']="rewardsbox_category_level_2.menu_id";
            $firstjoin ['second_column']=$this->general_category.".parent_id";
            $leftjoin []=$firstjoin;

            $firstjoin ['table_name']="rewardsbox_category_level_1";
            $firstjoin ['first_column']="rewardsbox_category_level_1.menu_id";
            $firstjoin ['second_column']="rewardsbox_category_level_2.parent_id";
            $leftjoin []=$firstjoin;

            $get_category = $this->select_tb($this->table, $columns,$where,"","","","","",$leftjoin);

            if(is_array($get_category)){

                return $get_category;

            } else {

                return 0;
            }

        } else {

            return "No Category found";
        }

    }


    public function view_company_flag_categories($company_id, $flag_id){

        if(is_numeric($company_id)){

            $columns =array($this->table.".cat_id", "rewardsbox_category_level_1.menu_name AS main_menu", "rewardsbox_category_level_1.image AS main_image", "rewardsbox_category_level_2.menu_id AS sub_menu_id", "rewardsbox_category_level_2.menu_name AS sub_menu","rewardsbox_flag.name","cat_name","image_url AS cat_image");

            $m_where['column_name'] ="company_id";
            $m_where['sign'] ="=";
            $m_where['value'] =$company_id;
            $where[] = $m_where;

            $m_where['column_name'] ="rewardsbox_category.flag_id";
            $m_where['sign'] ="=";
            $m_where['value'] =$flag_id;
            $where[] = $m_where;

            $firstjoin ['table_name']=$this->general_category;
            $firstjoin ['first_column']=$this->general_category.".cat_id";
            $firstjoin ['second_column']=$this->table.".cat_id";
            $leftjoin []=$firstjoin;

            $firstjoin ['table_name']="rewardsbox_flag";
            $firstjoin ['first_column']=$this->general_category.".flag_id";
            $firstjoin ['second_column']="rewardsbox_flag.flag_id";
            $leftjoin []=$firstjoin;

            $firstjoin ['table_name']="rewardsbox_category_level_2";
            $firstjoin ['first_column']="rewardsbox_category_level_2.menu_id";
            $firstjoin ['second_column']=$this->general_category.".parent_id";
            $leftjoin []=$firstjoin;

            $firstjoin ['table_name']="rewardsbox_category_level_1";
            $firstjoin ['first_column']="rewardsbox_category_level_1.menu_id";
            $firstjoin ['second_column']="rewardsbox_category_level_2.parent_id";
            $leftjoin []=$firstjoin;

            $get_category = $this->select_tb($this->table, $columns,$where,"","","","","",$leftjoin);

            if(is_array($get_category)){

                return $get_category;

            } else {

                return 0;
            }

        } else {

            return "No Category found";
        }

    }

    public function min_view_company_flag_categories($company_id, $flag_id){

        if(is_numeric($company_id)){

            $columns =array($this->table.".cat_id", "cat_name", "partner_category_id","margin", "margin_type","partner_api_id" );

            $m_where['column_name'] ="company_id";
            $m_where['sign'] ="=";
            $m_where['value'] =$company_id;
            $where[] = $m_where;

            $m_where['column_name'] ="rewardsbox_category.flag_id";
            $m_where['sign'] ="=";
            $m_where['value'] =$flag_id;
            $where[] = $m_where;

            $m_where['column_name'] = $this->general_category.".status";
            $m_where['sign'] ="=";
            $m_where['value'] =1;
            $where[] = $m_where;

            $firstjoin ['table_name']=$this->general_category;
            $firstjoin ['first_column']=$this->general_category.".cat_id";
            $firstjoin ['second_column']=$this->table.".cat_id";
            $leftjoin []=$firstjoin;

            $get_category = $this->select_tb($this->table, $columns,$where,"","","","","",$leftjoin);

            if(is_array($get_category)){

                return $get_category;

            } else {

                return 0;
            }

        } else {

            return "No Category found";
        }

    }


    public function view_company_flags($company_id){

        if(is_numeric($company_id)){

            $columns =array("rewardsbox_flag.flag_id", "rewardsbox_flag.name");

            $m_where['column_name'] ="company_id";
            $m_where['sign'] ="=";
            $m_where['value'] =$company_id;
            $where[] = $m_where;


            $firstjoin ['table_name']=$this->general_category;
            $firstjoin ['first_column']=$this->general_category.".cat_id";
            $firstjoin ['second_column']=$this->table.".cat_id";
            $leftjoin []=$firstjoin;

            $firstjoin ['table_name']="rewardsbox_flag";
            $firstjoin ['first_column']=$this->general_category.".flag_id";
            $firstjoin ['second_column']="rewardsbox_flag.flag_id";
            $leftjoin []=$firstjoin;

            $get_category = $this->select_tb($this->table, $columns,$where,"","","","","1",$leftjoin);

            if(is_array($get_category)){

                return $get_category;

            } else {

                return 0;
            }

        } else {

            return "No Category found";
        }

    }



    public function nested_company_category ($company_id, $flag_id){

        $get_data = $this->view_company_flag_categories($company_id, $flag_id);

        //echo json_encode($get_data);
        //echo "<br>";
        if (is_array($get_data)){

              if($flag_id == 1) {
                $parent = array();
                $sub_menu['name'] = "SALE";
                $sub_menu['image'] = "";
                $sub_menu['id'] = "sale";
                $parent[] = $sub_menu;
            } else {

                $parent = array();
            }

            //$child = array();

            foreach ($get_data['data'] as $result){

                $sub2_menu = array();
                $sub_menu = array();
                $sub1_menu = array();

                if (in_array($result['main_menu'], array_column($parent, 'name'))){

                    $key = array_search($result['main_menu'], array_column($parent, 'name'));



                } else {
                    $sub_menu['name'] = $result['main_menu'];
                    $sub_menu['image'] = $this->image_url.$result['main_image'];
                    $sub_menu['child_menu'] = array();
                    $parent[] = $sub_menu;
                    $key = max(array_keys($parent));
                }

                if (in_array($result['sub_menu'], array_column($parent[$key]['child_menu'], 'name'))){

                    $key1 = array_search($result['sub_menu'], array_column($parent[$key]['child_menu'], 'name'));

                } else {
                    $sub1_menu['name'] = $result['sub_menu'];
                    $sub1_menu['id'] = $result['sub_menu_id'];
                    $sub1_menu['category'] = array();
                    $parent[$key]['child_menu'][] = $sub1_menu;
                    $key1 = max(array_keys($parent[$key]['child_menu']));
                }


                $sub2_menu['name'] = $result['cat_name'];
                $sub2_menu['id'] = $result['cat_id'];
                $sub2_menu['image'] = $this->image_url.$result['cat_image'];

                $parent[$key]['child_menu'][$key1]['category'][] = $sub2_menu;



            }

            return $parent;
        } else {

            return "No data found";
        }
    }

    public function get_assign($id){

        $columns = array("company_cat_id");
        $first_where['column_name'] ="company_cat_id";
        $first_where['sign'] ="=";
        $first_where['value'] =$id;
        $where[] = $first_where;

        $get_data = $this->select_tb($this->table, $columns,$where);

        if (is_array($get_data)){

            return $get_data['data'][0];
        } else{

            return "No data found";
        }
    }


    public function del_parent($id){

        $check_data = $this->get_assign($id);
        if (is_array($check_data)){

            $first_where['column_name'] ="company_cat_id";
            $first_where['sign'] ="=";
            $first_where['value'] =$id;
            $where[] = $first_where;

            $del_data = $this->delete_data($this->table, $where);

            if ($del_data == 1){

                return 1;

            } else {

                return "Error Deleting Parent";
            }


        } else {

            return "Invalid Parent Category";
        }


    }

    public function verify_assign_category ($cat_id, $company_id){
        $columns = array("company_cat_id");

        $first_where['column_name'] ="cat_id";
        $first_where['sign'] ="=";
        $first_where['value'] =$cat_id;
        $where[] = $first_where;

        $first_where['column_name'] ="company_id";
        $first_where['sign'] ="=";
        $first_where['value'] =$company_id;
        $where[] = $first_where;

        $get_data = $this->select_tb($this->table, $columns,$where);

        if (is_array($get_data)){

            return $get_data['data'][0];
        } else{

            return "No data found";
        }


    }

    public function check_rb_category($partner_category_id){

        $new_category = new category_class();

        $get_cat_id = $new_category->get_rewardsbox_category_($partner_category_id);

        if (is_array($get_cat_id)){

            return $get_cat_id;

        } else {

            return "Invalid Category";
        }


    }

}

//$page_test = new company_category_class();
//echo json_encode($page_test->get_rand_multi_margin(10, 5));
//echo json_encode($page_test->verify_assign_category(3,10));
//echo json_encode($page_test->min_view_company_flag_categories(10,1));
//echo json_encode($page_test->view_company_flag_categories(10, 4));
//echo json_encode($page_test->nested_company_category(10,4));
//echo json_encode($page_test->apply_margin(1000, 2,1079.46));
//echo json_encode($page_test->edit_assign_category(4, 1,75));
//echo json_encode($page_test->get_multi_margin(array(3,4), 10));
//echo json_encode($page_test->get_margin(3,10));
//echo json_encode($page_test->change_assign_status(4,0));
//echo json_encode($page_test->nested_company_category(10,3));
//echo json_encode($page_test->view_company_flags(10));
//echo json_encode($page_test->view_company_categories(10));
//echo json_encode($page_test->get_not_assigned(10));

//echo json_encode($page_test->get_detailed_company_category(10));