<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 02/10/2018
 * Time: 14:08
 */
require_once("database_class.php");
require_once ("CurlService.php");

class curl_class extends Database
{

    protected $timeout = 600;
	
	
	    public function send_get($url, $header) {
        
        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => $this->timeout,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "GET",
            CURLOPT_SSL_VERIFYPEER => FALSE,
            CURLOPT_HTTPHEADER => $header,
        ));


        $response = curl_exec($curl);
        $err = curl_error($curl);
        $httpcode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
        curl_close($curl);
;
        if ($err) {
            return 0;
        } else {

                
                return json_decode($response, true);


        }


    }

    public function send_get_v2($url, $header) {

        
        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => $this->timeout,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "GET",
            CURLOPT_SSL_VERIFYPEER => FALSE,
            CURLOPT_HTTPHEADER => $header,
        ));
            

        $response = curl_exec($curl);
       // print_r($response); exit;
        $err = curl_error($curl);
        $httpcode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
        curl_close($curl);

        
        if ($err) {
            return 0;
        } else {
            
            if ($httpcode == 200) {
                
                return json_decode($response, true);
            } else {

                return "An error occurred";
            }
        }


    }



    public function send_post($url, $fields, $header) {
       
        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => $this->timeout,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "POST",
            CURLOPT_POSTFIELDS => $fields,
            CURLOPT_SSL_VERIFYPEER => FALSE,
            CURLOPT_HTTPHEADER => $header,
        ));


        $response = curl_exec($curl);
        $err = curl_error($curl);
        $httpcode = curl_getinfo($curl, CURLINFO_HTTP_CODE);

        curl_close($curl);

        if ($err) {
            $err = curl_error($curl);
            return $err;
            //return 0;
        } else {
            
                return json_decode($response, true);
            
        }


    }
	
	public function send_post_v2($url, $fields, $header) {
       
        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => $this->timeout,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "POST",
            CURLOPT_POSTFIELDS => $fields,
            CURLOPT_SSL_VERIFYPEER => FALSE,
            CURLOPT_HTTPHEADER => $header,
        ));


        $response = curl_exec($curl);
        $err = curl_error($curl);
        $httpcode = curl_getinfo($curl, CURLINFO_HTTP_CODE);

        curl_close($curl);

        if ($err) {
            
            //$err = curl_error($curl);
            return $err;
            
        } else {
            
            if ($httpcode == 200) {
                
                return $response;
            } else {
                
                return $response;
            }
        }


    }
	
	public function send_post_v3($url, $fields, $header) {
        
        $field_string = $fields;
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);

        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($field_string));// http_build_query($field_string))
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $this->timeout);
        $result = curl_exec($ch);
        $err = curl_error($ch);
        curl_close($ch);

        if ($err) {
            //$err = curl_error($ch);
            return $err;
           
        } else {
           return json_decode($result, true);

        }

    }
    
    public function send_get_v4($url, $header) {
        
        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => $url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => $this->timeout,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "GET",
            CURLOPT_SSL_VERIFYPEER => FALSE,
            CURLOPT_HTTPHEADER => $header,
        ));


        $response = curl_exec($curl);
        $err = curl_error($curl);
        $httpcode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
        curl_close($curl);
        
        if ($err) {
           
            return 0;
        } else {
            
            if ($httpcode == 200) {
               
                $result['data'] = json_decode($response, true);
                $result['status'] = $httpcode;
                return $result;
            } else {

                $result['status'] = $httpcode;
                $result['message'] =$response;
                return $result;
            }
        }


    }
    
    public function send_post_v6($url, $token, $payload){

        $use_curl = new \Ixudra\Curl\CurlService();
        $response = $use_curl->to($url)
            ->returnResponseArray()
            ->withTimeout(60)
            ->withHeader($token)
            ->withData($payload)
            ->asJson()
            ->post();

        if($response){

            //echo json_encode($response);
            //echo "<hr>";
            return $response;
        } else {

            //echo "Error";
            return "Error";
        }

    }
}


