<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 24/09/2020
 * Time: 09:39
 */
require_once("curl_class.php");
require_once ("main_class.php");
require_once ("company_class.php");
require_once ("service_access_class.php");
require_once ("company_user_class.php");
require_once ("send_mail_class.php");

class custom_email_class extends Rewardsbox_main
{

    private $store = "custom_email_store";

    public function save_email($client_id, $client_no, $type,$email_array){


        if(is_array($email_array)) {

            $this->delete_email_store($client_id);
            $counter = 1;
            foreach ($email_array as $value) {

                if (isset($value['email']) && isset($value['firstname'])) {

                    $balance = number_format($value['point_virtual']);
                    if($value['point_virtual'] > 0) {
                        $this->save_email_store($client_id, $value['firstname'], $value['email'], $value['password'], $balance, $client_no, $value['member_number'], $type, null);
                        $counter++;
                    }
                } else {

                    return "email and name not set  " . json_encode($value);
                }


            }

            return $counter;

        } else {

            return "Array Expected";
        }

    }

    private function save_email_store ($client_id, $first_name, $email, $password, $balance, $client_no, $member_no, $type, $pin ){

        $columns = array("client_id", "first_name", "email", "password","balance", "client_no", "member_no","type", "pin");
        $values = array($client_id, $first_name, $email, $password,$balance, $client_no, $member_no, $type, $pin);
        $insert_data = $this->insert_data($this->store, $columns, $values);

        if ($insert_data > 0) {
            return 1;
        } else {

            return 0;
        }

    }

    public function delete_email_store($client_id){

        $thirdwhere['column_name'] ="client_id";
        $thirdwhere['sign'] = "=";
        $thirdwhere['value'] =$client_id;
        $where[] = $thirdwhere;

        $get_delete = $this->delete_data($this->store, $where);

        return $get_delete;

    }



    public function get_email_data($client_id){

        $columns =array("first_name", "email","password","balance","client_no","member_no", "pin","type");
        $thirdwhere['column_name'] ="client_id";
        $thirdwhere['sign'] ="=";
        $thirdwhere['value'] =$client_id;
        $where[] = $thirdwhere;

        $check_no =  $this->select_tb($this->store,$columns, $where);

        if (is_array($check_no)){

            return $check_no;
        } else {

            return 0;
        }

    }



    public function send_email($client_id){
        $use_email = new send_mail_class();
        $get_data = $this->get_email_data($client_id);
        $response_array = array();
        $response_array['data'] = array();
        if(is_array($get_data)){
            $counter = 0;
            foreach ($get_data['data'] as $datum){

                if($datum['type'] == 1){
                    $send_data = $use_email->send_portal_enrol($datum['first_name'],$datum['email'],$datum['password'],$datum['balance'],$datum['client_no'],$datum['member_no'],$datum['pin']);

                }

                $response_array['data'][] = $send_data;
                $counter++;
            }
            $this->delete_email_store($client_id);
            $response_array['counter'] = $counter;
            return $response_array;
        } else {

            return "No data found";
        }

    }
}