<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 23/11/2018
 * Time: 09:22
 */
require_once ("main_class.php");
require_once ("company_class.php");
class licence_class extends Rewardsbox_main
{
    private $table = "usr_mgt_license_log";


    public function renew_licence($company_id, $period_id) {
        $use_company = new Reward_company();
        $check_period = $use_company->get_period($period_id);

        if (is_array($check_period)){

            $period_text = $check_period['period_text'];
            $no_of_days = $check_period['no_of_days'];
            $today_date = Date('Y-m-d');

            $check_company = $use_company->get_company($company_id);

            if (is_array($check_company)){

                $company_name = $check_company['company_name'];
                $expire_date = $check_company['expire_date'];

                if ($expire_date > $today_date){

                    $start_date = $expire_date;
                } else {

                    $start_date = $today_date;
                }

                $new_expire = Date('Y-m-d', strtotime($start_date. "+".$no_of_days."days"));

                $update_company = $use_company->update_licence($company_id, $new_expire);

                if (is_array($update_company)){

                    $insert_log = $this->create_history($company_id,$company_name,$period_id,$no_of_days, $period_text,$start_date, $new_expire);

                    if ($insert_log > 0){

                        $d_array['company'] = $company_name;
                        $d_array['expiry'] = $new_expire;
                        return $d_array;
                    } else {

                        return "Error creating log";
                    }

                } else {

                    return $update_company;
                }

            } else {

                return "Invalid Company";
            }


        } else {

            return "Invalid Period";
        }


    }

    public function  create_history($company_id, $company_name, $period_id, $no_of_days, $period_text, $start_date, $expire_date)
    {

        $licence_log_columns = array("company_id", "company_name", "period_id", "no_of_days", "period_text", "start_date", "expire_date");
        $licence_log_values = array($company_id, $company_name, $period_id, $no_of_days, $period_text, $start_date, $expire_date);

        $insert_data = $this->insert_data($this->table, $licence_log_columns, $licence_log_values);

        if ($insert_data > 0){

            return $insert_data;
        } else {

            return "Error inserting data";
        }
    }


    public function view_history ($company_id = null, $start_date=null, $end_date=null){

        $columns = array("company_name", "no_of_days", "period_text", "start_date", "expire_date", "create_date");

        $where = null;
        if($company_id != null || $company_id!="") {
            $p_where['column_name'] = $this->table . ".company_id";
            $p_where['sign'] = "=";
            $p_where['value'] = $company_id;
            $where[] = $p_where;
        }


        if($start_date != null || $start_date!=""){

            if($end_date != null || $end_date!=""){

                $p_where['column_name'] = $this->table.".create_date";
                $p_where['sign'] = ">=";
                $p_where['value'] = $start_date;
                $where[] = $p_where;

                $p_where['column_name'] = $this->table.".create_date";
                $p_where['sign'] = "<=";
                $p_where['value'] = $end_date;
                $where[] = $p_where;
            }



        }

        $get_data = $this->select_tb($this->table, $columns, $where);

        if(is_array($get_data)){

            return $get_data['data'];
        } else {

            return "No data found";
        }
    }


}


//$page_test = new licence_class();
//echo json_encode($page_test->renew_licence(12,2));
//echo json_encode($page_test->view_history("", "2018-12-30", "2019-01-02"));