<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 28/10/2018
 * Time: 20:50
 */

require_once ("main_class.php");
class partner_type_class extends Rewardsbox_main
{
    private $table = 'rewardsbox_partner_type';

    public function list_partner_type(){

        $columns = array("type_id","type_name", "description", "status");
        $get_type = $this->select_tb($this->table,$columns);

        if (is_array($get_type)){

            return $get_type['data'];
        } else {

            return "No data found";
        }
    }

    public function active_partner_type(){

        $columns = array("type_id","type_name", "status");

        $p2_where['column_name'] ="status";
        $p2_where['sign'] ="=";
        $p2_where['value'] =1;

        $where[]=$p2_where;

        $get_type = $this->select_tb($this->table,$columns, $where);

        if (is_array($get_type)){

            return $get_type['data'];
        } else {

            return "No data found";
        }
    }


    public function get_type($id){
        $columns=array("type_name");

        $p2_where['column_name'] ="type_id";
        $p2_where['sign'] ="=";
        $p2_where['value'] =$id;

        $where[]=$p2_where;

        $get_type = $this->select_tb($this->table, $columns, $where);

        if (is_array($get_type)){

            return $get_type['data'][0];
        } else {

            return "No data found";
        }
    }

    public function create_partner_type ($type_name, $desc){


        $column = array("type_name","description", "status");
        $value = array($type_name, $desc, 1);


        $thirdwhere['column_name'] = "type_name";
        $thirdwhere['sign'] = "=";
        $thirdwhere['value'] = $type_name;
        $where[] = $thirdwhere;

        $insert_data = $this->insert_check_duplicate($this->table, $column, $value, $where);

        if ($insert_data > 0) {
            $insert_array['id'] = $insert_data;
            $insert_array['name'] = $type_name;

            return $insert_array;

        } elseif ($insert_data < 0) {
            return "Partner type already exists";

        } else {
            return "An error occurred";
        }

    }


    public function edit_partner_type($id, $type_name, $desc) {
        $key = "type_id";
        //$columns_name = "service_name";

        $firstset['column_name'] ="type_name";
        $firstset['sign'] ="=";
        $firstset['value'] =$type_name;
        $set[] = $firstset;
        $whereduplicate[] = $firstset;

        $firstset['column_name'] ="desc";
        $firstset['sign'] ="=";
        $firstset['value'] =$desc;
        $set[] = $firstset;


        $first_where['column_name'] =$key;
        $first_where['sign'] ="=";
        $first_where['value'] =$id;
        $where[] = $first_where;

        $edit_result = $this->update_check_duplicate($this->table, $set, $where, $whereduplicate, $key);
        //print_r($edit_name);

        if ($edit_result == 1){
            return 1;

        } elseif ($edit_result ==-1) {
            return "Type already exists";

        }  else {
            return "Invalid Partner Type";
        }

    } // end edi name function


    public function change_type_status ($type_id, $new_status){
        $key = "type_id";
        //$columns = array($key,"status");

        if ($new_status == 1) {

            $msg = "Active";

        } else {
            $new_status = 0;
            $msg= "Inactive";
        }

        $change_status = $this->change_status($type_id, $new_status,$this->table,$key);
        if ($change_status == 1){
            return 1;

        } elseif ($change_status ==-2) {
            return "Cannot locate Type";

        } elseif ($change_status ==-1) {
            return "Type already ".$msg;

        } else {
            return "An error occurred";
        }


    } // end change status
}