<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 03/12/2018
 * Time: 14:44
 */

require_once ("curl_class.php");
require_once ("notification_class.php");
class send_mail_class extends curl_class
{
    private $token = "1001";
    private $lsl_no = "Client-LSL";
    private $company_no = "LSL-test";
    private $default_email = "rewardsbox@rewardsboxnigeria.com";
    private $note_create_company = 5;
    private $note_com_enrol =1 ;
    private $note_company_user_enrol =48 ;
    private $note_customer_credit =8 ;
    private $note_customer_debit = 9;
    private $note_reset_password= 7;
    private $note_reset_pin= 38;
    private $note_customer_redeem= 23;
    private $note_customer_redeem_delivery= 10;
    private $note_customer_redeem_evoucher= 11;
    private $note_customer_redeem_experience= 43;
    private $note_customer_redeem_bills= 44;
    private $note_customer_redeem_cinema= 45;
    private $note_customer_redeem_event= 46;
    private $note_customer_redeem_fuel= 47;
    private $note_customer_redeem_uber= 52;
    private $note_customer_redeem_food= 55;
    private $note_wallet_credit = 21;
    private $note_wallet_debit = 22;
    private $note_change_password = 3;
    private $note_change_pin = 39;
    private $note_prepaid_wallet = 26;
    private $note_customer_shipped = 33 ;
    private $note_customer_delivered = 32;
    private $note_customer_expired = 34;
    private $note_customer_cancelled = 25 ;
    private $note_customer_picked = 35;
    private $note_expire_reminder = 18;
    private $note_expire_reminder_2days = 36;
    private $note_expire_reminder_7days = 37;
    private $note_utilization_reminder = 13;
    private $note_partner_balance_limit = 50;
    private $note_client_custom = 51;
    private $expiry_days = 15;
    private $note_partner_wallet_credit = 53;
    private $note_partner_wallet_debit = 54;
    private $note_forfiet_30_days = 56;
    private $note_forfiet_5_days = 57;
    private $note_forfiet_complete = 58;
    private $note_customer_picked_cancel = 61;
    private $note_premium_incentives_custom = 62;
    private $note_premium_incentives_transaction = 63;
    private $note_custom_mails = 64;
    private $note_forfiet_90_days = 65;
    private $note_forfiet_60_days = 66;

    public function create_company($company_name, $expiry_date, $licence, $email){

        $v_array['company_name'] = $company_name;
        $v_array['expiry_date'] = $expiry_date;
        $v_array['licence_name'] = $licence;

        $use_note = new notification_class();
        $send_data = $use_note->emailsend($this->lsl_no,$email, $this->note_create_company,$v_array);

        return $send_data;


    }

    public function send_prepaid_credit($company_name, $amount, $current_balance){

        $v_array['company_name'] = $company_name;
        $v_array['amount'] = $amount;
        $v_array['current_balance'] = $current_balance;

        $use_note = new notification_class();
        $send_data = $use_note->emailsend($this->lsl_no,$this->default_email, $this->note_prepaid_wallet,$v_array);

        return $send_data;


    }

    public function send_lsl_enrol($first_name,$last_name, $email,$password, $username, $role){

        $v_array['first_name'] = ucwords($first_name);
        $v_array['last_name'] = ucwords($last_name);
        $v_array['password'] = $password;
        $v_array['role'] = $role;
        $v_array['username'] = $username;
        $v_array['email'] = $email;

        $use_note = new notification_class();
        $send_data = $use_note->emailsend($this->lsl_no,$email, $this->note_com_enrol,$v_array);

        return $send_data;

    }

    public function send_company_portal_enrol($first_name,$last_name, $email,$password){

        $v_array['first_name'] = ucwords($first_name);
        $v_array['last_name'] = ucwords($last_name);
        $v_array['password'] = $password;
        $v_array['email'] = $email;

        $use_note = new notification_class();
        $send_data = $use_note->emailsend($this->lsl_no,$email, $this->note_company_user_enrol,$v_array);

        return $send_data;

    }

    public function send_portal_enrol($first_name, $email,$password, $current_balance, $client_no, $member_no, $pin = null){

        $v_array['first_name'] = ucwords($first_name);
        $v_array['password'] = $password;
        $v_array['current_balance'] = $current_balance;
        $v_array['email'] = $email;
        $v_array['member_no'] = $member_no;
        $v_array['pin'] = $pin;


        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_com_enrol,$v_array);

        return $send_data;

    }

    public function send_customer_credit($first_name, $email, $old_balance, $new_balance, $amount_gained,$company_name,$member_no, $client_no){

        $v_array['first_name'] = ucwords($first_name);
        $v_array['old_balance'] = $old_balance;
        $v_array['current_balance'] = $new_balance;
        $v_array['amount'] = $amount_gained;
        $v_array['company_name'] = $company_name;
        $v_array['member_no'] = $member_no;
        $v_array['email'] = $email;

        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_customer_credit,$v_array);

        return $send_data;


    }
    public function send_customer_debit($first_name, $email, $old_balance, $new_balance, $amount_lost,$company_name,$member_no, $client_no){

        $v_array['first_name'] = ucwords($first_name);
        $v_array['old_balance'] = $old_balance;
        $v_array['current_balance'] = $new_balance;
        $v_array['amount'] = $amount_lost;
        $v_array['company_name'] = $company_name;
        $v_array['member_no'] = $member_no;
        $v_array['email'] = $email;


        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_customer_debit,$v_array);

        return $send_data;


    }

    public function send_reset_password($first_name, $email, $last_name, $member_no, $company_name, $reset_url, $client_no){

        $v_array['first_name'] = ucwords($first_name);
        $v_array['last_name'] = ucwords($last_name);
        $v_array['member_no'] = $member_no;
        $v_array['company_name'] = $company_name;
        $v_array['reset_url'] = $reset_url;


        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_reset_password,$v_array);

        return $send_data;

    }

    public function send_reset_pin($first_name, $email, $last_name, $member_no, $company_name, $reset_url, $client_no){

        $v_array['first_name'] = ucwords($first_name);
        $v_array['last_name'] = ucwords($last_name);
        $v_array['member_no'] = $member_no;
        $v_array['company_name'] = $company_name;
        $v_array['reset_url'] = $reset_url;


        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_reset_pin,$v_array);

        return $send_data;

    }

    public function lsl_reset_password($first_name, $email, $password){

        $v_array['first_name'] = ucwords($first_name);
        $v_array['password'] = $password;


        $use_note = new notification_class();
        $send_data = $use_note->emailsend($this->lsl_no,$email, $this->note_reset_password,$v_array);

        return $send_data;

    }

    public function company_portal_reset_password($first_name, $email, $last_name, $password){

        $v_array['first_name'] = ucwords($first_name);
        $v_array['last_name'] = $last_name;
        $v_array['password'] = $password;


        $use_note = new notification_class();
        $send_data = $use_note->emailsend($this->company_no,$email, $this->note_reset_password,$v_array);

        return $send_data;

    }

    public function send_redemption($first_name,$email, $last_name, $order_no, $member_no, $company_name, $current_balance, $spend_amount, $table,$client_no){
        $v_array['first_name'] = ucwords($first_name);
        $v_array['last_name'] = ucwords($last_name);
        $v_array['order_no'] = $order_no;
        $v_array['member_no'] = $member_no;
        $v_array['company_name'] = $company_name;
        $v_array['current_balance'] = $current_balance;
        $v_array['spend'] = $spend_amount;
        $v_array['table'] = $table;


        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_customer_redeem,$v_array);

        return $send_data;
    }

    public function send_redemption_delivery($first_name,$email, $last_name, $order_no, $member_no, $company_name, $current_balance, $spend_amount, $table,$client_no){
        $v_array['first_name'] = ucwords($first_name);
        $v_array['last_name'] = ucwords($last_name);
        $v_array['order_no'] = $order_no;
        $v_array['member_no'] = $member_no;
        $v_array['company_name'] = $company_name;
        $v_array['current_balance'] = $current_balance;
        $v_array['spend'] = $spend_amount;
        $v_array['table'] = $table;


        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_customer_redeem_delivery,$v_array);

        return $send_data;
    }

    public function send_redemption_pickup($first_name,$email, $last_name, $order_no, $member_no, $company_name, $current_balance, $spend_amount,$table,$client_no){
        $v_array['first_name'] = ucwords($first_name);
        $v_array['last_name'] = ucwords($last_name);
        $v_array['order_no'] = $order_no;
        $v_array['member_no'] = $member_no;
        $v_array['company_name'] = $company_name;
        $v_array['current_balance'] = $current_balance;
        $v_array['spend'] = $spend_amount;
        $v_array['table'] = $table;


        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_customer_redeem_evoucher,$v_array);

        return $send_data;
    }

    public function send_redemption_experience($first_name,$email, $last_name, $order_no, $member_no, $company_name, $current_balance, $spend_amount, $supplier_email, $supplier_phone, $table,$client_no){
        $v_array['first_name'] = ucwords($first_name);
        $v_array['last_name'] = ucwords($last_name);
        $v_array['order_no'] = $order_no;
        $v_array['member_no'] = $member_no;
        $v_array['company_name'] = $company_name;
        $v_array['current_balance'] = $current_balance;
        $v_array['spend'] = $spend_amount;
        $v_array['supplier_email'] = $supplier_email;
        $v_array['supplier_phone'] = $supplier_phone;
        $v_array['table'] = $table;


        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_customer_redeem_experience,$v_array);

        return $send_data;
    }

    public function send_redemption_bills($first_name,$email, $last_name, $order_no, $member_no, $company_name, $current_balance, $spend_amount, $table,$client_no){
        $v_array['first_name'] = ucwords($first_name);
        $v_array['last_name'] = ucwords($last_name);
        $v_array['order_no'] = $order_no;
        $v_array['member_no'] = $member_no;
        $v_array['company_name'] = $company_name;
        $v_array['current_balance'] = $current_balance;
        $v_array['spend'] = $spend_amount;
        $v_array['table'] = $table;


        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_customer_redeem_bills,$v_array);

        return $send_data;
    }

    public function send_redemption_food($first_name,$email, $last_name, $order_no, $member_no, $company_name, $current_balance, $spend_amount, $table,$client_no){
        $v_array['first_name'] = ucwords($first_name);
        $v_array['last_name'] = ucwords($last_name);
        $v_array['order_no'] = $order_no;
        $v_array['member_no'] = $member_no;
        $v_array['company_name'] = $company_name;
        $v_array['current_balance'] = $current_balance;
        $v_array['spend'] = $spend_amount;
        $v_array['table'] = $table;


        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_customer_redeem_food,$v_array);

        return $send_data;
    }

    public function send_redemption_cinema($first_name,$email, $last_name, $order_no, $member_no, $company_name, $current_balance, $spend_amount, $table,$client_no){
        $v_array['first_name'] = ucwords($first_name);
        $v_array['last_name'] = ucwords($last_name);
        $v_array['order_no'] = $order_no;
        $v_array['member_no'] = $member_no;
        $v_array['company_name'] = $company_name;
        $v_array['current_balance'] = $current_balance;
        $v_array['spend'] = $spend_amount;
        $v_array['table'] = $table;


        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_customer_redeem_cinema ,$v_array);

        return $send_data;
    }

    public function send_redemption_events($first_name,$email, $last_name, $order_no, $member_no, $company_name, $current_balance, $spend_amount, $table,$client_no){
        $v_array['first_name'] = ucwords($first_name);
        $v_array['last_name'] = ucwords($last_name);
        $v_array['order_no'] = $order_no;
        $v_array['member_no'] = $member_no;
        $v_array['company_name'] = $company_name;
        $v_array['current_balance'] = $current_balance;
        $v_array['spend'] = $spend_amount;
        $v_array['table'] = $table;


        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_customer_redeem_event,$v_array);

        return $send_data;
    }

    public function send_redemption_fuel($first_name,$email, $last_name, $order_no, $member_no, $company_name, $current_balance, $spend_amount, $table,$client_no){
        $v_array['first_name'] = ucwords($first_name);
        $v_array['last_name'] = ucwords($last_name);
        $v_array['order_no'] = $order_no;
        $v_array['member_no'] = $member_no;
        $v_array['company_name'] = $company_name;
        $v_array['current_balance'] = $current_balance;
        $v_array['spend'] = $spend_amount;
        $v_array['table'] = $table;


        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_customer_redeem_fuel,$v_array);

        return $send_data;
    }

    public function send_redemption_uber($first_name,$email, $last_name, $order_no, $member_no, $company_name, $current_balance, $spend_amount, $table,$client_no){
        $v_array['first_name'] = ucwords($first_name);
        $v_array['last_name'] = ucwords($last_name);
        $v_array['order_no'] = $order_no;
        $v_array['member_no'] = $member_no;
        $v_array['company_name'] = $company_name;
        $v_array['current_balance'] = $current_balance;
        $v_array['spend'] = $spend_amount;
        $v_array['table'] = $table;


        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_customer_redeem_uber,$v_array);

        return $send_data;
    }

    public function send_shipped($first_name,$email, $last_name, $member_no, $order_no, $table,$client_no){
        $v_array['first_name'] = ucwords($first_name);
        $v_array['last_name'] = ucwords($last_name);
        $v_array['member_no'] = $member_no;
        $v_array['order_no'] = $order_no;
        //$v_array['current_balance'] = $current_balance;
        $v_array['table'] = $table;


        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_customer_shipped,$v_array);

        return $send_data;
    }

    public function send_delivered($first_name,$email, $last_name, $member_no, $order_no, $company_name, $table,$client_no){
        $v_array['first_name'] = ucwords($first_name);
        $v_array['last_name'] = ucwords($last_name);
        $v_array['member_no'] = $member_no;
        $v_array['order_no'] = $order_no;
        $v_array['company_name'] = $company_name;
        //$v_array['current_balance'] = $current_balance;
        $v_array['table'] = $table;


        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_customer_delivered,$v_array);

        return $send_data;
    }

    public function send_picked_up($first_name,$email, $last_name, $member_no, $order_no, $table,$client_no, $branch_name = null){
        $v_array['first_name'] = ucwords($first_name);
        $v_array['last_name'] = ucwords($last_name);
        $v_array['member_no'] = $member_no;
        $v_array['order_no'] = $order_no;
        $v_array['days'] = $this->expiry_days;
        $v_array['branch_name'] = $branch_name;
        //$v_array['current_balance'] = $current_balance;
        $v_array['table'] = $table;


        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_customer_picked,$v_array);

        return $send_data;
    }

    public function send_expired($first_name,$email, $current_balance, $refund_amount, $member_no, $order_no, $table,$client_no){
        $v_array['first_name'] = ucwords($first_name);
        $v_array['current_balance'] = $current_balance;
        $v_array['refund_amount'] = $refund_amount;
        $v_array['member_no'] = $member_no;
        $v_array['order_no'] = $order_no;
        $v_array['table'] = $table;


        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_customer_expired,$v_array);

        return $send_data;
    }

    public function send_cancelled($first_name,$email, $last_name, $member_no, $current_balance, $refund_amount, $table,$client_no, $order_no =null, $item_name = null){
        $v_array['first_name'] = ucwords($first_name);
        $v_array['last_name'] = ucwords($last_name);
        $v_array['member_no'] = $member_no;
        $v_array['current_balance'] = $current_balance;
        $v_array['refund_amount'] = $refund_amount;
        $v_array['order_no'] = $order_no;
        $v_array['item_name'] = $item_name;
        $v_array['table'] = $table;


        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_customer_cancelled,$v_array);

        return $send_data;
    }

    public function send_wallet_credit($company_name, $amount, $balance,$client_no, $email){

        $v_array['company_name'] = $company_name;
        $v_array['current_balance'] = $balance;
        $v_array['amount'] = $amount;


        $use_note = new notification_class();
        $send_data = $use_note->emailsend($this->lsl_no,$email, $this->note_wallet_credit,$v_array);


        return $send_data;

    }


    public function send_wallet_debit($company_name, $amount, $balance,$client_no, $email){


        $v_array['company_name'] = $company_name;
        $v_array['current_balance'] = $balance;
        $v_array['amount'] = $amount;


        $use_note = new notification_class();
        $send_data = $use_note->emailsend($this->lsl_no,$this->default_email, $this->note_wallet_debit,$v_array);

        return $send_data;

    }

    public function send_change_password($first_name, $last_name, $email, $member_no, $company_name, $client_no){
        $v_array['first_name'] = ucwords($first_name);
        $v_array['last_name'] = ucwords($last_name);
        $v_array['member_no'] = $member_no;
        $v_array['company_name'] = $company_name;



        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_change_password,$v_array);


        return $send_data;
    }

    public function send_change_pin($first_name, $last_name, $email, $member_no, $company_name, $client_no){
        $v_array['first_name'] = ucwords($first_name);
        $v_array['last_name'] = ucwords($last_name);
        $v_array['member_no'] = $member_no;
        $v_array['company_name'] = $company_name;



        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_change_pin,$v_array);


        return $send_data;
    }


    public function lsl_send_change_password($first_name,$email, $last_name){
        $v_array['first_name'] = ucwords($first_name);
        $v_array['last_name'] = ucwords($last_name);
        $v_array['member_no'] = "";



        $use_note = new notification_class();
        $send_data = $use_note->emailsend($this->lsl_no,$email, $this->note_change_password,$v_array);


        return $send_data;
    }

    public function company_portal_send_change_password($first_name,$email, $last_name){
        $v_array['first_name'] = ucwords($first_name);
        $v_array['last_name'] = ucwords($last_name);
//        $v_array['member_no'] = "";



        $use_note = new notification_class();
        $send_data = $use_note->emailsend($this->company_no,$email, $this->note_change_password,$v_array);


        return $send_data;
    }

    public function expire_reminder($company_name, $expiry_date, $days, $email){

        $v_array['company_name'] = $company_name;
        $v_array['date'] = $expiry_date;
        $v_array['days'] = $days;

        $use_note = new notification_class();
        $send_data = $use_note->emailsend($this->lsl_no,$email, $this->note_expire_reminder,$v_array);

        return $send_data;


    }

    public function expire_reminder_2days($first_name,  $email, $expiry_date, $table, $client_no, $company_name = null, $member_no = null, $days = 2){

        $v_array['first_name'] = ucwords($first_name);
        $v_array['expiry_date'] = $expiry_date;
        $v_array['table'] = $table;
        $v_array['company_name'] = $company_name;
        $v_array['member_no'] = $member_no;
        $v_array['days'] = $days;

        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_expire_reminder_2days,$v_array);

        return $send_data;


    }

    public function expire_reminder_7days($first_name, $email, $expiry_date, $table, $client_no, $company_name = null, $member_no = null, $days = 7){

        $v_array['first_name'] = ucwords($first_name);
        $v_array['expiry_date'] = $expiry_date;
        $v_array['table'] = $table;
        $v_array['company_name'] = $company_name;
        $v_array['member_no'] = $member_no;
        $v_array['days'] = $days;

        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_expire_reminder_7days,$v_array);

        return $send_data;


    }

    public function utilization_reminder($company_name, $util, $current_balance, $email){

        $v_array['company_name'] = $company_name;
        $v_array['utilization_value'] = $util;
        $v_array['current_balance'] = $current_balance;

        $use_note = new notification_class();
        $send_data = $use_note->emailsend($this->lsl_no,$email, $this->note_utilization_reminder,$v_array);

        return $send_data;


    }

    public function prepaid_partner_limit_reminder($partner_name, $current_balance, $reminder_limit){

        $v_array['partner_name'] = $partner_name;
        $v_array['reminder_limit'] = $reminder_limit;
        $v_array['current_balance'] = $current_balance;

        $use_note = new notification_class();
        $send_data = $use_note->emailsend($this->lsl_no,$this->default_email, $this->note_partner_balance_limit,$v_array);
        echo $send_data;
        return $send_data;


    }

    public function send_partner_credit($partner_name, $amount, $current_balance){

        $v_array['partner_name'] = $partner_name;
        $v_array['amount'] = $amount;
        $v_array['current_balance'] = $current_balance;

        $use_note = new notification_class();
        $send_data = $use_note->emailsend($this->lsl_no,$this->default_email, $this->note_partner_wallet_credit,$v_array);

        return $send_data;


    }

    public function send_partner_debit($partner_name, $amount, $current_balance){

        $v_array['partner_name'] = $partner_name;
        $v_array['amount'] = $amount;
        $v_array['current_balance'] = $current_balance;

        $use_note = new notification_class();
        $send_data = $use_note->emailsend($this->lsl_no,$this->default_email, $this->note_partner_wallet_debit,$v_array);

        return $send_data;


    }

    public function send_custom_comm($email, $body, $client_no){


        $v_array['body'] = $body;


        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_client_custom,$v_array);

        return $send_data;


    }
    
     public function forfeit_reminder_30days($first_name, $last_name, $email, $expiry_date, $client_no, $points, $company_name = null, $member_no = null, $days = 30){

        $v_array['first_name'] = ucwords($first_name);
        $v_array['expiry_date'] = $expiry_date;
        $v_array['last_name'] = ucwords($last_name);
        $v_array['company_name'] = $company_name;
        $v_array['member_no'] = $member_no;
        $v_array['current_balance'] = number_format($points);
        $v_array['days'] = $days;

        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_forfiet_30_days,$v_array);

        return $send_data;


    }

    public function forfeit_reminder_5days($first_name, $last_name, $email, $expiry_date, $client_no, $points, $company_name = null, $member_no = null, $days = 5){

        
        $v_array['first_name'] = ucwords($first_name);
        $v_array['expiry_date'] = $expiry_date;
        $v_array['last_name'] = ucwords($last_name);
        $v_array['company_name'] = $company_name;
        $v_array['member_no'] = $member_no;
        $v_array['current_balance'] = number_format($points);
        $v_array['days'] = $days;

        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_forfiet_5_days,$v_array);

        return $send_data;


    }


    public function forfeit_complete($first_name, $last_name, $email, $expiry_date, $client_no, $points, $company_name = null, $member_no = null){

        $v_array['first_name'] = ucwords($first_name);
        $v_array['expiry_date'] = $expiry_date;
        $v_array['last_name'] = ucwords($last_name);
        $v_array['company_name'] = $company_name;
        $v_array['current_balance'] = number_format($points);
        $v_array['member_no'] = $member_no;


        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_forfiet_complete,$v_array);

        return $send_data;


    }
    
    public function send_picked_up_cancel($first_name,$email, $last_name, $member_no, $order_no, $cancel_table, $pickup_table, $refund_amount, $current_balance, $date, $client_no, $branch_name = null){
        $v_array['first_name'] = ucwords($first_name);
        $v_array['last_name'] = ucwords($last_name);
        $v_array['member_no'] = $member_no;
        $v_array['order_no'] = $order_no;
        $v_array['pickup_table'] = $pickup_table;
        $v_array['cancel_table'] = $cancel_table;
        $v_array['branch_name'] = $branch_name;
        $v_array['current_balance'] = $current_balance;
        $v_array['refund_amount'] = $refund_amount;


        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_customer_picked_cancel,$v_array);

        return $send_data;
    }
    
    
    
    public function send_premium_incentives_custom($first_name,$email, $last_name, $member_no, $client_no){
        $v_array['first_name'] = ucwords($first_name);
        $v_array['last_name'] = ucwords($last_name);
        $v_array['member_no'] = $member_no;



        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_premium_incentives_custom,$v_array);

        return $send_data;
    }
    
    public function send_premium_incentives_transaction($date, $first_name,$email, $last_name, $member_no, $client_no, $store = null, $transaction_amount = null, $discount_given = null, $amount_paid = null, $table = null){
       
       $v_array['date'] = date('d-m-Y');
        $v_array['first_name'] = ucwords($first_name);
        $v_array['last_name'] = ucwords($last_name);
        $v_array['member_no'] = $member_no;
        $v_array['store'] = $store;
        $v_array['transaction_amount'] = $transaction_amount;
        $v_array['discount'] = $discount_given;
        $v_array['amount_paid'] = $amount_paid;
        $v_array['table'] = $table;


        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_premium_incentives_transaction,$v_array);

        return $send_data;
    }
    
    
    public function send_rewardsbox_custom($first_name,$email, $last_name, $member_no, $client_no, $points){
        $v_array['first_name'] = ucwords($first_name);
        $v_array['last_name'] = ucwords($last_name);
        $v_array['member_no'] = $member_no;
        $v_array['current_balance'] = number_format($points);



        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_custom_mails,$v_array);

        return $send_data;
    }

    public function forfeit_reminder_60days($first_name, $last_name, $email, $expiry_date, $client_no, $points, $company_name = null, $member_no = null, $days = 60){

        $v_array['first_name'] = ucwords($first_name);
        $v_array['expiry_date'] = $expiry_date;
        $v_array['last_name'] = ucwords($last_name);
        $v_array['company_name'] = $company_name;
        $v_array['member_no'] = $member_no;
        $v_array['current_balance'] = number_format($points);
        $v_array['days'] = $days;

        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_forfiet_60_days,$v_array);

        return $send_data;


    }
    
    
     public function forfeit_reminder_90days($first_name, $last_name, $email, $expiry_date, $client_no, $points, $company_name = null, $member_no = null, $days = 90){

        $v_array['first_name'] = ucwords($first_name);
        $v_array['expiry_date'] = $expiry_date;
        $v_array['last_name'] = ucwords($last_name);
        $v_array['company_name'] = $company_name;
        $v_array['member_no'] = $member_no;
        $v_array['current_balance'] = number_format($points);
        $v_array['days'] = $days;

        $use_note = new notification_class();
        $send_data = $use_note->emailsend($client_no,$email, $this->note_forfiet_90_days,$v_array);

        return $send_data;


    }

}


//$details = "<table><th>Date</th><th>Item Name</th><th>Points</th><tr><td>10-12-2018</td><td>Test Item</td><td>50</td></tr></table>";
//$page_test = new send_mail_class();
//echo json_encode($page_test->send_custom_comm("adeoye@loyaltysolutionsnigeria.com","Test","127892"));
//echo json_encode($page_test->send_reset_password("John", "adeoye@loyaltysolutionsnigeria.com", "Smith","1234","test Company","url",204904));
//echo json_encode($page_test->send_wallet_debit("Test API Company", "500", "1000", "127892", "adeoye@loyaltysolutionsnigeria.com"));
//echo json_encode($page_test->send_delivered("John", "adeoye@loyaltysolutionsnigeria.com",$details,127892));
//echo json_encode($page_test->send_prepaid_credit("Test", 500, "1000"));
//echo json_encode($page_test->send_change_password("James","adeoye@loyaltysolutionsnigeria.com","1234", "127892"));

//echo json_encode($page_test->send_wallet_credit("Test", "adeoye@loyaltysolutionsnigeria.com", 230, 500, 127892));
//echo json_encode($page_test->send_redemption("John", "adeoye@loyaltysolutionsnigeria.com", "","","","","50 points",$details,"204904"));
//echo json_encode($page_test->send_customer_credit("John","adeoye@loyaltysolutionsnigeria.com","500","1100","600","Test","212", "127892"));
//echo json_encode($page_test->create_company("Cadbury", "02-08-2018", "5 days","adeoye1225@gmail.com"));
//echo json_encode($page_test->send_portal_enrol("John","adeoye@loyaltysolutionsnigeria.com", "12345", 4000,127892));