<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 25/10/2018
 * Time: 09:36
 */
require_once ("main_class.php");
require_once ("company_class.php");
require_once ("services_class.php");
require_once ("portal_user_class.php");
require_once ("company_access_class.php");
class service_access_class extends Rewardsbox_main
{

    private $table = "user_mgt_service_access";


    public function register_access($company_id, $service_id,$status, $message,$status_id){

        $columns = array("company_id","service_id","status_code","status_message","status");
        $values = array($company_id,$service_id,$status,$message,$status_id);

        $store_data = $this->insert_data($this->table, $columns,$values);

        return $store_data;


    }


    public function grant_service_access($service_id,$company_id){

        $check_access = $this->check_com_service($service_id,$company_id);

        if (is_array($check_access)){

            return "Already has access";
        } else {
            $use_company = new Reward_company();
            $get_details = $use_company->get_company($company_id);

            if (is_array($get_details)) {

                $use_access = new company_access_class();
                $get_token = $use_access->get_token_company($company_id);

                if (is_array($get_token)) {
                    $token = $get_token['company_token'];
                    if ($service_id == 2) {
                        $service_name = "Portal";
                        $client_name = $get_details['company_name'];
                        $client_no = $get_details['client_no'];

                        $use_company->change_portal_access($company_id, 1);
                        $use_portal = new portal_user_class();

                        $save_data = $use_portal->save_company($client_name, $client_no, $company_id, $token);

                        if ($save_data == 1){

                            $d_array['company_name'] =$client_name ;

                            $d_array['service_name'] = $service_name;

                            return $d_array;
                        } else {


                            return $save_data;
                        }

                    } else {

                        return "Invalid Service";
                    }
                } else {

                    return "Invalid Company token";
                }
            } else {

                return "Invalid Company";
            }
        }
    }


    public function list_all_service($company_id){

        $column = array("access_id","company_name", "user_mgt_services.service_name");

        $firstjoin ['table_name']="user_mgt_services";

        $firstjoin ['first_column']=$this->table.".service_id";

        $firstjoin ['second_column']="user_mgt_services.service_id";

        $leftjoin []=$firstjoin;

        $firstjoin ['table_name']="user_mgt_company";
        $firstjoin ['first_column']=$this->table.".company_id";
        $firstjoin ['second_column']="user_mgt_company.company_id";
        $leftjoin []=$firstjoin;


        $first_where['column_name'] =$this->table.".status";

        $first_where['sign'] ="=";

        $first_where['value'] =1;

        $where[] = $first_where;

        $first_where['column_name'] =$this->table.".company_id";

        $first_where['sign'] ="=";

        $first_where['value'] =$company_id;

        $where[] = $first_where;

        $first_where['column_name'] =$this->table.".service_id";

        $first_where['sign'] ="IN";

        $first_where['value'] =array(2);

        $where[] = $first_where;

        $get_data = $this->select_tb($this->table,$column,$where,"","","","","",$leftjoin);

        if (is_array($get_data)){

            return $get_data['data'];

        } else {

            return "No data found";
        }

    }


    public function check_com_service($service_id, $company_id){

        $column = array("access_id");

        $first_where['column_name'] ="service_id";

        $first_where['sign'] ="=";

        $first_where['value'] =$service_id;

        $where[] = $first_where;


        $first_where['column_name'] ="company_id";

        $first_where['sign'] ="=";

        $first_where['value'] =$company_id;

        $where[] = $first_where;


        $get_data = $this->select_tb($this->table, $column, $where);

        if (is_array($get_data)){

            return $get_data['data'];
        } else {

            return "No data found";
        }


    }
}

//$page_test = new service_access_class();

//echo json_encode($page_test->check_com_service(2,10));
//echo json_encode($page_test->list_all_service());
