<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 20/09/2018
 * Time: 10:55
 */
require_once("main_class.php");
require_once("pages_class.php");
require_once ("user_class.php");


class Rewards_user_login_class extends Rewardsbox_main
{

    private $table = "user_mgt_lsl_users";
    private $lock_max = 3;
    private $session_name = "rewardsbox";
    private $home_path = "https://rewardsbox.perxclm.com/rewardsbox_app/v1/";

    public function user_login ($email,$password) {

        if (filter_var($email, FILTER_VALIDATE_EMAIL)) {

            $hash_password =hash('sha512',$password);
            $columns = array("user_id","username","password","is_locked","lock_count","status","role_id","page_id");

            $u_where['column_name'] ="email";
            $u_where['sign'] ="=";
            $u_where['value'] =$email;
            $user_where[] = $u_where;

//            $u2_where['column_name'] ="status";
//            $u2_where['sign'] ="=";
//            $u2_where['value'] =1;
//            $user_where[] = $u2_where;


            $check_user=$this->select_tb($this->table,$columns,$user_where);

            //echo json_encode($check_user);
            //echo "<br>";
            if (is_array($check_user)){
                if($check_user['total'] == 1){
                    if($check_user['data'][0]['status'] == 1) {
                        if ($check_user['data'][0]['is_locked'] == 0) {
                            if ($check_user['data'][0]['password'] != $hash_password) {
                                $lock_account =$this->lock_counter($check_user['data'][0]['user_id']);

                                    if($lock_account == 1) {
                                        return "Invalid username or password";
                                    } elseif ($lock_account == -1){

                                        return "Account locked";
                                    } else {

                                        return "An error has occurred";
                                    }
                            } else {
                               // $this->start_session();
                                $this->assign_session($check_user['data'][0]['user_id'],$check_user['data'][0]['username'],$check_user['data'][0]['role_id'],1);
                                $get_page = new Create_pages();
                                $go_page = $get_page->get_page_name($check_user['data'][0]['page_id']);
                                $use_user = new Reward_users();
                                $use_user->login_reset($check_user['data'][0]['user_id']);
                                if ($go_page == 0) {

                                    return array("pages/profile.php");

                                } else {

                                    return array("pages/".$go_page.".php");

                                }
                            }

                        } else {

                            return "Account is locked. Reset password to unlock";
                        }
                    } else {

                        return "Account is inactive";
                    }
                } else {

                    return "Duplicate entry. Contact Administrator";
                }

            } else {

                return "Invalid username or password";
            }
        } else {

            return "Invalid email address";
        }



    }

    public function start_session(){
        session_name($this->session_name);
        session_start();
    }

    public function end_session(){
        session_name($this->session_name);
        session_start();
        session_unset($this->session_name);

    }


    public function stop_session($page_name ="")
    {
        $get_page = new Create_pages();
        $hash_page = $get_page->get_page_hash($page_name);
        if ($hash_page == 0) {

            header('Location: index.php');
        } else {

        header('Location: index.php?page='.$hash_page);
        }
    }

    public function assign_session($user_id,$username,$role_id, $user_type){
        $_SESSION['username'] = $username;
        $_SESSION['user_id'] = $user_id;
        $_SESSION['role_id'] = $role_id;
        $_SESSION['user_type'] = $user_type;

    }

    public function lock_counter($user_id){
        $column = array("lock_count");
        $c_where['column_name'] ="user_id";
        $c_where['sign'] ="=";
        $c_where['value'] =$user_id;
        $count_where[] = $c_where;

        $check_user = $this->select_tb($this->table,$column,$count_where);
        if (is_array($check_user)){
            $lock_count = $check_user['data'][0]['lock_count'];
            $lock_count = (int)$lock_count + 1;
            $u_where['column_name'] ="user_id";
            $u_where['sign'] ="=";
            $u_where['value'] =$user_id;
            $user_where[] = $u_where;

            $firstset['column_name'] ="lock_count";
            $firstset['sign'] ="=";
            $firstset['value'] =$lock_count;
            $set[] = $firstset;
            //echo $lock_count."-".$this->lock_max;
            //echo "<br>";
                if ($lock_count >= (int)$this->lock_max) {


                    $secondset['column_name'] ="is_locked";
                    $secondset['sign'] ="=";
                    $secondset['value'] =1;
                    $set[] = $secondset;
                    $update_lock =$this->update_data($this->table,$set, $user_where);
                        if ($update_lock == 1){

                            return 1;
                        } else {


                            return 0;
                        }

                } else{
                    $update_lock =$this->update_data($this->table,$set, $user_where);
                    if ($update_lock == 1){

                        return 1;
                    } else {


                        return 0;
                    }

                }

        } else {

            return 0;
        }

    }


    public function get_current_page(){

        return str_replace(array(' ','.php'),array('',''),basename($_SERVER['PHP_SELF']));
    }

    public function check_login(){
        //$this->start_session();
        if (isset($_SESSION['user_id'])){
            return 1;
        } else {
            return 0;
        }

    }

    public function go_to_page(){
        $page_name = $this->get_current_page();
        $check_session = $this->check_login();
//        echo $check_session;
//        echo "<br>";
            if ($check_session ==0){
                $hash_page= md5($page_name);
                header('Location: https://rewardsbox.perxclm.com/rewardsbox_app/v1/');
                exit();

            } else {

                $role_id = $_SESSION['role_id'];

//                if ($role_id == 1){
//                 //super admin
//                    $super_admin = array("create_access"=>1,"read_access"=>1,"update_access"=>1,"delete_access"=>1);
//                    return $super_admin;
//                } else {
                    $page_check = new Create_pages();
                    $check_access = $page_check->get_page_access($page_name, $role_id);
                    if (is_array($check_access)) {
                        return $check_access;
                    } else {
                        return 0;
                    }

                //}
            }

    }


    public function script_access(){
        $page_name = $this->get_current_page();
        $check_session = $this->check_login();
        if ($check_session ==1) {
            $page_check = new Create_pages();
            $role_id = $_SESSION['role_id'];
            $check_access = $page_check->get_page_access($page_name, $role_id);

            if (is_array($check_access)){
                return $check_access;

            } else {

                return -1;
            }

        } else {
            return 0;
        }

    }


    public function forgot_password($email){
        $today_date = Date('Y-m-d H:i:s');
                if (filter_var($email, FILTER_VALIDATE_EMAIL)) {

                    $randno =mt_rand(1000000,99999999);
                    $hash_password = hash('sha512', $randno);
                    $columns = array("user_id", "username");

                    $u_where['column_name'] = "email";
                    $u_where['sign'] = "=";
                    $u_where['value'] = $email;
                    $user_where[] = $u_where;

                    $u_where['column_name'] = "status";
                    $u_where['sign'] = "=";
                    $u_where['value'] = 1;
                    $user_where[] = $u_where;

                    $get_data = $this->select_tb($this->table, $columns, $user_where);

//                    echo json_encode($get_data);
//                    echo "<br>";
                    if (is_array($get_data)){

                        $user_id = $get_data['data'][0]['user_id'];
                        $username = $get_data['data'][0]['username'];

                        $u_where['column_name'] = "user_id";
                        $u_where['sign'] = "=";
                        $u_where['value'] = $user_id;
                        $user_where[] = $u_where;

                        $u_where['column_name'] = "status";
                        $u_where['sign'] = "=";
                        $u_where['value'] = 1;
                        $user_where[] = $u_where;

                        $firstset['column_name'] ="lock_count";
                        $firstset['sign'] ="=";
                        $firstset['value'] =0;
                        $set[] = $firstset;

                        $firstset['column_name'] ="is_locked";
                        $firstset['sign'] ="=";
                        $firstset['value'] =0;
                        $set[] = $firstset;

                        $firstset['column_name'] ="password";
                        $firstset['sign'] ="=";
                        $firstset['value'] =$hash_password;
                        $set[] = $firstset;

                        $firstset['column_name'] ="update_date";
                        $firstset['sign'] ="=";
                        $firstset['value'] =$today_date;
                        $set[] = $firstset;

                        $set_data = $this->update_data($this->table, $set, $user_where);

                        if ($set_data == 1){
                            $s_array['email'] = $email;
                            $s_array['date'] = $today_date;

                            $use_note = new send_mail_class();
                            $use_note->lsl_reset_password($username, $email,$randno);
                            return $s_array;

                        } else {

                            return "Error resetting password";
                        }


                    } else {

                        return "Email address not found";
                    }

                } else {

                    return "Invalid email address";
                }
    }


} // end class



//$page_test = new Rewards_user_login_class();

//echo json_encode($page_test->forgot_password("test@test.com"));
//echo json_encode($page_test->user_login("email@mail.com","123456"));
//echo json_encode($page_test->get_current_page());