<?php

require_once ('../includes/startsession.php');

if (isset($_SESSION['user_id'])) {
require_once ('../classes/user_login_class.php');
require_once ('../classes/category_lv1_class.php');

$check_details = new Rewards_user_login_class();


$get_details = $check_details->script_access();
$get_parent = new category_lv1_class();
if(is_array($get_details)) {
//{"create_access":"0","read_access":"0","update_access":"0","delete_access":"0"}
    if (isset($get_details['create_access'])) {

        $create = $get_details['create_access'];

    } else {

        $create = 0;
    }

    if (isset($get_details['read_access'])) {

        $read = $get_details['read_access'];

    } else {

        $read = 0;
    }

    if (isset($get_details['update_access'])) {

        $update = $get_details['update_access'];

    } else {

        $update = 0;
    }

    if (isset($get_details['delete_access'])) {

        $delete = $get_details['delete_access'];

    } else {

        $delete = 0;
    }


    if (isset($_POST['action'])){
        $action = $_POST['action'];

        if($action == 'add'){
            if ($create == 1){

                if(isset($_POST['parentcat'])){

                    if ($_POST['parentcat'] == ""){

                        $response_array['status'] = 0;
                        $response_array['message'] ="No Parent Category sent";

                    } else {

                        $parent_cat = strtolower(trim($_POST['parentcat']));
                        $img = strtolower(trim($_POST['logo']));
                        $add_parent = $get_parent->create_lv1_category($parent_cat,$img);
                        if (is_array($add_parent)) {

                            //return $add_parent;
                            $response_array['status'] = 1;
                            $response_array['message'] = "success";
                            $response_array['data'] = $add_parent;
                            $response_array['iedit'] = $update;
                            $response_array['idelete'] = $delete;
                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] =$add_item;
                        }


                    }

                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] ="Invalid color";

                }


            } else{

                $response_array['status'] = -1;
                $response_array['message'] ="Access denied";

            }


        } elseif ($action =='edit'){

            if ($update == 1){

                if(isset($_POST['parent_name']) || isset($_POST['item_id'])){

                    if ($_POST['parent_name'] == "" || $_POST['item_id'] =="" || !is_numeric($_POST['item_id']) || $_POST['item_id'] < 1){

                        $response_array['status'] = 0;
                        $response_array['message'] ="Invalid data";

                    } else {

                        $id = trim($_POST['item_id']);
                        $parent_name = strtolower(trim($_POST['parent_name']));
                        $img = strtolower(trim($_POST['logo']));

                        $edit_parent = $get_parent->edit_parent($id,$parent_name, $img);

                        if ($edit_parent == 1){

                            $response_array['status'] = 1;
                            $response_array['message'] ="Update Successful";

                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] =$edit_parent;
                        }


                    }

                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] ="No values set";

                }

            } else{

                $response_array['status'] = -1;
                $response_array['message'] ="Access denied";

            }

        } elseif ($action =='delete'){
            if ($delete == 1){

                if(isset($_POST['status']) || isset($_POST['item_id'])){


                    if($_POST['status'] == "" || $_POST['item_id'] == "" || !is_numeric($_POST['status']) || !is_numeric($_POST['item_id'])){

                        $response_array['status'] = 0;
                        $response_array['message'] ="Invalid Data sent";

                    } else {
                        $id = trim($_POST['item_id']);
                        $status = trim($_POST['status']);
                        if ($status == 1){
                        $msg = "active";

                        }else{

                            $msg = "inactive";
                        }

                        $del_parent = $get_parent->del_parent($id);

                        if ($del_parent == 1){
                            $response_array['status'] = 1;
                            $response_array['message'] ="Parent is ".$msg;

                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] =$del_parent;
                        }

                    }


                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] ="Missing data";

                }


            } else{

                $response_array['status'] = -1;
                $response_array['message'] ="Access denied";

            }

        }else{

            $response_array['status'] = 0;
            $response_array['message'] ="Invalid action";
        }


    } else {

        $response_array['status'] = 0;
        $response_array['message'] ="No action sent";
    }


} else {

    $response_array['status'] = 0;
    $response_array['message'] = "Error getting Access";
}
} else {

    $response_array['status'] = 4004;
    $response_array['message'] ="Session expired";
}

echo json_encode($response_array);
?>