<?php

require_once ('../includes/startsession.php');

if (isset($_SESSION['user_id'])) {
require_once ('../classes/user_login_class.php');
require_once ('../classes/tier_class.php');

$check_details = new Rewards_user_login_class();

$get_details = $check_details->script_access();
$get_tier = new tier_class();
if(is_array($get_details)) {
//{"create_access":"0","read_access":"0","update_access":"0","delete_access":"0"}
    if (isset($get_details['create_access'])) {

        $create = $get_details['create_access'];

    } else {

        $create = 0;
    }

    if (isset($get_details['read_access'])) {

        $read = $get_details['read_access'];

    } else {

        $read = 0;
    }

    if (isset($get_details['update_access'])) {

        $update = $get_details['update_access'];

    } else {

        $update = 0;
    }

    if (isset($get_details['delete_access'])) {

        $delete = $get_details['delete_access'];

    } else {

        $delete = 0;
    }


    if (isset($_POST['action'])){
        $action = $_POST['action'];

        if($action == 'add'){
            if ($create == 1){

                if(isset($_POST['company_id']) || isset($_POST['tier']) || isset($_POST['credit'])){

                    if ($_POST['company_id'] == ""){

                        $response_array['status'] = 0;
                        $response_array['message'] ="No Company ID sent";

                    } else {
                        $company_id = $_POST['company_id'];
                        $credit = $_POST['credit'];
                        $tier = strtolower(trim($_POST['tier']));
                        $add_tier = $get_tier->create_tier($company_id, $tier, $credit);
                        if (is_array($add_tier)) {
                            $response_array['status'] = 1;
                            $response_array['message'] = "success";
                            $response_array['data'] = $add_tier;
                            $response_array['iedit'] = $update;
                            $response_array['idelete'] = $delete;
                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] =$add_tier;
                        }


                    }

                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] ="Invalid data";

                }


            } else{

                $response_array['status'] = -1;
                $response_array['message'] ="Access denied";

            }


        } elseif ($action =='edit'){

            if ($update == 1){

                if(isset($_POST['company_id']) || isset($_POST['item_id'])){

                    if ($_POST['company_id'] == "" || $_POST['item_id'] =="" || !is_numeric($_POST['item_id']) || $_POST['item_id'] < 1){

                        $response_array['status'] = 0;
                        $response_array['message'] ="Invalid data";

                    } else {

                        $id = trim($_POST['item_id']);
                        $company_id = strtolower(trim($_POST['company_id']));
                        $tier = strtolower(trim($_POST['tier']));
                        $credit = trim($_POST['tier']);

                        $edit_tier = $get_tier->edit_tier($id,$company_id,$tier,$credit);

                        if ($edit_tier == 1){

                            $response_array['status'] = 1;
                            $response_array['message'] ="Update Successful";

                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] =$edit_tier;
                        }


                    }

                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] ="No values set";

                }

            } else{

                $response_array['status'] = -1;
                $response_array['message'] ="Access denied";

            }

        } elseif ($action =='delete'){
            if ($delete == 1){

                if(isset($_POST['status']) || isset($_POST['item_id'])){


                    if($_POST['status'] == "" || $_POST['item_id'] == "" || !is_numeric($_POST['status']) || !is_numeric($_POST['item_id'])){

                        $response_array['status'] = 0;
                        $response_array['message'] ="Invalid Data sent";

                    } else {
                        $color_id = trim($_POST['item_id']);
                        $status = trim($_POST['status']);
                        if ($status == 1){
                        $msg = "active";

                        }else{

                            $msg = "inactive";
                        }

                        $del_tier = $get_tier->change_tier_status($color_id,$status);

//                        print_r($del_tier);

                        if (is_array($del_tier)){
                            $response_array['status'] = 1;
                            $response_array['message'] ="Tier is ".$msg;

                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] =$del_tier;
                        }

                    }


                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] ="Missing data";

                }


            } else{

                $response_array['status'] = -1;
                $response_array['message'] ="Access denied";

            }

        }else{

            $response_array['status'] = 0;
            $response_array['message'] ="Invalid action";
        }


    } else {

        $response_array['status'] = 0;
        $response_array['message'] ="No action sent";
    }


   

} else {

    $response_array['status'] = 0;
    $response_array['message'] = "Error getting Access";
}
} else {

    $response_array['status'] = 4004;
    $response_array['message'] ="Session expired";
}

echo json_encode($response_array);
?>