<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 31/10/2018
 * Time: 10:43
 */

require_once("../../../classes/purchase_class.php");
require_once("../../../classes/rims_class.php");


$response_array = array();
if (isset($_SERVER['HTTP_TOKEN'])) {

    if ($_SERVER['HTTP_TOKEN'] == "") {
        $response_array['status'] = 0;
        $response_array['message'] = "blank token sent";
    } else {
        $token = $_SERVER['HTTP_TOKEN'];
        $use_rims = new rims_class();
        $get_details = $use_rims->verify_api_token($token);

        if ($get_details == 1){

            if( isset($_GET['api'])) {

                if ($_GET['api'] == "") {

                    $response_array['status'] = 0;
                    $response_array['message'] = "Blank api call";

                } else {
                    $api = $_GET['api'];

                    if ($api == "move_shipped") {

                        if (isset($_POST['order_no']) && isset($_POST['voucher_no'])) {

                            $order_no = $_POST['order_no'];
                            $voucher_no = $_POST['voucher_no'];
                            if ($order_no == "" || $voucher_no == "") {

                                $response_array['status'] = 0;
                                $response_array['message'] = "Blank Order number or voucher number";

                            } else {

                                $f_array = array();
                                $s_array = array();
                                $s_array['order_no'] = $order_no;
                                $v_array = array();
                                $v_array[] =$voucher_no;
                                $s_array['vouchers'] = $v_array;
                                $f_array[] = $s_array;
                                $use_purchase = new purchase_class();
                                $get_data = $use_purchase->bulk_move_to_shipped($f_array);

                                if (is_array($get_data)) {

                                    $response_array['status'] = 1;
                                    $response_array['message'] = "success";
                                    $response_array['data'] = $get_data;
                                } else {

                                    $response_array['status'] = 0;
                                    $response_array['message'] = $get_data;

                                }


                            }
                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Missing Parameters";

                        }
                    }elseif ($api == "bulk_move_shipped") {

                            if(isset($_POST['order_array'])) {

                                $order_array = json_decode($_POST['order_array'], true);

                                if (is_array($order_array)) {

                                    $use_purchase = new purchase_class();
                                    $get_data = $use_purchase->bulk_move_to_shipped($order_array);

                                    if (is_array($get_data)) {

                                        $response_array['status'] = 1;
                                        $response_array['message'] = "success";
                                        $response_array['data'] = $get_data;
                                    } else {

                                        $response_array['status'] = 0;
                                        $response_array['message'] = $get_data;

                                    }

                                } else {

                                    $response_array['status'] = 0;
                                    $response_array['message'] = "Blank Order number or voucher number";


                                }
                            } else {

                                $response_array['status'] = 0;
                                $response_array['message'] = "Missing Parameters";

                            }
                    }elseif ($api == "bulk_confirm_shipped") {

                        if(isset($_POST['order_array'])) {

                            $order_array = json_decode($_POST['order_array'], true);

                            if (is_array($order_array)) {

                                $use_purchase = new purchase_class();
                                $get_data = $use_purchase->bulk_confirm_shipped($order_array);

                                if (is_array($get_data)) {

                                    $response_array['status'] = 1;
                                    $response_array['message'] = "success";
                                    $response_array['data'] = $get_data;
                                } else {

                                    $response_array['status'] = 0;
                                    $response_array['message'] = $get_data;

                                }

                            } else {

                                $response_array['status'] = 0;
                                $response_array['message'] = "Blank Order number or voucher number";


                            }
                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Missing Parameters";

                        }
                    }elseif($api == "move_delivered"){

                        if(isset($_POST['order_no']) && isset($_POST['voucher_no'])) {

                            $order_no = $_POST['order_no'];
                            $voucher_no = $_POST['voucher_no'];
                            if ($order_no == "" || $voucher_no == "") {

                                $response_array['status'] = 0;
                                $response_array['message'] = "Blank Order number or voucher number";

                            } else {
                                $f_array = array();
                                $s_array = array();
                                $s_array['order_no'] = $order_no;
                                $v_array = array();
                                $v_array[] =$voucher_no;
                                $s_array['vouchers'] = $v_array;
                                $f_array[] = $s_array;
                                $use_purchase = new purchase_class();
                                $get_data = $use_purchase->bulk_move_to_delivered($f_array);
                                if (is_array($get_data)) {

                                    $response_array['status'] = 1;
                                    $response_array['message'] = "success";
                                    $response_array['data'] = $get_data;
                                } else {

                                    $response_array['status'] = 0;
                                    $response_array['message'] = $get_data;

                                }


                            }
                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Missing Parameters";

                        }

                    }elseif ($api == "bulk_move_delivered") {

                        if(isset($_POST['order_array'])) {

                            $order_array = json_decode($_POST['order_array'], true);

                            if (is_array($order_array)) {

                                $use_purchase = new purchase_class();
                                $get_data = $use_purchase->bulk_move_to_delivered($order_array);

                                if (is_array($get_data)) {

                                    $response_array['status'] = 1;
                                    $response_array['message'] = "success";
                                    $response_array['data'] = $get_data;
                                } else {

                                    $response_array['status'] = 0;
                                    $response_array['message'] = $get_data;

                                }

                            } else {

                                $response_array['status'] = 0;
                                $response_array['message'] = "Blank Order number or voucher number";


                            }
                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Missing Parameters";

                        }

                    } elseif ($api == "move_pickup"){

                        if(isset($_POST['order_no']) && isset($_POST['voucher_no'])) {

                            $order_no = $_POST['order_no'];
                            $voucher_no = $_POST['voucher_no'];
                            if ($order_no == "" || $voucher_no == "") {

                                $response_array['status'] = 0;
                                $response_array['message'] = "Blank Order number or voucher number";

                            } else {
                                $f_array = array();
                                $s_array = array();
                                $s_array['order_no'] = $order_no;
                                $v_array = array();
                                $v_array[] =$voucher_no;
                                $s_array['vouchers'] = $v_array;
                                $f_array[] = $s_array;
                                $use_purchase = new purchase_class();
                                $get_data = $use_purchase->bulk_move_to_pickup($f_array);
                                if (is_array($get_data)) {

                                    $response_array['status'] = 1;
                                    $response_array['message'] = "success";
                                    $response_array['data'] = $get_data;
                                } else {

                                    $response_array['status'] = 0;
                                    $response_array['message'] = $get_data;

                                }


                            }
                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Missing Parameters";

                        }

                    }elseif ($api == "bulk_move_pick_up") {

                        if(isset($_POST['order_array'])) {

                            $order_array = json_decode($_POST['order_array'], true);

                            if (is_array($order_array)) {

                                $use_purchase = new purchase_class();
                                $get_data = $use_purchase->bulk_move_to_pickup($order_array);

                                if (is_array($get_data)) {

                                    $response_array['status'] = 1;
                                    $response_array['message'] = "success";
                                    $response_array['data'] = $get_data;
                                } else {

                                    $response_array['status'] = 0;
                                    $response_array['message'] = $get_data;

                                }

                            } else {

                                $response_array['status'] = 0;
                                $response_array['message'] = "Blank Order number or voucher number";


                            }
                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Missing Parameters";

                        }

                    } elseif ($api == "order_settlement"){

                        if(isset($_POST['voucher_no']) && isset($_POST['amount'])) {

                            $amount = $_POST['amount'];
                            $voucher_no = $_POST['voucher_no'];
                            if ($amount == "" || $voucher_no == "") {

                                $response_array['status'] = 0;
                                $response_array['message'] = "Blank Order number or Amount";

                            } else {
                                $use_purchase = new purchase_class();
                                $get_data = $use_purchase->order_settlement($voucher_no,$amount);

                                if (is_array($get_data)) {

                                    $response_array['status'] = 1;
                                    $response_array['message'] = "success";
                                    $response_array['data'] = $get_data;
                                } else {

                                    $response_array['status'] = 0;
                                    $response_array['message'] = $get_data;

                                }


                            }
                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Missing Parameters";

                        }


                    } elseif ($api == "delivery_settlement"){

                        if(isset($_POST['order_no']) && isset($_POST['amount'])) {

                            $amount = $_POST['amount'];
                            $order_no = $_POST['order_no'];
                            if ($amount == "" || $order_no == "") {

                                $response_array['status'] = 0;
                                $response_array['message'] = "Blank Order number or Amount";

                            } else {
                                $use_purchase = new purchase_class();
                                $get_data = $use_purchase->delivery_settlement($order_no,$amount);

                                if (is_array($get_data)) {

                                    $response_array['status'] = 1;
                                    $response_array['message'] = "success";
                                    $response_array['data'] = $get_data;
                                } else {

                                    $response_array['status'] = 0;
                                    $response_array['message'] = $get_data;

                                }


                            }
                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Missing Parameters";

                        }


                    } elseif ($api == "cancel_item"){
                                    
                        if(isset($_POST['order_no'])) {

                            if(isset($_POST['voucher_no'])) {
                                $voucher_no = $_POST['voucher_no'];
                                $order_no = $_POST['order_no'];
                                if ($voucher_no == "" || $order_no == "") {

                                    $response_array['status'] = 0;
                                    $response_array['message'] = "Blank Order number or voucher number";

                                } else {
                                    $use_purchase = new purchase_class();
                                    $get_data = $use_purchase->cancel_item($order_no, $voucher_no);

                                    if (is_array($get_data)) {

                                        $response_array['status'] = 1;
                                        $response_array['message'] = "success";
                                        $response_array['data'] = $get_data;
                                    } else {

                                        $response_array['status'] = 0;
                                        $response_array['message'] = $get_data;

                                    }


                                }
                            } else {

                                $response_array['status'] = 0;
                                $response_array['message'] = "Voucher Number required";
                            }
                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Order Number required -". json_encode($_POST);

                        }




                    }  elseif ($api == "bulk_move_cancel"){

                        if(isset($_POST['order_no'])) {

                            if(isset($_POST['vouchers'])) {
                                //$voucher_no = $_POST['voucher_no'];
                                $order_no = $_POST['order_no'];
                                $voucher_array = json_decode($_POST['vouchers'], true);


                                if ($order_no == "") {

                                    $response_array['status'] = 0;
                                    $response_array['message'] = "Blank Order number or voucher number";
                                } elseif (!is_array($voucher_array)){
                                    $response_array['status'] = 0;
                                    $response_array['message'] = "Invalid Voucher Array format";

                                } else {
                                    $use_purchase = new purchase_class();
                                    $get_data = $use_purchase->bulk_cancel_items($order_no, $voucher_array);

                                    if (is_array($get_data)) {

                                        $response_array['status'] = 1;
                                        $response_array['message'] = "success";
                                        $response_array['data'] = $get_data;
                                    } else {

                                        $response_array['status'] = 0;
                                        $response_array['message'] = $get_data;

                                    }


                                }
                            } else {

                                $response_array['status'] = 0;
                                $response_array['message'] = "Voucher Number required";
                            }
                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Order Number required -". $_POST['order_no'];

                        }
                    } elseif ($api == "bulk_pickup_cancel"){

                        if(isset($_POST['order_no'])) {

                            if(isset($_POST['picked']) && isset($_POST['cancel'])) {
                                //$voucher_no = $_POST['voucher_no'];
                                $order_no = $_POST['order_no'];
                                $picked_array = json_decode($_POST['picked'], true);
                                $cancel_array = json_decode($_POST['cancel'], true);


                                if ($order_no == "") {

                                    $response_array['status'] = 0;
                                    $response_array['message'] = "Blank Order number or voucher number";
                                } elseif (!is_array($picked_array) && !is_array($cancel_array)){
                                    $response_array['status'] = 0;
                                    $response_array['message'] = "Invalid Voucher Array format cancel or picked";

                                } else {
                                    $use_purchase = new purchase_class();
                                    $orders = array();
                                    $orders['order_no'] = $order_no;
                                    $orders['pickup'] = $picked_array;
                                    $orders['cancel'] = $cancel_array;
                                    $get_data = $use_purchase->bulk_cancel_pickup($orders);

                                    if (is_array($get_data)) {

                                        $response_array['status'] = 1;
                                        $response_array['message'] = "success";
                                        $response_array['data'] = $get_data;
                                    } else {

                                        $response_array['status'] = 0;
                                        $response_array['message'] = $get_data;

                                    }


                                }
                            } else {

                                $response_array['status'] = 0;
                                $response_array['message'] = "Voucher Picked and Cancel Array required";
                            }
                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Order Number required -". $_POST['order_no'];

                        }


                    } else {

                        $response_array['status'] = 0;
                        $response_array['message'] = "Invalid Request";
                    }



                }
            } else {

                $response_array['status'] = 0;
                $response_array['message'] = "Missing Request";
            }
        } else {

            $response_array['status'] = 0;
            $response_array['message'] = $get_details;

        }


    }


} else {

    $response_array['status'] = 0;
    $response_array['message'] = "no header sent";
}
echo json_encode($response_array);



