<?php
require_once("database_class.php");
date_default_timezone_set("Africa/Lagos");
class Rewardsbox_main extends Database {

    public $image_url = "https://rewardsbox.perxclm.com/rewardsbox_app/v1/img/company_logo/";
    public $manger_type = 7;
    public $no_manger_type = 0;

	public function create_all_data ($table, $columns, $values, $where, $name ="Data"){
		
		$create_data = $this->insert_check_duplicate($table,$columns, $values, $where);
		
		if ($create_data > 0) {
				
				return $create_data;
				
			} elseif ($create_data < 0) {
				
				return $create_data;
			
			} else {
			
			return 0;
			
			}
		
	}// end create all function
	
	
	public function edit_single_data($present_data, $new_data, $table, $set_column, $key, $name = "Data") {
		
		$columns = array($key,$set_column);
		$thirdwhere['column_name'] =$set_column;
		$thirdwhere['sign'] ="=";
		$thirdwhere['value'] =$present_data;
		$where[] = $thirdwhere;
		
		$check_data = $this->select_tb($table,$columns,$where);
		
		if (is_array($check_data)) {
			
				$data_id = $check_data['data']['0'][$key];
				
				$setwhere['column_name'] =$key;
				$setwhere['sign'] ="=";
				$setwhere['value'] =$data_id;
				$where_set[] = $setwhere;
				
				$firstset['column_name'] =$set_column;
				$firstset['sign'] ="=";
				$firstset['value'] =$new_data;
				$set[] = $firstset;
				
					if ($this->update_data($table,$set, $where_set) == 1){
								
								return 1;
							}
							else {
								
								return 0;
							}
		} else {
			
			return -1;
		}
	} // end change single data function


	public function change_status ($dataid, $new_status, $table,$key, $name= "Data"){
	$columns = array($key,"status");
				
		$thirdwhere['column_name'] =$key;
		$thirdwhere['sign'] ="=";
		$thirdwhere['value'] =$dataid;
		$where[] = $thirdwhere;
		
		if ($new_status == 1) {
				
			$status_msg = $name." Active";
		} else {
			$new_status = 0;
			$status_msg = $name." Inactive";
		}
		
		$data_details = $this->select_tb($table,$columns,$where);
		
		if (is_array($data_details)) {
			
			$data_status = $data_details['data'][0]['status'];
			
				if ($new_status == $data_status) {
					
					return -1;
				} else {
					$firstset['column_name'] ="status";
					$firstset['sign'] ="=";
					$firstset['value'] =$new_status;
					$set[] = $firstset;
						if ($this->update_data($table,$set, $where) == 1){
								
								return 1;
							}
							else {
								
								return 0;
							}
						
				}
		} else {
			return -2;
			
		}
	
	
} // end change status


public function view_all_active_data($table, $columns) {
	
	$thirdwhere['column_name'] ="status";
		$thirdwhere['sign'] ="=";
		$thirdwhere['value'] =1;
		$where[] = $thirdwhere;
	
	$getdata = $this->select_tb($table,$columns, $where);	
		
		if (is_array($getdata)) {
		
			return $getdata['data'];	
		} else {
		return 0;
	}
	
}


public function status_codes ($code) {
	
	$status_message =array("201"=>"Duplicate Data",
	"202"=>"Cannot find data",
	"203"=>"Same as old and new data",
	"101"=>"Successful",
	"200"=>"An error has occured",
	"204"=>"No data found"
	
	
	
	
);
}


public function adjust_phone_no($phone_no){

	if ($phone_no == null){

	 return "";
    } else {
        $country_code = "234";
        $firstCharacter = $phone_no[0];

        if ($firstCharacter == 0) {

            $int_phone = ltrim($phone_no, '0');

        } else {

            $int_phone = $phone_no;
        }

        $ten_char = substr($int_phone, 0, 10);
        $new_phone = $country_code . $ten_char;
        return $new_phone;
    }
}

public function get_unit_cost_price($total_cost, $quantity){

    $unit_cost = $total_cost / $quantity;
    $unit_cost_value = round($unit_cost,2);
//    $unit_value = (float)$unit_cost_value;
    return $unit_cost_value;
}


    public function get_ip_address()
    {
        foreach (array('HTTP_CLIENT_IP', 'HTTP_X_FORWARDED_FOR', 'HTTP_X_FORWARDED', 'HTTP_X_CLUSTER_CLIENT_IP', 'HTTP_FORWARDED_FOR', 'HTTP_FORWARDED', 'REMOTE_ADDR') as $key)
        {
            if (array_key_exists($key, $_SERVER) === true)
            {
                foreach (explode(',', $_SERVER[$key]) as $ip)
                {
                    if (filter_var($ip, FILTER_VALIDATE_IP) !== false)
                    {
                        return $ip;
                    }
                }
            } else{

                return null;
            }
        }

        return "No ip";
    }
}

//$page_test = new Rewardsbox_main();
//echo json_encode($page_test->get_unit_cost_price(2800,9));
//echo $page_test->get_unit_cost_price(11,3);
//echo $page_test->adjust_phone_no("8122890094");
?>