<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 29/10/2018
 * Time: 21:53
 */

require_once ("curl_class.php");
//require_once ("database_class.php");
require_once ("company_category_class.php");
class nairafood_class extends curl_class
{

    private $token = 'Bearer loyalty_akhmfosaqikpupgooucchwxialqxtthxevcpglpiljovxkjxcxcteuzescpcvjng';
    private $post_token = 'Authorization:Bearer loyalty_akhmfosaqikpupgooucchwxialqxtthxevcpglpiljovxkjxcxcteuzescpcvjng';
    //private $end_point ='https://nairabox-food-thirdparty-api.herokuapp.com/api/external/';
    private $end_point ='https://food-server.nairabox.com/api/external/';
    private  $header;
    private $delivery_type = 9;
    private $rims_partner_id = 129;
    //private $rb_partner_id = 11;
    private $salt = "gRSEohsJPg";
    //private $store_name = "Loyalty Solutions";
    //private $store_url= "loyaltysolutionsnigeria.com";
    private $log_table = "naira_food_log";
    private $store_table = "naira_food_orders";
    private $hook_log = "naira_food_hook_log";
    private $rb_email ="takeout@loyaltysolutionsnigeria.com";




    private function set_header(){

        //$header = array('content-type: multipart/form-data','token: ' . $this->master_token);
        $this->header=array(
            'Content-Type= application/json',
            //'Content-Type= application/x-www-form-urlencoded',
            'Authorization:'. $this->token
        );
        //return $this->header = array("key: " .$this->key,"content-type: application/json", "cache-control: no-cache");
    }


    public function get_city(){

        $this->set_header();
        $api = "states";
        $new_url = $this->end_point.$api;

        $get_city = $this->send_get_v4($new_url,$this->header);

        if(is_array($get_city)){

            if($get_city['status'] == 200){

                return $get_city['data'];
            } else {

                return "No data found";
            }


        } else {

            return "No city found";
        }

    }

    public function location_by_city ($city_id){


        if (isset($city_id)){

            $this->set_header();
            $api = "locationByCity/";

            $new_url = $this->end_point.$api.$city_id;

            //$body['country_id'] = $country_id;
            $get_location = $this->send_get_v4($new_url,$this->header);

            if(is_array($get_location)){

                if($get_location['status'] == 200){

                    return $get_location['data'];
                } else {

                    return "No data found";
                }


            } else {

                return "No city found";
            }

        } else {

            return "Invalid country";
        }
    }


    public function restaurant_by_location ($location_id){


        if (isset($location_id)){

            $this->set_header();
            $api = "restaurantBylocation/";

            $new_url = $this->end_point.$api.$location_id;

            //$body['country_id'] = $country_id;
            $get_restaurant = $this->send_get_v4($new_url,$this->header);

            if(is_array($get_restaurant)){

                if($get_restaurant['status'] == 200){

                    return $get_restaurant['data'];
                } else {

                    return "No data found";
                }


            } else {

                return "No city found";
            }

        } else {

            return "Invalid country";
        }
    }

    public function featured_restaurant ($num=6){


        if (isset($num)){

            $this->set_header();
            $api = "restaurantByFeatured/";

            $new_url = $this->end_point.$api.$num;

            //$body['country_id'] = $country_id;
            $get_restaurant = $this->send_get_v4($new_url,$this->header);

            if(is_array($get_restaurant)){

                if($get_restaurant['status'] == 200){

                    return $get_restaurant['data'];
                } else {

                    return "No data found";
                }


            } else {

                return "No restaurant found";
            }

        } else {

            return "Invalid amount";
        }
    }

    public function get_restaurant ($restaurant_id){


        if (isset($restaurant_id)){

            $this->set_header();
            $api = "restaurant/";

            $new_url = $this->end_point.$api.$restaurant_id;

            //$body['country_id'] = $country_id;
            $get_restaurant = $this->send_get_v4($new_url,$this->header);

            if(is_array($get_restaurant)){

                if($get_restaurant['status'] == 200){

                    return $get_restaurant['data'];
                } else {

                    return "No data found";
                }


            } else {

                return "No restaurant found";
            }

        } else {

            return "Invalid amount";
        }
    }

    public function meals_by_restaurant ($restaurant_id){


        if (isset($restaurant_id)){

            $this->set_header();
            $api = "mealByRestaurant/";

            $new_url = $this->end_point.$api.$restaurant_id;

            //$body['country_id'] = $country_id;
            $get_restaurant = $this->send_get_v4($new_url,$this->header);

            if(is_array($get_restaurant)){

                if($get_restaurant['status'] == 200){

                    return $get_restaurant['data'];
                } else {

                    return "No data found";
                }


            } else {

                return "No meal found";
            }

        } else {

            return "Invalid restaurant";
        }
    }




    public function get_service_products($margin, $margin_type, $restaurant_id){

        if(!isset($restaurant_id)){

            return "Restaurant is required";
        } else {



                $get_data = $this->meals_by_restaurant($restaurant_id);

                if(is_array($get_data)){

                    if (is_array($get_data)) {

                        $get_products = $this->arrange_list_cat_item($margin, $margin_type, $get_data);

                        if (is_array($get_products)){

                            return $get_products;

                        } else {

                            return "No data found";
                        }
                    } else {

                        return $get_data['message'];
                    }
                } else {

                    return $get_data;


                }

        }



    }

    public function arrange_list_cat_item($margin, $margin_type, $result_array){
        $add_margin = new company_category_class();
        $products = array();
//            echo json_encode($result_array);
//            echo "<hr>";
        foreach ($result_array as $result){


            $new_price = $add_margin->apply_margin($margin, $margin_type, $result['amount']);

            if ($new_price >= 0){
                $result['amount'] = $new_price;
                $result['signal'] = $this->string_encrypt($new_price);


                $products[] = $result;

            }

        }



        return $products;
    }



    public function confirm_order_price($partner_id,$margin,$margin_type, $email, $phone,$restaurant, $delivery_location,$delivery_city, $delivery_address, $delivery_instruction = null, $cart){

        if (isset($email, $phone, $restaurant, $delivery_location, $delivery_city, $delivery_address, $cart)){

            if(!filter_var($email, FILTER_VALIDATE_EMAIL)){

                return "Invalid Email address";

            } else {

                if (strlen($phone) < 10 ){

                    return "Invalid Phone number length";
                } else {

                    if(is_array($cart)) {
                        $get_data = $this->check_food_price($email, $phone, $restaurant, $delivery_location, $delivery_city, $delivery_address, $delivery_instruction, $cart);
//                        echo "<hr>";
//                         echo json_encode($get_data);
//                    echo "<hr>";
                        if(is_object($get_data)){
                            $add_margin = new company_category_class();
                            $delivery_amount = $get_data->orderData->delivery_amount;
                            $sub_total = $get_data->orderData->sub_total_amount;
                            $vat = $get_data->orderData->vat_amount;
                            $consumption = $get_data->orderData->consumption_amount;
                            $pack = $get_data->orderData->pack_amount;
                            $total = $get_data->orderData->total_amount;
                            $quantity = $get_data->orderData->item_count;
                            $amount = (float)$sub_total + (float)$vat + (float)$consumption + (float)$pack;

                            $signal = array();
                            $main_array = array();

                            if ($margin_type == 1){

                                $main_array['sub_total'] = $add_margin->apply_margin($margin, $margin_type, $amount);

                            } else {

                                $main_array['sub_total'] = ($margin * (int)$quantity) + $amount;

                            }

                            $main_array['delivery_price'] = $delivery_amount;

                            $main_array['price'] = $main_array['sub_total'] + $main_array['delivery_price'];
                            //var_dump($)
                            $main_array['address'] = $get_data->origin[0]->formattedAddress;

                            if ($main_array['price'] >= $total){

//                                $signal['email'] = $get_data['orderData']['customer']['email'];
//                                $signal['phone'] = $get_data['orderData']['customer']['phone'];
                                $signal['selling_price'] = $main_array['price'];
                                $signal['cost_price'] = $total;
                                $signal['delivery_price'] = $main_array['delivery_price'];
                                $signal['item_code'] = $restaurant;
                               // var_dump($get_data->orderData);
                                $signal['item_name'] = $get_data->orderData->restaurant[0]->name;
                                $signal['cart'] = $cart;
                                $signal['delivery_address'] = $delivery_address;
                                $signal['delivery_location'] = $delivery_location;
                                $signal['delivery_city'] = $delivery_city;
                                $signal['delivery_instruction'] = $delivery_instruction;
                                $signal['rb_partner_id'] = $partner_id;
                                $signal['rims_partner_id'] = $this->rims_partner_id;


                                $main_array['signature'] = $this->string_encrypt(json_encode($signal));

                                return $main_array;

                            }  else {

                                return "Error calculating cost";
                            }

                        } else {

                            return $get_data;
                            //return "Error getting price";
                        }

                    } else {

                        return "Invalid cart data";
                    }
                }

            }

        } else {

            return "Missing Parameter";
        }


    }

    public function check_food_price ($email, $phone,$restaurant, $delivery_location,$delivery_city, $delivery_address, $delivery_instruction, $cart){



            $this->set_header();
            $api = "order/placeorder";

            $new_url = $this->end_point.$api;

            //$payload['email'] = $email;
            $payload['email'] = $this->rb_email;
            $payload['phone'] = $phone;
            $payload['restaurant'] = $restaurant;
            $payload['order_id'] = "5689623";
            $payload['restaurant_charges'] = "";
            $payload['delivery_option'] = "";
            $payload['delivery_location'] = $delivery_location;
            $payload['delivery_city'] = $delivery_city;
            $payload['delivery_address'] = $delivery_address;
            $payload['delivery_instruction'] = $delivery_instruction;
            $payload['delivery_amount'] = "";
            $payload['is_corp'] = 0;
            $payload['check_order'] = 1;
            $payload['pack_amount'] = 0;
            $payload['payment_option'] = "THIRD PARTY";
            $payload['payment_cash_comment'] = "";
            $payload['order_comment'] = "";
            $payload['charged_amount'] = "";
            $payload['status'] = 1;
            $payload['options'] = $cart;
            //$body['country_id'] = $country_id;
            //$get_restaurant = $this->send_post_v4($new_url,$payload,$this->header);
        $get_restaurant = $this->send_post_v6($new_url,$this->post_token,$payload);
        $this->save_order_request(json_encode($payload), json_encode($get_restaurant));
//        echo $get_restaurant;
//        echo "<hr>";
            if(is_array($get_restaurant)){

                if($get_restaurant['status'] == 200){

//                    var_dump($get_restaurant);
//                    echo json_encode($get_restaurant['content']);
//                    echo "<hr>";
                    return $get_restaurant['content'];
                } else {

                    return "No data found";
                }


            } else {

                return "An error occurred";
            }


    }


    public function process_transaction($redemption_array, $delivery_array){

//echo json_encode($redemption_array);
//echo "<br>";
        //$email = $delivery_array['email'];
        $email = $this->rb_email;
        $phone_no = $delivery_array['phone_no'];

        $order_item = $redemption_array[11]['product_details'][0];



        //$quantity = $order_item['quantity'];
        //$payment_code = $order_item['signature']['item_code'];

        $price = $order_item['signature']['cost_price'];
        //$total_price = (float)$price * (int)$quantity;
        $reference = $order_item['voucher_no'];
        $restaurant = $order_item['signature']['item_code'];
        $delivery_location = $order_item['signature']['delivery_location'];
        $delivery_address = $order_item['signature']['delivery_address'];
        $delivery_city = $order_item['signature']['delivery_city'];
        $delivery_instruction = $order_item['signature']['delivery_instruction'];
        $cart = $order_item['signature']['cart'];
        $item_name = $order_item['signature']['item_name'];
        $selling_price = $order_item['signature']['selling_price'];
        $delivery_price = $order_item['signature']['delivery_price'];
        $sub_total = $selling_price - $delivery_price;


        $confirm_order = $this->place_order($email, $reference,$phone_no,$restaurant,$delivery_location,$delivery_city,$delivery_address,$delivery_instruction,$cart, $item_name, $selling_price, $delivery_price, $sub_total);


        return $confirm_order;




    }


    public function place_order ($email, $voucher_no, $phone,$restaurant, $delivery_location,$delivery_city, $delivery_address, $delivery_instruction, $cart, $item_name = null, $selling_price = null, $delivery_price = null, $sub_total = null){



        $this->set_header();
        $api = "order/placeorder";

        $new_url = $this->end_point.$api;

        $payload['email'] = $email;
        $payload['phone'] = $phone;
        $payload['restaurant'] = $restaurant;
        $payload['order_id'] = $voucher_no;
        $payload['restaurant_charges'] = "";
        $payload['delivery_option'] = "";
        $payload['delivery_location'] = $delivery_location;
        $payload['delivery_city'] = $delivery_city;
        $payload['delivery_address'] = $delivery_address;
        $payload['delivery_instruction'] = $delivery_instruction;
        $payload['delivery_amount'] = "";
        $payload['is_corp'] = 0;
        $payload['check_order'] = 0;
        //$payload['pack_amount'] = 0;
        $payload['payment_option'] = "THIRD PARTY";
        $payload['payment_cash_comment'] = "";
        $payload['order_comment'] = "";
        $payload['charged_amount'] = "";
        $payload['status'] = 1;
        $payload['options'] = $cart;
        //$body['country_id'] = $country_id;
        //$get_restaurant = $this->send_post_v4($new_url,$payload,$this->header);
        $get_restaurant = $this->send_post_v6($new_url,$this->post_token,$payload);
        $this->save_order_request(json_encode($payload), json_encode($get_restaurant));
//        echo $get_restaurant;
//        echo "<hr>";
        if(is_array($get_restaurant)){

            if($get_restaurant['status'] == 200){

//                    var_dump($get_restaurant);
//                    echo json_encode($get_restaurant['content']);
//                    echo "<hr>";
                //$order_status = $get_restaurant['content']['orderData']['status'];
                $order_status = "PENDING";

                $this->save_food_order($voucher_no, json_encode($cart),$order_status);
                $b_array = array();
                $b_array['cart'] = $cart;
                $b_array['address'] = $delivery_address;
                $b_array['restaurant'] = $item_name;
                $b_array['sub_total'] = $sub_total;
                $b_array['delivery_price'] = $delivery_price;
                $b_array['total'] = $selling_price;


                $response_array['status'] = 1;
                $response_array['message'] = "Booking Successful";
                $response_array['data'] = array($voucher_no);
                $response_array['booking_info'] = $b_array;
                return $response_array;
                //return $get_restaurant['content'];
            } else {

                $response_array['status'] = 0;
                $response_array['message'] = "Error Booking Take out";
                $response_array['data'] = array($voucher_no);
                return $response_array;
            }


        } else {

            return "An error occurred";
        }


    }

    public function save_order_request($request, $response){

        $columns =array("request_array", "response_array");
        $values = array($request, $response);

        $save_data = $this->insert_data($this->log_table, $columns, $values);

        return $save_data;

    }


    public function save_hook_request($request, $response, $ip = null){

        $columns =array("request", "response","ip");
        $values = array($request, $response, $ip);

        $save_data = $this->insert_data($this->hook_log, $columns, $values);

        return $save_data;

    }


    public function save_food_order($order_no, $item, $status){

        $today = date('Y-m-d H:i:s');
        $columns =array("order_no", "order_item","status", "create_date");
        $values = array($order_no, $item, $status, $today);

        $save_data = $this->insert_data($this->store_table, $columns, $values);

        return $save_data;

    }


    public function update_food_status($order_id, $status, $comment){

        if(isset($order_id) && isset($status)) {
            $column = array("order_no", "status");

            $p_where['column_name'] = "order_no";
            $p_where['sign'] = "=";
            $p_where['value'] = $order_id;
            $where[] = $p_where;

            $get_data = $this->select_tb($this->store_table, $column, $where);

            if (is_array($get_data)) {

                //return $get_data['data'][0];

                $first_set['column_name'] = "status";
                $first_set['sign'] = "=";
                $first_set['value'] = $status;
                $set[] = $first_set;

                $first_set['column_name'] = "comment";
                $first_set['sign'] = "=";
                $first_set['value'] = $comment;
                $set[] = $first_set;

                $update_data = $this->update_data($this->store_table, $set, $where);

                if ($update_data == 1) {

                    $d_array ['order_id'] = $order_id;
                    $d_array['new_status'] = $status;
                    $d_array['old_status'] = $get_data['data'][0]['status'];

                    return $d_array;
                } else {

                    return "Error updating Status";
                }
            } else {

                return "Order not found";
            }

        } else {

            return "Order ID  and status is required";
        }
    }

}


//$test = new nairafood_class();
//echo json_encode($test->save_food_order("5555", "test item", "PENDING"));
//echo json_encode($test->update_food_status("5555", "DELIVERED", "Your Item has been delivered"));
//$c_array['_id'] = "5c98f5a4cbfb6569ea6dee87";
//$c_array['qty'] = 1;
//$c_array['options'] = array();

//$cart_array[] = $c_array;
//$cart = json_encode($cart_array);
//$cart = json_encode($cart_array);
//$json =  "{\n                \"email\": \"adeoye@loyaltysolutionsnigeria.com\",\n                \"phone\": \"08122890094\",\n                \"order_id\": \"5689623\",\n                \"restaurant\": \"5c92f7e961d6604250824d4f\",\n                \"restaurant_charges\":\"\",\n                \"delivery_option\": \"\",\n                \n                \"delivery_address\": \"14, thomas street, Lagos island\",\n                \"delivery_location\": \"Lagos\",\n                \"delivery_city\": \"Lekki\",\n                \"delivery_instruction\": \"drop at gate\",\n                \"delivery_amount\": \"\",\n                \"is_corp\": 0,\n                \"payment_option\": \"THIRD PARTY\",\n                \"payment_cash_comment\": \"\",\n                \"order_comment\": \"\",\n                \"charged_amount\": \"\",\n                \"check_order\": 1,\n                \"status\": 1,\n                \"pack_amount\":0,\n                \"options\": [ {\"_id\":\"5c98f5a4cbfb6569ea6dee87\" ,\"qty\": 1, \"options\": []} \n                             \n                           ]\n                \n}";
//$json2 = json_encode(json_decode($json, true));
//echo $test->send_post_v4($json2);
//echo json_encode($test->check_food_price("adeoye@loyaltysolutionsnigeria.com", "08122890094","5c92f7e961d6604250824d4f","Lagos","Lekki","14, Thomas Street, lagos Island", "drop at gate", $cart_array));
//echo json_encode($test->get_city());
//echo json_encode($test->location_by_city("5c77b818c69bb473a5251a6b"));
//echo json_encode($test->restaurant_by_location("5c92c20f3e45e118c8fb72a7"));
//echo json_encode($test->featured_restaurant());
//echo json_encode($test->meals_by_restaurant("5c92f7e961d6604250824d36"));
//echo json_encode($test->get_restaurant("5c92f7e961d6604250824d36"));
//echo json_encode($test->get_service_products(100,2,"5c92f7e961d6604250824d36"));
//$type = explode("-","7525-Adult");
//print_r($type[1]);
//echo json_encode($test->list_booking_form("e7ffdbe5-bf19-03a3-700b-611662c26bbf"));
//echo "<hr>";
//echo json_encode($test->get_availability("eadd06b3-dd6e-44eb-5b3c-76110c937fd5",3,0,2));
//echo json_encode(base64_decode("eyJwX2lkIjoiOTcwMDBhMDItZDZiNi03ZWEyLTJmZTMtN2UwMzBlYWZmMTEwIiwiY19pZCI6IjAifQ=="));
//echo json_encode($test->list_availability("e7ffdbe5-bf19-03a3-700b-611662c26bbf"));
//echo json_encode($test->list_detail_items("e7ffdbe5-bf19-03a3-700b-611662c26bbf"));
//echo json_encode($test->get_products(14));
//echo json_encode($test->get_countries());
//echo json_encode($test->get_city(9));
//echo json_encode($test->send_order("1234"));
//echo json_encode($test->create_order("Test", "Person", "testing@test.com", "9876543210","2018-11-30 05:00:00", 47477,"2",0,0,0,65,"abc1"));
//echo json_encode($test->get_hash("testing@test.com","9876543210","2018-09-29 08:00:00", "4435", 0, "e98opew212412", 1,"0"));
//echo json_encode($test->convert_xoxo_naira("GBP","65"));
//echo json_encode($test->get_product_details("https://corp.xoxoday.com/v2/getProduct?", "3", "1000","2",47477));
//echo json_encode($test->list_detail_items("https://corp.xoxoday.com/v2/",47477));
//echo json_encode($test->get_naira_products("https://corp.xoxoday.com/v2/getProducts","adventure","3","50", 1,5,222,2176));
//echo json_encode($test->get_products(222,2176,"adventure","https://corp.xoxoday.com/v2/getProducts"));
//echo json_encode($test->add_rates());
//echo json_encode($test->get_all_rates());