<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 24/10/2018
 * Time: 14:03
 */

require_once ("curl_class.php");
require_once ("services_class.php");
require_once ("service_access_class.php");
class rims_class extends curl_class
{

    private $service_id = 4;
    private $third_party = "2a42e366f17b062cd7ec0377d676b";
    protected $master_token;
    private $end_point = "https://rims.perxclm.com/api/v1/?API_flag="; //"https://rims.perxclm.com/v2_/api/v1/?API_flag="; Previous url
    private $admin_url = 'https://rims.perxclm.com/api/v1/?API_flag='; //"https://rims.perxclm.com/v2_/api/v1/?API_flag="; Previous url
    private $log_table = "rims_send_log";



    public function get_token(){
        $use_token = new Reward_services();

        $find_token = $use_token->get_token($this->service_id);
        if(is_array($find_token)){

            $this->master_token = $find_token['token'];
            return $this->master_token;

        } else {

            return "Unable to connect";
        }


    }

    public function set_header(){

        return $header = array('content-type: multipart/form-data','token: ' . $this->master_token);
    }

    public function send_transaction ($body){
        //echo json_encode($body);
        //echo "<br>";
        $set_token = $this->get_token();
        $api = 'push_redemption';
        $url = $this->end_point.$api;
        $set_header = $this->set_header();
        $send_data = $this->send_post($url,$body,$set_header);
//        echo "<br>";
        if (is_array($send_data)){

            $this->save_rims_request(json_encode($body),json_encode($send_data));
            return $send_data;
        } else {

            return 0;
        }


    }



    private function send_company ($body){

        $api = 'create_company';
        $url = $this->admin_url.$api;
        $this->get_token();
        $set_header = $this->set_header();
        //echo json_encode($set_header);
        //echo "<br>";
        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return 0;
        }
    }


    private function send_partner ($body){

        $api = 'create_partner';
        $url = $this->admin_url.$api;
        $this->get_token();
        $set_header = $this->set_header();
        //echo json_encode($set_header);
        //echo "<br>";
        $send_data = $this->send_post($url,$body,$set_header);

        if (is_array($send_data)){

            return $send_data;
        } else {

            return 0;
        }
    }


    public function create_client($client_name,$company_id){
        $service_id = $this->service_id;
        $body = array();
        if($company_id ==""){

            return "Invalid Company id";


        } else {

            $body['company_id'] = $company_id;
            if ($client_name !==""){

                $body['company_name'] = $client_name;
                if ($service_id == ""){

                    return "Invalid Service id";
                } else {



                        $make_company = $this->send_company($body);

                        if (is_array($make_company)) {
                            $use_service_access = new service_access_class();
                            if ($make_company['status_code'] == 1001){

                                $status = 1;
                            } else {
                                $status = 0;
                            }
                            $store_access = $use_service_access->register_access($company_id,$service_id,$make_company['status_code'],$make_company['status_message'],$status);
                            return $make_company;

                        } else {

                            return "Error creating client";
                        }


                }
            } else {

                return "Client name required";
            }



        }


    }


    public function create_partner($partner_name){
        $service_id = $this->service_id;
        $body = array();
        if($partner_name =="" || !isset($partner_name)){

            return "Invalid Partner";


        } else {

            $body['partner_name'] = $partner_name;




                    $make_company = $this->send_partner($body);

                    if (is_array($make_company)) {
                        $use_service_access = new service_access_class();
                        if ($make_company['status_code'] == 1001){

                            $status = 1;
                        } else {
                            $status = 0;
                        }
                        $store_access = $use_service_access->register_access(0,$service_id,$make_company['status_code'],$make_company['status_message'],$status);
                        return $make_company['result_data']['rims_partner_id'];

                    } else {

                        return "Error creating client";
                    }




        }


    }

    public function verify_api_token($token){

        if($token == $this->third_party){

            return 1;

        } else{

            return "Invalid token";
        }

    }



    public function save_rims_request($request, $response){

        $columns =array("request_array", "response_array");
        $values = array($request, $response);

        $save_data = $this->insert_data($this->log_table, $columns, $values);

        return $save_data;

    }
}

//$page_test = new rims_class();
//echo json_encode($page_test->create_client("Joy test",13,4));