<?php
require_once ('../includes/startsession.php');
require_once ('../classes/user_login_class.php');
require_once ('../classes/menu_class.php');
require_once ('../classes/menu_color_class.php');
$check_details = new Rewards_user_login_class();
//$check_details->start_session();
$get_details = $check_details->go_to_page();
include('../includes/head-datatable.php');


$use_company = new company_access_class();
$check_company = $use_company->get_single_company($_GET['c_id']);

if(is_array($check_company)) {
    $company_name = $check_company['company_name'];
    $company_id = $_GET['c_id'];

    if(is_array($get_details)){
//{"create_access":"0","read_access":"0","update_access":"0","delete_access":"0"}
        $get_color = new menu_color_class();

        if(isset($get_details['create_access'])) {

            $create = $get_details['create_access'];
            // add record script





            // end add record script


        } else {

            $create = 0;
        }

        if(isset($get_details['update_access'])) {

            $update = $get_details['update_access'];

            // update record script





            // end update record script

        } else {

            $update = 0;
        }

        if(isset($get_details['delete_access'])) {

            $delete = $get_details['delete_access'];

            // delete record script





            // delete add record script
        } else {

            $delete = 0;
        }

        if(isset($get_details['read_access'])) {

            $read = $get_details['read_access'];



        } else {

            $read = 0;
        }



        $menu = new menu_class();
        $list_menu = $menu->show_user_menu($_SESSION['role_id']);
        ?>

        <!DOCTYPE html>
        <html>
        <head lang="en">
            <meta charset="UTF-8">
            <meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=no">
            <meta http-equiv="x-ua-compatible" content="ie=edge">
            <title>Rewards Box</title>

            <?php include('../includes/head-datatable.php'); ?>

        </head>
        <body class="with-side-menu">

        <?php include('../includes/header.php'); ?><!--.site-header-->

        <div class="mobile-menu-left-overlay"></div>
        <nav class="side-menu">
            <?php echo $list_menu; ?><!--.side-menu-->
        </nav>



        <div class="page-content">
            <div class="container-fluid">
                <header class="section-header">
                    <div class="tbl">
                        <div class="tbl-row">
                            <div class="tbl-cell">
                                <h3>Customer Details</h3>

                            </div>
                        </div>
                    </div>
                </header>

                <?php if ($create == 1) { ?>
                    <div class="box-typical box-typical-padding">


                        <h5 class="m-t-lg with-border">Customer Details</h5>

                        <input type="hidden" value="<?php echo $company_id ?>" id="company_id">
                        <form class="row">
                            <h5 class="col-sm-3"><p>Membership Number</p></h5>
                            <div class="col-sm-6">
                                <p class="form-control-static"><input type="text" class="form-control" id="member_id" placeholder="member number"></p>
                            </div>
                        </form>

                        <div id="curr"></div>

                        <div id="details" class="row"></div>


                        <div class="row border-top">
                            <div class="col-md-10"></div>
                            <div class="col-md-2">
                                <div class="float-right">
                                    <br>
                                    <button type="button" id="create" class="btn btn-inline btn-primary float-right">View Details</button>
                                </div>
                            </div>
                        </div>



                    </div><!--.box-typical-->
                <?php } // close create if?>

                <?php if ($read == 1){?>
                    <section class="card">
                        <div class="card-block">
                            <table id="example" class="stripe row-border order-column display table table-striped table-bordered" cellspacing="0" width="100%">
                                <thead>
                                <tr>
                                    <th>Tran ID</th>
                                    <th>First Name</th>
                                    <th>Last Name</th>
                                    <th>Email</th>
                                    <!--							<th>Address</th>-->
                                    <th>Transaction Type</th>
                                    <th>Balance (Naira)</th>
                                    <th>Balance (Points)</th>
                                    <th>Action</th>
                                </tr>
                                </thead>
                                <tbody id="item_show">

                                <!--                            --><?php //echo $show_data; ?>


                                </tbody>
                            </table>
                        </div>
                    </section>
                <?php } // close read?>
            </div><!--.container-fluid-->
        </div><!--.page-content-->

        <div id="edit_modal" class="modal fade bd-example-modal-lg"
             tabindex="-1"
             role="dialog"
             aria-labelledby="myLargeModalLabel"
             aria-hidden="true">
            <div class="modal-dialog modal-lg">
                <div class="modal-content">
                    <div class="modal-header">
                        <button type="button" class="modal-close" data-dismiss="modal" aria-label="Close">
                            <i class="font-icon-close-2"></i>
                        </button>
                        <h4 class="modal-title" id="myModalLabel">View Order Details</h4>
                    </div>
                    <div class="modal-body">

                        <div class="card-block">
                            <table id="example2" class="stripe row-border order-column display table table-striped table-bordered" cellspacing="0" width="100%">
                                <thead>
                                <tr>
                                    <th>Item Name</th>
                                    <th>Type</th>
                                    <th>Quantity</th>
                                    <th>Price</th>
                                    <!--							<th>Address</th>-->
                                    <th>Voucher</th>
                                    <th>Status</th>
                                    <th>Create Date</th>

                                </tr>
                                </thead>
                                <tbody id="item_show2">


                                <!--                            --><?php //echo $show_data; ?>


                                </tbody>
                            </table>
                        </div>


                    </div>
<!--                    <div class="modal-footer">-->
<!--                        <button type="button" class="btn btn-rounded btn-default" data-dismiss="modal">Close</button>-->
<!--                        <button type="button" class="btn btn-rounded btn-primary" id="edit_btn" data-myedit ="0">Save changes</button>-->
<!--                    </div>-->
                </div>
            </div>
        </div><!--.modal-->


        <?php include('../includes/script-datatable.php'); ?>
        <script>
            $(function() {
                var table = $('#example').DataTable({
                    scrollX:        true,
                    scrollCollapse: true,
                    paging:         true,
                    fixedColumns:   true
                });

                var table = $('#example1').DataTable({
                    scrollY:        "300px",
                    scrollX:        true,
                    scrollCollapse: true,
                    paging:         false,
                    fixedColumns:   {
                        leftColumns: 2
                    }
                });

                setTimeout(function() {
                    table.draw();
                }, 50);

            });

            $('#create1').click (function () {

                let member_no = $('#member_id').val();
                let amount = $('#amount').val();
                let company_id = $('#company_id').val();
                let action = "add";

                if (member_no == "") {

                    alert("Blank Member Number");

                    return false;
                }

                else if (amount == "") {

                    alert("Blank Amount");

                    return false;
                }
                else if (company_id == "") {

                    alert("Blank Company ID");

                    return false;
                }
                else {

                    $.ajax({
                        type: "POST",
                        url: "../scripts/credit_customer_page.php",
                        data: {company_id: company_id, amount:amount, member_no:member_no, action:action},
                        dataType: 'json',

                        success: function(msg){
                            //alert(msg.status);
                            if (msg.status == 1) {

                                $.notify({
                                    icon: 'font-icon font-icon-check-circle',
                                    title: '<strong>Success!</strong>',
                                    message: 'Customer Credited'
                                },{
                                    type: 'success'
                                });


                                location.reload();
                            }

                            else {
                                $.notify({
                                    icon: 'glyphicon glyphicon-alert',
                                    title: '<strong>Error!</strong>',
                                    message: msg.message
                                },{
                                    type: 'danger'
                                });

                            }

                        }

                    });

                    return false;
                }
            });



            $('.page-content').on('click', '.edit_modal_btn', function () {
                $('#edit_color').val('');
                let item_id = $(this).attr('data-item');

                let color_name = $("span[class='color_name'][data-item='" + item_id + "']").html();

                $('#edit_btn').data('myedit',item_id);
                //console.log( $('#edit_btn').data('myedit'));

                $('#edit_color').val(color_name);

            });


            $('#edit_btn').click (function () {
                let item_id = $('#edit_btn').data('myedit');
                //alert($('#edit_btn').data('myedit'));
                //alert(item_id);
                let color = $('#edit_color').val();
                let action = "edit";

                if (color == ""){

                    alert("Enter a color");

                    return false;
                } else {

                    $.ajax({
                        type: "POST",
                        url: "../scripts/menu_color.php",
                        data: {color: color, item_id: item_id, action:action},
                        dataType: 'json',

                        success: function(msg){
                            //alert(msg.status);
                            if (msg.status == 1) {

                                $("span[class='color_name'][data-item='" + item_id + "']").html(color);

                                $('#edit_modal').modal('toggle');

                                $.notify({
                                    icon: 'font-icon font-icon-check-circle',
                                    title: '<strong>Success!</strong>',
                                    message: 'Color updated'
                                },{
                                    type: 'success'
                                });
                            }

                            else {
                                //alert(msg.message);
                                $('#edit_modal').modal('toggle');

                                $.notify({
                                    icon: 'glyphicon glyphicon-alert',
                                    title: '<strong>Error!</strong>',
                                    message: msg.message
                                },{
                                    type: 'danger'
                                });
                                // $('#loading_image').remove();
                                // $('#btnlogin').show();
                            }

                        }

                    });

                    return false;
                }




            });



            //$('.del_btn').click (function () {
            $('.page-content').on('click', '.del_btn', function () {
                let item_id = $(this).attr('id');
                let item_status = $(this).data('status');
                let action ='delete';

                $.ajax({
                    type: "POST",
                    url: "../scripts/menu_color.php",
                    data: {status: item_status, item_id: item_id, action:action},
                    dataType: 'json',

                    success: function(msg){

                        if (msg.status == 1) {
                            let del_icon ="";

                            if (item_status == 0){
                                $("span[class='label_tag'][data-item='"+item_id+"']").html('<span class="label label-danger">Inactive</span>');
                                del_icon ='<a href="#" data-status = 1 class="del_btn" id="'+item_id+'"><i class="fa fa-check" style="color:green;"></i></a>';
                            } else {
                                $("span[class='label_tag'][data-item='"+item_id+"']").html('<span class="label label-success">Active</span>');
                                del_icon ='<a href="#" data-status = 0 class="del_btn" id="'+item_id+'"><i class="fa fa-close" style="color:red;"></i></a>';

                            }
                            $("span[class='del_icon'][data-item='" + item_id + "']").html(del_icon);

                            $.notify({
                                icon: 'font-icon font-icon-check-circle',
                                title: '<strong>Success!</strong>',
                                message: msg.message
                            },{
                                type: 'success'
                            });
                        }

                        else {
                            $.notify({
                                icon: 'glyphicon glyphicon-alert',
                                title: '<strong>Error!</strong>',
                                message: msg.message
                            },{
                                type: 'danger'
                            });

                        }

                    }

                });

                return false;


            });



            // $('.page-content').on('change', '#member_id', function () {

            $('#create').click (function () {
                // alert("test");
                let company_id= $('#company_id').val();
                let member_no = $('#member_id').val();

                // alert(company_id);

                $.ajax({
                    type: "POST",
                    url: "../data/cust_details.php",
                    data: {member_no: member_no, company_id:company_id},
                    dataType: 'json',

                    success: function(msg){
                        if(msg.status == 1){

                            // console.log(msg);
//alert(msg.data.group_id);
                            //let display = '<div class="">';
                            let   display ='<h5 class="col-md-3">Member Details</h5>';
                            //display +='</div>';

                            // <h5 class="col-sm-3"><p>Credit Amount (Naira)</p></h5>
                            //     <div class="col-sm-6">
                            //         <p class="form-control-static"><input type="text" class="form-control" id="amount" placeholder="1.00"></p>
                            //         </div>

                            //display +='<div class="col-md-12">';
                            display +='<div class="form-group col-md-3"> <label for="exampleInputEmail1">Firstname</label>';
                            display +='<p class = "form-control-static">'+msg.message.firstname+'</p>';
                            display +='</div>';
                            // display +='</div>';


                            display +='<div class="form-group col-md-3"> <label for="exampleInputEmail1">Lastname</label>';
                            display +='<p>'+msg.message.lastname+'</p>';
                            display +='</div>';
                            // display +='</div>';

                            display +='<div class="form-group col-md-3 "> <label for="exampleInputEmail1">Email</label>';
                            display +='<p>'+msg.message.email+'</p>';
                            display +='</div>';


                            display +='<div class="form-group col-md-3 offset-3"> <label for="exampleInputEmail1">Phone</label>';
                            display +='<p>'+msg.message.phone+'</p>';
                            display +='</div>';

                            display +='<div class="form-group col-md-3" offset-6> <label for="exampleInputEmail1">Current Balance (Naira)</label>';
                            display +='<p>'+msg.message.point_raw+'</p>';
                            display +='</div>';

                            display +='<div class="form-group col-md-3"> <label for="exampleInputEmail1">Current Balance (Points)</label>';
                            display +='<p>'+msg.message.point_virtual+'</p>';
                            display +='</div>';

                            display +='<button class="btn btn-primary col-md-3 offset-4" id="tran" data-dataid ="'+msg.message.member_id+'">View Member Transactions</button>';
                            display +='</div>';

                            $('#details').html(display);

                        } else {

                            alert("No data found");
                        }
                    }

                });
                return false;

            });



            $('#details').on('click', '#tran', function () {

                let company_id= $('#company_id').val();
                let	member_id = $(this).attr('data-dataid');

                //alert (member_id);


                if (member_id == "")
                {
                    alert("Blank Member ID");
                    return false;
                }


                else{

                    $.ajax({
                        type:"POST",
                        url:"../data/member_transactions.php",
                        data:{ member_id:member_id, company_id:company_id},
                        dataType:"json",
                        success: function(msg){

                            // console.log(msg);

                            if (msg.success == false) {
                                alert("There was an error submitting the form. Please try again.");
                            } else {

                                if (msg.status == 1){

                                    //alert(msg.status);
// console.log(msg.message);
                                    //let table = '';
                                    $.each(msg.message, function(key,val) {

                                        //table += '<tr>';
                                        if (val.order_id == null ){

                                            var data = "";

                                        } else{

                                            var data = '<button class="btn btn-primary modal12" data-toggle="modal" data-target="#edit_modal"  id="'+company_id+'" data-dataid ="' + val.order_id + '">Details</button>';
                                        }
                                        let column1 = '<td>' + val.trans_id + '</td>';
                                        let column2 = '<td>' + val.firstname + '</td>';
                                        let column3 = '<td>' + val.lastname + '</td>';
                                        let column4 ='<td>' + val.email + '</td>';
                                        let column5 = '<td>' + val.type_name + '</td>';
                                        let column6 = '<td>' + val.point_raw + '</td>';
                                        let column7 = '<td>' + val.point_virtual + '</td>';
                                        // if (val.order_id != '') {
                                        let column8 = '<td>'+ data +'</td>';


                                        let table = $('#example').DataTable();

                                        let rowNode = table
                                            .row.add( [ column1, column2, column3,column4, column5, column6, column7, column8 ] )
                                            .draw()

                                    });



                                    //	$('#details').html(table);
                                    //alert(msg.message)

                                }

                                else {

                                    //if (msg.email != ""){

                                    //	alert(msg.email);
                                    //}
                                    //	else {


                                    alert(msg.message);

                                    //	}
                                    // $('#username').val('');
                                    // $('#password').val('');
                                }
                            }
                        }
                    });

                    return false;
                }


            });


            $('.page-content').on('click', '.modal12', function () {

                $('#edit_modal').modal('show');
                // alert("work");
                let company_id = $(this).attr('id');
                let order_id = $(this).data('dataid');
                let action ='delete';

                let table1 = $('#example2').DataTable();
                table1
    .clear()
    .draw();
                //  table1.clear();
                 
                //  console.log(table1);
                
                $.ajax({
                    type: "POST",
                    url: "../data/order_details.php",
                    data: {order_id: order_id, company_id: company_id},
                    dataType: 'json',

                    success: function(msg){


                        // console.log(msg);
                        
                        
                        if (msg.status == 1) {

                        // table1.clear();
                            $.each(msg.data, function(key,val) {
                                
                                console.log(val);
                                // $.each(val2, function(key,val) {
                                
                                // console.log(val);
                                // 

                                let column11 = '<td>' + val.name + '</td>';
                                let column21 = '<td>' + val.delivery_type_name + '</td>';
                                let column31 = '<td>' + val.qty + '</td>';
                                let column41 ='<td>' + val.price + '</td>';
                                let column51 = '<td>' + val.voucher + '</td>';
                                let column61 = '<td>' + val.status_text + '</td>';
                                let column71 = '<td>' + val.created_at.date + '</td>';


                                let rowNode1 = table1
                                    .row.add( [ column11, column21, column31,column41, column51, column61, column71 ] )
                                    .draw()

//  });

                            });
                        }

                        else {
                            //  table1.clear();
                            $.notify({
                                icon: 'glyphicon glyphicon-alert',
                                title: '<strong>Error!</strong>',
                                message: msg.message
                            },{
                                type: 'danger'
                            });

                        }

                    }

                });

                return false;


            });




            $('.page-content').on('change', '#amount', function () {

                let amount = $(this).val();
                let company_id= $('#company_id').val();

                // alert(member_id);

                $.ajax({
                    type: "POST",
                    url: "../data/getpoints.php",
                    data: {amount: amount, company_id:company_id},
                    dataType: 'json',

                    success: function(msg){

                        //	console.log(msg);
                        if(msg.status == 1){


                            let display1 = '<div class="form-group col-md-5 offset-3"> <label for="exampleInputEmail1">Amount To Credit is '+msg.message.point_virtual+' '+msg.message.currency+' Points </label>';

                            $('#curr').html(display1);

                        } else {

                            alert("Customer Not found");
                        }
                    }

                });
                return false;

            });

        </script>

        </body>
        </html>


    <?php } }// close if array?>

