<?php
require_once ('../includes/startsession.php');
require_once ('../classes/user_login_class.php');
require_once ('../classes/menu_class.php');
require_once ('../classes/menu_color_class.php');
require_once ('../classes/menu_library_class.php');
$check_details = new Rewards_user_login_class();
//$check_details->start_session();
$get_details = $check_details->go_to_page();
include('../includes/head-datatable.php');




if(is_array($get_details)){
//{"create_access":"0","read_access":"0","update_access":"0","delete_access":"0"}
$get_color = new menu_color_class();
$use_library = new menu_library_class();
$use_menu = new menu_class();

$color_options = $get_color->view_active_color();
    if(is_array($color_options)) {
        $p_menu = "";
        foreach ($color_options as $color){

            $p_menu .= '<option value="'.$color['color'].'">'.$color['color'].'</option>';

        }

    }

    $lib_options = $use_library->get_active_library();
    if(is_array($lib_options)) {
        $p_lib = '<option>Select Library</option>';
        foreach ($lib_options as $lib){

            $p_lib .= '<option value="'.$lib['library_name'].'" data-lib="'.$lib['library_id'].'">'.$lib['library_name'].'</option>';

        }

    }

    if(isset($get_details['create_access'])) {

        $create = $get_details['create_access'];
        // add record script





        // end add record script


    } else {

        $create = 0;
    }

    if(isset($get_details['update_access'])) {

        $update = $get_details['update_access'];

        // update record script





        // end update record script

    } else {

        $update = 0;
    }

    if(isset($get_details['delete_access'])) {

        $delete = $get_details['delete_access'];

        // delete record script





        // delete add record script
    } else {

        $delete = 0;
    }

    if(isset($get_details['read_access'])) {

        $read = $get_details['read_access'];

        // view record script

        $show_menu=$use_menu->show_all_parent();

        if (is_array($show_menu)){
            //echo json_encode($show_color);
            $show_data = "";
            foreach ($show_menu as $parent){
                //echo $color['color'];
                $data = "";
                $data .= '<tr>';
                $data .= '<td><span class="menu_name" data-item ="' . $parent['menu_id'] . '">'.ucfirst($parent['menu_name']).'</span></td>';
                $data .= '<td><span class="menu_color" data-item ="' . $parent['menu_id'] . '" style="color:'.$parent['color'].';">'.ucfirst($parent['color']).'</span></td>';
                $data .= '<td><span class="menu_library" data-item ="' . $parent['menu_id'] . '">'.ucfirst($parent['library']).'</span></td>';
                $data .= '<td><span class="menu_icon" data-item="' . $parent['menu_id'] . '">';
                $data .='<i class="'.$parent['library'].' '.$parent['icon'].'" style="color:'.$parent['color'].';"></i>';
                $data .='</span>';
                $data .='</td>';

                $data.='<td>';
                if ($parent['status'] == 1){
                    $data .='<span class="label_tag" data-item="'.$parent['menu_id'].'"><span class="label label-success">Active</span></span>';
                } else {
                    $data .='<span class="label_tag" data-item="'.$parent['menu_id'].'"><span class="label label-danger">Inactive</span></span>';


                }
                $data.='</td>';

                $data .= '<td>';

                if ($update == 1) {
                    $data .= '<a href="#" data-toggle="modal" data-target="#edit_modal" class="edit_modal_btn" data-item ="' . $parent['menu_id'] . '"><i class="fa fa-edit"></i></a>';
                } else {
                    $data.='&nbsp;';
                }

                if ($delete == 1) {
                    if ($parent['status'] == 1) {
                        $data .= '&nbsp;&nbsp;&nbsp;<span class="del_icon" data-item="' . $parent['menu_id'] . '"><a href="#" data-status = 0 class="del_btn" id="' . $parent['menu_id'] . '"><i class="fa fa-close" style="color:red;"></i></a></span>';
                    } else {

                        $data .= '&nbsp;&nbsp;&nbsp;<span class="del_icon" data-item="' . $parent['menu_id'] . '"><a href="#" data-status = 1 class="del_btn" id="' . $parent['menu_id'] . '"><i class="fa fa-check" style="color:green;"></i></a></span>';
                    }

                }{
                    $data.='&nbsp;';
                }

                $data.='</td>';
                $data.='</tr>';

                $show_data = $show_data.$data;
            }



        } else {

            $show_data = "";
        }
        //echo $show_data;


        // end view record script





    } else {

        $read = 0;
    }



    $menu = new menu_class();
    $list_menu = $menu->show_user_menu($_SESSION['role_id']);
?>

<!DOCTYPE html>
<html>
<head lang="en">
	<meta charset="UTF-8">
	<meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=no">
	<meta http-equiv="x-ua-compatible" content="ie=edge">
	<title>Rewards Box</title>
	
<?php include('../includes/head-datatable.php'); ?>

</head>
<body class="with-side-menu">

<?php include('../includes/header.php'); ?><!--.site-header-->

	<div class="mobile-menu-left-overlay"></div>
    <nav class="side-menu">
        <?php echo $list_menu; ?><!--.side-menu-->
    </nav>



	<div class="page-content">
		<div class="container-fluid">
						<header class="section-header">
				<div class="tbl">
					<div class="tbl-row">
						<div class="tbl-cell">
							<h3>Parent Menu</h3>
							
						</div>
					</div>
				</div>
			</header>

            <?php if ($create == 1) { ?>
			<div class="box-typical box-typical-padding">
				

				<h5 class="m-t-lg with-border">Add Parent</h5>

				<form>
                    <div class="row">
                    <h5 class="col-sm-3"><p>Menu name</p></h5>
                    <div class="col-sm-6">
                        <p class="form-control-static"><input type="text" class="form-control" id="menu" placeholder="Parent menu"></p>
                    </div>
                    </div>

                    <div class="row">

                        <h5 class="col-sm-3"><p>Color</p></h5>
                        <div class="col-sm-6">
                            <select class="select2 select2-arrow manual select2-no-search-arrow" id="color">
                                <?php echo $p_menu; ?>
                            </select>
                        </div>

                    </div>
                    <div class="row">

                        <h5 class="col-sm-3"><p>library</p></h5>
                        <div class="col-sm-6">
                            <select class="select2 select2-arrow manual select2-no-search-arrow" id="library">
                                <?php echo $p_lib; ?>
                            </select>
                        </div>

                    </div>

                    <div class="row">

                        <h5 class="col-sm-3"><p>Icon</p></h5>
                        <div class="col-sm-6">
                            <select class="select2 select2-arrow manual select2-no-search-arrow" id="lib_icon">

                            </select>
                        </div>

                    </div>
				</form>
				<div class="row border-top">
						<div class="col-md-10"></div>
						<div class="col-md-2">
						<div class="float-right">
							<br>
							<button type="button" id="create" class="btn btn-inline btn-primary float-right">Add</button>
						</div>
							</div>
					</div>

		

			</div><!--.box-typical-->
        <?php } // close create if?>

            <?php if ($read == 1){?>
			<section class="card">
				<div class="card-block">
					<table id="example" class="stripe row-border order-column display table table-striped table-bordered" cellspacing="0" width="100%">
						<thead>
						<tr>
							<th>Menu</th>
							<th>Color</th>
                            <th>Library</th>
                            <th>Icon</th>
                            <th>Status</th>
							<th>Action</th>
						</tr>
						</thead>
						<tbody id="item_show">
						
							<?php echo $show_data; ?>
							
				
						</tbody>
					</table>
				</div>
			</section>
        <?php } // close read?>
		</div><!--.container-fluid-->
	</div><!--.page-content-->
	
		<div id="edit_modal" class="modal fade bd-example-modal-lg"
					 tabindex="-1"
					 role="dialog"
					 aria-labelledby="myLargeModalLabel"
					 aria-hidden="true">
					<div class="modal-dialog modal-lg">
						<div class="modal-content">
							<div class="modal-header">
								<button type="button" class="modal-close" data-dismiss="modal" aria-label="Close">
									<i class="font-icon-close-2"></i>
								</button>
								<h4 class="modal-title" id="myModalLabel">Edit Color</h4>
							</div>
							<div class="modal-body">
								
									<form>

					<div class="form-group row">
						<label class="col-sm-2 form-control-label">Color</label>
						<div class="col-sm-10">
							<p class="form-control-static"><input type="text" class="form-control" id="edit_color" placeholder="Color"></p>
						</div>
					</div>

				</form>

								
							</div>
							<div class="modal-footer">
								<button type="button" class="btn btn-rounded btn-default" data-dismiss="modal">Close</button>
								<button type="button" class="btn btn-rounded btn-primary" id="edit_btn" data-myedit ="0">Save changes</button>
							</div>
						</div>
					</div>
				</div><!--.modal-->


<?php include('../includes/script-datatable.php'); ?>
<script>
    $(function() {
        var table = $('#example').DataTable({
            scrollX:        true,
            scrollCollapse: true,
            paging:         true,
            fixedColumns:   true
        });

        var table = $('#example1').DataTable({
            scrollY:        "300px",
            scrollX:        true,
            scrollCollapse: true,
            paging:         false,
            fixedColumns:   {
                leftColumns: 2
            }
        });

        setTimeout(function() {
            table.draw();
        }, 50);

    });

        $('#create').click (function () {

            let menu = $('#menu').val();
            let color = $('#color').val();
            let library = $('#library').val();
            let icon = $('#lib_icon').val();
            let action = "add";

            if (color == "") {

                alert("Enter a color");

                return false;
            } else if (menu == ""){

                alert("Enter a menu");

                return false;

            } else if (library == ""){

                alert("Select Library");

                return false;

            } else if (icon == ""){

                alert("Select Icon");

                return false;

            } else {

                $.ajax({
                    type: "POST",
                    url: "../scripts/parent_menu.php",
                    data: {menu:menu, library:library, color: color, icon:icon, action:action},
                    dataType: 'json',

                    success: function(msg){
                        //alert(msg.status);
                        if (msg.status == 1) {

                            let column_1 ='<span class="menu_name" data-item ="'+msg.data.id+'">'+msg.data.name+'</span>';
                            let column_2 ='<span class="menu_color" data-item="'+msg.data.id+'" style="color:'+msg.data.color+';">'+msg.data.color+'</span>';
                            let column_3 ='<span class="menu_library" data-item="'+msg.data.id+'">'+msg.data.lib+'</span>';
                            let column_5 ='<span class="menu_icon" data-item="'+msg.data.id+'"><i class="'+msg.data.lib+' '+msg.data.icon+'" style="color:'+msg.data.color+';"></i></span>';
                            let column_6 ='<span class="label_tag" data-item="'+msg.data.id+'"><span class="label label-success" data-item="'+msg.data.id+'">Active</span></span>';

                            let part_4 = '&nbsp';
                            if (msg.iedit == 1) {
                                part_4='<a href="#" data-toggle="modal" data-target="#edit_modal" class="edit_modal_btn" data-item ="'+msg.data.id+'"><i class="fa fa-edit"></i></a>';
                            }

                            let part2_4 = '&nbsp';

                            if (msg.idelete == 1) {
                                part2_4= '&nbsp;&nbsp;&nbsp;<span class="del_icon" data-item ="'+msg.data.id+'"><a href="#" data-status = 0 class="del_btn" id="'+msg.data.id+'"><i class="fa fa-close" style="color:red;"></i></a>';
                            }
                            let column_4 =part_4+part2_4;
							let table = $('#example').DataTable();
 
							let rowNode = table
								.row.add( [ column_1, column_2, column_3, column_5, column_6,column_4 ] )
								.draw()

                            $.notify({
                                icon: 'font-icon font-icon-check-circle',
                                title: '<strong>Success!</strong>',
                                message: 'Color added'
                            },{
                                type: 'success'
                            });
							$('#color').val('');
							//$("#item_show").prepend(data);
							//$("#example").DataTable('refresh');
							//table.row.add(data);
                        }

                        else {
                            $.notify({
                                icon: 'glyphicon glyphicon-alert',
                                title: '<strong>Error!</strong>',
                                message: msg.message
                            },{
                                type: 'danger'
                            });
                            // $('#loading_image').remove();
                            // $('#btnlogin').show();
                        }

                    }

                });

                return false;
            }
        });



    $('.page-content').on('click', '.edit_modal_btn', function () {
        $('#edit_color').val('');
        let item_id = $(this).attr('data-item');

        let color_name = $("span[class='color_name'][data-item='" + item_id + "']").html();

        $('#edit_btn').data('myedit',item_id);
        //console.log( $('#edit_btn').data('myedit'));

        $('#edit_color').val(color_name);

    });


    $('#edit_btn').click (function () {
        let item_id = $('#edit_btn').data('myedit');
        //alert($('#edit_btn').data('myedit'));
        //alert(item_id);
        let color = $('#edit_color').val();
        let action = "edit";

        if (color == ""){

            alert("Enter a color");

            return false;
        } else {

            $.ajax({
                type: "POST",
                url: "../scripts/menu_color.php",
                data: {color: color, item_id: item_id, action:action},
                dataType: 'json',

                success: function(msg){
                    //alert(msg.status);
                    if (msg.status == 1) {

                        $("span[class='color_name'][data-item='" + item_id + "']").html(color);

                        $('#edit_modal').modal('toggle');

                        $.notify({
                            icon: 'font-icon font-icon-check-circle',
                            title: '<strong>Success!</strong>',
                            message: 'Color updated'
                        },{
                            type: 'success'
                        });
                    }

                    else {
                        //alert(msg.message);
                        $('#edit_modal').modal('toggle');

                        $.notify({
                            icon: 'glyphicon glyphicon-alert',
                            title: '<strong>Error!</strong>',
                            message: msg.message
                        },{
                            type: 'danger'
                        });
                        // $('#loading_image').remove();
                        // $('#btnlogin').show();
                    }

                }

            });

            return false;
        }




    });



    //$('.del_btn').click (function () {
    $('.page-content').on('click', '.del_btn', function () {
        let item_id = $(this).attr('id');
        let item_status = $(this).data('status');
        let action ='delete';

        $.ajax({
            type: "POST",
            url: "../scripts/menu_color.php",
            data: {status: item_status, item_id: item_id, action:action},
            dataType: 'json',

            success: function(msg){
                
                if (msg.status == 1) {
                    let del_icon ="";

                    if (item_status == 0){
                        $("span[class='label_tag'][data-item='"+item_id+"']").html('<span class="label label-danger">Inactive</span>');
                        del_icon ='<a href="#" data-status = 1 class="del_btn" id="'+item_id+'"><i class="fa fa-check" style="color:green;"></i></a>';
                    } else {
                        $("span[class='label_tag'][data-item='"+item_id+"']").html('<span class="label label-success">Active</span>');
                        del_icon ='<a href="#" data-status = 0 class="del_btn" id="'+item_id+'"><i class="fa fa-close" style="color:red;"></i></a>';

                    }
                    $("span[class='del_icon'][data-item='" + item_id + "']").html(del_icon);

                    $.notify({
                        icon: 'font-icon font-icon-check-circle',
                        title: '<strong>Success!</strong>',
                        message: msg.message
                    },{
                        type: 'success'
                    });
                }

                else {
                    $.notify({
                        icon: 'glyphicon glyphicon-alert',
                        title: '<strong>Error!</strong>',
                        message: msg.message
                    },{
                        type: 'danger'
                    });

                }

            }

        });

        return false;


    });

    $('.page-content').on('change', '#library', function () {

        let lib_id = $(this).find(':selected').data('lib');

        $.ajax({
            type: "POST",
            url: "../data/icons.php",
            data: {lib_id: lib_id},
            dataType: 'json',

            success: function(msg){
                if(msg.status == 1){

                    let option = "";
                    $.each(msg.data, function(key,val) {

                        //alert(val.name);
                        option +='<option value ="'+val.name+'">'+val.name+'</option>';

                    });


                    $('#lib_icon').html(option);

                } else {

                    alert("No data found");
                }
            }

        });
        return false;

    });
</script>

</body>
</html>


<?php } // close if array?>

