<?php
require_once ('../includes/startsession.php');
require_once ('../classes/user_login_class.php');
require_once ('../classes/menu_class.php');
require_once ('../classes/partner_class.php');
require_once ('../classes/partner_type_class.php');
require_once ('../classes/payment_type_class.php');
$check_details = new Rewards_user_login_class();
//$check_details->start_session();
$get_details = $check_details->go_to_page();
include('../includes/head-datatable.php');




if(is_array($get_details)){
//{"create_access":"0","read_access":"0","update_access":"0","delete_access":"0"}
$use_partner = new partner_class();
$use_partner_type = new partner_type_class();
$use_payment_type = new payment_type_class();
    $partner_type_options = $use_partner_type->active_partner_type();

    if(is_array($partner_type_options)) {
        $pt_menu = "";
        foreach ($partner_type_options as $partner_type){

            $pt_menu .= '<option value="'.$partner_type['type_id'].'">'.$partner_type['type_name'].'</option>';

        }

    }

    $payment_type_options = $use_payment_type->active_payment_type();
    if(is_array($payment_type_options)) {
        $pa_menu = "";
        foreach ($payment_type_options as $payment_type){

            $pa_menu .= '<option value="'.$payment_type['payment_id'].'">'.$payment_type['name'].'</option>';

        }

    }
    if(isset($get_details['create_access'])) {

        $create = $get_details['create_access'];
        // add record script





        // end add record script


    } else {

        $create = 0;
    }

    if(isset($get_details['update_access'])) {

        $update = $get_details['update_access'];

        // update record script





        // end update record script

    } else {

        $update = 0;
    }

    if(isset($get_details['delete_access'])) {

        $delete = $get_details['delete_access'];

        // delete record script





        // delete add record script
    } else {

        $delete = 0;
    }

    if(isset($get_details['read_access'])) {

        $read = $get_details['read_access'];

        // view record script

        $show_result=$use_partner->view_partners();

        if (is_array($show_result)){
            //echo json_encode($show_result);
            $show_data = "";
            foreach ($show_result as $result){
                //echo $color['color'];
                $data = "";
                $data .= '<tr>';
                $data .= '<td><span class="partner_no" data-item ="' . $result['partner_id'] . '">'.ucfirst($result['partner_no']).'</span></td>';
                $data .= '<td><span class="partner_name" data-item ="' . $result['partner_id'] . '">'.ucfirst($result['partner_name']).'</span></td>';
                $data .= '<td><span class="partner_type" data-item ="' . $result['partner_id'] . '">'.ucfirst($result['type_name']).'</span></td>';
                $data .= '<td><span class="payment_type" data-item ="' . $result['partner_id'] . '">'.ucfirst($result['name']).'</span></td>';

                $data.='<td>';
                if ($result['status'] == 1){
                    $data .='<span class="label_tag" data-item="'.$result['partner_id'].'"><span class="label label-success">Active</span></span>';
                } else {
                    $data .='<span class="label_tag" data-item="'.$result['partner_id'].'"><span class="label label-danger">Inactive</span></span>';


                }
                $data.='</td>';

                $data .= '<td>';

                if ($update == 1) {
                    $data .= '<a href="#" data-toggle="modal" data-target="#edit_modal" class="edit_modal_btn" data-item ="' . $result['partner_id'] . '"><i class="fa fa-edit"></i></a>';
                } else {
                    $data.='&nbsp;';
                }

                if ($delete == 1) {
                    if ($result['status'] == 1) {
                        $data .= '&nbsp;&nbsp;&nbsp;<span class="del_icon" data-item="' . $result['partner_id'] . '"><a href="#" data-status = 0 class="del_btn" id="' . $result['partner_id'] . '"><i class="fa fa-close" style="color:red;"></i></a></span>';
                    } else {

                        $data .= '&nbsp;&nbsp;&nbsp;<span class="del_icon" data-item="' . $result['partner_id'] . '"><a href="#" data-status = 1 class="del_btn" id="' . $result['partner_id'] . '"><i class="fa fa-check" style="color:green;"></i></a></span>';
                    }

                }{
                    $data.='&nbsp;';
                }

                $data.='</td>';
                $data.='</tr>';

                $show_data = $show_data.$data;
            }



        } else {

            $show_data = "";
        }
        //echo $show_data;


        // end view record script





    } else {

        $read = 0;
    }



    $menu = new menu_class();
    $list_menu = $menu->show_user_menu($_SESSION['role_id']);
?>

<!DOCTYPE html>
<html>
<head lang="en">
	<meta charset="UTF-8">
	<meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=no">
	<meta http-equiv="x-ua-compatible" content="ie=edge">
	<title>Rewards Box</title>
	
<?php include('../includes/head-datatable.php'); ?>

</head>
<body class="with-side-menu">

<?php include('../includes/header.php'); ?><!--.site-header-->

	<div class="mobile-menu-left-overlay"></div>
    <nav class="side-menu">
        <?php echo $list_menu; ?><!--.side-menu-->
    </nav>



	<div class="page-content">
		<div class="container-fluid">
						<header class="section-header">
				<div class="tbl">
					<div class="tbl-row">
						<div class="tbl-cell">
							<h3>Partners</h3>
							
						</div>
					</div>
				</div>
			</header>

            <?php if ($create == 1) { ?>
			<div class="box-typical box-typical-padding">
				

				<h5 class="m-t-lg with-border">Add Partner</h5>

				<form>
                    <div class="row">
                        <h5 class="col-sm-3"><p>Name</p></h5>
                        <div class="col-sm-6">
                            <p class="form-control-static"><input type="text" class="form-control" id="partner_name" placeholder="Partner Name"></p>
                        </div>
                    </div>


                    <div class="row">

                        <h5 class="col-sm-3"><p>Partner Type</p></h5>
                        <div class="col-sm-6">
                            <select class="select2 select2-arrow manual select2-no-search-arrow" id="partner_type">
                                <?php echo $pt_menu; ?>
                            </select>
                        </div>

                    </div>
                    <div class="row">

                        <h5 class="col-sm-3"><p>Settlement Type</p></h5>
                        <div class="col-sm-6">
                            <select class="select2 select2-arrow manual select2-no-search-arrow" id="payment_type">
                                <?php echo $pa_menu; ?>
                            </select>
                        </div>

                    </div>

                    <div class="row">
                        <h5 class="col-sm-3"><p>Partner Token</p></h5>
                        <div class="col-sm-6">
                            <p class="form-control-static"><input type="text" class="form-control" id="partner_token" placeholder="Token"></p>
                        </div>
                    </div>
				</form>
				<div class="row border-top">
						<div class="col-md-10"></div>
						<div class="col-md-2">
						<div class="float-right">
							<br>
							<button type="button" id="create" class="btn btn-inline btn-primary float-right">Add</button>
						</div>
							</div>
					</div>

		

			</div><!--.box-typical-->
        <?php } // close create if?>

            <?php if ($read == 1){?>
			<section class="card">
				<div class="card-block">
					<table id="example" class="stripe row-border order-column display table table-striped table-bordered" cellspacing="0" width="100%">
						<thead>
						<tr>
							<th>Partner no</th>
							<th>Partner</th>
                            <th>Partner Type</th>
                            <th>Payment Type</th>
                            <th>Status</th>
							<th>Action</th>
						</tr>
						</thead>
						<tbody id="item_show">
						
							<?php echo $show_data; ?>
							
				
						</tbody>
					</table>
				</div>
			</section>
        <?php } // close read?>
		</div><!--.container-fluid-->
	</div><!--.page-content-->
	
		<div id="edit_modal" class="modal fade bd-example-modal-lg"
					 tabindex="-1"
					 role="dialog"
					 aria-labelledby="myLargeModalLabel"
					 aria-hidden="true">
					<div class="modal-dialog modal-lg">
						<div class="modal-content">
							<div class="modal-header">
								<button type="button" class="modal-close" data-dismiss="modal" aria-label="Close">
									<i class="font-icon-close-2"></i>
								</button>
								<h4 class="modal-title" id="myModalLabel">Edit Partner</h4>
							</div>
							<div class="modal-body">

                                <form>
                                    <div class="row">
                                        <h5 class="col-sm-3"><p>Name</p></h5>
                                        <div class="col-sm-6">
                                            <p class="form-control-static"><input type="text" class="form-control" id="edit_partner_name" placeholder="Partner Name"></p>
                                        </div>
                                    </div>


                                    <div class="row">

                                        <h5 class="col-sm-3"><p>Partner Type</p></h5>
                                        <div class="col-sm-6">
                                            <select class="select2 select2-arrow manual select2-no-search-arrow" id="edit_partner_type">
                                                <?php echo $pt_menu; ?>
                                            </select>
                                        </div>

                                    </div>
                                    <div class="row">

                                        <h5 class="col-sm-3"><p>Settlement Type</p></h5>
                                        <div class="col-sm-6">
                                            <select class="select2 select2-arrow manual select2-no-search-arrow" id="edit_payment_type">
                                                <?php echo $pa_menu; ?>
                                            </select>
                                        </div>

                                    </div>

<!--                                    <div class="row">-->
<!--                                        <h5 class="col-sm-3"><p>Partner Token</p></h5>-->
<!--                                        <div class="col-sm-6">-->
<!--                                            <p class="form-control-static"><input type="text" class="form-control" id="edit_partner_token" placeholder="Token"></p>-->
<!--                                        </div>-->
<!--                                    </div>-->
                                </form>

								
							</div>
							<div class="modal-footer">
								<button type="button" class="btn btn-rounded btn-default" data-dismiss="modal">Close</button>
								<button type="button" class="btn btn-rounded btn-primary" id="edit_btn" data-myedit ="<?php echo $result['partner_id'] ?>">Save changes</button>
							</div>
						</div>
					</div>
				</div><!--.modal-->


<?php include('../includes/script-datatable.php'); ?>
<script>
    $(function() {
        var table = $('#example').DataTable({
            scrollX:        true,
            scrollCollapse: true,
            paging:         true,
            fixedColumns:   true
        });

        var table = $('#example1').DataTable({
            scrollY:        "300px",
            scrollX:        true,
            scrollCollapse: true,
            paging:         false,
            fixedColumns:   {
                leftColumns: 2
            }
        });

        setTimeout(function() {
            table.draw();
        }, 50);

    });

        $('#create').click (function () {

            let partner_name = $('#partner_name').val();
            let partner_type = $('#partner_type').val();
            let payment_type = $('#payment_type').val();
            let partner_token = $('#partner_token').val();
            let action = "add";

            if (partner_name == ""){

                alert("Enter Partner Name");

                return false;
            } else if (partner_type == ""){

                alert("Select Partner Type");

                return false;

            } else if (payment_type == ""){

                alert("Select Payment Type");

                return false;

            } else if (partner_token == ""){

                alert("Enter Partner Token");

                return false;

            } else {

                $.ajax({
                    type: "POST",
                    url: "../scripts/partner.php",
                    data: {partner_name:partner_name, partner_type:partner_type, payment_type:payment_type, partner_token:partner_token, action:action},
                    dataType: 'json',

                    success: function(msg){
                        //alert(msg.status);
                        if (msg.status == 1) {

                            let column_1 ='<span class="partner_no" data-item ="'+msg.data.id+'">'+msg.data.partner_no+'</span>';
                            let column_2 ='<span class="partner_name" data-item="'+msg.data.id+'">'+msg.data.partner_name+'</span>';
                            let column_5 ='<span class="color_icon" data-item="'+msg.data.id+'">'+msg.data.partner_type+'</span>';
                            let column_6 ='<span class="color_icon" data-item="'+msg.data.id+'">'+msg.data.payment_type+'</span>';
                            //let column_6 ='<input class="color_icon" type="hidden" value="'+msg.data.payment_type+'" data-item="'+msg.data.id+'">';
                            let column_3 ='<span class="label_tag" data-item="'+msg.data.id+'"><span class="label label-success" data-item="'+msg.data.id+'">Active</span></span>';

                            let part_4 = '&nbsp';
                            if (msg.iedit == 1) {
                                part_4='<a href="#" data-toggle="modal" data-target="#edit_modal" class="edit_modal_btn" data-item ="'+msg.data.id+'"><i class="fa fa-edit"></i></a>';
                            }

                            let part2_4 = '&nbsp';

                            if (msg.idelete == 1) {
                                part2_4= '&nbsp;&nbsp;&nbsp;<span class="del_icon" data-item ="'+msg.data.id+'"><a href="#" data-status = 0 class="del_btn" id="'+msg.data.id+'"><i class="fa fa-close" style="color:red;"></i></a>';
                            }
                            let column_4 =part_4+part2_4;
							let table = $('#example').DataTable();
 
							let rowNode = table
								.row.add( [ column_1, column_2, column_5,column_6, column_3,column_4 ] )
								.draw()

                            $.notify({
                                icon: 'font-icon font-icon-check-circle',
                                title: '<strong>Success!</strong>',
                                message: 'Partner Added'
                            },{
                                type: 'success'
                            });
							$('#color').val('');
							//$("#item_show").prepend(data);
							//$("#example").DataTable('refresh');
							//table.row.add(data);
                        }

                        else {
                            $.notify({
                                icon: 'glyphicon glyphicon-alert',
                                title: '<strong>Error!</strong>',
                                message: msg.message
                            },{
                                type: 'danger'
                            });
                            // $('#loading_image').remove();
                            // $('#btnlogin').show();
                        }

                    }

                });

                return false;
            }
        });



    $('.page-content').on('click', '.edit_modal_btn', function () {
        $('#edit_partner_name').val('');
        let item_id = $(this).attr('data-item');

        let name = $("span[class='partner_name'][data-item='" + item_id + "']").html();
        //let token = $("span[class='token'][data-item='" + item_id + "']").html();


        $('#edit_btn').data('myedit',item_id);
        //console.log( $('#edit_btn').data('myedit'));

        $('#edit_partner_name').val(name);

    });


    $('#edit_btn').click (function () {
        let item_id = $('#edit_btn').data('myedit');
        //alert($('#edit_btn').data('myedit'));
        //alert(item_id);
        let partner_name = $('#edit_partner_name').val();
        let partner_type = $('#edit_partner_type').val();
        let payment_type = $('#edit_payment_type').val();
        let action = "edit";

        if (partner_name == ""){

            alert("Enter Partner Name");

            return false;
        }
        else if (partner_type == ""){

            alert("Enter Partner Type");

            return false;
        }
        else if (payment_type == ""){

            alert("Enter Payment Type");

            return false;
        }else {

            $.ajax({
                type: "POST",
                url: "../scripts/partner.php",
                data: {partner_name:partner_name, partner_type:partner_type, payment_type:payment_type, item_id: item_id, action:action},
                dataType: 'json',

                success: function(msg){
                    //alert(msg.status);
                    if (msg.status == 1) {

                        // $("span[class='partner_name'][data-item='" + item_id + "']").html(partner_name);
                        // $("span[class='partner_name'][data-item='" + item_id + "']").html(partner_name);

                        $('#edit_modal').modal('toggle');

                        $.notify({
                            icon: 'font-icon font-icon-check-circle',
                            title: '<strong>Success!</strong>',
                            message: 'Partner updated'
                        },{
                            type: 'success'
                        });

                        location.reload()
                    }

                    else {
                        //alert(msg.message);
                        $('#edit_modal').modal('toggle');

                        $.notify({
                            icon: 'glyphicon glyphicon-alert',
                            title: '<strong>Error!</strong>',
                            message: msg.message
                        },{
                            type: 'danger'
                        });
                        // $('#loading_image').remove();
                        // $('#btnlogin').show();
                    }

                }

            });

            return false;
        }




    });



    //$('.del_btn').click (function () {
    $('.page-content').on('click', '.del_btn', function () {
        let item_id = $(this).attr('id');
        let item_status = $(this).data('status');
        let action ='delete';

        $.ajax({
            type: "POST",
            url: "../scripts/partner.php",
            data: {status: item_status, item_id: item_id, action:action},
            dataType: 'json',

            success: function(msg){
                
                if (msg.status == 1) {
                    let del_icon ="";

                    if (item_status == 0){
                        $("span[class='label_tag'][data-item='"+item_id+"']").html('<span class="label label-danger">Inactive</span>');
                        del_icon ='<a href="#" data-status = 1 class="del_btn" id="'+item_id+'"><i class="fa fa-check" style="color:green;"></i></a>';
                    } else {
                        $("span[class='label_tag'][data-item='"+item_id+"']").html('<span class="label label-success">Active</span>');
                        del_icon ='<a href="#" data-status = 0 class="del_btn" id="'+item_id+'"><i class="fa fa-close" style="color:red;"></i></a>';

                    }
                    $("span[class='del_icon'][data-item='" + item_id + "']").html(del_icon);

                    $.notify({
                        icon: 'font-icon font-icon-check-circle',
                        title: '<strong>Success!</strong>',
                        message: msg.message
                    },{
                        type: 'success'
                    });
                }

                else {
                    $.notify({
                        icon: 'glyphicon glyphicon-alert',
                        title: '<strong>Error!</strong>',
                        message: msg.message
                    },{
                        type: 'danger'
                    });

                }

            }

        });

        return false;


    });
</script>

</body>
</html>


<?php } // close if array?>

