<?php

require_once ('../includes/startsession.php');

if (isset($_SESSION['user_id'])) {
require_once ('../classes/user_login_class.php');
require_once ('../classes/sms_class.php');
require_once ('../classes/portal_user_class.php');

$check_details = new Rewards_user_login_class();

$get_details = $check_details->script_access();
//$use_menu = new menu_class();
if(is_array($get_details)) {
    $get_sms = new sms_class();
    $use_portal = new portal_user_class();
    //{"create_access":"0","read_access":"0","update_access":"0","delete_access":"0"}
    if (isset($get_details['create_access'])) {

        $create = $get_details['create_access'];

    } else {

        $create = 0;
    }

    if (isset($get_details['read_access'])) {

        $read = $get_details['read_access'];

    } else {

        $read = 0;
    }

    if (isset($get_details['update_access'])) {

        $update = $get_details['update_access'];

    } else {

        $update = 0;
    }

    if (isset($get_details['delete_access'])) {

        $delete = $get_details['delete_access'];

    } else {

        $delete = 0;
    }


    if (isset($_POST['action'])){
        $action = $_POST['action'];

        if($action == 'add'){
            if ($create == 1){

                if(isset($_POST['redeem'])){

                    if ($_POST['redeem'] == ""){

                        $response_array['status'] = 0;
                        $response_array['message'] ="No menu name sent";

                    } else {

                                $redeem = $_POST['redeem'];
                                $greater = $_POST['greater'];
                                $less = $_POST['less'];
                                $company_id = $_POST['company_id'];
                                $add_item = $use_portal->fetch_save_criteria_sms($company_id,$redeem,$greater,$less);
                                if (is_array($add_item)) {
                                    $response_array['status'] = 1;
                                    $response_array['message'] = "success";
                                    $response_array['data'] = $add_item;

                                } else {

                                    $response_array['status'] = 0;
                                    $response_array['message'] = $add_item;
                                }


                    }

                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] ="Redeem Option Sent";

                }


            } else{

                $response_array['status'] = -1;
                $response_array['message'] ="Access denied";

            }


        } elseif ($action =='edit'){

            if ($update == 1){

                if(isset($_POST['content']) || isset($_POST['id'])){

                    if ($_POST['content'] == "" || $_POST['id'] =="" || !is_numeric($_POST['id']) || $_POST['id'] < 1){

                        $response_array['status'] = 0;
                        $response_array['message'] ="Invalid data";

                    } else {

                        $id = trim($_POST['id']);
                        $content = strtolower(trim($_POST['content']));

                        $edit_content = $get_sms->edit_active_program_type_sms($id, $content);

                        if ($edit_content == 1){

                            $response_array['status'] = 1;
                            $response_array['message'] ="Update Successful";

                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] =$edit_content;
                        }


                    }

                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] ="No values set";

                }

            } else{

                $response_array['status'] = -1;
                $response_array['message'] ="Access denied";

            }

        } elseif ($action =='delete'){
            if ($delete == 1){

//                if(isset($_POST['status']) || isset($_POST['item_id'])){
//
//
//                    if($_POST['status'] == "" || $_POST['item_id'] == "" || !is_numeric($_POST['status']) || !is_numeric($_POST['item_id'])){
//
//                        $response_array['status'] = 0;
//                        $response_array['message'] ="Invalid Data sent";
//
//                    } else {
//                        $color_id = trim($_POST['item_id']);
//                        $status = trim($_POST['status']);
//                        if ($status == 1){
//                            $msg = "active";
//
//                        }else{
//
//                            $msg = "inactive";
//                        }
//
//                        $del_color = $get_color->change_color_status($color_id,$status);
//
//                        if ($del_color == 1){
//                            $response_array['status'] = 1;
//                            $response_array['message'] ="color is ".$msg;
//
//                        } else {
//
//                            $response_array['status'] = 0;
//                            $response_array['message'] =$del_color;
//                        }
//
//                    }
//
//
//                } else {
//
//                    $response_array['status'] = 0;
//                    $response_array['message'] ="Missing data";
//
//                }


            } else{

                $response_array['status'] = -1;
                $response_array['message'] ="Access denied";

            }

        }else{

            $response_array['status'] = 0;
            $response_array['message'] ="Invalid action";
        }


    } else {

        $response_array['status'] = 0;
        $response_array['message'] ="No action sent";
    }


} else {

    $response_array['status'] = 0;
    $response_array['message'] = "Error getting Access";
}
} else {

    $response_array['status'] = 4004;
    $response_array['message'] ="Session expired";
}

echo json_encode($response_array);
?>