<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 31/10/2018
 * Time: 10:43
 */

require_once("../../../classes/purchase_class.php");
require_once("../../../classes/rims_class.php");



if (isset($_SERVER['HTTP_TOKEN'])) {

    if ($_SERVER['HTTP_TOKEN'] == "") {
        $response_array['status'] = 0;
        $response_array['message'] = "blank token sent";
    } else {
        $token = $_SERVER['HTTP_TOKEN'];
        $use_rims = new rims_class();
        $get_details = $use_rims->verify_api_token($token);

        if ($get_details == 1){

            if( isset($_GET['api'])) {

                if ($_GET['api'] == "") {

                    $response_array['status'] = 0;
                    $response_array['message'] = "Blank api call";

                } else {
                    $api = $_GET['api'];

                    if ($api == "move_shipped") {

                        if(isset($_POST['order_no']) && isset($_POST['voucher_no'])) {

                            $order_no = $_POST['order_no'];
                            $voucher_no = $_POST['voucher_no'];
                            if ($order_no == "" || $voucher_no == "") {

                                $response_array['status'] = 0;
                                $response_array['message'] = "Blank Order number or voucher number";

                            } else {
                                $use_purchase = new purchase_class();
                                $get_data = $use_purchase->move_to_shipped($order_no, $voucher_no);

                                if (is_array($get_data)) {

                                    $response_array['status'] = 1;
                                    $response_array['message'] = "success";
                                    $response_array['data'] = $get_data;
                                } else {

                                    $response_array['status'] = 0;
                                    $response_array['message'] = $get_data;

                                }


                            }
                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Missing Parameters";

                        }

                    }elseif($api == "move_delivered"){

                        if(isset($_POST['order_no']) && isset($_POST['voucher_no'])) {

                            $order_no = $_POST['order_no'];
                            $voucher_no = $_POST['voucher_no'];
                            if ($order_no == "" || $voucher_no == "") {

                                $response_array['status'] = 0;
                                $response_array['message'] = "Blank Order number or voucher number";

                            } else {
                                $use_purchase = new purchase_class();
                                $get_data = $use_purchase->move_to_delivered($order_no, $voucher_no);

                                if (is_array($get_data)) {

                                    $response_array['status'] = 1;
                                    $response_array['message'] = "success";
                                    $response_array['data'] = $get_data;
                                } else {

                                    $response_array['status'] = 0;
                                    $response_array['message'] = $get_data;

                                }


                            }
                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Missing Parameters";

                        }
                    } elseif ($api == "move_pickup"){

                        if(isset($_POST['order_no']) && isset($_POST['voucher_no'])) {

                            $order_no = $_POST['order_no'];
                            $voucher_no = $_POST['voucher_no'];
                            if ($order_no == "" || $voucher_no == "") {

                                $response_array['status'] = 0;
                                $response_array['message'] = "Blank Order number or voucher number";

                            } else {
                                $use_purchase = new purchase_class();
                                $get_data = $use_purchase->move_to_pickup($order_no, $voucher_no);

                                if (is_array($get_data)) {

                                    $response_array['status'] = 1;
                                    $response_array['message'] = "success";
                                    $response_array['data'] = $get_data;
                                } else {

                                    $response_array['status'] = 0;
                                    $response_array['message'] = $get_data;

                                }


                            }
                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] = "Missing Parameters";

                        }

                    }


                }
            } else {

                $response_array['status'] = 0;
                $response_array['message'] = "Missing Request";
            }
        } else {

            $response_array['status'] = 0;
            $response_array['message'] = $get_details;

        }


    }


} else {

    $response_array['status'] = 0;
    $response_array['message'] = "no header sent";
}
echo json_encode($response_array);



