<?php
require_once("main_class.php");
require_once ("wallet_service_class.php");
require_once ("rims_class.php");
require_once ("purchase_class.php");
require_once("notification_class.php");
require_once ("report_class.php");
require_once ("send_mail_class.php");

class Reward_company extends Rewardsbox_main {
	
	private $comapany_table = "user_mgt_company";
	private $details_table = "user_mgt_com_details";
	private $gen_no_table = "rewardsbox_gen_no";
	private $company_contact_table = "user_mgt_com_contact";
    private $plan_table = "user_mgt_plan";
    private $period_table = "usr_mgt_license_period";
    private $licence_log_table = "usr_mgt_license_log";
    private $settings_table = "user_mgt_com_settings";
	
	public function create_company ($company_name,$plan_id, $period_id, $prefix ="RB", $email = null, $phone1 = null, $phone2 = null, $address = null, $country = 1, $state = 7, $city = 181, $image = null){
		
		$this->auto_commit_off();
		$randno =mt_rand(100,9999);

		$use_purchase = new purchase_class();
		$random_string = $use_purchase->get_random_string(10);
		$token = md5($randno.$random_string);

		$gen_column = array("details");
		$gen_values = array("Create Company");
        $plan_columns = array("plan_name");
        $p_where['column_name'] ="plan_id";
        $p_where['sign'] ="=";
        $p_where['value'] =$plan_id;

        $plan_where[]=$p_where;

        $p2_where['column_name'] ="status";
        $p2_where['sign'] ="=";
        $p2_where['value'] =1;

        $plan_where[]=$p2_where;

        $pr_where['column_name'] ="period_id";
        $pr_where['sign'] ="=";
        $pr_where['value'] =$period_id;
        $period_where[] = $pr_where;

        $period_columns = array("period_id","no_of_days","period_text");
        $period_where[] = $p2_where;

        $c_where['column_name'] =  "company_name";
        $c_where['sign'] ="=";
        $c_where['value'] =$company_name;
        $duplicate_check_company[] =$c_where;
        $check_period = $this->select_tb($this->period_table,$period_columns,$period_where);
        if (is_array($check_period)) {
            $no_of_days = $check_period['data'][0]['no_of_days'];
            $period_text = $check_period['data'][0]['period_text'];
            //print_r($check_period);
            $check_plan = $this->select_tb($this->plan_table, $plan_columns, $plan_where);

            if (is_array($check_plan)) {
                $unique_no = $this->insert_data($this->gen_no_table, $gen_column, $gen_values);
                if ($unique_no > 0) {
                    $client_no = $unique_no.$randno;
                    $company_column1 = array("client_no", "company_name", "status", "user_plan","company_token","prefix","image");
                    $company_values1 = array($client_no, $company_name, 1, $plan_id, $token, $prefix, $image);
                    $insert_company_1 = $this->insert_check_duplicate($this->comapany_table, $company_column1, $company_values1, $duplicate_check_company);
                    //print_r($insert_company_1);
                    if ($insert_company_1 > 0) {

                        $company_id = $insert_company_1;
                        $company_details_column = array("company_id", "address", "email", "country_id","state_id","city_id","phone1","phone2","status");
                        $company_details_values = array($company_id, $address, $email, $country, $state, $city, $phone1, $phone2, 1);
                        $insert_details = $this->insert_data($this->details_table,$company_details_column, $company_details_values);
                        if ($insert_details > 0){
                            $insert_settings = $this->create_setting($company_id);
                            if($insert_settings > 0) {

                                $expire_date = Date('Y-m-d', strtotime("+" . $check_period['data'][0]['no_of_days'] . "days"));
                                $today_date = Date('Y-m-d');
                                $licence_log_columns = array("company_id", "company_name", "period_id", "no_of_days", "period_text", "start_date", "expire_date");
                                $licence_log_values = array($company_id, $company_name, $period_id, $no_of_days, $period_text, $today_date, $expire_date);
                                //print_r($expire_date);
                                $expire_log = $this->insert_data($this->licence_log_table, $licence_log_columns, $licence_log_values);

                                if ($expire_log > 0) {

                                    $ci_where['column_name'] = "company_id";
                                    $ci_where['sign'] = "=";
                                    $ci_where['value'] = $company_id;

                                    $company_where[] = $ci_where;

                                    $ci_set['column_name'] = "expire_date";
                                    $ci_set['sign'] = "=";
                                    $ci_set['value'] = $expire_date;

                                    $company_set[] = $ci_set;

                                    $update_licence = $this->update_data($this->comapany_table, $company_set, $company_where);
                                    if ($update_licence == 1) {
                                        $this->commit_now();
                                        $use_rims = new rims_class();
                                        $save_rims = $use_rims->create_client($company_name, $insert_company_1);
                                        $use_wallet = new wallet_service_class();
                                        $save_wallet = $use_wallet->create_company($client_no, $token, $expire_date, $insert_company_1);
                                        $use_catalogue = new catalogue_service_class();
                                        $save_catalogue = $use_catalogue->create_client($client_no, $company_name, $token, $expire_date, $insert_company_1);
                                        $use_notification = new notification_class();
                                        $save_notification = $use_notification->create_client($client_no, $company_name, $token, $expire_date, $insert_company_1);
                                        $use_report = new report_class();
                                        $use_report->create_entry($company_id, $expire_date);
                                        $use_send = new send_mail_class();
                                        $use_send->create_company($company_name, $expire_date, $period_text, $email);

                                        $insert_array['id'] = $insert_company_1;
                                        $insert_array['company_name'] = $company_name;
                                        $insert_array['client_no'] = $client_no;
                                        $insert_array['prefix'] = $prefix;
                                        $insert_array['expire_Date'] = $expire_date;

                                        return $insert_array;
                                    } else {
                                        $this->rollback_now();
                                        return "Licence update failed";
                                    }

                                } else {
                                    $this->rollback_now();
                                    return "Register Licence failed";
                                }
                            } else {

                                $this->rollback_now();
                                return "Settings Creation failed";
                            }
                        }  else {
                            $this->rollback_now();
                            return "Error storing details";
                        }
                    } elseif($insert_company_1 == -1){
                        $this->rollback_now();
                        return "Company ".$company_name." already exits";
                    } else {
                        $this->rollback_now();
                        return "Error Creating Company";
                    }

                } else {
                    $this->rollback_now();
                    return "Unable to generate client number";
                }
            } else {

                return "Invalid plan";
            }
        } else {

            return "Invalid licence Period";
        }
	}

    public function edit_company($company_id, $company_name, $prefix, $image = null) {
        $key = "company_id";
        //$columns_name = "service_name";

        $firstset['column_name'] ="company_name";
        $firstset['sign'] ="=";
        $firstset['value'] =$company_name;
        $set[] = $firstset;
        //$whereduplicate[] = $firstset;

        $firstset['column_name'] ="prefix";
        $firstset['sign'] ="=";
        $firstset['value'] =$prefix;
        $set[] = $firstset;

        if($image != null || $image!="") {
            $firstset['column_name'] = "image";
            $firstset['sign'] = "=";
            $firstset['value'] = $image;
            $set[] = $firstset;

        }
        //$whereduplicate[] = $firstset;

        $first_where['column_name'] ="company_id";
        $first_where['sign'] ="=";
        $first_where['value'] =$company_id;
        $where[] = $first_where;

        $edit_result = $this->update_data($this->comapany_table, $set, $where);
        //print_r($edit_name);

        if ($edit_result == 1) {
            return 1;

        }  else {
            return "Invalid Company";
        }

    } // end edi name function

    public function change_company_status ($company_id, $new_status){
        $key = "company_id";
        //$columns = array($key,"status");

        if ($new_status == 1) {

            $msg = "Active";

        } else {
            $new_status = 0;
            $msg= "Inactive";
        }

        $change_status = $this->change_status($company_id, $new_status,$this->comapany_table,$key);
        if ($change_status == 1){
            return 1;

        } elseif ($change_status ==-2) {
            return "Cannot locate Company";

        } elseif ($change_status ==-1) {
            return "Company already ".$msg;

        } else {
            return "An error occurred";
        }


    } // end change status

	public function check_company_token($token){
        $today_date = date('Y-m-d');
	    $column = array("company_id", "user_plan", "client_no","company_name","prefix","portal_access");

        $m_where['column_name'] ="company_token";
        $m_where['sign'] ="=";
        $m_where['value'] =$token;
        $where[] = $m_where;

        $m_where['column_name'] ="status";
        $m_where['sign'] ="=";
        $m_where['value'] =1;
        $where[] = $m_where;

        $m_where['column_name'] ="expire_date";
        $m_where['sign'] =">=";
        $m_where['value'] =$today_date;
        $where[] = $m_where;
        $check_token = $this->select_tb($this->comapany_table,$column,$where);

        if (is_array($check_token)){

            return $check_token['data'][0];

        } else {

            return 0;
        }
    }


    public function list_all_company(){

	    $colums = array("company_id","client_no","company_name", "prefix","status","expire_date");
	    $get_company = $this->select_tb($this->comapany_table, $colums);

	    if(is_array($get_company)){

	        return $get_company['data'];

        } else {

	        return $get_company;
        }

    }

    public function change_portal_access($company_id, $status = 1){

        $m_where['column_name'] ="company_id";
        $m_where['sign'] ="=";
        $m_where['value'] =$company_id;
        $where[] = $m_where;

        $firstset['column_name'] ="portal_access";
        $firstset['sign'] ="=";
        $firstset['value'] =$status;
        $set[] = $firstset;

	    $check_company = $this->get_company($company_id);
	    if (is_array($check_company)){

	        if ($check_company['portal_access'] == 0 && $status == 1) {

	            return $this->update_data($this->comapany_table, $set,$where);

	        } elseif ($check_company['portal_access'] == 1 && $status == 0){

                return $this->update_data($this->comapany_table, $set,$where);

            } else {

	            if ($status == 1) {
                    return "Already has access";
                } else {

	                return "Did not have access";
                }
            }


        } else {


	        return "Invalid Company";
        }

    }



    public function list_active_company(){

        $colums = array("company_id","client_no","company_name", "prefix","status","expire_date");
        $p2_where['column_name'] ="status";
        $p2_where['sign'] ="=";
        $p2_where['value'] =1;

        $where[]=$p2_where;
        $get_company = $this->select_tb($this->comapany_table, $colums,$where);

        if(is_array($get_company)){

            return $get_company['data'];

        } else {

            return $get_company;
        }

    }

    public function get_company($id){
	    $column = array("company_name", "client_no","expire_date","image","portal_access","portal_link");

        $p2_where['column_name'] ="company_id";
        $p2_where['sign'] ="=";
        $p2_where['value'] =$id;

        $where[]=$p2_where;

	    $get_company = $this->select_tb($this->comapany_table,$column,$where);

	    if (is_array($get_company)){

	        return $get_company['data'][0];

        } else {

	        return "No company found";
        }


    }

    public function get_company_others($id){
        $column = array("company_name", "client_no","expire_date","image","portal_access", "credit_single_limit", "enrol_no_limit","total_customers");

        $p2_where['column_name'] =$this->comapany_table.".company_id";
        $p2_where['sign'] ="=";
        $p2_where['value'] =$id;

        $where[]=$p2_where;

        $p2_where['column_name'] ="status";
        $p2_where['sign'] ="=";
        $p2_where['value'] =1;

        $where[]=$p2_where;

        $firstjoin ['table_name'] = $this->settings_table;
        $firstjoin ['first_column'] = $this->settings_table.".company_id";
        $firstjoin ['second_column'] = $this->comapany_table . ".company_id";
        $leftjoin [] = $firstjoin;

        $firstjoin ['table_name'] = "rewardsbox_com_report";
        $firstjoin ['first_column'] = "rewardsbox_com_report.company_id";
        $firstjoin ['second_column'] = $this->comapany_table . ".company_id";
        $leftjoin [] = $firstjoin;

        $get_company = $this->select_tb($this->comapany_table,$column,$where, "","","","","",$leftjoin);

        if (is_array($get_company)){

            return $get_company['data'][0];

        } else {

            return "No company found";
        }


    }

    public function get_company_details($id){
        $column = array("company_name", "client_no","expire_date","image","portal_access", "email", "current_balance");


        $p2_where['column_name'] =$this->comapany_table.".company_id";
        $p2_where['sign'] ="=";
        $p2_where['value'] =$id;

        $where[]=$p2_where;

        $firstjoin ['table_name'] = $this->details_table;
        $firstjoin ['first_column'] = $this->details_table.".company_id";
        $firstjoin ['second_column'] = $this->comapany_table . ".company_id";
        $leftjoin [] = $firstjoin;

        $firstjoin ['table_name'] = "rewardsbox_com_report";
        $firstjoin ['first_column'] = "rewardsbox_com_report.company_id";
        $firstjoin ['second_column'] = $this->comapany_table . ".company_id";
        $leftjoin [] = $firstjoin;
        $get_company = $this->select_tb($this->comapany_table,$column,$where,"","","","","",$leftjoin);

        if (is_array($get_company)){

            return $get_company['data'][0];

        } else {

            return "No company found";
        }


    }

    public function view_active_plan(){
	    $columns = array("plan_id", "plan_name");

        $c_where['column_name'] =  "status";
        $c_where['sign'] ="=";
        $c_where['value'] =1;
        $where[] = $c_where;

        $get_data = $this->select_tb($this->plan_table, $columns, $where);

        if(is_array($get_data)){

            return $get_data['data'];

        } else {

            return $get_data;
        }


    }


    public function view_active_period(){
        $columns = array("period_id", "period_text");

        $c_where['column_name'] =  "status";
        $c_where['sign'] ="=";
        $c_where['value'] =1;
        $where[] = $c_where;

        $get_data = $this->select_tb($this->period_table, $columns, $where);

        if(is_array($get_data)){

            return $get_data['data'];

        } else {

            return $get_data;
        }


    }

    public function view_period(){
        $columns = array("period_id", "period_text", "no_of_days", "status");

        $get_data = $this->select_tb($this->period_table, $columns);

        if(is_array($get_data)){

            return $get_data['data'];

        } else {

            return $get_data;
        }


    }

    public function create_period ($no_of_days, $period_text){

	    if (is_numeric($no_of_days)) {
            $column = array("no_of_days", "period_text","status");
            $value = array($no_of_days, $period_text, 1);
            $thirdwhere['column_name'] = "no_of_days";
            $thirdwhere['sign'] = "=";
            $thirdwhere['value'] = $no_of_days;

            $thirdwhere['column_name'] = "period_text";
            $thirdwhere['sign'] = "=";
            $thirdwhere['value'] = $period_text;
            $where[] = $thirdwhere;

            $insert_data = $this->insert_check_duplicate($this->period_table, $column, $value, $where);

            if ($insert_data > 0) {
                $insert_array['id'] = $insert_data;
                $insert_array['name'] = $period_text;
                $insert_array['no_of_days'] = $no_of_days;
                return $insert_array;

            } elseif ($insert_data < 0) {
                return "Menu already exists";

            } else {
                return "An error occurred";
            }
        } else {

	        return "Invalid no of days";
        }
    }

    public function edit_period($id, $no_of_days, $period_text) {
        $key = "period_id";
        //$columns_name = "service_name";

        $firstset['column_name'] ="no_of_days";
        $firstset['sign'] ="=";
        $firstset['value'] =$no_of_days;
        $set[] = $firstset;
        $whereduplicate[] = $firstset;

        $firstset['column_name'] ="period_text";
        $firstset['sign'] ="=";
        $firstset['value'] =$period_text;
        $set[] = $firstset;
        $whereduplicate[] = $firstset;

        $first_where['column_name'] ="period_id";
        $first_where['sign'] ="=";
        $first_where['value'] =$id;
        $where[] = $first_where;

        $edit_result = $this->update_check_duplicate($this->period_table, $set, $where, $whereduplicate, $key);
        //print_r($edit_name);

        if ($edit_result == 1){
            return 1;

        } elseif ($edit_result ==-1) {
            return "No of days or period text already exists";

        }  else {
            return "Invalid licence Period";
        }

    } // end edi name function


    public function change_period_status ($period_id, $new_status){
        $key = "period_id";
        //$columns = array($key,"status");

        if ($new_status == 1) {

            $msg = "Active";

        } else {
            $new_status = 0;
            $msg= "Inactive";
        }

        $change_status = $this->change_status($period_id, $new_status,$this->period_table,$key);
        if ($change_status == 1){
            return 1;

        } elseif ($change_status ==-2) {
            return "Cannot locate Period";

        } elseif ($change_status ==-1) {
            return "Period already ".$msg;

        } else {
            return "An error occurred";
        }


    } // end change status


    public function get_period($id){
        $columns = array("period_id", "period_text", "no_of_days", "status");

        $p_where['column_name'] = "period_id";
        $p_where['sign'] = "=";
        $p_where['value'] = $id;
        $where[] = $p_where;

        $get_data = $this->select_tb($this->period_table, $columns, $where);

        if(is_array($get_data)){

            return $get_data['data'][0];

        } else {

            return $get_data;
        }


    }

    public function total_active_company(){


        $column = array("company_id","company_name");

        $p_where['column_name'] ="status";
        $p_where['sign'] ="=";
        $p_where['value'] =1;
        $where[]=$p_where;
        $get_data = $this->select_tb($this->comapany_table, $column,$where);
        return $get_data;
    }

    public function update_licence($company_id, $expire_date){
        $today_date = Date('Y-m-d H:i:s');


        $check_company = $this->get_company($company_id);

        if(is_array($check_company)) {
            $p_where['column_name'] = "company_id";
            $p_where['sign'] = "=";
            $p_where['value'] = $company_id;
            $where[] = $p_where;

            $ci_set['column_name'] = "expire_date";
            $ci_set['sign'] = "=";
            $ci_set['value'] = $expire_date;

            $set[] = $ci_set;

            $ci_set['column_name'] = "update_expire_date";
            $ci_set['sign'] = "=";
            $ci_set['value'] = $today_date;

            $set[] = $ci_set;

            $update_data = $this->update_data($this->comapany_table, $set, $where);

            if ($update_data == 1){

                return $check_company;

            } else {

                return "Error updating company";
            }

        } else {

            return "Invalid Company";
        }


    }

    public function list_expire_active_company(){

        $columns = array($this->comapany_table.".company_id","client_no","company_name", "prefix","expire_date", "email", "DATEDIFF(STR_TO_DATE(expire_date, '%Y-%m-%d'),CURRENT_DATE) as diff");
        $p2_where['column_name'] =$this->comapany_table.".status";
        $p2_where['sign'] ="=";
        $p2_where['value'] =1;

        $where[]=$p2_where;


        $p2_where['column_name'] ="expire_date";
        $p2_where['sign'] =">";
        $p2_where['value'] ="CURDATE()";

        $where[]=$p2_where;

        $firstjoin ['table_name'] = $this->details_table;
        $firstjoin ['first_column'] = $this->details_table.".company_id";
        $firstjoin ['second_column'] = $this->comapany_table . ".company_id";
        $leftjoin [] = $firstjoin;

        $get_company = $this->select_tb($this->comapany_table, $columns,$where,"","","","","",$leftjoin);

        if(is_array($get_company)){

            return $get_company['data'];

        } else {

            return $get_company;
        }

    }

    public function get_expiry_days(){

	    $get_data = $this->list_expire_active_company();

        if(is_array($get_data)){

            foreach ($get_data as $check_expire){


                $diff = $check_expire['diff'];
                $expire_date = $check_expire['expire_date'];
                $company_name = $check_expire['company_name'];
                $email = $check_expire['email'];


                if($diff == 1 || $diff == 3 || $diff == 7 || $diff == 15 || $diff == 30 || $diff == 60 ){

//
                    $use_mail = new send_mail_class();
                    $use_mail->expire_reminder($company_name, $expire_date, $diff, $email);

                }



            }


            return "Done";
        } else {

            return "No data found";
        }

    }


    public function single_company_detail($client_no){

        $columns = array($this->comapany_table.".company_id","client_no","company_name", "prefix","expire_date", "email");
        $p2_where['column_name'] =$this->comapany_table.".status";
        $p2_where['sign'] ="=";
        $p2_where['value'] =1;

        $where[]=$p2_where;

        $p2_where['column_name'] ="client_no";
        $p2_where['sign'] ="=";
        $p2_where['value'] =$client_no;

        $where[]=$p2_where;

        $p2_where['column_name'] ="expire_date";
        $p2_where['sign'] =">";
        $p2_where['value'] ="CURDATE()";

        $where[]=$p2_where;

        $firstjoin ['table_name'] = $this->details_table;
        $firstjoin ['first_column'] = $this->details_table.".company_id";
        $firstjoin ['second_column'] = $this->comapany_table . ".company_id";
        $leftjoin [] = $firstjoin;

        $get_company = $this->select_tb($this->comapany_table, $columns,$where,"","","","","",$leftjoin);

        if(is_array($get_company)){

            return $get_company['data'][0];

        } else {

            return $get_company;
        }

    }

    public function view_settings($company_id){

	    $column = array("settings_id","company_name","credit_single_limit", "enrol_no_limit");

        $p2_where['column_name'] =$this->settings_table.".company_id";
        $p2_where['sign'] ="=";
        $p2_where['value'] =$company_id;

        $where[]=$p2_where;

        $firstjoin ['table_name'] = $this->comapany_table;
        $firstjoin ['first_column'] = $this->comapany_table.".company_id";
        $firstjoin ['second_column'] = $this->settings_table . ".company_id";
        $leftjoin [] = $firstjoin;

        $get_company = $this->select_tb($this->settings_table, $column,$where,"","","","","",$leftjoin);

        if(is_array($get_company)){

            return $get_company['data'][0];

        } else {

            return $get_company;
        }



    }

    public function get_setting($company_id){

        $column = array("settings_id","credit_single_limit", "enrol_no_limit");

        $p2_where['column_name'] ="company_id";
        $p2_where['sign'] ="=";
        $p2_where['value'] =$company_id;

        $where[]=$p2_where;


        $get_company = $this->select_tb($this->settings_table, $column,$where);

        if(is_array($get_company)){

            return $get_company['data'][0];

        } else {

            return $get_company;
        }

    }

    public function edit_settings($company_id, $enrol_limit, $transaction_limit){

	    if (isset($company_id) && isset($enrol_limit) && isset($transaction_limit)){

	        if (is_numeric($company_id) && is_numeric($enrol_limit) && is_numeric($transaction_limit)){

	            $check_setting = $this->get_setting($company_id);

	            if (is_array($check_setting)){

                    $p2_where['column_name'] ="company_id";
                    $p2_where['sign'] ="=";
                    $p2_where['value'] =$company_id;

                    $where[]=$p2_where;

                    $ci_set['column_name'] = "credit_single_limit";
                    $ci_set['sign'] = "=";
                    $ci_set['value'] = $transaction_limit;

                    $set[] = $ci_set;

                    $ci_set['column_name'] = "enrol_no_limit";
                    $ci_set['sign'] = "=";
                    $ci_set['value'] = $enrol_limit;

                    $set[] = $ci_set;

	                $set_data = $this->update_data($this->settings_table, $set,$where);

	                if ($set_data == 1){
	                    $r_array['company_id'] = $company_id;
                        $r_array['enrol_limit'] = $enrol_limit;
                        $r_array['transaction_limit'] = $transaction_limit;
	                    return $r_array;

                    } else {

	                    return "Error updating";
                    }

                } else {

	                return "Invalid setting";
                }

            } else {

	            return "Parameters should be numeric";
            }


        } else {

	        return "Missing Parameter";
        }

    }

    private function create_setting ($company_id){

	    $column = array("company_id", "credit_single_limit", "enrol_no_limit");
	    $values = array($company_id, 0, 0);

	    $put_data = $this->insert_data($this->settings_table, $column,$values);

	    return $put_data;

    }
}// end class


//$page_test = new Reward_company();
//echo json_encode($page_test->create_setting(35));
//echo json_encode($page_test->edit_settings("1","ab", 600));
//echo json_encode($page_test->view_settings(10));
//echo json_encode($page_test->get_company_others(10));
//echo json_encode($page_test->get_company_details(10));
//echo json_encode($page_test->single_company_detail(3));
//echo json_encode($page_test->list_expire_active_company());
//echo json_encode($page_test->get_expiry_days());
//echo json_encode($page_test->change_portal_access(10, 1));
//echo json_encode($page_test->change_company_status(1,0));
//echo json_encode($page_test->edit_company(1,"test_23","XYZ"));
//echo json_encode($page_test->total_active_company());
//echo json_encode($page_test->create_period(10,"10 days"));
//echo json_encode($page_test->edit_period(2, "10","10 days" ));
//echo json_encode($page_test->view_period());
//echo json_encode($page_test->change_period_status(2,1));
//echo json_encode($page_test->view_active_plan());
//echo json_encode($page_test->list_all_company());
//echo json_encode($page_test->create_company("Test_Company11", 1, 1, "ace@spades.com","0812222222"));
//echo json_encode($page_test->check_company_token("1200"));