<?php
/**
 * Created by PhpStorm.
 * User: itmanager
 * Date: 14/08/2019
 * Time: 17:20
 */

require_once ("curl_class.php");
class discount_class extends curl_class
{
    private $token = '1234';
    private $end_point ='https://perxclm.com/rewardsbox/discount/v1/?API_flag=';
    private  $header;


    private function set_header(){

        //$header = array('content-type: multipart/form-data','token: ' . $this->master_token);
        $this->header=array(
            'Content-type= application/json',
            'token:'. $this->token
        );
        //return $this->header = array("key: " .$this->key,"content-type: application/json", "cache-control: no-cache");
    }

    public function get_states(){

        $this->set_header();


        $api = "get_states";

        $new_url = $this->end_point.$api;

        $get_states = $this->send_get($new_url,$this->header);

        if(is_array($get_states)){

            if($get_states['status_code'] == 1001){

                return $get_states['data'];
            } else {

                return "No data found";
            }


        } else {

            return "No States found";
        }

    }

    public function get_partners($state_id = null){

        $this->set_header();

        if(isset($state_id)){

            $api=  "all_partners&state_id=".$state_id;
        } else {
            $api = "all_partners";
        }
        $new_url = $this->end_point.$api;

        $get_partners = $this->send_get($new_url,$this->header);

        if(is_array($get_partners)){

            if($get_partners['status_code'] == 1001){

                return $get_partners['data'];
            } else {

                return "No data found";
            }


        } else {

            return "No Partner found";
        }

    }

    public function get_discounts($partner_id = 0){

        if(isset( $partner_id)) {
            $this->set_header();

            $api = "partner_discounts";

            $new_url = $this->end_point.$api;

            $body['partner_id'] = $partner_id;

            $get_discount = $this->send_post($new_url, $body, $this->header);

            if (is_array($get_discount)) {

                if ($get_discount['status_code'] == 1001) {

                    return $get_discount['data'];
                } else {

                    return "No data found";
                }


            } else {

                return "No Discount found";
            }
        } else {

            return "Partner ID required";
        }
    }


}

//$page_test = new discount_class();
//echo json_encode($page_test->get_states());
//echo json_encode($page_test->get_partners());
//echo json_encode($page_test->get_discounts(1));