<?php
require_once ('../includes/startsession.php');
require_once ('../classes/user_login_class.php');
require_once ('../classes/menu_class.php');
require_once ('../classes/category_class.php');
require_once ('../classes/company_class.php');
require_once ('../classes/purchase_class.php');
require_once ('../classes/partner_class.php');
require_once ('../classes/wallet_service_class.php');
$check_details = new Rewards_user_login_class();
//$check_details->start_session();
$get_details = $check_details->go_to_page();

include('../includes/head.php');




if(is_array($get_details)){

//{"create_access":"0","read_access":"0","update_access":"0","delete_access":"0"}
$use_category = new category_class();
$total_category = $use_category->total_active_category();

$use_company = new Reward_company();
$total_company = $use_company->total_active_company();

$use_purchase = new purchase_class();
$total_sales = $use_purchase->total_active_transactions();


$use_partner = new partner_class();
$total_partners = $use_partner->total_active_partners();


    if(isset($get_details['create_access'])) {

        $create = $get_details['create_access'];
        // add record script





        // end add record script


    } else {

        $create = 0;
    }

    if(isset($get_details['update_access'])) {

        $update = $get_details['update_access'];

        // update record script

        $use_wallet = new wallet_service_class();



        $get_balance = $use_partner->view_prepaid_wallet();
//        print_r($get_balance);
        if(is_array($get_balance)){
            $result_w ="";
            foreach ($get_balance as $balance){
                $result_w .="<tr>";
                $result_w .="<td>".$balance['partner_name']."</td>";
                $result_w .="<td>".$balance['current_balance']."</td>";
                $result_w .="</tr>";
            }


        }




        // end update record script

    } else {

        $update = 0;
    }

    if(isset($get_details['delete_access'])) {

        $delete = $get_details['delete_access'];

        // delete record script





        // delete add record script
    } else {

        $delete = 0;
    }

    if(isset($get_details['read_access'])) {

        $read = $get_details['read_access'];

        $list_transactions = $use_purchase->limit_transactions();

        if (is_array($list_transactions)){
            $result = "";
            foreach ($list_transactions['data'] as $transaction_data){

                if ($transaction_data['order_status'] == 1){

                    $order_status = "<span class=\"label label-primary\">Ordered</span>";
                } elseif($transaction_data['order_status'] == 2){

                    if($transaction_data['delivery_type'] =="Delivery"){

                        $order_status = "<span class=\"label label-warning\">Shipped</span>";

                    } else {

                        $order_status = "<span class=\"label label-primary\">Picked</span>";
                    }


                } elseif ($transaction_data['order_status'] ==3){

                    $order_status = "<span class=\"label label-success\">Delivered</span>";
                }
                elseif ($transaction_data['order_status'] ==0){

                    $order_status = "<span class=\"label label-danger\">Cancelled</span>";
                }
                $result .="<tr>";
                $result .="<td>".$transaction_data['order_no']."</td>";
                $result .="<td>".$transaction_data['company_name']."</td>";
                $result .="<td>".$transaction_data['item_code']."</td>";
                $result .="<td>".$transaction_data['item_name']."</td>";
                $result .="<td>".$transaction_data['unit_price']."</td>";
                $result .="<td>".$transaction_data['unit_cost_price']."</td>";
                $result .="<td>".$transaction_data['quantity']."</td>";
                //$result .="<td>".$transaction_data['profit']."</td>";
                $result .="<td><span class=\"label label-success\">".$transaction_data['delivery_type']."</span></td>";
                $result .="<td>$order_status</td>";
                $result .="<td>".$transaction_data['create_date']."</td>";
                $result .="</tr>";

            }

        }




        $use_purchase = new purchase_class();

        $get_items = $use_purchase->frequently_ordered();
        if(is_array($get_items)){
            $result_f ="";
            foreach ($get_items as $items){
                $result_f .="<tr>";
                $result_f .="<td>".$items['item_name']."</td>";
                $result_f .="<td>".$items['no_of_items']."</td>";
                $result_f .="</tr>";
            }


        }

    } else {

        $read = 0;
    }



    $menu = new menu_class();
    $list_menu = $menu->show_user_menu($_SESSION['role_id']);

?>

<!DOCTYPE html>
<html>
<head lang="en">
	<meta charset="UTF-8">
	<meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=no">
	<meta http-equiv="x-ua-compatible" content="ie=edge">
	<title>Rewards Box</title>
	


</head>
<body class="with-side-menu">

<?php include('../includes/header.php'); ?><!--.site-header-->

	<div class="mobile-menu-left-overlay"></div>
    <nav class="side-menu">
        <?php echo $list_menu; ?><!--.side-menu-->
    </nav>



<div class="page-content">
    <div class="container-fluid">
        <div class="row">
            <!--
            <div class="col-xl-6">
                <div class="chart-statistic-box">
                    <div class="chart-txt">
                        <div class="chart-txt-top">
                            <p><span class="unit">$</span><span class="number">1540</span></p>
                            <p class="caption">Week income</p>
                        </div>
                        <table class="tbl-data">
                            <tr>
                                <td class="price color-purple">120$</td>
                                <td>Orders</td>
                            </tr>
                            <tr>
                                <td class="price color-yellow">15$</td>
                                <td>Investments</td>
                            </tr>
                            <tr>
                                <td class="price color-lime">55$</td>
                                <td>Others</td>
                            </tr>
                        </table>
                    </div>
                    <div class="chart-container">
                        <div class="chart-container-in">
                            <div id="chart_div"></div>
                            <header class="chart-container-title">Income</header>
                            <div class="chart-container-x">
                                <div class="item"></div>
                                <div class="item">tue</div>
                                <div class="item">wed</div>
                                <div class="item">thu</div>
                                <div class="item">fri</div>
                                <div class="item">sat</div>
                                <div class="item">sun</div>
                                <div class="item">mon</div>
                                <div class="item"></div>
                            </div>
                            <div class="chart-container-y">
                                <div class="item">300</div>
                                <div class="item"></div>
                                <div class="item">250</div>
                                <div class="item"></div>
                                <div class="item">200</div>
                                <div class="item"></div>
                                <div class="item">150</div>
                                <div class="item"></div>
                                <div class="item">100</div>
                                <div class="item"></div>
                                <div class="item">50</div>
                                <div class="item"></div>
                            </div>
                        </div>
                    </div>
                </div><!--.chart-statistic-box-->
            <!--</div> --><!--.col-->

            <div class="col-xl-12">
                <div class="row">
                    <div class="col-sm-3">
                        <article class="statistic-box red">
                            <div>
                                <div class="number"><?php echo $total_partners['total']; ?></div>
                                <div class="caption"><div>Total Active<br/>Partners</div></div>
                                <div class="percent">
                                    <div class="arrow up"></div>
                                    <!--<p>15%</p>-->
                                </div>
                            </div>
                        </article>
                    </div><!--.col-->
                    <div class="col-sm-3">
                        <article class="statistic-box purple">
                            <div>
                                <div class="number"><?php echo $total_company['total']; ?></div>
                                <div class="caption"><div>Total Active<br/>Companies</div></div>
                                <div class="percent">
                                    <div class="arrow up"></div>
                                    <!--<p>11%</p>-->
                                </div>
                            </div>
                        </article>
                    </div><!--.col-->
                    <div class="col-sm-3">
                        <article class="statistic-box yellow">
                            <div>
                                <div class="number"><?php echo $total_category['total']; ?></div>
                                <div class="caption"><div>Total Active<br/>Categories</div></div>
                                <div class="percent">
                                    <div class="arrow up"></div>
                                    <!--<p>5%</p>-->
                                </div>
                            </div>
                        </article>
                    </div><!--.col-->
                    <div class="col-sm-3">
                        <article class="statistic-box green">
                            <div>
                                <div class="number"><?php echo $total_sales['total']; ?></div>
                                <div class="caption"><div>Total <br/>Sales</div></div>
                                <div class="percent">
                                    <div class="arrow up"></div>
                                    <!--<p>84%</p>-->
                                </div>
                            </div>
                        </article>
                    </div><!--.col-->
                </div><!--.row-->
            </div><!--.col-->
        </div><!--.row-->

        <?php if ($read == 1) { ?>
        <div class="row">
            <div class="col-xl-12 dahsboard-column">
                <section class="box-typical box-typical-dashboard panel panel-default scrollable">
                    <header class="box-typical-header panel-heading">
                        <h3 class="panel-title">Recent Transactions</h3>
                    </header>
                    <div class="box-typical-body panel-body">
                        <table class="tbl-typical">
                            <tr>
                                <th><div>Order No</div></th>
                                <th>Company</th>
                                <th>Item Code</th>
                                <th><div>Item Name</div></th>
                                <th><div>Unit Redeem Price</div></th>
                                <th><div>Unit Cost Price</div></th>
                                <th><div>Qty</div></th>
                                <!--<th><div>Profit</div></th>-->
                                <th><div>Delivery Type</div></th>
                                <th><div>Order Status</div></th>
                                <th><div>Date</div></th>
                            </tr>

                                <?php echo $result; ?>
<!--
                            <tr>
                                <td>
                                    <span class="label label-primary">Paid</span>
                                    <span class="label label-success">Active</span>
                                </td>
                                <td>Company A</td>
                                <td>1234567890</td>
                                <td>John Doe</td>
                                <td align="center">3435362</td>
                                <td class="color-blue-grey" nowrap align="center"><span class="semibold">Today</span> 8:30</td>
                            </tr>
                            <tr>
                                <td>
                                    <span class="label label-primary">Paid</span>
                                    <span class="label label-success">Active</span>
                                </td>
                                <td>Company A</td>
                                <td>1234567890</td>
                                <td>Thomas Bayer</td>
                                <td align="center">3435362</td>
                                <td class="color-blue-grey" nowrap align="center"><span class="semibold">Today</span> 16:30</td>
                            </tr>
                            <tr>
                                <td>
                                    <span class="label label-primary">Paid</span>
                                    <span class="label label-default">Inactive</span>
                                </td>
                                <td>Company A</td>
                                <td>1234567890</td>
                                <td>Nicolas Karabat</td>
                                <td align="center">3435362</td>
                                <td class="color-blue-grey" nowrap align="center"><span class="semibold">Yesterday</span></td>
                            </tr>
                            <tr>
                                <td>
                                    <span class="label label-default">Unpaid</span>
                                    <span class="label label-default">Inactive</span>
                                </td>
                                <td>Company A</td>
                                <td>1234567890</td>
                                <td>Alexandre Pome</td>
                                <td align="center">3435362</td>
                                <td class="color-blue-grey" nowrap align="center">23th May</td>
                            </tr>
                            <tr>
                                <td>
                                    <span class="label label-primary">Paid</span>
                                    <span class="label label-success">Active</span>
                                </td>
                                <td>Company A</td>
                                <td>1234567890</td>
                                <td>John Doe</td>
                                <td align="center">3435362</td>
                                <td class="color-blue-grey" nowrap align="center"><span class="semibold">Today</span> 8:30</td>
                            </tr>
                            <tr>
                                <td>
                                    <span class="label label-primary">Paid</span>
                                    <span class="label label-success">Active</span>
                                </td>
                                <td>Company A</td>
                                <td>1234567890</td>
                                <td>Thomas Bayer</td>
                                <td align="center">3435362</td>
                                <td class="color-blue-grey" nowrap align="center"><span class="semibold">Today</span> 16:30</td>
                            </tr>
                            <tr>
                                <td>
                                    <span class="label label-primary">Paid</span>
                                    <span class="label label-default">Inactive</span>
                                </td>
                                <td>Company A</td>
                                <td>1234567890</td>
                                <td>Nicolas Karabat</td>
                                <td align="center">3435362</td>
                                <td class="color-blue-grey" nowrap align="center"><span class="semibold">Yesterday</span></td>
                            </tr>
                            <tr>
                                <td>
                                    <span class="label label-default">Unpaid</span>
                                    <span class="label label-default">Inactive</span>
                                </td>
                                <td>Company A</td>
                                <td>1234567890</td>
                                <td>Alexandre Pome</td>
                                <td align="center">3435362</td>
                                <td class="color-blue-grey" nowrap align="center">23th May</td>
                            </tr>

                            -->
                        </table>
                    </div><!--.box-typical-body-->
                </section><!--.box-typical-dashboard-->




            </div><!--.col-->
        </div>


            <div class="row">
                <div class="col-md-6 dahsboard-column">


                    <section class="box-typical box-typical-dashboard panel panel-default scrollable">
                        <header class="box-typical-header panel-heading">
                            <h3 class="panel-title">Partner Wallet Balance</h3>
                        </header>
                        <div class="box-typical-body panel-body">
                            <table class="tbl-typical">
                                <tr>
                                    <th><div>Partner</div></th>
                                    <th><div>Balance</div></th>

                                </tr>
                                <?php echo $result_w; ?>

                            </table>
                        </div><!--.box-typical-body-->
                    </section><!--.box-typical-dashboard-->
                </div>

                <div class="col-md-6 dahsboard-column">


                    <section class="box-typical box-typical-dashboard panel panel-default scrollable">
                        <header class="box-typical-header panel-heading">
                            <h3 class="panel-title">Fequently Ordered</h3>
                        </header>
                        <div class="box-typical-body panel-body">
                            <table class="tbl-typical">
                                <tr>
                                    <th><div>Item Name</div></th>
                                    <th><div>No of Orders</div></th>

                                </tr>
                                <tr>

                                    <?php echo $result_f; ?>
                                </tr>

                            </table>
                        </div><!--.box-typical-body-->
                    </section><!--.box-typical-dashboard-->
                </div>




            </div>

        <?php }?>
    </div><!--.container-fluid-->
</div><!--.page-content-->
	


<?php include('../includes/script-chart.php'); ?>
<script>
    $(function() {
        var table = $('#example').DataTable({
            scrollX:        true,
            scrollCollapse: true,
            paging:         true,
            fixedColumns:   true
        });

        var table = $('#example1').DataTable({
            scrollY:        "300px",
            scrollX:        true,
            scrollCollapse: true,
            paging:         false,
            fixedColumns:   {
                leftColumns: 2
            }
        });

        setTimeout(function() {
            table.draw();
        }, 50);

    });




</script>

</body>
</html>


<?php } // close if array?>

