<?php
require_once ('../includes/startsession.php');
require_once ('../classes/user_login_class.php');
require_once ('../classes/menu_class.php');
require_once ('../classes/company_class.php');

$check_details = new Rewards_user_login_class();
//$check_details->start_session();
$get_details = $check_details->go_to_page();
include('../includes/head-datatable.php');




if(is_array($get_details)){
//{"create_access":"0","read_access":"0","update_access":"0","delete_access":"0"}
    $use_company = new Reward_company();



    $plan_options = $use_company->view_active_plan();
    if(is_array($plan_options)) {
        $p_plan = "";
        foreach ($plan_options as $plan){

            $p_plan .= '<option value="'.$plan['plan_id'].'">'.$plan['plan_name'].'</option>';

        }

    }

    $period_options = $use_company->view_active_period();
    if(is_array($period_options)) {
        $p_period = "";
        foreach ($period_options as $period){

            $p_period .= '<option value="'.$period['period_id'].'">'.$period['period_text'].'</option>';

        }

    }

    if(isset($get_details['create_access'])) {

        $create = $get_details['create_access'];
        // add record script





        // end add record script


    } else {

        $create = 0;
    }

    if(isset($get_details['update_access'])) {

        $update = $get_details['update_access'];

        // update record script





        // end update record script

    } else {

        $update = 0;
    }

    if(isset($get_details['delete_access'])) {

        $delete = $get_details['delete_access'];

        // delete record script





        // delete add record script
    } else {

        $delete = 0;
    }

    if(isset($get_details['read_access'])) {

        $read = $get_details['read_access'];

        // view record script

        $show_result=$use_company->list_all_company();

        if (is_array($show_result)){
            //echo json_encode($show_color);
            $show_data = "";
            foreach ($show_result as $result){
                //echo $color['color'];
                $data = "";
                $data .= '<tr>';
                $data .= '<td><span class="company_name" data-item ="' . $result['company_id'] . '">'.ucfirst($result['company_name']).'</span></td>';
                $data .= '<td><span class="client_no" data-item ="' . $result['company_id'] . '">'.$result['client_no'].'</span></td>';
                $data .= '<td><span class="prefix" data-item ="' . $result['company_id'] . '">'.$result['prefix'].'</span></td>';
                $data .= '<td><span class="expire_date" data-item ="' . $result['company_id'] . '">'.ucfirst($result['expire_date']).'</span></td>';


                $data.='<td>';
                if ($result['status'] == 1){
                    $data .='<span class="label_tag" data-item="'.$result['company_id'].'"><span class="label label-success">Active</span></span>';
                } else {
                    $data .='<span class="label_tag" data-item="'.$result['company_id'].'"><span class="label label-danger">Inactive</span></span>';


                }
                $data.='</td>';

                $data .= '<td>';

                if ($update == 1) {
                    $data .= '<a href="#" data-toggle="modal" data-target="#edit_modal" class="edit_modal_btn" data-item ="' . $result['company_id'] . '"><i class="fa fa-edit"></i></a>';
                } else {
                    $data.='&nbsp;';
                }

                if ($delete == 1) {
                    if ($result['status'] == 1) {
                        $data .= '&nbsp;&nbsp;&nbsp;<span class="del_icon" data-item="' . $result['company_id'] . '"><a href="#" data-status = 0 class="del_btn" id="' . $result['company_id'] . '"><i class="fa fa-close" style="color:red;"></i></a></span>';
                    } else {

                        $data .= '&nbsp;&nbsp;&nbsp;<span class="del_icon" data-item="' . $result['company_id'] . '"><a href="#" data-status = 1 class="del_btn" id="' . $result['company_id'] . '"><i class="fa fa-check" style="color:green;"></i></a></span>';
                    }

                }{
                    $data.='&nbsp;';
                }

                $data.='</td>';
                $data.='</tr>';

                $show_data = $show_data.$data;
            }



        } else {

            $show_data = "";
        }
        //echo $show_data;


        // end view record script





    } else {

        $read = 0;
    }



    $menu = new menu_class();
    $list_menu = $menu->show_user_menu($_SESSION['role_id']);
    ?>

    <!DOCTYPE html>
    <html>
    <head lang="en">
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=no">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>Rewards Box</title>

        <?php include('../includes/head-datatable.php'); ?>

    </head>
    <body class="with-side-menu">

    <?php include('../includes/header.php'); ?><!--.site-header-->

    <div class="mobile-menu-left-overlay"></div>
    <nav class="side-menu">
        <?php echo $list_menu; ?><!--.side-menu-->
    </nav>



    <div class="page-content">
        <div class="container-fluid">
            <header class="section-header">
                <div class="tbl">
                    <div class="tbl-row">
                        <div class="tbl-cell">
                            <h3>Company</h3>

                        </div>
                    </div>
                </div>
            </header>

            <?php if ($create == 1) { ?>
                <div class="box-typical box-typical-padding">


                    <h5 class="m-t-lg with-border">Add Company</h5>

                    <form>

                        <div class="row">
                            <div class="col-md-6">

                                <div class="form-group ">
                                    <label class="form-label">Company</label>

                                    <p class="form-control-static"><input type="text" class="form-control" id="company" placeholder="Company Name"></p>

                                </div>

                                <div class="form-group ">
                                    <label class="form-label">Voucher Prefix</label>

                                    <p class="form-control-static"><input type="text" class="form-control" id="prefix" placeholder="RB"></p>

                                </div>

                                <div class="form-group">
                                    <label class="form-label">Email</label>

                                    <p class="form-control-static"><input type="text" class="form-control" id="email" placeholder="john@gmail.com"></p>

                                </div>

                                <div class="form-group">
                                    <label class="form-label">Upload Company Logo</label>

                                    <p class="form-control-static"><input type="file" class="form-control" id="logo" placeholder="john@gmail.com"></p>

                                </div>

                            </div>


                            <div class="col-md-6">

                                <div class="form-group ">
                                    <label class="form-label">Phone no</label>

                                    <p class="form-control-static"><input type="number" class="form-control" id="phone_no" placeholder="08121239934"></p>

                                </div>


                                <div class="form-group ">
                                    <label class="form-label">Plan</label>

                                    <select class="select2 select2-arrow manual select2-no-search-arrow" id="plan">
                                        <?php echo $p_plan; ?>
                                    </select>

                                </div>
                                <div class="form-group">
                                    <label class="form-label">Licence Period</label>

                                    <select class="select2 select2-arrow manual select2-no-search-arrow" id="period">
                                        <?php echo $p_period; ?>
                                    </select>
                                </div>
                            </div>

                        </div>

                    </form>
                    <div class="row border-top">
                        <div class="col-md-10"></div>
                        <div class="col-md-2">
                            <div class="float-right">
                                <br>
                                <button type="button" id="create" class="btn btn-inline btn-primary float-right">Add</button>
                            </div>
                        </div>
                    </div>



                </div><!--.box-typical-->
            <?php } // close create if?>

            <?php if ($read == 1){?>
                <section class="card">
                    <div class="card-block">
                        <table id="example" class="stripe row-border order-column display table table-striped table-bordered" cellspacing="0" width="100%">
                            <thead>
                            <tr>
                                <th>Company</th>
                                <th>Client No</th>
                                <th>Voucher Prefix</th>
                                <th>Expiry Date</th>
                                <th>Status</th>
                                <th>Action</th>
                            </tr>
                            </thead>
                            <tbody id="item_show">

                            <?php echo $show_data; ?>


                            </tbody>
                        </table>
                    </div>
                </section>
            <?php } // close read?>
        </div><!--.container-fluid-->
    </div><!--.page-content-->

    <div id="edit_modal" class="modal fade bd-example-modal-lg"
         tabindex="-1"
         role="dialog"
         aria-labelledby="myLargeModalLabel"
         aria-hidden="true">
        <div class="modal-dialog modal-lg">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="modal-close" data-dismiss="modal" aria-label="Close">
                        <i class="font-icon-close-2"></i>
                    </button>
                    <h4 class="modal-title" id="myModalLabel">Edit Company</h4>
                </div>
                <div class="modal-body">

                    <form>

                        <!--                                        <div class="col-md-6">-->

                        <div class="form-group ">
                            <label class="form-label">Company</label>

                            <p class="form-control-static"><input type="text" class="form-control" id="edit_company" placeholder="Company Name"></p>

                        </div>

                        <div class="form-group ">
                            <label class="form-label">Voucher Prefix</label>

                            <p class="form-control-static"><input type="text" class="form-control" id="edit_prefix" placeholder="RB"></p>

                        </div>

                        <div class="form-group">
                            <label class="form-label">Change Company Logo</label>

                            <p class="form-control-static"><input type="file" class="form-control" id="editlogo" placeholder=""></p>

                        </div>

                        <!--                                            <div class="form-group">-->
                        <!--                                                <label class="form-label">Email</label>-->
                        <!---->
                        <!--                                                <p class="form-control-static"><input type="text" class="form-control" id="edit_email" placeholder="john@gmail.com"></p>-->
                        <!---->
                        <!--                                            </div>-->

                        <!--                                        </div>-->

                        <!---->
                        <!--                                        <div class="col-md-6">-->
                        <!---->
                        <!--                                            <div class="form-group ">-->
                        <!--                                                <label class="form-label">Phone no</label>-->
                        <!---->
                        <!--                                                <p class="form-control-static"><input type="number" class="form-control" id="edit_phone_no" placeholder="08121239934"></p>-->
                        <!---->
                        <!--                                            </div>-->


                    </form>


                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-rounded btn-default" data-dismiss="modal">Close</button>
                    <button type="button" class="btn btn-rounded btn-primary" id="edit_btn" data-myedit ="<?php echo $company_id?>" >Save changes</button>
                </div>
            </div>
        </div>
    </div><!--.modal-->


    <?php include('../includes/script-datatable.php'); ?>
    <script>
        $(function() {
            var table = $('#example').DataTable({
                scrollX:        true,
                scrollCollapse: true,
                paging:         true,
                fixedColumns:   true
            });

            var table = $('#example1').DataTable({
                scrollY:        "300px",
                scrollX:        true,
                scrollCollapse: true,
                paging:         false,
                fixedColumns:   {
                    leftColumns: 2
                }
            });

            setTimeout(function() {
                table.draw();
            }, 50);

        });


        $('.page-content').on('change', '#logo', function () {

            let company_id= $('#company_id').val();
            // let file = $('#color').val();
            let logo = 1;
            var file1 = this.files[0];
            var form_data = new FormData();
            form_data.append('file', file1);
            form_data.append('company_id', company_id);
            form_data.append('logo', logo);

            //alert(form_data);

            $.ajax({
                type: "POST",
                url: "../data/upload_data.php",
                //data: 'form_data',
                cache: false,
                contentType: false,
                processData: false,
                data: form_data,
                // type: 'post',
                dataType: 'json',

                success: function(msg){



                    // var test1 = jQuery.parseJSON(msg);
                    // console.log(msg);
                    if(msg.status == 1){
//alert(msg.data.group_id);
                        // console.log(msg);

                        $.notify({
                            icon: 'font-icon font-icon-check-circle',
                            title: '<strong>Success!</strong>',
                            message: 'Logo Upload Successful'
                        }, {
                            type: 'success'
                        });

                        // location.reload();

                        // $('#child_id').html(option);

                    } else {

                        $.notify({
                            icon: 'glyphicon glyphicon-alert',
                            title: '<strong>Error!</strong>',
                            message: msg.message
                        }, {
                            type: 'danger'
                        });
                        //alert("No data found");
                    }
                }

            });
            return false;

        });


        $('.modal-body').on('change', '#editlogo', function () {

            let company_id= $('#company_id').val();
            // let file = $('#color').val();
            let logo = 1;
            var file1 = this.files[0];
            var form_data = new FormData();
            form_data.append('file', file1);
            form_data.append('company_id', company_id);
            form_data.append('logo', logo);

            //alert(form_data);

            $.ajax({
                type: "POST",
                url: "../data/upload_data.php",
                //data: 'form_data',
                cache: false,
                contentType: false,
                processData: false,
                data: form_data,
                // type: 'post',
                dataType: 'json',

                success: function(msg){



                    // var test1 = jQuery.parseJSON(msg);
                    // console.log(msg);
                    if(msg.status == 1){
//alert(msg.data.group_id);
                        // console.log(msg);

                        // $.notify({
                        //     icon: 'font-icon font-icon-check-circle',
                        //     title: '<strong>Success!</strong>',
                        //     message: 'Logo Upload Successful'
                        // }, {
                        //     type: 'success'
                        // });

                        // location.reload();

                        // $('#child_id').html(option);

                        alert("Logo Updated");

                    } else {

                        // $.notify({
                        //     icon: 'glyphicon glyphicon-alert',
                        //     title: '<strong>Error!</strong>',
                        //     message: msg.message
                        // }, {
                        //     type: 'danger'
                        // });

                        alert(msg.message);
                        //alert("No data found");
                    }
                }

            });
            return false;

        });


        $('#create').click (function () {

            let company = $('#company').val();
            let prefix = $('#prefix').val();
            let email = $('#email').val();
            let phone = $('#phone_no').val();
            let plan = $('#plan').val();
            let period = $('#period').val();
            let logo = $('#logo').val();

            let action = "add";

            if (company == ""){

                alert("Enter Company Name");

                return false;
            }
            else if (prefix == ""){

                alert("Enter Prefix");

                return false;
            } else if (email == ""){

                alert("Enter Email");

                return false;
            }
            else if (phone== ""){

                alert("Enter Phone Number");

                return false;
            }
            else if (plan == ""){

                alert("Select Plan");

                return false;
            }
            else if (period == ""){

                alert("Select Licence Period");

                return false;
            }else {

                $.ajax({
                    type: "POST",
                    url: "../scripts/company.php",
                    data: {company:company, prefix:prefix, email:email, phone:phone, plan:plan, period:period, logo:logo, action:action},
                    dataType: 'json',

                    success: function(msg){
                        //alert(msg.status);
                        console.log(msg);
                        if (msg.status == 1) {

                            let column_1 ='<span class="company_name" data-item ="'+msg.data.id+'">'+msg.data.company_name+'</span>';
                            let column_2 ='<span class="client_no" data-item ="'+msg.data.id+'">'+msg.data.client_no+'</span>';
                            let column_5 ='<span class="prefix" data-item ="'+msg.data.id+'">'+msg.data.prefix+'</span>';
                            let column_6 ='<span class="expire_date" data-item ="'+msg.data.id+'">'+msg.data.expire_Date+'</span>';

                            let column_3 ='<span class="label_tag" data-item="'+msg.data.id+'"><span class="label label-success" data-item="'+msg.data.id+'">Active</span></span>';

                            let part_4 = '&nbsp';
                            if (msg.iedit == 1) {
                                part_4='<a href="#" data-toggle="modal" data-target="#edit_modal" class="edit_modal_btn" data-item ="'+msg.data.id+'"><i class="fa fa-edit"></i></a>';
                            }

                            let part2_4 = '&nbsp';

                            if (msg.idelete == 1) {
                                part2_4= '&nbsp;&nbsp;&nbsp;<span class="del_icon" data-item ="'+msg.data.id+'"><a href="#" data-status = 0 class="del_btn" id="'+msg.data.id+'"><i class="fa fa-close" style="color:red;"></i></a>';
                            }
                            let column_4 =part_4+part2_4;
                            let table = $('#example').DataTable();

                            let rowNode = table
                                .row.add( [ column_1, column_2, column_5, column_6, column_3,column_4 ] )
                                .draw();

                            $.notify({
                                icon: 'font-icon font-icon-check-circle',
                                title: '<strong>Success!</strong>',
                                message: 'Company added'
                            },{
                                type: 'success'
                            });
                            $('#color').val('');
                            //$("#item_show").prepend(data);
                            //$("#example").DataTable('refresh');
                            //table.row.add(data);
                        }

                        else {
                            $.notify({
                                icon: 'glyphicon glyphicon-alert',
                                title: '<strong>Error!</strong>',
                                message: msg.message
                            },{
                                type: 'danger'
                            });
                            // $('#loading_image').remove();
                            // $('#btnlogin').show();
                        }

                    }

                });

                return false;
            }
        });



        $('.page-content').on('click', '.edit_modal_btn', function () {
            $('#edit_color').val('');
            let item_id = $(this).attr('data-item');

            let company = $("span[class='company_name'][data-item='" + item_id + "']").html();
            let prefix = $("span[class='prefix'][data-item='" + item_id + "']").html();
            // let email = $("span[class='email'][data-item='" + item_id + "']").html();
            // let phone = $("span[class='phone'][data-item='" + item_id + "']").html();

            $('#edit_btn').data('myedit',item_id);
            //console.log( $('#edit_btn').data('myedit'));

            $('#edit_company').val(company);
            $('#edit_prefix').val(prefix);
            // $('#edit_email').val(email);
            // $('#edit_phone_no').val(phone);

        });


        $('#edit_btn').click (function () {
            let item_id = $('#edit_btn').data('myedit');
            let company = $('#edit_company').val();
            let prefix = $('#edit_prefix').val();
            let logo = $('#editlogo').val();
            // let email = $('#edit_email').val();
            // let phone = $('#edit_phone_no').val();

            let action = "edit";

            if (company == ""){

                alert("Enter Company Name");

                return false;
            }
            else if (prefix == ""){

                alert("Enter Prefix");

                return false;
            }
            // else if (email == ""){
            //
            //     alert("Enter Email");
            //
            //     return false;
            // }
            // else if (phone == ""){
            //
            //     alert("Enter Phone");
            //
            //     return false;
            // }
            else {

                $.ajax({
                    type: "POST",
                    url: "../scripts/company.php",
                    data: {company: company, prefix:prefix, logo:logo, item_id: item_id, action:action},
                    dataType: 'json',

                    success: function(msg){
                        //alert(msg.status);
                        if (msg.status == 1) {

                            $("span[class='company_name'][data-item='" + item_id + "']").html(company);
                            $("span[class='prefix'][data-item='" + item_id + "']").html(prefix);
                            // $("span[class='email'][data-item='" + item_id + "']").html(email);
                            // $("span[class='phone'][data-item='" + item_id + "']").html(phone);

                            $('#edit_modal').modal('toggle');

                            $.notify({
                                icon: 'font-icon font-icon-check-circle',
                                title: '<strong>Success!</strong>',
                                message: 'Company updated'
                            },{
                                type: 'success'
                            });
                        }

                        else {
                            //alert(msg.message);
                            $('#edit_modal').modal('toggle');

                            $.notify({
                                icon: 'glyphicon glyphicon-alert',
                                title: '<strong>Error!</strong>',
                                message: msg.message
                            },{
                                type: 'danger'
                            });
                            // $('#loading_image').remove();
                            // $('#btnlogin').show();
                        }

                    }

                });

                return false;
            }




        });



        //$('.del_btn').click (function () {
        $('.page-content').on('click', '.del_btn', function () {
            let item_id = $(this).attr('id');
            let item_status = $(this).data('status');
            let action ='delete';

            $.ajax({
                type: "POST",
                url: "../scripts/company.php",
                data: {status: item_status, item_id: item_id, action:action},
                dataType: 'json',

                success: function(msg){

                    if (msg.status == 1) {
                        let del_icon ="";

                        if (item_status == 0){
                            $("span[class='label_tag'][data-item='"+item_id+"']").html('<span class="label label-danger">Inactive</span>');
                            del_icon ='<a href="#" data-status = 1 class="del_btn" id="'+item_id+'"><i class="fa fa-check" style="color:green;"></i></a>';
                        } else {
                            $("span[class='label_tag'][data-item='"+item_id+"']").html('<span class="label label-success">Active</span>');
                            del_icon ='<a href="#" data-status = 0 class="del_btn" id="'+item_id+'"><i class="fa fa-close" style="color:red;"></i></a>';

                        }
                        $("span[class='del_icon'][data-item='" + item_id + "']").html(del_icon);

                        $.notify({
                            icon: 'font-icon font-icon-check-circle',
                            title: '<strong>Success!</strong>',
                            message: msg.message
                        },{
                            type: 'success'
                        });
                    }

                    else {
                        $.notify({
                            icon: 'glyphicon glyphicon-alert',
                            title: '<strong>Error!</strong>',
                            message: msg.message
                        },{
                            type: 'danger'
                        });

                    }

                }

            });

            return false;


        });
    </script>

    </body>
    </html>


<?php } // close if array?>

