<!DOCTYPE html>
<html>
<head lang="en">
	<meta charset="UTF-8">
	<meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=no">
	<meta http-equiv="x-ua-compatible" content="ie=edge">
	<title>Rewards Box</title>

	<link href="img/favicon.144x144.png" rel="apple-touch-icon" type="image/png" sizes="144x144">
	<link href="img/favicon.114x114.png" rel="apple-touch-icon" type="image/png" sizes="114x114">
	<link href="img/favicon.72x72.png" rel="apple-touch-icon" type="image/png" sizes="72x72">
	<link href="img/favicon.57x57.png" rel="apple-touch-icon" type="image/png">
	<link href="img/favicon.png" rel="icon" type="image/png">
	<link href="img/favicon.ico" rel="shortcut icon">

	<!-- HTML5 shim and Respond.js for IE8 support of HTML5 elements and media queries -->
	<!--[if lt IE 9]>
	<script src="https://oss.maxcdn.com/html5shiv/3.7.2/html5shiv.min.js"></script>
	<script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
	<![endif]-->
<link rel="stylesheet" href="css/separate/pages/login.min.css">
    <link rel="stylesheet" href="css/lib/font-awesome/font-awesome.min.css">
    <link rel="stylesheet" href="css/lib/bootstrap/bootstrap.min.css">
    <link rel="stylesheet" href="css/main.css">
</head>
<body>

    <div class="page-center">
        <div class="page-center-in reset-bg">
            <div class="container-fluid">
                <form class="sign-box">
                    <div class="sign-avatar">
                        <img src="img/logo-2.png" alt="">
                    </div>
                    <header class="sign-title purple-text">Reset Password</header>
                    <div class="form-group">
                        <input type="text" class="form-control" id="email" placeholder="E-Mail"/>
                    </div>
                    <div class="form-group">

                        <div class="float-right reset">
                            <a href="index.php" class="grey-text">Back to homepage <i class="fa fa-arrow-left"></i></a>
                        </div>
                    </div>
                    <button type="submit" class="btn btn-rounded btn-purple" id="create">Reset Password</button>

                </form>
            </div>
        </div>
    </div><!--.page-center-->


<script src="js/lib/jquery/jquery-3.2.1.min.js"></script>
<script src="js/lib/popper/popper.min.js"></script>
<script src="js/lib/tether/tether.min.js"></script>
<script src="js/lib/bootstrap/bootstrap.min.js"></script>
<script src="js/plugins.js"></script>
    <script type="text/javascript" src="js/lib/match-height/jquery.matchHeight.min.js"></script>
    <script>
        $(function() {
            $('.page-center').matchHeight({
                target: $('html')
            });

            $(window).resize(function(){
                setTimeout(function(){
                    $('.page-center').matchHeight({ remove: true });
                    $('.page-center').matchHeight({
                        target: $('html')
                    });
                },100);
            });

            $('#create').click (function () {


                let email = $('#email').val();
                // let npassword = $('#npassword').val();
                // let cnpassword = $('#cnpassword').val();
                let action = "add";

                if (email == ""){

                    alert("Enter Email");
                    return false;
                }
                else {

                    $.ajax({
                        type: "POST",
                        url: "scripts/forgot_password.php",
                        data: {email: email, action:action},
                        dataType: 'json',

                        success: function(msg){
                            //alert(msg.status);
                            if (msg.status == 1) {

                                alert("Email Sent");
                                location.reload();
                              
                            }

                            else {

                                alert(msg.message);
                            //     $.notify({
                            //         icon: 'font-icon font-icon-check-circle',
                            //         title: '<strong>Success!</strong>',
                            //         message: 'Email Sent'
                            //     },{
                            //         type: 'success'
                            //     });
                            //     // $('#color').val('');
                            //     //$("#item_show").prepend(data);
                            //     //$("#example").DataTable('refresh');
                            //     //table.row.add(data);

                            //     // location.reload();
                            // }

                            // else {
                            //     $.notify({
                            //         icon: 'glyphicon glyphicon-alert',
                            //         title: '<strong>Error!</strong>',
                            //         message: msg.message
                            //     },{
                            //         type: 'danger'
                            //     });
                                // $('#loading_image').remove();
                                // $('#btnlogin').show();
                            }

                        }

                    });

                    return false;
                }
            });


        });
    </script>
<script src="js/app.js"></script>
</body>
</html>