<?php

require_once ('../includes/startsession.php');

if (isset($_SESSION['user_id'])) {
require_once ('../classes/user_login_class.php');
require_once ('../classes/category_lv2_class.php');

$check_details = new Rewards_user_login_class();

$get_details = $check_details->script_access();
$get_child = new category_lv2_class();
if(is_array($get_details)) {
//{"create_access":"0","read_access":"0","update_access":"0","delete_access":"0"}
    if (isset($get_details['create_access'])) {

        $create = $get_details['create_access'];

    } else {

        $create = 0;
    }

    if (isset($get_details['read_access'])) {

        $read = $get_details['read_access'];

    } else {

        $read = 0;
    }

    if (isset($get_details['update_access'])) {

        $update = $get_details['update_access'];

    } else {

        $update = 0;
    }

    if (isset($get_details['delete_access'])) {

        $delete = $get_details['delete_access'];

    } else {

        $delete = 0;
    }


    if (isset($_POST['action'])){
        $action = $_POST['action'];

        if($action == 'add'){
            if ($create == 1){

                if(isset($_POST['category']) && isset($_POST['child'])){

                    if ($_POST['category'] == ""){

                        $response_array['status'] = 0;
                        $response_array['message'] ="Blank Parent";

                    }

                    elseif ($_POST['child'] == ""){

                        $response_array['status'] = 0;
                        $response_array['message'] ="Blank Child Category Name";

                    }
                    else {
                        $child = strtolower(trim($_POST['child']));
                        $p_category= strtolower(trim($_POST['category']));
                        $add_child = $get_child->create_lv2_category($p_category,$child);

                        //print_r($add_child);
                        if (is_array($add_child)) {
                            $response_array['status'] = 1;
                            $response_array['message'] = "success";
                            $response_array['data'] = $add_child;
                            $response_array['iedit'] = $update;
                            $response_array['idelete'] = $delete;
                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] =$add_child;
                        }


                    }

                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] ="Invalid data";

                }


            } else{

                $response_array['status'] = -1;
                $response_array['message'] ="Access denied";

            }


        } elseif ($action =='edit'){

            if ($update == 1){

                if(isset($_POST['child']) || isset($_POST['item_id'])){

                    if ($_POST['child'] == "" || $_POST['item_id'] =="" || !is_numeric($_POST['item_id']) || $_POST['item_id'] < 1){

                        $response_array['status'] = 0;
                        $response_array['message'] ="Invalid data";

                    } else {

                        $id = trim($_POST['item_id']);
                        $child = strtolower(trim($_POST['child']));

                        $edit_child = $get_child->edit_child($id,$child);

                        if ($edit_child == 1){

                            $response_array['status'] = 1;
                            $response_array['message'] ="Update Successful";

                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] =$edit_child;
                        }


                    }

                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] ="No values set";

                }

            } else{

                $response_array['status'] = -1;
                $response_array['message'] ="Access denied";

            }

        } elseif ($action =='delete'){
            if ($delete == 1){

                if(isset($_POST['status']) || isset($_POST['item_id'])){


                    if($_POST['status'] == "" || $_POST['item_id'] == "" || !is_numeric($_POST['status']) || !is_numeric($_POST['item_id'])){

                        $response_array['status'] = 0;
                        $response_array['message'] ="Invalid Data sent";

                    } else {
                        $id = trim($_POST['item_id']);
                        $status = trim($_POST['status']);
                        if ($status == 1){
                        $msg = "active";

                        }else{

                            $msg = "inactive";
                        }

                        $del_child = $get_child->del_child($id);

                        if ($del_child == 1){
                            $response_array['status'] = 1;
                            $response_array['message'] ="Category is ".$msg;

                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] =$del_child;
                        }

                    }


                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] ="Missing data";

                }


            } else{

                $response_array['status'] = -1;
                $response_array['message'] ="Access denied";

            }

        }else{

            $response_array['status'] = 0;
            $response_array['message'] ="Invalid action";
        }


    } else {

        $response_array['status'] = 0;
        $response_array['message'] ="No action sent";
    }


} else {

    $response_array['status'] = 0;
    $response_array['message'] = "Error getting Access";
}
} else {

    $response_array['status'] = 4004;
    $response_array['message'] ="Session expired";
}

echo json_encode($response_array);
?>