<?php

require_once ('../includes/startsession.php');

if (isset($_SESSION['user_id'])) {
    
require_once ('../classes/user_login_class.php');
require_once ('../classes/company_category_class.php');

$check_details = new Rewards_user_login_class();

$get_details = $check_details->script_access();
$use_company_cat = new company_category_class();
if(is_array($get_details)) {
//{"create_access":"0","read_access":"0","update_access":"0","delete_access":"0"}
    if (isset($get_details['create_access'])) {

        $create = $get_details['create_access'];

    } else {

        $create = 0;
    }

    if (isset($get_details['read_access'])) {

        $read = $get_details['read_access'];

    } else {

        $read = 0;
    }

    if (isset($get_details['update_access'])) {

        $update = $get_details['update_access'];

    } else {

        $update = 0;
    }

    if (isset($get_details['delete_access'])) {

        $delete = $get_details['delete_access'];

    } else {

        $delete = 0;
    }


    if (isset($_POST['action'])){
        $action = $_POST['action'];

        if($action == 'add'){
            if ($create == 1){

                if(isset($_POST['category']) && isset($_POST['margin_type']) && isset($_POST['margin']) && isset($_POST['company_id'])){

                    if ($_POST['category'] == "" || $_POST['margin_type'] == "" || $_POST['margin'] == "" || $_POST['company_id'] == ""){

                        $response_array['status'] = 0;
                        $response_array['message'] ="Blank parameter";

                    } else {
                        $category = strtolower(trim($_POST['category']));
                        $margin_type = strtolower(trim($_POST['margin_type']));
                        $margin = strtolower(trim($_POST['margin']));
                        $company_id = strtolower(trim($_POST['company_id']));
                        $add_item = $use_company_cat->assign_category($company_id,$category,$margin_type, $margin);
                        if (is_array($add_item)) {
                            $response_array['status'] = 1;
                            $response_array['message'] = "success";
                            $response_array['data'] = $add_item;
                            $response_array['iedit'] = $update;
                            $response_array['idelete'] = $delete;
                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] =$add_item;
                        }


                    }

                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] ="Missing parameter";

                }


            } else{

                $response_array['status'] = -1;
                $response_array['message'] ="Access denied";

            }


        } elseif ($action =='edit'){

            if ($update == 1){

                if(isset($_POST['margin']) || isset($_POST['item_id'])){

                    if ($_POST['margin'] == "" || $_POST['item_id'] =="" || !is_numeric($_POST['item_id']) || $_POST['item_id'] < 1){

                        $response_array['status'] = 0;
                        $response_array['message'] ="Invalid data";

                    } else {

                        $id = trim($_POST['item_id']);
                        $margin = strtolower(trim($_POST['margin']));
                        $type = strtolower(trim($_POST['type']));

                        $edit_color = $use_company_cat->edit_assign_category($id,$type,$margin);

                        if ($edit_color  == 1){

                            $response_array['status'] = 1;
                            $response_array['message'] ="Update Successful";

                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] =$edit_color;
                        }


                    }

                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] ="No values set";

                }

            } else{

                $response_array['status'] = -1;
                $response_array['message'] ="Access denied";

            }

        } elseif ($action =='delete'){
            if ($delete == 1){

                if(isset($_POST['item_id'])){


                    if( $_POST['item_id'] == "" || !is_numeric($_POST['status']) || !is_numeric($_POST['item_id'])){

                        $response_array['status'] = 0;
                        $response_array['message'] ="Invalid Data sent";

                    } else {
                        $color_id = trim($_POST['item_id']);
                        //$status = trim($_POST['status']);
//                        if ($status == 1){
//                        $msg = "active";
//
//                        }else{
//
//                            $msg = "inactive";
//                        }

                        $del_color = $use_company_cat->del_parent($color_id);

                        if ($del_color == 1){
                            $response_array['status'] = 1;
                            $response_array['message'] ="Category is Removed";

                        } else {

                            $response_array['status'] = 0;
                            $response_array['message'] =$del_color;
                        }

                    }


                } else {

                    $response_array['status'] = 0;
                    $response_array['message'] ="Missing data";

                }


            } else{

                $response_array['status'] = -1;
                $response_array['message'] ="Access denied";

            }

        }else{

            $response_array['status'] = 0;
            $response_array['message'] ="Invalid action";
        }


    } else {

        $response_array['status'] = 0;
        $response_array['message'] ="No action sent";
    }


} else {

    $response_array['status'] = 0;
    $response_array['message'] = "Error getting Access";
}

} else {

    $response_array['status'] = 4004;
    $response_array['message'] ="Session expired";
}

echo json_encode($response_array);
?>